/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CCM_CIF_SESSIONCONTEXT_EXT_IMPL_HPP
#define INCL_CCM_CIF_SESSIONCONTEXT_EXT_IMPL_HPP

#include <CCMContainer/idllib/CdmwComponents.skel.hpp>
#include <CCMContainer/ccmcif/CCMContextExt_impl.hpp>




namespace Cdmw {

namespace CCM {

namespace CIF {


/**
*Purpose:
*<p>    [class description]
*    This class implement the Components::SessionContext interface.
*    It will be inherited by all session components context implementation.
*
*/

//
// IDL:omg.org/CdmwComponents/SessionContextExt:1.0
//
class SessionContextExt_impl : virtual public CdmwComponents::SessionContextExt,
                            public CCMContextExt_impl
{
public:

    SessionContextExt_impl(Components::CCMContext_ptr ctx,
                           CdmwLogging::LoggerFactory_ptr logger_factory)
        throw (CORBA::SystemException);

     ~SessionContextExt_impl();

    //
    // IDL:omg.org/Components/SessionContext/get_CCM_object:1.0
    //
    virtual CORBA::Object_ptr get_CCM_object()
        throw(Components::IllegalState,
              CORBA::SystemException);

private:
    SessionContextExt_impl();
    SessionContextExt_impl(const SessionContextExt_impl&);
    void operator=(const SessionContextExt_impl&);

    Components::SessionContext_var m_session_context;  // session context given by the container

    // logger to be used in CCMContext
    CdmwLogging::Logger_var m_logger;

};  // End SessionContextExt class

} // End namespace CIF

} // End namespace CCM

} // End namespace Cdmw


#endif  // INCL_CCM_CIF_SESSIONCONTEXT_EXT_IMPL_HPP



