/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


// Cdmw CCM files
#include <ccmcif/LoggerFactory_impl.hpp>
#include <ccmcif/Logger_impl.hpp>



namespace Cdmw {

namespace CCM {

namespace CIF {

LoggerFactory_impl::LoggerFactory_impl(const char* component_name)
    : m_component_name(component_name)
{
}

LoggerFactory_impl::~LoggerFactory_impl()
  throw()
{
}

CdmwLogging::Logger_ptr LoggerFactory_impl::get_logger(const char* name)  
    throw(CORBA::SystemException)
{
    return new Logger_impl(m_component_name.c_str(), name);
}


} // end namespace CIF
} // end namespace CCM
} // end namespace Cdmw
