/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testftccmcif/TestThread.hpp"
#include "testftccmcif/TestNavigationWithFT.hpp"


TestFtCcmCif::TestThread::TestThread(CORBA::ORB_ptr orb,
                                     CosNaming::NamingContext_ptr nc)
    throw (CORBA::SystemException)
    : m_orb(CORBA::ORB::_duplicate(orb)),
      m_nc(CosNaming::NamingContext::_duplicate(nc))
{}


TestFtCcmCif::TestThread::~TestThread()
    throw()
{}


void TestFtCcmCif::TestThread::run() 
    throw()
{
    // Testing TestNavigation
    Cdmw::TestUtils::CORBATestManager::instance()->add("namingContext", 
                                                       m_nc.in()); 
    Cdmw::TestUtils::CORBATestManager::instance()->run_tests();
    Cdmw::TestUtils::CORBATestManager::instance()->summary();

    m_orb->shutdown(false);
}   

