/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_CCM_CIF_TEST_EVENT_TIMESTAMPS_HPP
#define INCL_CCM_CIF_TEST_EVENT_TIMESTAMPS_HPP

// #include <Foundation/commonsvcs/time/Utils.hpp>
#include <iostream>
#include <fstream>
#include <string>
#include <Time/clockservice/Time.hpp>
#include <Foundation/commonsvcs/time/Util.hpp>
#include "Foundation/testutils/TestManager.hpp"
#include <Foundation/common/Properties.hpp>

namespace Cdmw
{
    namespace CCM
    {
        namespace CIF
        {

class TestEventTimestamps : public CppUnit::TestFixture
{
public:

    TestEventTimestamps();

    ~TestEventTimestamps()
        throw();

protected:

    virtual void verify_time_zone();

private:

    /**
    *
    * @param current_time added to be able to cache current time
    * @param time2  time to be checked
    *
    * @return returns whether the difference between current_time and time2 less than an hour
    */
    bool is_current_timezone(const std::string& current_time, const std::string& time2);

CPPUNIT_TEST_SUITE( TestEventTimestamps );
CPPUNIT_TEST( verify_time_zone );
CPPUNIT_TEST_SUITE_END();
};
        };// CIF
    };// CCM
};// Cdmw

#endif //INCL_CCM_CIF_TEST_EVENT_TIMESTAMPS_HPP
