/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

   
#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/ExceptionMinorCodes.hpp"
#include <Foundation/testutils/CORBATestManager.hpp>
   
#include "testphilosophers/EventConsumerBase_impl.hpp"
#include "CCMContainer/ccmcommon/CCMUtils.hpp"
   
   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace Dinner {

   EventConsumerBase_impl::EventConsumerBase_impl(PortableServer::POA_ptr  poa)
    : m_poa(PortableServer::POA::_duplicate(poa))
   {
   }

   EventConsumerBase_impl::~EventConsumerBase_impl()
   {
      TEST_INFO("EventConsumerBase destructor called");
   }

   void 
   EventConsumerBase_impl::push_event(Components::EventBase * evt)
      throw (Components::BadEventType, CORBA::SystemException)
   {
      TEST_INFO("EventConsumerBase received an event");

      if (!evt)
      {
         TEST_INFO("EventConsumerBase received a nil event type");
         throw Components::BadEventType();
      }
   }

} // end of namespace Dinner

} // end of namespace CIF

} // end of namespace CCM

} // end of namespace Cdmw

