/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.ccm.cif.test;

import cdmw.ossupport.OS;
import cdmw.testutils.CORBATestManager;
import cdmw.testutils.TestManager;

public class ClientThread extends Thread {
    
    private org.omg.CORBA.ORB orb;
    
    private String containerIOR;
    private String consumerIOR;
    private String consumerBaseIOR;

    public ClientThread(
        org.omg.CORBA.ORB orb, 
        String containerIOR, 
        String consumerIOR,
        String consumerBaseIOR) {

        this.orb = orb;
        this.containerIOR = containerIOR;
        this.consumerIOR = consumerIOR;
        this.consumerBaseIOR = consumerBaseIOR;
    }
    
    public void run() {
        
        int timescale = TestManager.getTimescale();
        try {
            OS.sleep(timescale * 3000);
        } catch(InterruptedException ie) {}
        // Testing PhiloTest
        CORBATestManager testManager = new CORBATestManager();
        TestManager.activateLocalInstance(testManager);
        
        testManager.init("cdmw.ccm.cif.test.PhiloTest", this.orb, null);
        
        testManager.setLocalProperty(
            PhiloTest.CONTAINER_IOR,
            this.containerIOR
            );
        testManager.setLocalProperty(
            PhiloTest.NON_CDMW_CONSUMER_IOR,
            this.consumerIOR
            );
        testManager.setLocalProperty(
            PhiloTest.CONSUMER_BASE_IOR,
            this.consumerBaseIOR
            );
        testManager.addTest(PhiloTest.class);

        testManager.runTests();
        testManager.printSummary();

        try {
            OS.sleep(timescale * 3000);
        } catch(InterruptedException ie) {}

        // Testing TypedPhiloTest
        testManager = new CORBATestManager();
        TestManager.activateLocalInstance(testManager);
        
        testManager.init("cdmw.ccm.cif.test.PhiloTest", this.orb, null);
        
        testManager.setLocalProperty(
            TypedPhiloTest.CONTAINER_IOR,
            this.containerIOR);
        testManager.setLocalProperty(
            TypedPhiloTest.CONSUMER_IOR,
            this.consumerIOR);
        testManager.addTest(TypedPhiloTest.class);

        testManager.runTests();
        testManager.printSummary();

        this.orb.shutdown(false);        
    }

}


