/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___TESTRECORDING_TIMEOUTTESTER_IMPL_HPP__
#define ___TESTRECORDING_TIMEOUTTESTER_IMPL_HPP__

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"
#include "testrecording/RecordingTest_cif.skel.hpp"


namespace RecordingTest
{


//
// IDL:thalesgroup.com/RecordingTest/CCM_FacetTest:1.0
//
class CCM_FacetTest_impl : virtual public ::RecordingTest::CCM_FacetTest,
                         virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    CCM_FacetTest_impl(const CCM_FacetTest_impl&);
    void operator=(const CCM_FacetTest_impl&);

public:

    CCM_FacetTest_impl();
    ~CCM_FacetTest_impl();

    //
    // IDL:thalesgroup.com/RecordingTest/CCM_FacetTest/sleep:1.0
    //
    virtual void sleep(CORBA::ULong)
        throw(CORBA::SystemException);


};

}; // End of namespace RecordingTest

#endif // ___TESTRECORDING_TIMEOUTTESTER_IMPL_HPP__

