/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_CCM_CIF_TEST_SERVER_HPP
#define INCL_CCM_CIF_TEST_SERVER_HPP

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"

#include <Foundation/idllib/Components.skel.hpp>
#include <TraceAndPerf/recordingidl/CdmwRecordingDaemonControl.stub.hpp>


namespace Cdmw
{
namespace CCM
{
namespace CIF
{

/**
*Purpose:
*<p>    [class description]
*
*Features:
*<p> [Thread safety, exception safety, performance]
*    [if no pertinent write none ]
*
*@see  [if necessary] 
*@link [if necessary] 
*
*/
class TestServer : public CppUnit::TestFixture
{

    public:

        /**
        * Purpose:
        * <p> [Constructor description if necessary]
        * 
        *@param
        *@exception
        */ 
       TestServer()
                throw(CORBA::SystemException);

        /**
        * Purpose:
        * <p>  [Copy constructor description if necessary]
        * 
        *@param
        *@exception
        */ 
       TestServer(const TestServer& rhs)
                throw();


        /**
        * Purpose:
        * <p> [ Destructor description if necessary]
        * 
        */ 
        virtual 
        ~TestServer()
                throw();


        /**
        * Purpose:
        * <p> [ Assignement operator description if necessary]
        * 
        *@param
        *@return
        *@exception
        */ 
       TestServer&
        operator=(const TestServer& rhs)
                throw();

        /**
        *[Attribute description]
        */ 

        static std::string recording_server_url;

    protected:

        virtual void do_tests();

    private:
       CORBA::ORB_var              m_orb;
       Components::Deployment::Container_var   m_container;
       CdmwRecording::DaemonControl_var m_recording_daemon_ctrl;

CPPUNIT_TEST_SUITE( TestServer );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();

}; // End classTestServer

}; // End namespace CIF
}; // End namespace CCM
}; // End namespace Cdmw
#endif 

