/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/ossupport/OS.hpp"
#include "testrecording/CCM_FacetTest_impl.hpp"

//
// IDL:thalesgroup.com/RecordingTest/CCM_FacetTest:1.0
//
RecordingTest::CCM_FacetTest_impl::CCM_FacetTest_impl()
{
}

RecordingTest::CCM_FacetTest_impl::~CCM_FacetTest_impl()
{
    std::cout << "CCM_FacetTest_impl::~CCM_FacetTest_impl called!"
              << std::endl;
}

//
// IDL:thalesgroup.com/RecordingTest/CCM_FacetTest/sleep:1.0
//
void
RecordingTest::CCM_FacetTest_impl::sleep( CORBA::ULong time_in_sec )
    throw(CORBA::SystemException)
{

  usleep(time_in_sec * 1000000);

  std::cout << "RecordingTest::CCM_FacetTest_impl::sleep called!" << std::endl;

}

