/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>

#include "testrecording/CCM_Server_impl.hpp"
#include "testrecording/CCM_FacetTest_impl.hpp"

//
// IDL:thalesgroup.com/CCM_RecordingTest/CCM_Server:1.0
//
RecordingTest::CCM_Server_impl::CCM_Server_impl()
{
  m_facet_test = new RecordingTest::CCM_FacetTest_impl();
}

RecordingTest::CCM_Server_impl::~CCM_Server_impl()
{
    std::cout << "CCM_Server_impl::~CCM_Server_impl called!" << std::endl;
}


::RecordingTest::CCM_FacetTest_ptr
RecordingTest::CCM_Server_impl::get_for_clients ( )
  throw ( CORBA::SystemException )
{
  return  RecordingTest::CCM_FacetTest::_duplicate(m_facet_test.in());
}


//
// set_session_context function : it fixes the session context of the component (call by the container)
//
void
RecordingTest::CCM_Server_impl::set_session_context(Components::SessionContext_ptr ctx)
  throw(CORBA::SystemException)
{
  std::cout << "Set_session_context called!" << std::endl;
   
  m_session_context = ::RecordingTest::CCM_Server_Context::_narrow(ctx); 
}


//
// ccm_activate function : it actives the component (call by the container)
//
void
RecordingTest::CCM_Server_impl::ccm_activate()
  throw(CORBA::SystemException)
{
  std::cout << "Ccm_activate called!" << std::endl;

  // get_context() performs a duplicate
//   ::RecordingTest::CCM_Server_Context_var ctx = get_context();
//   Cdmw::TestUtils::CORBATestManager::instance()->add("client_context", ctx.in());

//   Cdmw::TestUtils::ThreadedTestRunner runner(Cdmw::TestUtils::CORBATestManager::instance()->get_controller());
//   runner.addTest( CppUnit::TestFactoryRegistry::getRegistry("test_ccm_client_activate").makeTest() );
//   runner.start();
//   runner.join();

//   sleep(5);
    
}


//
// ccm_passivate function : it makes stop the component (call by the container)
//

void
RecordingTest::CCM_Server_impl::ccm_passivate()
  throw(CORBA::SystemException)
{
  std::cout << "Ccm_passivate called!" << std::endl;
} 



//
// ccm_remove function : it destroys the component (call by the container)
void
RecordingTest::CCM_Server_impl::ccm_remove()
  throw(CORBA::SystemException)
{
  std::cout << "Ccm_remove called!" << std::endl;
}
