/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___TESTTIMEOUT_CLIENTHOME_IMPL_HPP__
#define ___TESTTIMEOUT_CLIENTHOME_IMPL_HPP__

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"
#include "testwithdefaulttimeout/TestTimeout_cif.skel.hpp"

namespace TestTimeout
{

  /*
   * Home creating client components to test the execution with a specific
   * and a default timeout on receptacle
   */

//
// IDL:thalesgroup.com/TestTimeout/ClientHome:1.0
//
class CCM_ClientHome_impl : virtual public ::TestTimeout::CCM_ClientHome,
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{

  CCM_ClientHome_impl(const CCM_ClientHome_impl&);
  void operator=(const CCM_ClientHome_impl&);

public:

    CCM_ClientHome_impl();
    ~CCM_ClientHome_impl();

    //
    // IDL:thalesgroup.com/TestTimeout/CCM_ClientHomeImplicit/create:1.0
    //
    virtual TestTimeout::CCM_Client_ptr create()
      throw (CORBA::SystemException, Components::CCMException);
};

}; // End of namespace TestTimeout


#endif // ___TESTTIMEOUT_CLIENTHOME_IMPL_HPP__

