/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___TESTTIMEOUT_SERVER_IMPL_HPP__
#define ___TESTTIMEOUT_SERVER_IMPL_HPP__

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"

#include "testwithdefaulttimeout/TestTimeout_cif.stub.hpp"


namespace TestTimeout
{
//
// IDL:thalesgroup.com/TestTimeout/CCM_Server:1.0
//
class CCM_Server_impl : virtual public ::TestTimeout::CCM_Server, 
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
  CCM_Server_impl(const CCM_Server_impl&);
  void operator=(const CCM_Server_impl&);
  ::TestTimeout::CCM_TimeoutTester_var  m_timeout_tester;
 
public:
  
  CCM_Server_impl();
  ~CCM_Server_impl();
  
   virtual ::TestTimeout::CCM_TimeoutTester_ptr get_tester ( )
     throw ( CORBA::SystemException );
   
};


}; // End of namespace TestTimeout

#endif // ___TESTTIMEOUT_SERVER_IMPL_HPP__

