/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_SYSTEM_PROPERTIES_H
#define CDMW_CCM_SYSTEM_PROPERTIES_H

namespace Cdmw {
namespace CCM {

    /**
     * SystemProperty name to be used to have container creating
     * persistent references for components
     */
    const char* const SESSION_CONTAINER_PERSISTENT_REF_PROPERTY_NAME =
    "Cdmw.CCMContainer.SessionContainer.PersistentRef";

    /**
     * SystemProperty name to be used to activate or deactivate the type 
     * checking while the connection establishment.
     */
    const char* const TYPECHECKING_PROPERTY_NAME =
    "Cdmw.CCMContainer.Typechecking";

    /**
     * SystemProperty name to be used to set the duration of the timeout for
     * the type checking while the connection establishment.
     */
    const char* const TYPECHECKING_TIMEOUT_PROPERTY_NAME =
    "Cdmw.CCM.TypeChecking.Timeout";


}  // End namespace CCM
}  // End namespace Cdmw

#endif // CDMW_FT_SYSTEM_PROPERTIES_H


