/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.ccm.common;


/**
 * Class with constant definitions for SystemProperties used by CCM
 *
 */
public class CCMSystemProperties {

    /**
     * SystemProperty name to be used to have container creating
     * persistent references for components
     */
    public static final String SESSION_CONTAINER_PERSISTENT_REF = 
        "Cdmw.CCM.SessionContainer.PersistentRef";

    /**
     * SystemProperty name to be used to activate or deactivate the type 
     * checking while the connection establishment.
     */
    public static final String TYPECHECKING =
        "Cdmw.CCM.TypeChecking";

    /**
     * SystemProperty name to be used to set the duration of the timeout for
     * the type checking while the connection establishment.
     */
    public static final String TYPECHECKING_TIMEOUT =
        "Cdmw.CCM.TypeChecking.Timeout";

}
