/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef ___CCM_TEST_CCM_SERVICES_CCM_SERVER_IMPL_HPP__
#define ___CCM_TEST_CCM_SERVICES_CCM_SERVER_IMPL_HPP__

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtManagedElementContexts.stub.hpp>

#include <ccm_services/TestCcmServicesSessionServer.skel.hpp>

namespace TestCcmServices
{

class CCM_Server_impl;
    

//
// IDL:thalesgroup.com/TestCcmServices/Session_CCM_Server:1.0
//
class CCM_Server_impl : virtual public ::TestCcmServices::Session_CCM_Server,
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
public:

    CCM_Server_impl();
    ~CCM_Server_impl();
     
    //
    // facet test_services
    //
    virtual ::TestCcmServices::CCM_TestServices_ptr get_test_services ()
        throw (CORBA::SystemException);
    

    virtual ::TestCcmServices::FTState get_initial_ft_state()
      throw (CORBA::SystemException);
        
    virtual ::TestCcmServices::FTState get_actual_ft_state()
      throw (CORBA::SystemException);
        
    virtual void call_notify_message(CORBA::Long level, const char * message)
      throw (CORBA::SystemException);
      
    virtual void call_notify_fatal_error(const char * error_info)
      throw (CORBA::SystemException);
      
    virtual void call_notify_user_event(const CORBA::Any & data)
      throw (CORBA::SystemException);
      
    virtual void call_exit(CORBA::Long exit_code)
      throw (CORBA::SystemException);

      
    //
    // Session component specific operations
    //
    void set_session_context(Components::SessionContext_ptr ctx)
        throw(CORBA::SystemException);
    void ccm_activate()
        throw(CORBA::SystemException);
    void ccm_passivate()
        throw(CORBA::SystemException);
    void ccm_remove()
        throw(CORBA::SystemException);


    ::TestCcmServices::CCM_Server_Context* get_context();


private:
    
    CCM_Server_impl(const CCM_Server_impl&);
    void operator=(const CCM_Server_impl&);

    // session context
    ::TestCcmServices::CCM_Server_Context_var m_session_context;
     
    // initial FTState at start-up 
    FTState m_ft_initial_state;
    
    // Supervision's ProcessContext
    CdmwPlatformMngt::ManagedElementContexts::ProcessContext_var m_process_context;
    
    // Supervision's ComponentContext
    CdmwPlatformMngt::ManagedElementContexts::ComponentContext_var m_component_context;
};

}; // End of namespace CcmFtTest


#endif // ___CCM_TEST_CCM_SERVICES_CCM_SERVER_IMPL_HPP__

