/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testccmservices;

import com.thalesgroup.CdmwPlatformMngt.FunctioningMode;


// Implementation of CdmwPlatformMngt::ApplicationModeChange valuetype;
// since it's not yet implemented in SystemMngt/platformvaluetypes/java
class ApplicationModeChangeImpl 
    extends com.thalesgroup.CdmwPlatformMngt.ApplicationModeChange
{
    protected ApplicationModeChangeImpl() 
    {
    }
    
    public String get_issuer()
    {
        return com.thalesgroup.CdmwPlatformMngtBase.PFMMNG.value;
    }
    
    public String to_string()
    {
        String mode = "";
        switch (this.application_mode.value()) {
            case FunctioningMode._NORMAL_MODE:
            mode = "NORMAL";
            break;

            case FunctioningMode._DEGRADED_MODE:
            mode = "DEGRADED";
            break;
        }
        mode += " : " + this.mode_info;
        
        return EventUtil.beginString(this) +
               " A:'"  + this.application_name +
               "' " + mode;
    }
}


public class ApplicationModeChangeFactory
    implements org.omg.CORBA.portable.ValueFactory
{
    public ApplicationModeChangeFactory()
    {
    }
    
    public java.io.Serializable 
    read_value(org.omg.CORBA_2_3.portable.InputStream is) 
    {
        ApplicationModeChangeImpl result = new ApplicationModeChangeImpl();
        return is.read_value(result);
    }
}


