/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testccmservices;

import com.thalesgroup.CdmwPlatformMngt.Event;

class EventUtil
{

    public static String headerString(Event event)
    {
        java.io.ByteArrayOutputStream os = new java.io.ByteArrayOutputStream();
        java.io.PrintStream temp = new java.io.PrintStream(os);
        
        com.thalesgroup.CdmwPlatformMngtBase.TimeStamp timeStamp = 
            event.header.time_stamp;
        
        String levelStr;
        switch(event.header.level) {
            case com.thalesgroup.CdmwPlatformMngtBase.INF.value:
                levelStr = com.thalesgroup.CdmwPlatformMngtBase.INF_STR.value;
                break;
            case com.thalesgroup.CdmwPlatformMngtBase.WRN.value:
                levelStr = com.thalesgroup.CdmwPlatformMngtBase.WRN_STR.value;
                break;
            case com.thalesgroup.CdmwPlatformMngtBase.ERR.value:
                levelStr = com.thalesgroup.CdmwPlatformMngtBase.ERR_STR.value;
                break;
            case com.thalesgroup.CdmwPlatformMngtBase.FTL.value:
                levelStr = com.thalesgroup.CdmwPlatformMngtBase.FTL_STR.value;
                break;
            default:
                levelStr = Short.toString(event.header.level);
        }
            
        temp.printf("%1$04d/%2$02d/%3$02d %4$02d:%5$02d:%6$02d:%7$03d:%8$03d %9$s",
                    event.header.time_stamp.year,
                    event.header.time_stamp.month,
                    event.header.time_stamp.day,
                    event.header.time_stamp.hour,
                    event.header.time_stamp.minute,
                    event.header.time_stamp.second,
                    event.header.time_stamp.millisecond,
                    event.header.time_stamp.microsecond,
                    levelStr);
        temp.flush();
        return os.toString();
    }

    
    public static String beginString(Event event)
    {
        return headerString(event) + " " + event.get_issuer()
               + " S:'" + event.system_name + "'";
    }

    
}

