/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testccmservices;

import com.thalesgroup.CdmwPlatformMngt.ProcessStatus;


// Implementation of CdmwPlatformMngt::ProcessStatusChange valuetype;
// since it's not yet implemented in SystemMngt/platformvaluetypes/java
class ProcessStatusChangeImpl 
    extends com.thalesgroup.CdmwPlatformMngt.ProcessStatusChange
{
    protected ProcessStatusChangeImpl() 
    {
    }
    
    public String get_issuer()
    {
        return this.issuer;
    }
    
    public String to_string()
    {
        String status = "";
        switch (this.process_status.value()) {
            case ProcessStatus._PROCESS_INITIAL:
            status = "INITIAL";
            break;

            case ProcessStatus._PROCESS_INITIALISING:
            status = "INITIALISING";
            break;

            case ProcessStatus._PROCESS_STEP_PERFORMED:
            status = "STEP_PERFORMED";
            break;

            case ProcessStatus._PROCESS_INITIALISED:
            status = "INITIALISED";
            break;

            case ProcessStatus._PROCESS_RUN_REQUEST:
            status = "RUN_REQUEST";
            break;

            case ProcessStatus._PROCESS_RUNNING:
            status = "RUNNING";
            break;

            case ProcessStatus._PROCESS_STOPPING:
            status = "STOPPING";
            break;

            case ProcessStatus._PROCESS_STOPPED:
            status = "STOPPED";
            break;

            case ProcessStatus._PROCESS_ENDED:
            status = "ENDED";
            break;

            case ProcessStatus._PROCESS_FAILED_ERROR:
            status = "FAILED_ERROR";
            break;

            case ProcessStatus._PROCESS_FAILED_TIMEOUT:
            status = "FAILED_TIMEOUT";
            break;

            case ProcessStatus._PROCESS_FAILED_DISCREPANCY:
            status = "FAILED_DISCREPANCY";
            break;

            case ProcessStatus._PROCESS_FAILED_INVALID:
            status = "FAILED_INVALID";
            break;

            case ProcessStatus._PROCESS_FAILED_NO_RESPONSE:
            status = "FAILED_NO_RESPONSE";
            break;

            case ProcessStatus._PROCESS_FAILED_DEATH:
            status = "FAILED_DEATH";
            break;
        }
        
        if (this.process_status == ProcessStatus.PROCESS_INITIALISING
            || this.process_status == ProcessStatus.PROCESS_STEP_PERFORMED)
        {
            status += " step " + this.step_number + 
                      " '" + this.step_label + "'";
        }
        else
        {
            status += " : " + this.info;
        }
        
        
        return EventUtil.beginString(this) +
               " A:'"  + this.process_id.application_name +
               "' H:'" + this.process_id.host_name +
               "' P:'" + this.process_id.process_name +
               "' " + status;
    }
}


public class ProcessStatusChangeFactory
    implements org.omg.CORBA.portable.ValueFactory
{
    public ProcessStatusChangeFactory()
    {
    }
    
    public java.io.Serializable 
    read_value(org.omg.CORBA_2_3.portable.InputStream is) 
    {
        ProcessStatusChangeImpl result = new ProcessStatusChangeImpl();
        return is.read_value(result);
    }
}


