/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.testccmsupervisedcomp;

/**
* Purpose:
* <p>
* The abstract process behaviour.
*/
public class MyProcessBehaviour extends cdmw.platformmngt.ProcessBehaviour
{

    private org.omg.CORBA.ORB orb;
    private org.omg.PortableServer.POA poa;
    private TestSupervisedComponentThread testThread;
    private String hostName1;
    private String hostName2;

    /**
     * Purpose:
     * <p> The constructor.
     */
    public MyProcessBehaviour(org.omg.CORBA.ORB orb,
                              org.omg.PortableServer.POA poa,
                              String hostName1, String hostName2)
    {
        this.orb = orb;
        this.poa = poa;
        this.hostName1 = hostName1;
        this.hostName2 = hostName2;
    }

    /**
     * Purpose:
     * <p>
     * the behaviour for the
     * IDL:thalesgroup.com/CdmwPlatformMngt/Process/initialise:1.0
     * operation
     */
    public void initialise(
        com.thalesgroup.CdmwPlatformMngtBase.StartupKind startupKind)
    {
    }

    /**
     * The behaviour for the
     * IDL:thalesgroup.com/CdmwPlatformMngt/ProcessDelegate/run:1.0
     * operation
     */
    public void run()
        throws com.thalesgroup.CdmwPlatformMngt.ProcessDelegatePackage.NotReadyToRun
    {
        // Launch the test in a thread
        testThread = 
            new TestSupervisedComponentThread(orb, hostName1, hostName2);
        testThread.start();
    }

   /**
     * The behaviour for the
     * IDL:thalesgroup.com/CdmwPlatformMngt/ProcessDelegate/stop:1.0
     * operation
     */
    public void stop()
    {
        try {
            testThread.join();
        }
        catch (java.lang.InterruptedException e) {
            System.err.println("Unexpected exception : " + e);
        }
    }

}
