/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testccmsupervisedcomp;

import cdmw.testutils.CORBATestManager;
import cdmw.testutils.TestManager;
import java.lang.String;

class TestSupervisedComponentThread extends Thread
{

    private String hostName1;
    private String hostName2;
    private org.omg.CORBA.ORB orb;

    public TestSupervisedComponentThread(org.omg.CORBA.ORB orb,
                                         String hostName1, String hostName2)
    {
        this.orb = orb;
        this.hostName1 = hostName1;
        this.hostName2 = hostName2;
    }

    public void run() {

        CORBATestManager localTestManager = new CORBATestManager();
        localTestManager.init("test_supervised_component", orb, null);
        TestManager.activateLocalInstance(localTestManager);

        localTestManager.setLocalProperty ("hostName1", hostName1);
        localTestManager.setLocalProperty ("hostName2", hostName2);
        localTestManager.addTest(TestSupervisedComponent.class);

        localTestManager.runTests();
        localTestManager.printSummary();
    }

}
