#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2009. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

case @config.CCMContainer.java.orb@ in
    ORBacusJAVA)
    __ORB_CLASSPATH__=@config.ORBacusJAVA.classpath@
    ;;

        JacORB)
        __ORB_CLASSPATH__=@config.JacORB.classpath@:@config.JacORB.install.dir@
        ;;
    *)
    echo " invalid ORB constraint...";
    exit 1;
    ;;
esac

__TOOLS_CLASSPATH__=$__ORB_CLASSPATH__:@config.XercesJAVA.classpath@:@config.XalanJAVA.classpath@

__CLASSPATH__=""

# add jars
for jar in `find @config.install.dir@ -name "*.jar"`
do
    __CLASSPATH__=$__CLASSPATH__$jar:
done

__CLASSPATH__=$__CLASSPATH__$__TOOLS_CLASSPATH__

# set library path for java native libraries
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:@config.install.dir@/lib/c++
LIBPATH=$LIBPATH:@config.install.dir@/lib/c++

#if we use the onlyqualificationtest or onlyvalidationtest options we should set additional paths
__CDMW_CLASSPATH__=""
if [ $CDMW_ROOT ]
then
    # add CARDAMOM jars
    for cjar in `find $CDMW_ROOT -name "*.jar"`
    do
        __CDMW_CLASSPATH__=$cjar:$__CDMW_CLASSPATH__
    done
    __CLASSPATH__=$__CLASSPATH__:$__CDMW_CLASSPATH__
    
    #paths to CARDAMOM install
    LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$CDMW_ROOT/lib/c++
    LIBPATH=$LIBPATH:$CDMW_ROOT/lib/c++    
fi

exec java -Xbootclasspath/p:$__CLASSPATH__ cdmw.dinnerdemo.ObserverComponentServer $*

