#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2009. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

if [ -z "$1" -o "$1" = "-h" -o "$1" = "--help" ]; then
    echo "Usage: $0 <DeploymentPlanFile.cdp>"    
    echo "       This script add the standard xmi:id and xmi:idref in a .cdp file."
    exit 0
fi

if [ ! -f $1 ]; then
    echo "Error: file $1 not found"
    exit 1
fi

echo "replacing id by xmi:id"
sed -i 's/\([^x][^m][^i][^:]\)id=/\1xmi:id=/' $1
echo "replacing id by xmi:idref"
sed -i 's/<artifact>\(.*\)<\/artifact>/<artifact xmi:idref="\1"\/>/' $1
sed -i 's/<implementation>\(.*\)<\/implementation>/<implementation xmi:idref="\1"\/>/' $1
sed -i 's/<instance>\(.*\)<\/instance>/<instance xmi:idref="\1"\/>/' $1
