#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2009. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

echo "=========================================================="
echo "Test DAnCE Trace collection through CDMW Trace logging mecanism"
echo "Creation of the cdr from the cdp"

./cdmw_cdp_to_cdr.sh CDPFileToTest.cdp 2>&1 | tee ./result.log

# TEST #001
R001=0
echo -n "Test existence of result.log         : "
if [ -f ./result.log ] ; then
    R001=1
    echo "[OK]"
else
    echo "[KO]"
fi

echo -n "Test of DAnCE Traces managed by CDMW : "
if [ ${R001} -eq 1 ] ; then
    if [ `grep 'OFTAO.DAnCE' ./result.log | wc -l` -gt 0 ] ; then
        echo "[OK]"
    else
        R001=0
        echo "[KO]"
    fi
else
    echo "[KO]"
fi

# TEST #002
R002=0
echo -n "Test existence of generated cdr file : "
if [ -f ./CDPFileToTest.cdr ] ; then
    R002=1
    echo "[OK]"
else
    echo "[KO]"
fi

rm -f ./CDPFileToTest.cdr ./result.log

# TEST RESULT
if [ ${R001} -eq 1 -a ${R002} -eq 1 ]; then 
    echo ">>>> Test result is set as TESTABLE_OK <<<<"
else
    echo "TEST FAILED"
fi

exit 0
