/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef _CDMW_CCM_LOGGERS_HPP_
#define _CDMW_CCM_LOGGERS_HPP_

#include <Foundation/logging/Logger.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <Foundation/common/Assert.hpp>


namespace Cdmw {
namespace CCM {
namespace NodeManager {

    /**
     * Utility class to be used by CARDAMOM only.
     * Returns the logger for ccmnodemanager csc usage.
     */
    class Logger
    {
        public:
        
        /**
         * CCM Domain for logs in ccmnodemanager
         */
        static const char* CCMNODEMANAGER_LOG_DOMAIN;

        /**
         * Get Logger for ccmnodemanager
         *
         * @return the Logger to be used in ccmnodemanager
         */
        inline static Cdmw::Logging::Logger * Get_Logger() throw () 
        {
            static Cdmw::Logging::Logger * Logger__ = 
                Cdmw::Logging::Logger::Get_Logger(CCMNODEMANAGER_LOG_DOMAIN);
            CDMW_ASSERT(Logger__ != 0);
            return Logger__;
        }
        
        private:
            Logger();
            ~Logger();
        
    };    
    

 
}; // namespace NodeManager
}; // namespace CCM
}; // namespace Cdmw

#endif // _CDMW_FT_LOGGER_HPP_

