/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <ccm/CCM_Display_impl.hpp>

#include <iostream>  

//
// IDL:thalesgroup.com/BasicDemo/CCM_Display:1.0
//
BasicDemo::CCM_Display_impl::CCM_Display_impl()
{
}

BasicDemo::CCM_Display_impl::~CCM_Display_impl()
{
    std::cout << "CCM_Display_impl::~CCM_Display_impl called!" << std::endl;
}

//
// IDL:thalesgroup.com/BasicDemo/Display/print:1.0
//
void
BasicDemo::CCM_Display_impl::print(const char* text)
    throw(CORBA::SystemException)
{
    // print the message on the default output
    std::cout << text << std::endl;
}


//
// IDL:thalesgroup.com/BasicDemo/Display/print_event:1.0
//
void 
BasicDemo::CCM_Display_impl::print_event(BasicDemo::Event * the_event)
    throw(CORBA::SystemException)
{
    // print the message on the default output
    std::cout << the_event->text() << std::endl;
}

