/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <ccm_ft/HostnameResult_impl.hpp>

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createHostnameResultFactory () {
        return new CcmFtTest::HostnameResultFactory();
    }
};



// Constructor
CcmFtTest::HostnameResult_impl::HostnameResult_impl ()
{
}

// Copy Constructor
CcmFtTest::HostnameResult_impl::HostnameResult_impl (const HostnameResult_impl& right)
{
    hostname(right.hostname());
}

// Destructor
CcmFtTest::HostnameResult_impl::~HostnameResult_impl ()
{
}

CORBA::ValueBase* 
CcmFtTest::HostnameResult_impl::_copy_value()
{
    CcmFtTest::HostnameResult_impl* result = new HostnameResult_impl();
    result->hostname(hostname());
    
    return result;
}

/******************************/
/*         Factory            */
/******************************/


CcmFtTest::HostnameResultFactory::HostnameResultFactory()
{
}

CcmFtTest::HostnameResultFactory::~HostnameResultFactory()
{
}

CORBA::ValueBase * 
CcmFtTest::HostnameResultFactory::create_for_unmarshal ()
{
    return new CcmFtTest::HostnameResult_impl();
}

