/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef ___CCM_TEST_CCM_NODE_MANAGER_CCM_SERVER_IMPL_HPP__
#define ___CCM_TEST_CCM_NODE_MANAGER_CCM_SERVER_IMPL_HPP__

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#include <ccm_testnodemanager/TestCcmNodeManagerLocal.skel.hpp>

namespace TestCcmNodeManager
{

class CCM_Server_impl;
    

//
// IDL:thalesgroup.com/TestCcmNodeManager/Session_CCM_Server:1.0
//
class CCM_Server_impl : virtual public ::TestCcmNodeManager::Session_CCM_Server,
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
public:

    CCM_Server_impl();
    ~CCM_Server_impl();
     
    //
    // facet hello_facet
    //
    virtual ::TestCcmNodeManager::CCM_HelloWorld_ptr get_hello_facet ()
        throw (CORBA::SystemException);
    

    //
    // HelloWorld facet
    //
    virtual void say_hello()
      throw (CORBA::SystemException);
      
      
    //
    // Session component specific operations
    //
    void set_session_context(Components::SessionContext_ptr ctx)
        throw(CORBA::SystemException);
    void ccm_activate()
        throw(CORBA::SystemException);
    void ccm_passivate()
        throw(CORBA::SystemException);
    void ccm_remove()
        throw(CORBA::SystemException);


    ::TestCcmNodeManager::CCM_Server_Context* get_context();


private:
    
    CCM_Server_impl(const CCM_Server_impl&);
    void operator=(const CCM_Server_impl&);

    // session context
    ::TestCcmNodeManager::CCM_Server_Context_var m_session_context;
     
};

}; // End of namespace TestCcmNodeManager


#endif // ___CCM_TEST_CCM_NODE_MANAGER_CCM_SERVER_IMPL_HPP__

