/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.event.test;

import cdmw.ossupport.OS;
import cdmw.testutils.CORBATestManager;
import cdmw.testutils.TestManager;

import org.omg.CORBA.ORB;

public class ClientThread extends Thread {

    private ORB orb;
    private boolean has_FT;

    public ClientThread(ORB orb, boolean has_FT) {    
        this.orb = orb;  
        this.has_FT = has_FT;
    }

    public void run() {

         // Testing TestEventChannel
        CORBATestManager corbaTestManager = new CORBATestManager();
        TestManager.activateLocalInstance(corbaTestManager);

        if (has_FT) {
            corbaTestManager.init("FTEventChannelTest", this.orb, null);
            corbaTestManager.addTest(FTEventChannelTest.class);
        }
        else {
            corbaTestManager.init("EventChannelTest", this.orb, null);
            corbaTestManager.addTest(EventChannelTest.class);
        }
        corbaTestManager.runTests();
        try {
            OS.sleep(cdmw.testutils.Testable.getTimescale() * 5000);
        } catch(InterruptedException ie) {
            ie.printStackTrace();
        }
    
        corbaTestManager.printSummary();
    }

}


