/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_FTMANAGER_GROUPS_H
#define CDMW_FTMANAGER_GROUPS_H

#include <FaultTolerance/idllib/FT.stub.hpp>

namespace Cdmw {
namespace FT {

  const char* const REP_ID_REPL_MNGT      = "IDL:thalesgroup.com/CdmwFT/ReplicationManagerPushConsumer:1.0";
  const char* const REP_ID_FAULT_NOTIFIER = "IDL:omg.org/FT/FaultNotifier:1.0";    
  const char* const REP_ID_FAULT_DETECTOR = "IDL:thalesgroup.com/CdmwFT/FaultManagement/FaultDetector:1.0";
  
  const ::FT::ObjectGroupId OGID_MIN  = 0x00000000L;
  const ::FT::ObjectGroupId OGID_MAX  = 0xffffff00L;
  const ::FT::ObjectGroupId FTMANAGER_PRIVATE_OGID_MIN  = OGID_MAX;
  const ::FT::ObjectGroupId FTMANAGER_PRIVATE_OGID_MAX  = 0xffffff0fL;

  const ::FT::ObjectGroupId OGID_REPL_MNGT      = 1 | FTMANAGER_PRIVATE_OGID_MIN;
  const ::FT::ObjectGroupId OGID_FAULT_NOTIFIER = 2 | FTMANAGER_PRIVATE_OGID_MIN;
  const ::FT::ObjectGroupId OGID_FAULT_DETECTOR = 3 | FTMANAGER_PRIVATE_OGID_MIN;

   const char* const GNAME_REPL_MNGT      = "ReplicationManager";
   const char* const GNAME_FAULT_NOTIFIER = "FaultNotifier";
   const char* const GNAME_FAULT_DETECTOR = "FaultDetector";
  
   
}  // End namespace FT
}  // End namespace Cdmw

#endif // CDMW_FTMANAGER_GROUPS_H


