/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_FTMANAGER_OBJECT_IDS_H
#define CDMW_FTMANAGER_OBJECT_IDS_H

#include <Foundation/orbsupport/CdmwObjectIds.hpp>

namespace Cdmw {
namespace FT {
    const char* const FT_CURRENT_ObjectId          = "FTCurrent";
    const char* const FT_GROUP_REPOSITORY_ObjectId = Cdmw::OrbSupport::FT_GROUP_REPOSITORY_ObjectId;
    const char* const FT_ACTIVATION_MANAGER_ObjectId = "FTActivationManager";
    const char* const REPLICATION_MANAGER_ObjectId = "ReplicationManager";
    const char* const FAULT_NOTIFIFER_ObjectId     = "FaultNotifier";
    const char* const FAULT_DETECTOR_ObjectId      = "FaultDetector";
    const char* const MONITORING_LIBRARY_ObjectId  = "MonitoringLibrary";
    const char* const FT_TYPE_REPOSITORY_ObjectId  = "FTTypeRepository";
}  // End namespace FT
}  // End namespace Cdmw

#endif // CDMW_FTMANAGER_OBJECT_IDS_H


