/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_FT_SYSTEM_PROPERTIES_H
#define CDMW_FT_SYSTEM_PROPERTIES_H

namespace Cdmw {
namespace FT {

    const char* const ULTIMATE_FALLBACK_HOST_PROPERTY_NAME  = "Cdmw.FaultTolerance.UltimateFallback.host";
    const char* const ULTIMATE_FALLBACK_PORT_PROPERTY_NAME  = "Cdmw.FaultTolerance.UltimateFallback.port";
    const char* const WATCHDOG_TIMEOUT_PROPERTY_NAME = "Cdmw.FaultTolerance.Watchdog.timeout";
    const char* const WATCHDOG_DEFAULT_TIMEOUT_PROPERTY_NAME = "Cdmw.FaultTolerance.Watchdog.default-timeout";
    const char* const RECOVERY_HOLD_TIME_PROPERTY_NAME  = "Cdmw.FaultTolerance.Recovery.holdTime";

    const char* const FTSTATEMNGR_SCHED_THREADS_STACKSIZE_PROPERTY_NAME =
          "Cdmw.FaultTolerance.Scheduler.Threads.Stacksize";
    const char* const FTSTATEMNGR_TIMER_THREAD_STACKSIZE_PROPERTY_NAME =
          "Cdmw.FaultTolerance.Timer.Thread.Stacksize";

    const char* const FT_SIMPLE_ISALIVE_RETRY_PROPERTY_NAME = "Cdmw.FaultTolerance.SimpleIsAliveRetry";
    const char* const FT_MUTUAL_ISALIVE_RETRY_PROPERTY_NAME = "Cdmw.FaultTolerance.MutualIsAliveRetry";

    // NOTA: Use of naming convention usable as environment variable!
   const char* const CDMW_FT_INSTALL_HEXDUMP_SIGUSR1_HANDLER = "CDMW_FT_INSTALL_HEXDUMP_SIGUSR1_HANDLER";
    // Default retry number of is_alive for monitoring
    const int DEFAULT_ISALIVE_RETRY = 3;

    // Object Group ID CosNaming::NameComponent::kind value
    const std::string OGID_KIND="gid";
    // Object Group Version CosNaming::NameComponent::kind value
    const std::string VERSION_KIND="v";
    // Repository ID CosNaming::NameComponent::kind value
    const std::string TYPEID_KIND="typeid";
    // Object Group Name CosNaming::NameComponent::kind value
    const std::string NAME_KIND="name";
   // Ultimate Fallback AdapterName
   const std::string FALLBACK_POA_NAME = "UltimateFallbackPOA";
     

}  // End namespace FT
}  // End namespace Cdmw

#endif // CDMW_FT_SYSTEM_PROPERTIES_H


