/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <FaultTolerance/ftcommon/FTLogger.hpp>

#if defined (CDMW_HAVE_GCC_ABI_DEMANGLE)
#include <cxxabi.h>
#endif

namespace Cdmw {
    namespace FT {
        const char* FTLogger::FLT_LOG_DOMAIN = "CDMW.FLT";

       std::string FTLogger::Get_typename(const std::type_info & typeinfo)
       {
#if defined (CDMW_HAVE_GCC_ABI_DEMANGLE)
          int status = 0;
          char* ret = abi::__cxa_demangle( typeinfo.name(), 0, 0, &status );

          std::string name( ret );
          free( ret );
#else
          std::string name( typeinfo.name() );
#endif
          return name;
       }

    } // End namespace FT
} // End namespace Cdmw

