/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ft;

import org.omg.CORBA.*;

public class FTConfiguration
{
    /**
     * Set the client_id
     * 
     * @param orb
     *            the orb.
     * @param client_id
     *            the client_id for the orb.
     * 
     * @return void
     */
    public static void SetClientId(ORB orb, String clientId) {
        ORBSpecificFTConfiguration.SetClientId(orb, clientId);
    }
    
    /**
     * Get the client_id
     *
     * @param orb the orb.
     *
     * @return client_id the client_id for the orb..
     */
    
    public static String GetClientId(ORB orb) {
        return ORBSpecificFTConfiguration.GetClientId(orb);
    }

    /**
     * Get the FT endpoint selector factory
     *
     * @return the name of the FT_endpoint_selector_factory for the ORB
     */
    public static String GetFTEndpointSelectorFactory() {
        return ORBSpecificFTConfiguration.GetFTEndpointSelectorFactory();
    }

    /**
     * Activate the FT service
     *
     * @param args The list of parameter received of the command line
     */
    public static void ActivateFTService(String[] args) {
        ORBSpecificFTConfiguration.ActivateFTService(args);
    }
 
}; // namespace Cdmw


