/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ft;

public class FTLocation {
    /**
     *  hostname of the location
     */
    private String hostName;

    /**
     *  application name of the location
     */
    private String applicationName;

    /**
     *  process name of the location
     */
    private String processName;
    
    
    /**
     * Constructor
     */
    public FTLocation(String hostName,
                           String applicationName,
                           String processName) {
        this.hostName = hostName;
        this.applicationName = applicationName;
        this.processName = processName;
    }
    
    /**
     * get the FT location
     * @return the location in FT::Location type
     *
     */
    org.omg.CosNaming.NameComponent[] get_FT_Location() {
        org.omg.CosNaming.NameComponent[] loc = new org.omg.CosNaming.NameComponent[3];
        loc[0] = new org.omg.CosNaming.NameComponent();
        loc[0].id = this.hostName;
        loc[0].kind = "hostname";
        loc[1] = new org.omg.CosNaming.NameComponent();
        loc[1].id = this.applicationName;
        loc[1].kind = "applicationname";
        loc[2] = new org.omg.CosNaming.NameComponent();
        loc[2].id = this.processName;
        loc[2].kind = "processname";  

        return loc;
    }
}
