/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_CDMW_TEST_FT_COMMON_HPP
#define INCL_CDMW_TEST_FT_COMMON_HPP

// include files
#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"
// class definition


class TestFTCommon : public CppUnit::TestFixture
{
      
CPPUNIT_TEST_SUITE( TestFTCommon );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST( test_FallbackOid );
CPPUNIT_TEST( test_FallbackOid_with_GroupName );
CPPUNIT_TEST( test_UltimateFallbackFactory ); 
CPPUNIT_TEST( test_make_ref_object_key);
CPPUNIT_TEST( test_make_ref_corbaloc);
CPPUNIT_TEST( test_make_ref_ior);
     
CPPUNIT_TEST_SUITE_END();
      
   public:
      
      TestFTCommon();
      
      virtual ~TestFTCommon();
      
   protected:
      virtual void do_tests();
      void test_FallbackOid();
      void test_FallbackOid_with_GroupName();
      void test_UltimateFallbackFactory();
      void test_make_ref_object_key();
      void test_make_ref_corbaloc();
      void test_make_ref_ior();
      
   private:
      CORBA::ORB_var m_orb;
      PortableServer::POA_var m_rootPOA;
      int m_argc;
      char** m_argv;
};
#endif //INCL_CDMW_TEST_FT_COMMON_HPP

