/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testftcommon/TestHello_impl.hpp"
#include <Foundation/common/Assert.hpp>

#include <string>
#include <iostream>


namespace Cdmw
{


HelloInterface1_impl::HelloInterface1_impl(CORBA::ORB_ptr orb)
   throw(CORBA::SystemException)
   : m_orb(CORBA::ORB::_duplicate(orb)),
     m_current(PortableServer::Current::_nil())
{ 
   CDMW_ASSERT(!CORBA::is_nil(orb));    
   CORBA::Object_var obj =
      orb->resolve_initial_references("POACurrent");
   m_current = PortableServer::Current::_narrow(obj.in());
}

HelloInterface1_impl::~HelloInterface1_impl()
   throw()
{
}

char* HelloInterface1_impl::get_ObjectId ()
   throw(CORBA::SystemException)                  
{
    std::cout << "<####### HELLO 1 ######>" << std::endl;        
    PortableServer::ObjectId_var oid = m_current->get_object_id();
    CORBA::String_var s = PortableServer::ObjectId_to_string(oid.in());
    std::cout << "<####### HELLO 1 ######> " << __FUNCTION__ << "() Returning '"
              << s.in() << "'" << std::endl;   
    return s._retn();    
}
void HelloInterface1_impl::shutdown()
   throw(CORBA::SystemException)           
{
   m_orb->shutdown(false);
}

HelloInterface2_impl::HelloInterface2_impl()
    throw(CORBA::SystemException)
{ 
}

HelloInterface2_impl::~HelloInterface2_impl()
    throw()
{
}

void HelloInterface2_impl::hello ()
     throw(CORBA::SystemException)                  
{
    std::cout << "<####### HELLO 2 ######>" << std::endl;
}

}; // End namespace Cdmw

