/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>

// Cdmw Files
#include <testftlocationmanager2/SIM_PrimaryBackupGroupRepository.hpp>
//
// IDL:thalesgroup.com/CdmwFT:1.0
//
namespace Cdmw
{

namespace FT
{

//
// IDL:thalesgroup.com/CdmwFT/Location:1.0
//
namespace Location
{


    SIM_PrimaryBackupGroupRepository_impl::SIM_PrimaryBackupGroupRepository_impl()
    {
    }
    

    SIM_PrimaryBackupGroupRepository_impl::~SIM_PrimaryBackupGroupRepository_impl()
    {
    }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/GroupRepository/get_object_group:1.0
    //
     ::FT::ObjectGroup_ptr SIM_PrimaryBackupGroupRepository_impl::get_object_group(CORBA::Object_ptr member)
        throw(::FT::MemberNotFound,
              CORBA::SystemException)
     {
         std::cout<<"SIM_PrimaryBackupGroupRepository_impl::get_object_group"<<std::endl;
         return NULL;
     }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/GroupRepository/get_other_group_members:1.0
    //
     CdmwFT::MemberInfos* SIM_PrimaryBackupGroupRepository_impl::get_other_group_members(CORBA::Object_ptr member)
        throw(::FT::MemberNotFound,
              CORBA::SystemException)
     {
         std::cout<<"SIM_PrimaryBackupGroupRepository_impl::get_other_group_members"<<std::endl;
         return NULL;
     }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/GroupRepository/get_object_group_version:1.0
    //
     ::FT::ObjectGroupRefVersion SIM_PrimaryBackupGroupRepository_impl::get_object_group_version(CORBA::Object_ptr member)
        throw(::FT::MemberNotFound,
              CORBA::SystemException)
     {
         std::cout<<"SIM_PrimaryBackupGroupRepository_impl::get_object_group_version"<<std::endl;
         return 0;
     }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/GroupRepository/get_object_group_from_gid:1.0
    //
     ::FT::ObjectGroup_ptr SIM_PrimaryBackupGroupRepository_impl::get_object_group_from_gid(::FT::ObjectGroupId object_group_id)
        throw(::FT::ObjectGroupNotFound,
              CORBA::SystemException)
     {
         std::cout<<"SIM_PrimaryBackupGroupRepository_impl::get_object_group_from_gid"<<std::endl;
         return NULL;
     }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/GroupRepository/get_other_group_members_from_gid:1.0
    //
     CdmwFT::MemberInfos* SIM_PrimaryBackupGroupRepository_impl::get_other_group_members_from_gid(::FT::ObjectGroupId object_group_id)
        throw(::FT::ObjectGroupNotFound,
              CORBA::SystemException)
     {
         std::cout<<"SIM_PrimaryBackupGroupRepository_impl::get_other_group_members_from_gid"<<std::endl;
         return NULL;
     }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/GroupRepository/get_object_group_version_from_gid:1.0
    //
     ::FT::ObjectGroupRefVersion SIM_PrimaryBackupGroupRepository_impl::get_object_group_version_from_gid(::FT::ObjectGroupId object_group_id)
        throw(::FT::ObjectGroupNotFound,
              CORBA::SystemException)
     {
         std::cout<<"SIM_PrimaryBackupGroupRepository_impl::get_object_group_version_from_gid"<<std::endl;
         return 0;
     }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/SIM_PrimaryBackupGroupRepository/is_primary:1.0
    //
     CORBA::Boolean SIM_PrimaryBackupGroupRepository_impl::is_primary(CORBA::Object_ptr member)
        throw(::FT::MemberNotFound,
              CORBA::SystemException)
     {
         std::cout<<"SIM_PrimaryBackupGroupRepository_impl::is_primary"<<std::endl;
         return true;
     }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/SIM_PrimaryBackupGroupRepository/is_primary_from_gid:1.0
    //
     CORBA::Boolean SIM_PrimaryBackupGroupRepository_impl::is_primary_from_gid(::FT::ObjectGroupId object_group_id)
        throw(::FT::ObjectGroupNotFound,
              CORBA::SystemException)
     {
         std::cout<<"SIM_PrimaryBackupGroupRepository_impl::is_primary_from_gid"<<std::endl;
         return true;
     }
    
    CdmwFT::ReplicationManager* SIM_PrimaryBackupGroupRepository_impl::the_replication_manager()
        throw(CORBA::SystemException)

    {
        std::cout<<"SIM_PrimaryBackupGroupRepository_impl::the_replication_manager"<<std::endl;
        return NULL;
    }
    
    
    ::FT::Location* SIM_PrimaryBackupGroupRepository_impl::the_location()
        throw(CORBA::SystemException)
    {
        std::cout<<"SIM_PrimaryBackupGroupRepository_impl::the_location"<<std::endl;
        return NULL;
    }
    



} // End of namespace Location

} // End of namespace FT

} // End of namespace Cdmw

