/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "ftmanager/Method_Request_On_Switch_To_Primary.hpp"
#include <FaultTolerance/ftcommon/FTLogger.hpp>

#include <iostream>

namespace Cdmw {
namespace FT {
namespace Scheduler {

    Method_Request_On_Switch_To_Primary::Method_Request_On_Switch_To_Primary (Cdmw::FT::FTManager_impl* ftmanager)
        : m_ftmanager(ftmanager)
    {
    }
    

    Method_Request_On_Switch_To_Primary::~Method_Request_On_Switch_To_Primary (void)
        throw()
    {
    }
    

    void Method_Request_On_Switch_To_Primary::run (void)
        throw()
    {
        try {
            m_ftmanager->activate(); 
        } catch (const CORBA::Exception & ex) {
            CDMW_WARN(Cdmw::FT::FTLogger::GetLogger(),
                      "[FTManager/Method_Request_On_Switch_To_Primary]=> activate()"
                      << " raised an exception:\n   " 
                      << Cdmw::OrbSupport::OrbSupport::exception_to_string(ex));
        }
    }
    

}; // namespace Scheduler
}; // namespace FT
}; // namespace Cdmw

