/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _CDMW_FT_REPLICATION_MANAGER_LOCATIONINFOS_PRINTER_IMPL_HPP_
#define _CDMW_FT_REPLICATION_MANAGER_LOCATIONINFOS_PRINTER_IMPL_HPP_

#include <Foundation/commonsvcs/naming/NamingInterface.hpp>
#include "ftreplicationmanager/ReplicationManager_impl.hpp"
#include "ftreplicationmanager/ReplicationManagerDefinition.hpp"


namespace Cdmw {
namespace FT {


class LocationInfosPrinter
{
public:
    LocationInfosPrinter(std::ostream & os) : m_os(os) { }         
    void operator()(const std::pair< Cdmw::OrbSupport::type_traits< std::string >::_var_type, 
                                     Cdmw::OrbSupport::type_traits< ::CdmwFT::LocationInfo >::_var_type > & x)
    {
        m_os << "Location : " << x.first << "\n";
        
        switch ((x.second)->state)
        {
            case CdmwFT::LocationState_INITIAL :
                m_os << "\tState : INITIAL\n";
                break;
                
            case CdmwFT::LocationState_INSERTING_PRIMARY :
                 m_os << "\tState : INSERTING_PRIMARY\n";
                break;
               
            case CdmwFT::LocationState_PRIMARY :
                m_os << "\tState : PRIMARY\n";
                break;
    
            case CdmwFT::LocationState_INSERTING_BACKUP :
                m_os << "\tState : INSERTING_BACKUP\n";
                break;

            case CdmwFT::LocationState_BACKUP :
                m_os << "\tState : BACKUP\n";
                break;
            case CdmwFT::LocationState_FAILED :
                m_os << "\tState : FAILED\n";
                break;

                
        };

        m_os <<"\tIs first baskup : ";
        if ((x.second)->first_backup)
            m_os<<"YES\n";
        else
            m_os<<"NO\n";
        
        m_os <<"\tMember admin was registered :";
        if((x.second)->has_members_admin)
            m_os<<"YES\n";
        else
            m_os<<"NO\n";
        m_os<<std::endl;
    }

private:    
    std::ostream & m_os;
};

    
}; // namespace FT
}; // namespace Cdmw

#endif // _CDMW_FT_REPLICATION_MANAGER_LOCATIONINFOS_PRINTER_IMPL_HPP_

