/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TEST_RETENTION_ID_HPP
#define INCL_TEST_RETENTION_ID_HPP

#include <string>

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>

#include <idllib/FT.stub.hpp>
#include <idllib/CdmwFTReplicationManager.stub.hpp>
#include <testretentionid/RetentionIdTester.skel.hpp>


namespace CdmwFT {
namespace Test {

class TestRetentionId : public CppUnit::TestFixture
{
public:
    // constructor
    TestRetentionId();
    
    // destructor
    virtual ~TestRetentionId();

    // do_tests
    void test();
    void test_execption();
    void test_ami();
    void test_ami_exception();
    
private:
    TestRetentionId(const TestRetentionId&);
    void operator=(const TestRetentionId&);

    CORBA::ORB_var                      m_orb;
    CdmwFT::Test::RetentionIdTester_var m_tester;
    
CPPUNIT_TEST_SUITE(TestRetentionId  );
CPPUNIT_TEST( test );
CPPUNIT_TEST( test_execption );
//As AMI does not work with the RW default strategy those two tests has not to be run
//CPPUNIT_TEST( test_ami );
//CPPUNIT_TEST( test_ami_exception );
CPPUNIT_TEST_SUITE_END();
   
}; // end class 

}; // namespace Test

}; // namespace CdmwFT

#endif // CdmwFT::Test::RetentionIdTester

