/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#include "ftstatemanager/Method_Request_Synchronous_Get_Transaction_Status.hpp"
#include <FaultTolerance/ftcommon/FTLogger.hpp>


namespace Cdmw {
namespace FT {
namespace Scheduler {

Method_Request_Synchronous_Get_Transaction_Status::Method_Request_Synchronous_Get_Transaction_Status (
             Cdmw::FT::TransactionEngineCohort & tx_engine_cohort,
             const std::string & coordinator,
             const CdmwFT::Transaction::TransactionIdentification & id)
  : m_transaction_engine_cohort (tx_engine_cohort),
    m_coordinator_location(coordinator),
    m_id(id)
{
}

Method_Request_Synchronous_Get_Transaction_Status::~Method_Request_Synchronous_Get_Transaction_Status (void) 
   throw() 
{
}

void Method_Request_Synchronous_Get_Transaction_Status::run() 
   throw()
{
    m_transaction_engine_cohort.do_get_transaction_status_i(m_coordinator_location, m_id);
}





}; // namespace Scheduler
}; // namespace FT
}; // namespace Cdmw

