/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_CDMW_TEST_TRANS_ENGINE_HPP
#define INCL_CDMW_TEST_TRANS_ENGINE_HPP

// include files
#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"

#if CDMW_ORB_VDR == tao
#include "PortableGroupC.h"
#include "PortableGroupS.h"
#include "PortableGroupS_T.h"
#endif

// class definition

class TestTransEngine : public CppUnit::TestFixture
{

public:
  TestTransEngine();
  
  virtual ~TestTransEngine();

protected:
  virtual void do_tests();

private:
    CORBA::ORB_var m_orb;
    PortableGroup::GOA_var m_rootGOA;

CPPUNIT_TEST_SUITE( TestTransEngine );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();
};
#endif //INCL_CDMW_TEST_TRANS_ENGINE_HPP

