/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _CDMW_FT_ULTIMATEFALLBACK_FALLBACKHELPER_HPP_
#define _CDMW_FT_ULTIMATEFALLBACK_FALLBACKHELPER_HPP_

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/CosNaming.stub.hpp>
#include <FaultTolerance/ftcommon/FallbackOid.hpp>

namespace Cdmw {
namespace FT {
namespace UltimateFallback {

   /**
    * 
    */
   class FallbackHelper
   {
      public:

         static CORBA::Object_ptr 
         Get_taget_object(CosNaming::NamingContextExt_ptr root,
                          const FallbackOid & foid)
            throw (CORBA::SystemException);

      private:
         // Default constructor.
         FallbackHelper(void)
            throw();
        
         // Hide the copy constructor.
         FallbackHelper(const FallbackHelper & fh)
            throw();
        
         // Hide the copy assignment operator.
         FallbackHelper &
         operator=(const FallbackHelper & fh)
            throw();
   };

}; // namespace UltimateFallback
}; // namespace FT
}; // namespace Cdmw

#endif // _CDMW_FT_ULTIMATEFALLBACK_FALLBACK_IMPL_HPP_

