/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <FaultTolerance/ftwatchdog/RequestTimeoutLocalPullMonitorable_impl.hpp>
#include <FaultTolerance/ftcommon/FTLogger.hpp>
#include <Foundation/logging/FunctionLogger.hpp>

#include "ftwatchdog/FTRequestTimeoutLogger.hpp"

namespace Cdmw
{
    
namespace FT
{

namespace Watchdog
{

    //
    // Constructor
    //
    RequestTimeoutLocalPullMonitorable_impl::RequestTimeoutLocalPullMonitorable_impl() 
        throw()
    {
    }

    //
    // Destructor
    //
    RequestTimeoutLocalPullMonitorable_impl::~RequestTimeoutLocalPullMonitorable_impl()
        throw()
    {
    }

    /**
     * Purpose:
     * <p> to call to check if object is still living that is a request
     * doesn't spend more time than the timeout specified.
     * 
     *@exception CORBA::SystemException
     *
     */ 
     CORBA::Boolean RequestTimeoutLocalPullMonitorable_impl::is_alive ()
         throw(CORBA::SystemException)
     {
         CDMW_LOG_FUNCTION(FTLogger::GetLogger(),"");
         CORBA::Boolean is_timeout 
             = RequestTimeoutLogger::Get_instance()->check_timeouts_expiration();
         return !is_timeout;
     }


} // End of namespace Watchdog

} // End of namespace FT

} // End of namespace Cdmw    
