/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ft.watchdog.test.testtimeoutrequest;

import java.io.*;

import org.omg.CORBA.*;
import org.omg.FT.*;

import com.thalesgroup.CdmwFT.Test.ComputInterfacePOA;

import cdmw.orbsupport.ExceptionMinorCodes;
import cdmw.ossupport.OS;

public class ComputInterfaceImpl extends ComputInterfacePOA {
    
    private ORB orb;
    private String location;
    
    /**
     * Purpose:
     * <p> [Constructor description if necessary]
     * 
     *@param
     **/ 
    public ComputInterfaceImpl(ORB orb, String location) {
        this.orb = orb;
        this.location = location;
    }
 
    //
    // IDL:thalesgroup.com/CdmwFT/Test/Comput/hello:1.0
    //
    public int get_result(int timeMs) throws SystemException {
        FileWriter fw = null;
        try {
            fw = new FileWriter("comput.stt");
            fw.write(this.location);
            fw.close();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        
        System.out.println(this.location + " <####### Comput " + timeMs + "  ######>");
        try {
            OS.sleep((int)timeMs);
        }
        catch (InterruptedException e) {
             e.printStackTrace();
        }
        System.out.println(this.location + " <####### End of Comput " + timeMs + "  ######>");
        
        return timeMs;
    }    
}
