/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <faulttoleranceserver/HelloThread.hpp>
#include <Foundation/commonsvcs/naming/NamingInterface.hpp>

namespace Cdmw
{

namespace FT
{

namespace FTInit
{

        
HelloThread::HelloThread(CORBA::ORB_ptr orb, const ::FT::Location & the_location)
   : m_orb(CORBA::ORB::_duplicate(orb)),
     m_name(Cdmw::CommonSvcs::Naming::NamingInterface::to_string(the_location))
{    
}


HelloThread::~HelloThread() 
throw() 
{
} 


void
HelloThread::shutdown() 
{
    m_orb->shutdown(true);
    m_orb->destroy();
}

void
HelloThread::run() 
    throw() 
{
    std::cout << m_name << " test_server: running..."<<std::endl;
    m_orb->run();   
}

    
} // end of namespace FT

} // end of namespace FTInit

} // end of namespace Cdmw

