/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_TESTFTREPOSITORY_THREAD_HPP
#define INCL_TESTFTREPOSITORY_THREAD_HPP

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"
#include "Foundation/osthreads/Thread.hpp"

#include "testftservers/TestFTRepository.hpp"


class TestFTRepositoryThread : public Cdmw::OsSupport::Thread
{

public:
        
    TestFTRepositoryThread(
        CORBA::ORB_ptr orb,
        PortableServer::POA_ptr rootPOA,
        const std::string&  name)
        :  m_orb( CORBA::ORB::_duplicate( orb ) ),
           m_rootPOA( PortableServer::POA::_duplicate( rootPOA ) ),
           m_test_name(name)
           
    {
        
    }
    
    virtual ~TestFTRepositoryThread()
        throw()
    {
    }

protected:

    void run() throw()
    {
        // Do test
        Cdmw::TestUtils::CORBATestManager::instance()->run_tests();
        Cdmw::TestUtils::CORBATestManager::instance()->summary();
    }
        
private:

    CORBA::ORB_var m_orb;
    PortableServer::POA_var m_rootPOA;
    std::string m_test_name;
    
};

#endif //INCL_TESTFTREPOSITORY_THREAD_HPP

