/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <fstream>

// Cdmw Files
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>
#include <Foundation/ossupport/OS.hpp>

#include <testtimeoutrequest/TestComput_impl.hpp>


namespace Cdmw
{
namespace Test
{



ComputInterface_impl::ComputInterface_impl(CORBA::ORB_ptr orb, 
                                         std::string location)
    throw(CORBA::SystemException)
    : m_orb(CORBA::ORB::_duplicate(orb)),
      m_location(location)
{ 
}


ComputInterface_impl::~ComputInterface_impl()
    throw()
{
}

CORBA::Long
ComputInterface_impl::get_result (CORBA::ULong time_ms)
     throw(CORBA::SystemException)                  
{
    // export the location to a file
    std::ofstream os("comput.stt");
    os << m_location;
    os.close();

    // export the location to a file
    std::cout << m_location << " <####### Comput " << time_ms <<"  ######>" << std::endl;
    Cdmw::OsSupport::OS::sleep(time_ms);

    std::cout << m_location << " <####### End of Comput " << time_ms <<"  ######>" << std::endl;

    return time_ms;
}



}; // End namespace Test

}; // End namespace Cdmw

