/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.valid.testtimeoutrequest;

import java.io.FileWriter;
import java.io.IOException;

import org.omg.CORBA.*;

import cdmw.orbsupport.*;

import com.thalesgroup.CdmwFT.Location.*;
import com.thalesgroup.CdmwFT.Test.ComputInterface;
import com.thalesgroup.CdmwFT.Test.HelloInterfacePOA;

public class HelloInterfaceImpl extends HelloInterfacePOA {

    private ORB orb;

    private String location;

    private int hello;

    public HelloInterfaceImpl(
        ORB orb, String location) {
        this.orb = orb;
        this.location = location;
        this.hello = 0;
    }

    //
    // IDL:thalesgroup.com/CdmwFT/Test/Hello/hello:1.0
    //
    public void hello(ComputInterface comput, int timeMs) {
        try {
            FileWriter fw = new FileWriter("hello.stt");
            fw.write(this.location);
            fw.close();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        this.hello++ ;
        System.out.println(location+" <####### HELLO " + this.hello + "  ######>");

        long result = comput.get_result(timeMs);
        System.out.println("result = " + result);

    }

    public void send_TRANSIENT_exception() {
        // TODO Auto-generated method stub
        throw new TRANSIENT(0, CompletionStatus.COMPLETED_MAYBE);
    }
}
