/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef _CDMW_FOUNDATION_COMMON_CONFIG_HPP_
#define _CDMW_FOUNDATION_COMMON_CONFIG_HPP_

/*
 * This file contains all the configuration needed by CARDAMOM in
 * order to adapt to different compilers and operating systems.
 *
 * NOTE: This file could/should be generated by the CARDAMOM build.
 */

#if defined (__GNUC__)
#if (__GNUC__ < 4)

// Sadly, GCC does not support the template exports yet.
#   define CDMW_TEMPLATE_EXPORT

// On currently supported platforms, CARDAMOM relies on the template
// inclusion model
#   define CDMW_USES_TEMPLATE_INCLUSION_MODEL 1
#endif /* (__GNUC__ <= 3) && (__GNUC_MINOR__ < 3) */
#else
#error COMPILER NOT SUPPORTED!!!
#endif /* defined (__GNUC__) */

#if defined(WIN32) && defined(USE_DLL)
# ifdef CDMW_EXPORTS
#   define CDMW_API __declspec(dllexport)
# else
#   define CDMW_API __declspec(dllimport)
# endif
#else
# define CDMW_API
#endif


#endif /* _CDMW_FOUNDATION_COMMON_CONFIG_HPP_ */
