/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */




#ifndef CDMW_COMMON_MACRO_DEFS_H
#define CDMW_COMMON_MACRO_DEFS_H

//
// Message printed in a #error directive in case of not implemented
//  feature
//
#define CDMW_NOT_IMPLEMENTED_FEATURE " Cdmw; Feature not yet implemented"

#ifdef sun
#   ifndef CDMW_POSIX
#       define CDMW_POSIX
#   endif
#   define CDMW_POSIX_THREAD
#   define CDMW_POSIX_SOLARIS_THREAD
#   define CDMW_HAVE_THREAD_STACK
#endif

#ifdef linux
#   ifndef CDMW_POSIX
#       define CDMW_POSIX
#   endif
#   define CDMW_POSIX_THREAD
#   define CDMW_POSIX_LINUX_THREAD
// Now use new Linux NPTL
//#   undef  CDMW_HAVE_THREAD_STACK
#   define CDMW_HAVE_THREAD_STACK
#endif

#ifdef AIX
#   ifndef CDMW_POSIX
#       define CDMW_POSIX
#   endif
#   define CDMW_POSIX_THREAD
#   define CDMW_POSIX_AIX_THREAD
#   undef  CDMW_HAVE_THREAD_STACK
#endif

#ifdef _WIN32
#   define  CDMW_HAVE_THREAD_STACK
#endif


#define CDMW_JOIN( symbol1, symbol2 ) _CDMW_DO_JOIN( symbol1, symbol2 )

/// \internal
#define _CDMW_DO_JOIN( symbol1, symbol2 ) _CDMW_DO_JOIN2( symbol1, symbol2 )

/// \internal
#define _CDMW_DO_JOIN2( symbol1, symbol2 ) symbol1##symbol2

#define CDMW_MAKE_UNIQUE_NAME( prefix ) CDMW_JOIN( prefix, __LINE__ )

#endif
