/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "Foundation/common/Options.hpp"


namespace Cdmw
{

    namespace Common
    {

        /**
         *Implementation notes:  none 
         *<p>
         *Portability issues: none
         *<p>
         */

        // (1) Note that we must avoid an option name that is the beginning of another one
        const char* Options::CALLBACK_IOR_OPTION = "--CdmwCallbackIor";
        const char* Options::PROCESS_NAME_OPTION = "--CdmwProcessName";
        const char* Options::PROCESS_PORT_OPTION = "--CdmwProcessPort";
        const char* Options::SYSTEM_PORT_OPTION = "--CdmwSystemPort";
        const char* Options::PROCESS_XML_FILE_OPTION = "--CdmwXMLFile";
        const char* Options::VALIDATE_XML_OPTION = "--validateXML";
        const char* Options::LOCALISATION_SERVICE_OPTION = "--CdmwLocalisationService";
        const char* Options::LOG_FILE_OPTION = "--CdmwLogFile";
        const char* Options::LOG_LEVEL_OPTION = "--CdmwLogLevel";
        const char* Options::LOG_VERBOSE_OPTION = "--CdmwLogVerbose";
        const char* Options::DEFAULT_HOME_REGISTRATION_OPTION = "--DefaultHomeRegistration";
        const char* Options::SYSTEM_REGISTRATION_OPTION = "--CdmwSystemRegistration";
        const char* Options::FT_DOMAIN_OPTION = "--FTDomain";
        const char* Options::REQUEST_DURATION_TIME = "--RequestDurationTime";
        const char* Options::ORB_THREADS = "--CdmwORBThreads";

        // These will be set via SystemProperties use.
        // Parameter name follow names defined in SystemProperties.
        const char* Options::CDMW_THREADS_STACKSIZE = "--CdmwThreadsStacksize";
        // Orb and not ORB because see note (1) above
        const char* Options::ORB_THREADS_STACKSIZE = "--CdmwOrbThreadsStacksize";
        const char* Options::FTSTATEMNGR_SCHED_THREADS_STACKSIZE = "--CdmwFTSchedulerThreadsStacksize";
        const char* Options::FTSTATEMNGR_TIMER_THREAD_STACKSIZE = "--CdmwFTTimerThreadStacksize";
        const char* Options::FLUSHAREAMNGR_THREAD_STACKSIZE = "--CdmwTraceFlushAreaMngrThreadStacksize";
        
        const char* Options::LB_GROUP_MANAGER_CONF = "--CdmwLBXMLFile";
        const char* Options::PLUGIN_CONFIGURATION = "--CdmwPluginConf";
        const char* Options::SUPERVISION_CONF = "--CdmwConfFile";

        // LV
        // TODO this should be replaced by CdmwDaemonPort, and hard-coded 
        // "DaemonPort" declarations (see SystemMngt/platformftsystem, 
        // Repository/namingandrepositoryproxy, ... ?) should use that
        // 
        const char* Options::DAEMON_PORT_OPTION = "--DaemonPort";

    } // End namespace Common
} // End namespace Cdmw

