/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.common;

/**
 * Bad Parameter Exception
 *
 */
 public class BadParameterException extends Exception {

    /**
     * Constructor with the given parameter and its value
     *
     * @param parameterName  the name of the conflicting parameter
     * @param parameterValue the value of this parameter
     */
    public BadParameterException(String parameterName,String parameterValue) {
        super(Severity.SAFE, "Invalid parameter " +
            " (" + parameterName + "=" + parameterValue + ").");
     }

     /**
      * Constructor with the given parameter.
      *
      * @param m message to be printed when exception raised
      */
     public BadParameterException(String m) {
         super(Severity.SAFE, "Invalid parameter: "+ m);
     }

     /**
     * Default constructor.
     */
    public BadParameterException() {
        super(Severity.SAFE, "Invalid Parameter.");
     }

}

