/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_COMMONSVCS_DATASTORE_TEST_TESTDATASTORE_HPP
#define INCL_COMMONSVCS_DATASTORE_TEST_TESTDATASTORE_HPP

// include files
#include "Foundation/testutils/TestManager.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"
// class definition

class TestDataStore : public CppUnit::TestFixture
{

public:
  TestDataStore();
  
  virtual ~TestDataStore();

protected:
  virtual void do_tests();


CPPUNIT_TEST_SUITE( TestDataStore );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();


};

class DataStoreDumper :  public std::unary_function<std::pair<int, std::string> , void>
{
public:
    DataStoreDumper(std::ostream & os) : m_os(os) { }
    void operator()(const std::pair<int, std::string>&elt);

private:
    std::ostream & m_os;
};

#endif

