/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_NAMINGANDREPOSITORY_TEST_NAMINGINTERFACE_BINDCONTEXT_HPP
#define INCL_NAMINGANDREPOSITORY_TEST_NAMINGINTERFACE_BINDCONTEXT_HPP 

#include "Foundation/testutils/CORBATestManager.hpp"

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/CosNaming.stub.hpp"
#include "test_lib/TestObject.stub.hpp"

namespace Cdmw
{
namespace CommonSvcs
{
namespace Naming
{

/**
*Purpose:
*<p>    [class description]
*
*Features:
*<p> [Thread safety, exception safety, performance]
*    [if no pertinent write none ]
*
*@see  [if necessary] 
*@link [if necessary] 
*
*/
class TestNamingInterfaceBindContext : public CppUnit::TestFixture
{

    public:

        /**
        * Purpose:
        * <p> [Constructor description if necessary]
        * 
        *@param
        *@exception
        */ 
        TestNamingInterfaceBindContext()
                throw();

        /**
        * Purpose:
        * <p>  [Copy constructor description if necessary]
        * 
        *@param
        *@exception
        */ 
        TestNamingInterfaceBindContext(const TestNamingInterfaceBindContext& rhs)
                throw();


        /**
        * Purpose:
        * <p> [ Destructor description if necessary]
        * 
        */ 
        virtual 
        ~TestNamingInterfaceBindContext()
                throw();


        /**
        * Purpose:
        * <p> [ Assignement operator description if necessary]
        * 
        *@param
        *@return
        *@exception
        */ 
        TestNamingInterfaceBindContext&
        operator=(const TestNamingInterfaceBindContext& rhs)
                throw();


        /**
        * Purpose:
        * <p>
        * 
        *@param
        *@return
        *@exception
        */ 


        /**
        *[Attribute description]
        */ 


    protected:

        virtual void do_tests();
        
        void test_bind_new_context();
        void test_bind_context();
        void test_rebind_context();
        void test_new_context();

    private:

        CosNaming::NamingContext_var m_context;
        test::TestObject_var               m_test_object;

CPPUNIT_TEST_SUITE( TestNamingInterfaceBindContext );
CPPUNIT_TEST( test_bind_new_context );
CPPUNIT_TEST( test_bind_context );
CPPUNIT_TEST( test_rebind_context );
CPPUNIT_TEST( test_new_context );
CPPUNIT_TEST_SUITE_END();

}; // End class TestNamingInterfaceBindContext 

} // End namespace Naming
} // End namespace CommonSvcs
} // End namespace Cdmw
#endif // INCL_NAMINGANDREPOSITORY_TEST_NAMINGINTERFACE_BINDCONTEXT_HPP

