/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CDMW_COMMNSVCS_SERVICE_REGISTRATION_TESTSERVICEREGISTRATION_CONFIG_HPP
#define INCL_CDMW_COMMNSVCS_SERVICE_REGISTRATION_TESTSERVICEREGISTRATION_CONFIG_HPP

namespace Cdmw
{
   namespace CommonSvcs
   {
      namespace ServiceRegistration
      {
         namespace Config
         {
            const char* const SERVICE_LOCATOR_NAME = "ServiceLocator";
            const char* const SERVICE_CONTEXT_NAME = "ServiceNamigContext";
            const char* const Unknown_OBJ = "Unknown.obj";
            const char* const Unknown_CTXT = "Unknown.context";
            const char* const O1_OBJ = "O1.obj";
            const char* const O2_CTXT = "O2.context";
            const char* const O3_OBJ = "O3.obj";
            const char* const O4_OBJ = "O4.obj";
            const char* const LOCATOR_MIOP_ADDRESS_PROP="locator-service-address";
            const char* const REGISTRATION_MIOP_ADDRESS_PROP="registration-service-address";
            const char* const LOCATOR_DEFAULT_MIOP_ADDRESS="corbaloc:miop:1.0@1.0-TestDomain-5/225.1.1.8:4560";
            const char* const REGISTRATION_DEFAULT_MIOP_ADDRESS="corbaloc:miop:1.0@1.0-TestDomain-6/225.1.1.8:4561";
            const char* const NB_RETRIES_PROP = "nb_retries=";
            const int DEFAULT_NB_RETRIES = 4;
            const char* const TIME_INTERVAL_PROP = "time_interval=";
            const int DEFAULT_TIME_INTERVAL_ms = 350; // milliseconds
            
         }; // End namespace Config
      } // End namespace ServiceRegistration
   } // End namespace CommonSvcs
} // End namespace Cdmw

#endif // INCL_CDMW_COMMNSVCS_SERVICE_REGISTRATION_TESTSERVICEREGISTRATION_CONFIG_HPP

