/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_CDMW_COMMNSVCS_SERVICE_REGISTRATION_TESTSERVICEREGISTRATION_SERVICE_LOCATOR_IMPL_HPP
#define INCL_CDMW_COMMNSVCS_SERVICE_REGISTRATION_TESTSERVICEREGISTRATION_SERVICE_LOCATOR_IMPL_HPP


#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/idllib/CdmwServiceLocator.skel.hpp>
#include <Foundation/logging/Logger.hpp>

namespace Cdmw
{
   namespace  CommonSvcs
   {
      namespace ServiceRegistration
      {
        
        /** 
         * CARDAMOM Locator service.
         *
         * Helper interface to allow users to locate distributed services.
         */
         class  ServiceLocator_impl :
               public virtual POA_CdmwServiceLocator::ServiceLocator,
               public virtual PortableServer::RefCountServantBase
         {
            public :
               ServiceLocator_impl(CORBA::ORB_ptr orb,
                                   CosNaming::NamingContextExt_ptr root,
                                   const char * name);
               ~ServiceLocator_impl();
               /**
                *Purpose:
                *<p>
                * Implements the
                * IDL:thalesgroup.com/CdmwServiceLocator/ServiceLocator/locate_service:1.0
                * operation
                */    
               virtual void locate_service (const char * name,
                                            const char * sender)
                  throw(CORBA::SystemException);
            private:
               CORBA::ORB_var                  m_orb;
               CosNaming::NamingContextExt_var m_root;
               Cdmw::Logging::Logger *         m_logger;
         };
      } // End namespace ServiceRegistration
   } // End namespace CommonSvcs
} // End namespace Cdmw

#endif // INCL_CDMW_COMMNSVCS_SERVICE_REGISTRATION_TESTSERVICEREGISTRATION_SERVICE_LOCATOR_IMPL_HPP
