/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#include "testserviceregistration/Foo_impl.hpp"
namespace Cdmw
{
   namespace  CommonSvcs
   {
      namespace ServiceRegistration
      {
         Foo_impl::Foo_impl(CORBA::ORB_ptr          orb, 
                            PortableServer::POA_ptr poa, 
                            const char*             s)
            throw(CORBA::SystemException)
            : m_orb(CORBA::ORB::_duplicate(orb)), 
              m_poa(PortableServer::POA::_duplicate(poa)),
              m_name(s)
         {
         }
         Foo_impl::~Foo_impl()
            throw()
         {}
         
         char * Foo_impl::op(const char* s) throw (CORBA::SystemException)
         {
            return CORBA::string_dup(m_name.c_str());
         }
         void Foo_impl::shutdown() throw (CORBA::SystemException)
         {
            m_orb->shutdown(false);
         }
      } // End namespace ServiceRegistration
   } // End namespace CommonSvcs
} // End namespace Cdmw

