/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.logging.test.testfunctionlogger;

import cdmw.logging.*;

import cdmw.common.*;

import org.junit.Test;

import static org.junit.Assert.assertTrue;

public class TestFunctionLogger {

    @Test
    public void testFunctionLogger() {
        int retval, res;
        FunctionLoggerUser flu;

        System.out.println("Obtaining a default logger for the TEST_FUNCTION_LOGGER domain");

        Logger logger = Logger.Get_Logger("TEST_FUNCTION_LOGGER");

        assertTrue(logger != null);

        System.out.println("Calling the Function logger. VISUAL CHECK!.");

        flu = new FunctionLoggerUser (logger);

        System.out.println ("Calling op1 (with no return and no exception).");

        flu.op1();
        
        retval = 30;

        System.out.println ("Calling opReturn that returns value " + retval);
        res = flu.opReturn (20,10);
        assertTrue(res == retval);
 
        System.out.println ("Calling op_exception that should raise exception with value 50");

        try 
        { 
            flu.opException (50);
        }
        catch (java.lang.Exception ex)
        {
            //println ("Called opException. This raised an exception");
           assertTrue(ex.getMessage().equals("50"));
        }
    }
}
           
       
