/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _CDMW_FDS_LOGGING_TESTLOGMANAGER_LOGCOLLECTOR_HPP_
#define _CDMW_FDS_LOGGING_TESTLOGMANAGER_LOGCOLLECTOR_HPP_


#include <string>

#include <Foundation/osthreads/Mutex.hpp>
#include <Foundation/common/Exception.hpp>
#include <Foundation/logging/FilterMngr.hpp>
#include <Foundation/logging/CdmwLoggingCollector.skel.hpp>
#include <fstream>



namespace Cdmw
{
    namespace Logging
    {
        namespace Test
        {

            class LogCollector_impl:
                public virtual POA_CdmwLogging::LogCollector,
                public PortableServer::RefCountServantBase
            {
            public:

                /**
                 * Constructor.
                 */
                LogCollector_impl(std::string file_name);

                /**
                 * Constructor.
                 * @param file_name output log file
                 */
                LogCollector_impl();

                /**
                 * Destructor.
                 */
                ~LogCollector_impl()
                    throw();

                /**
                 * Send a message to the logger.
                 */
                virtual ::CORBA::Boolean add_log (
                    const ::CdmwLogging::StructuredLog & log
                    )
                    throw(::CORBA::SystemException);

            private:

                std::ofstream m_ofstream;
                std::ostream* m_postream;
                OsSupport::Mutex m_mutex;
            };

        } // namespace Test
    } // namespace Logging
} // namespace Cdmw


#endif // _CDMW_FDS_LOGGING_TESTLOGMANAGER_LOGCOLLECTOR_HPP_
