package cdmw.logging.test;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import cdmw.common.BadParameterException;
import cdmw.logging.*;

import com.thalesgroup.CdmwLogging.LogCollectorPOA;
import com.thalesgroup.CdmwLogging.StructuredLog;

public class LogCollectorImpl extends LogCollectorPOA {

    private BufferedWriter ofstream;

    public LogCollectorImpl(String fileName) {
        try {
            this.ofstream = new BufferedWriter(new FileWriter(fileName, false));
        }
        catch (IOException ioe) {
            System.err.println("Couldn't create log file " + fileName + ": " + ioe.getMessage());
        }
    }

    public boolean add_log(StructuredLog log) {
        boolean result = true;
        try
        {
            String buffer =
                log.ctx.application_name + "-" + log.ctx.process_name + "-"
                + log.header.component_name + "-" + log.header.user_domain + "-"
                + LogLevel.LevelToString(log.header.level) + ":" + log.message;

            synchronized (this) {
                if (this.ofstream != null) {
                    this.ofstream.write(buffer);
                    this.ofstream.newLine();
                    this.ofstream.flush();
                }
                else {
                    System.out.println(buffer);
                }
            }
        }
        catch (IOException e) {
            System.out.println("Cannot log message: " + e.getMessage());
            result = false;
        }

        return result;
    }

}
