/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_LOGGING_TESTORBLOGGING_TESTHELLO_IMPL_HPP
#define INCL_LOGGING_TESTORBLOGGING_TESTHELLO_IMPL_HPP

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountServantBase.hpp"

#include "testorblogging/TestHello.skel.hpp"

namespace Cdmw
{

    namespace Logging
    {

        /**
         *Purpose:
         *<p>    [class description]
         *
         *Features:
         *<p> [Thread safety, exception safety, performance]
         *    [if no pertinent write none ]
         *
         *@see  [if necessary] 
         *@link [if necessary] 
         *
         */

        class TestHello_impl :
            public virtual POA_Cdmw::TestHello,
            public virtual Cdmw::OrbSupport::RefCountServantBase
        {

        public:
            /**
             * Purpose:
             * <p> [Constructor description if necessary]
             * 
             *@param
             *@exception
             */
            TestHello_impl(CORBA::ORB_ptr orb)
                throw();


            /**
             * Purpose:
             * <p> [ Destructor description if necessary]
             * 
             */
            virtual
            ~TestHello_impl()
                throw();


            virtual
            void
            hello()
                throw(CORBA::SystemException);


            virtual
            void
            shutdown()
                throw(CORBA::SystemException);

        private:
            CORBA::ORB_var m_orb;

        const int m_userDefinedLevel;
        }; // End class TestHello_impl

    } // End namespace Logging
} // End namespace Cdmw

#endif // INCL_LOGGING_TESTORBLOGGING_TESTHELLO_IMPL_HPP

