/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_ORBSUPPORT_TESTORBLOGGINGDRIVER_HPP
#define INCL_ORBSUPPORT_TESTORBLOGGINGDRIVER_HPP

#include <string>

#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/orbsupport/CORBA.hpp>

#include "testorblogging/TestOrbLoggingDriver.hpp"

namespace Cdmw
{

    namespace Logging
    {

        /**
         *Purpose:
         *<p>    [class description]
         *
         *Features:
         *<p> [Thread safety, exception safety, performance]
         *    [if no pertinent write none ]
         *
         *@see  [if necessary] 
         *@link [if necessary] 
         *
         */

        class TestOrbLoggingDriver : public CppUnit::TestFixture
        {
            
        public:
            
            /**
             * Purpose:
             * <p> [Constructor description if necessary]
             * 
             *@param
             *@exception
             */
            TestOrbLoggingDriver();

            /**
             * Purpose:
             * <p> [ Destructor description if necessary]
             * 
             */
            virtual
            ~TestOrbLoggingDriver()
                throw();

            /**
             * Purpose:
             * <p>  [Copy constructor description if necessary]
             * 
             *@param
             *@exception
             */
            TestOrbLoggingDriver(const TestOrbLoggingDriver& rhs);


            /**
             * Purpose:
             * <p> [ Assignement operator description if necessary]
             * 
             *@param
             *@return
             *@exception
             */
            TestOrbLoggingDriver&
            operator=(const TestOrbLoggingDriver& rhs)
                throw();


            /**
             * Purpose:
             * <p>
             * 
             *@param
             *@return
             *@exception
             */
            virtual
            void
            do_tests();

        private:
            CORBA::ORB_var m_orb;
            std::string m_process_name;

CPPUNIT_TEST_SUITE( TestOrbLoggingDriver );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();

        }; // End class TestOrbLoggingDriver

    } // End namespace Logging
} // End namespace Cdmw

#endif // INCL_ORBSUPPORT_TESTORBLOGGINGDRIVER_HPP

