/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <orbsupport/MarshallingBuffer.hpp>
#include "tao/AnyTypeCode/Any_Impl.h"

namespace Cdmw {
    
   namespace OrbSupport {

      void 
      MarshallingBuffer::add_any(const CORBA::Any& value) {
         value.impl()->marshal_value( m_TaoOutputCdr);
      }
      
      CORBA::OctetSeq*
      MarshallingBuffer::get_buffer() {       
         CORBA::OctetSeq_var reply;
         ACE_NEW_NORETURN( reply, CORBA::OctetSeq( m_TaoOutputCdr.total_length() ) );
         
         reply->length( m_TaoOutputCdr.total_length());

         CORBA::Octet* buf = reply->get_buffer ();
       
         
         // @@ What if this throws an exception??
         // We don't have any way to check whether this succeeded
         
         for ( ACE_Message_Block const* mb = m_TaoOutputCdr.begin() ; mb != 0 ; mb = mb->cont())
         {
            ACE_OS::memcpy(buf, mb->rd_ptr(), mb->length());
            buf += mb->length();
         }
         
         return reply._retn();
      }

   }
}
