#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

echo "=========================================================="
echo "Test the PCR-0910 which was corrected with TAO151_0_061123"
echo "compiling idl..."

# uncomment these lines if you want to test a specific TAO 1.5 TAO_IDL
# version which is not the TAO_IDL version of your Cardamom environnement
#export FORCED_TAO_VERSION=TAO151_0_061123
#export LD_LIBRARY_PATH=/tools/exec/$FORCED_TAO_VERSION/lib:$LD_LIBRARY_PATH
#export ACE_ROOT=/tools/exec/$FORCED_TAO_VERSION/src
#export TAO_ROOT=$ACE_ROOT/TAO
#export PATH=$TAO_ROOT/TAO_IDL:$PATH

# set TAO gperf in path, just to avoid a TAO_IDL warning (apparently with TAO 1.5)
export PATH=$ACE_ROOT/apps/gperf/src:$PATH

tao_idl -DTAO -Ge 0 -Sc test.idl 
RESULT1=$?
echo tao_idl result is $RESULT1

echo "compiling generated code ..."
g++ -g -Wall  -I$ACE_ROOT -I$TAO_ROOT -c -o testC.o testC.cpp
RESULT2=$?
echo g++ result is $RESULT2

if [ "$RESULT1" = "0" -a "$RESULT2" = "0" ]; then 
    echo ">>>> Test result is set as TESTABLE_OK <<<<"
else
    echo "TEST FAILED"
fi

exit 0
