/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_ORBSUPPORT_TEST_CORBA_EXCEPTION_HELPER_HPP
#define INCL_ORBSUPPORT_TEST_CORBA_EXCEPTION_HELPER_HPP

#include "Foundation/testutils/CORBATestManager.hpp"

#define DECLARE_SYSTEM_EXCEPTION_TEST(name) void test_##name##_extraction() 

namespace Cdmw
{

    namespace OrbSupport
    {

        /**
        *Purpose:
        *<p>    [class description]
        *
        *Features:
        *<p> [Thread safety, exception safety, performance]
        *    [if no pertinent write none ]
        *
        *@see  [if necessary] 
        *@link [if necessary] 
        *
        */

        class TestCORBAExceptionHelper : public CppUnit::TestFixture
        {

            public:

                /**
                * Purpose:
                * <p> [Constructor description if necessary]
                * 
                *@param
                *@exception
                */
                TestCORBAExceptionHelper(  );


                /**
                * Purpose:
                * <p>  [Copy constructor description if necessary]
                * 
                *@param
                *@exception
                */
                TestCORBAExceptionHelper(const TestCORBAExceptionHelper& rhs);



                /**
                * Purpose:
                * <p> [ Destructor description if necessary]
                * 
                */
                virtual
                ~TestCORBAExceptionHelper()
                throw();


                /**
                * Purpose:
                * <p> [ Assignement operator description if necessary]
                * 
                *@param
                *@return
                *@exception
                */
                TestCORBAExceptionHelper&
                operator=(const TestCORBAExceptionHelper& rhs)
                throw();


                /**
                * Purpose:
                * <p>
                * 
                *@param
                *@return
                *@exception
                */
       DECLARE_SYSTEM_EXCEPTION_TEST(TRANSIENT);
       DECLARE_SYSTEM_EXCEPTION_TEST(BAD_PARAM);
       DECLARE_SYSTEM_EXCEPTION_TEST(BAD_INV_ORDER);
       DECLARE_SYSTEM_EXCEPTION_TEST(COMM_FAILURE);
       DECLARE_SYSTEM_EXCEPTION_TEST(INTERNAL);
       DECLARE_SYSTEM_EXCEPTION_TEST(OBJECT_NOT_EXIST);
       DECLARE_SYSTEM_EXCEPTION_TEST(NO_MEMORY);
       DECLARE_SYSTEM_EXCEPTION_TEST(IMP_LIMIT);
       DECLARE_SYSTEM_EXCEPTION_TEST(INV_OBJREF);
       DECLARE_SYSTEM_EXCEPTION_TEST(UNKNOWN);
       DECLARE_SYSTEM_EXCEPTION_TEST(NO_PERMISSION);
       DECLARE_SYSTEM_EXCEPTION_TEST(MARSHAL);
       DECLARE_SYSTEM_EXCEPTION_TEST(INITIALIZE);
       DECLARE_SYSTEM_EXCEPTION_TEST(NO_IMPLEMENT);
       DECLARE_SYSTEM_EXCEPTION_TEST(BAD_TYPECODE);
       DECLARE_SYSTEM_EXCEPTION_TEST(BAD_OPERATION);
       DECLARE_SYSTEM_EXCEPTION_TEST(NO_RESOURCES);
       DECLARE_SYSTEM_EXCEPTION_TEST(NO_RESPONSE);
       DECLARE_SYSTEM_EXCEPTION_TEST(PERSIST_STORE);
       DECLARE_SYSTEM_EXCEPTION_TEST(FREE_MEM);
       DECLARE_SYSTEM_EXCEPTION_TEST(INV_IDENT);
       DECLARE_SYSTEM_EXCEPTION_TEST(INV_FLAG);
       DECLARE_SYSTEM_EXCEPTION_TEST(INTF_REPOS);
       DECLARE_SYSTEM_EXCEPTION_TEST(BAD_CONTEXT);
       DECLARE_SYSTEM_EXCEPTION_TEST(OBJ_ADAPTER);
       DECLARE_SYSTEM_EXCEPTION_TEST(DATA_CONVERSION);
       DECLARE_SYSTEM_EXCEPTION_TEST(TRANSACTION_REQUIRED);
       DECLARE_SYSTEM_EXCEPTION_TEST(TRANSACTION_ROLLEDBACK);
       DECLARE_SYSTEM_EXCEPTION_TEST(INVALID_TRANSACTION);
       DECLARE_SYSTEM_EXCEPTION_TEST(INV_POLICY);
       DECLARE_SYSTEM_EXCEPTION_TEST(CODESET_INCOMPATIBLE);

              void test_ForwardRequest_extraction();

                
                /**
                *[Attribute description]
                */


            protected:


            private:

CPPUNIT_TEST_SUITE( TestCORBAExceptionHelper );

CPPUNIT_TEST( test_TRANSIENT_extraction );
CPPUNIT_TEST( test_BAD_PARAM_extraction );
CPPUNIT_TEST( test_BAD_INV_ORDER_extraction );
CPPUNIT_TEST( test_COMM_FAILURE_extraction );
CPPUNIT_TEST( test_INTERNAL_extraction );
CPPUNIT_TEST( test_OBJECT_NOT_EXIST_extraction );
CPPUNIT_TEST( test_NO_MEMORY_extraction );
CPPUNIT_TEST( test_IMP_LIMIT_extraction );
CPPUNIT_TEST( test_INV_OBJREF_extraction );
CPPUNIT_TEST( test_UNKNOWN_extraction );
CPPUNIT_TEST( test_NO_PERMISSION_extraction );
CPPUNIT_TEST( test_MARSHAL_extraction );
CPPUNIT_TEST( test_INITIALIZE_extraction );
CPPUNIT_TEST( test_NO_IMPLEMENT_extraction );
CPPUNIT_TEST( test_BAD_TYPECODE_extraction );
CPPUNIT_TEST( test_BAD_OPERATION_extraction );
CPPUNIT_TEST( test_NO_RESOURCES_extraction );
CPPUNIT_TEST( test_NO_RESPONSE_extraction );
CPPUNIT_TEST( test_PERSIST_STORE_extraction );
CPPUNIT_TEST( test_FREE_MEM_extraction );
CPPUNIT_TEST( test_INV_IDENT_extraction );
CPPUNIT_TEST( test_INV_FLAG_extraction );
CPPUNIT_TEST( test_INTF_REPOS_extraction );
CPPUNIT_TEST( test_BAD_CONTEXT_extraction );
CPPUNIT_TEST( test_OBJ_ADAPTER_extraction );
CPPUNIT_TEST( test_DATA_CONVERSION_extraction );
CPPUNIT_TEST( test_TRANSACTION_REQUIRED_extraction );
CPPUNIT_TEST( test_TRANSACTION_ROLLEDBACK_extraction );
CPPUNIT_TEST( test_INVALID_TRANSACTION_extraction );
CPPUNIT_TEST( test_INV_POLICY_extraction );
CPPUNIT_TEST( test_CODESET_INCOMPATIBLE_extraction );

CPPUNIT_TEST( test_ForwardRequest_extraction );

CPPUNIT_TEST_SUITE_END();

        }; // End class TestCORBAExceptionHelper

    } // End namespace OrbSupport
} // End namespace Cdmw

#endif // INCL_ORBSUPPORT_TEST_CORBA_EXCEPTION_HELPER_HPP

