/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testorbsupport/TestStringToObj.hpp"


#include <fstream>
#include <sstream>
#include <string>
#include <vector>

#include "Foundation/orbsupport/StrategyList.hpp"
#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"

#include "Foundation/common/System.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/ossupport/OS.hpp"

namespace Cdmw
{

    namespace OrbSupport
    {

        /**
        *Implementation notes: [if no pertinent write none ]
        *<p>
        *Portability issues: [if no pertinent write none ]
        *<p>
        */

        CPPUNIT_TEST_SUITE_REGISTRATION( TestStringToObj );
        
        int argc_1 = 1;
        char **argv_1;
        
        void 
        TestStringToObj::setUp()
        {
            StrategyList strategies;
            strategies.add_OrbThreaded();
            strategies.add_PoaThreadPool(5);

            argv_1 = new char* [2];
            const char * name = "dummy_name";
            argv_1[0] = new char[strlen(name)+ 1 ];
            argv_1[1] = 0;
            strcpy(argv_1[0],name);
            m_orb = OrbSupport::ORB_init(argc_1, (char**)argv_1, strategies);
        }

        void 
        TestStringToObj::tearDown()
        {
            delete [] argv_1[0];
            delete [] argv_1;

            m_orb->shutdown(false);
            OrbSupport::OrbSupport::ORB_cleanup(m_orb.in());
            m_orb->destroy();
        }

        void
        TestStringToObj::string_to_object_1()
        {
           CORBA::Object_var obj;
           try
           {
              obj = m_orb->string_to_object("corbaname::localhost:1879#XXXX/YYYY");
           }
           catch (...)
           {
              CPPUNIT_ASSERT(false && "Bad format for stringified reference");
           }
           // Check that reference is nil.

           CPPUNIT_ASSERT( CORBA::is_nil(obj.in()) );
        }

        void
        TestStringToObj::string_to_object_2()
        {
           CORBA::Object_var obj;
           try
           {
              obj = m_orb->string_to_object("corbaname::localhost:1879#");
           }
           catch (...)
           {
              CPPUNIT_ASSERT(false && "Bad format for stringified reference");
           }
           // Check that reference is nil.
           CPPUNIT_ASSERT( CORBA::is_nil(obj.in()) );
        }
    } // End namespace OrbSupport
} // End namespace Cdmw

