/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.orbsupport.test;

import cdmw.ossupport.OS;

public class MainTest {
    
    public static void main(String[] args) {
        try {
            // Are we started as the CORBA server ?
            if ( OS.getOptionValue( args, "--server").equals("yes") ) {
                System.out.println("Java server started");
                ServerProcess serverp = new ServerProcess();
                try {
                    serverp.start( args );
                }
                catch(org.omg.CORBA.UserException ue) {
                    ue.printStackTrace();
                }

            // Else, we are the main test driver
            } else {
                System.out.println("Java client started");
                
                TestAnyValueTypePassingDriver driver = new TestAnyValueTypePassingDriver();
                driver.start();
                
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}

