/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_OSSUPPORT_ENDINGCALLBACK_HPP
#define INCL_OSSUPPORT_ENDINGCALLBACK_HPP

#include <Foundation/ossupport/ProcessCallback.hpp>

namespace Cdmw
{

    namespace OsSupport
    {

        /**
        *Purpose:
        *<p> 
        * The callback that may be attached to the ending of a process.
        */

        class EndingCallback: public ProcessCallback
        {

            public:

                /**
                * Purpose:
                * <p> Gets the process exit code.
                */
                virtual int get_exit_code ()
                {
                    return m_exit_code;
                }

                /**
                * Purpose:
                * <p> Sets the process exit code.
                */
                virtual void set_exit_code (int exit_code)
                {
                    m_exit_code=exit_code;
                }

            private:
                /**
                * Store process exit_code.
                */
                int m_exit_code; 
                

        }; // End class EndingCallback

    } // End namespace OsSupport
} // End namespace Cdmw

#endif // INCL_OSSUPPORT_ENDINGCALLBACK_HPP


