/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.ossupport;

import java.io.File;
import java.io.PrintStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import java.util.Vector;

import java.net.InetAddress;
import java.net.UnknownHostException;


public class PrintStreamThread extends Thread {
        

    /**
     * Boolean variable indicating if the thread is stopped or not
     */
    private boolean stoppedThread = false;

    /**
     * Stops the thread
     */
    public void stopThread() 
    {
       stoppedThread = true;
    }
        
    /**
     * Checks if the thread has been stopped
     */
    private boolean isStopped() 
    {
       return stoppedThread;
    }
        
    /**
     * Reader which provides data to be read
     */
    private BufferedReader reader;
    
    /**
     * PrintStream object
     */
     private PrintStream out;
    
     /**
      * Constructor
      *
      * @param reader Buffered reader of the data.
      * @param out PrintStream object to print the input data.
      */
      public PrintStreamThread(BufferedReader reader, PrintStream out) {
           this.reader = reader;
           this.out = out;
      }
    
     /**
      * Every line read is sent to the PrintStream object.
      */
      public void run() 
      {
           String line = null;

            try 
            {
                while   (  (! (isStopped()) ) &&  (line = reader.readLine()) != null ) 
                { 
                        out.println(line);
                } 
            } 
            catch(IOException ioe) 
            {
                ioe.printStackTrace(out);
            }
      }
}

