/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testossupport/TestOS.hpp"

#include <cstdio>
#include <fstream>

#include "Foundation/common/MacroDefs.hpp"
#include "Foundation/ossupport/OS.hpp"
#include "Foundation/common/String.hpp"
 

using namespace Cdmw::OsSupport;
        
CPPUNIT_TEST_SUITE_REGISTRATION( TestOS );
        
TestOS::TestOS( )
{
}


TestOS::~TestOS()
throw()
{
}

void
TestOS::test_get_pid()
{
  /*
  std::cout<<"My pid before is: "<<getpid()<<std::endl;

  fork();

  std::cout<<"My pid after is: "<<getpid()<<std::endl;
  */

  int refPid[]={0,0};
  refPid[0] = OS::get_processId();
  const static int prevPid = refPid[0];
  std::cout<<"My pid before is: "<< refPid[0] <<std::endl;

  if( (refPid[1] = fork()) < 0)
  {
      CPPUNIT_FAIL("Error with fork");
  }
   
  if(!refPid[1]) // I'm in the child
{
      std::cout<<"My pre fork pid was: "<< prevPid <<std::endl;
      std::cout<<"My child pid is: "<<  OS::get_processId() <<std::endl;
      
      CPPUNIT_ASSERT_MESSAGE( "Assume get_process and fork pid are equal", OS::get_processId() != prevPid );
      refPid[1]=OS::get_processId();
      std::cout<<"My pid is: "<< refPid[1] <<std::endl;
      // not zero nor equals
      CPPUNIT_ASSERT( (refPid[1] && refPid[0]) &&
                      (refPid[1] != refPid[0]));
  }
  else
     exit(0);
}
