/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.ossupport.test;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import static org.junit.Assert.assertTrue;

import cdmw.ossupport.OS;
import cdmw.ossupport.Mutex;
//import cdmw.ossupport.MutexGuard;

import cdmw.testutils.TestManager;

public class MutexTest {
    private static int timescale;
    
    @BeforeClass
    public static void initTests() {
        timescale = TestManager.getTimescale();
        System.out.println("===================================================");
        System.out.println("Starting test " + MutexTest.class.getName());
        System.out.println("===================================================");        
    }

    @AfterClass
    public static void finiTests() {
        System.out.println("===================================================");
        System.out.println("Ending test " + MutexTest.class.getName());
        System.out.println("===================================================");        
    }

    /*
    public void doTestWithGuard()
        throws InterruptedException {

        System.out.println("Creating a Mutex");
        Mutex mutex = new Mutex();

        System.out.println("Locking the mutex");
        mutex.lock();

        System.out.println("Creating a thread using automatic lock/unlock of a thread");
        int val = 0;
        MutexGuardThread mgt = new MutexGuardThread(mutex, val);

        System.out.println("Starting the thread");
        mgt.start();

        System.out.println("Sleeping a while to see if the thread changes the variable");
        OS.sleep(getTimescale() * 2000);

        check( mgt.getVal() == 0 );

        System.out.println("Unlocking the mutex");
        mutex.unlock();

        System.out.println("Sleeping a while to see if the thread changes the variable");
        OS.sleep(getTimescale() * 2000);

        check( mgt.getVal() != 0 );

        System.out.println("Waiting for the completion of the thread");
        mgt.join();

    }
    */

    @Test
    public void doTestWithoutGuard()
        throws InterruptedException {

        System.out.println("Creating a Mutex");
        Mutex mutex = new Mutex();

        System.out.println("Ckech the mutex is unlock");
        assertTrue(!mutex.is_locked());

        System.out.println("Locking the mutex");
        mutex.lock();

        System.out.println("Ckech the mutex is lock");
        assertTrue(mutex.is_locked());

        System.out.println("Creating a thread with the mutex as reference and a variable to be changed");
        int val = 0;
        MutexThread mt = new MutexThread(mutex, val);

        System.out.println("Starting the thread");
        mt.start();

        System.out.println("Sleeping a while to see if the thread changes the variable");
        OS.sleep(timescale * 2000);

        assertTrue(mt.getVal() == 0);

        System.out.println("Unlocking the mutex");
        mutex.unlock();

        System.out.println("Ckech the mutex is unlock");
        assertTrue(!mutex.is_locked());

        System.out.println("Sleeping a while to see if the thread changes the variable");
        OS.sleep(timescale * 2000);

        assertTrue(mt.getVal() != 0);

        System.out.println("Waiting for the completion of the thread");
        mt.join();
    }
}

