/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.ossupport.test;

import java.util.Random;

import cdmw.ossupport.ReadWriteLock;
import cdmw.ossupport.OS;
import cdmw.testutils.TestManager;

public class WriterThread extends Thread {

    private ReadWriteLock lock;
    private ReadWriteLockThread test;
    private int nbLocks;

    WriterThread(ReadWriteLock rwl,ReadWriteLockThread rwlt,int nb) {

        this.lock = rwl;
        this.test = rwlt;
        this.nbLocks = nb;

    }

    public void run() {

        try {
            for(int i=0; i < nbLocks; i++) {
                lock.writeLock();

                test.incrementWriter();
                OS.sleep(TestManager.getTimescale() * getSleepTime());
                test.decrementWriter();

                lock.writeUnlock();
                OS.sleep(TestManager.getTimescale() * getSleepTime());

            }
        } catch(InterruptedException ie) {}

    }

    public int getSleepTime() {

        // We return a value between 0 and 3 seconds
        return new Random().nextInt(4);

    }


}

