/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CDMW_OS_THREAD_TEST_ATOMIC_COUNT_HPP
#define INCL_CDMW_OS_THREAD_TEST_ATOMIC_COUNT_HPP

#include <iostream>
#include <string>

#include <cppunit/extensions/HelperMacros.h>

namespace Cdmw
{
    namespace TestOsThread
    {

    /*
       Uses a pool of thread to perform concurrent access over 
       a shared resources (an int and an atomic counter).
       Try to fill a structure (a vector)
     */
        class TestAtomicCount 
            : public CppUnit::TestFixture
        {
            CPPUNIT_TEST_SUITE( TestAtomicCount  );
                CPPUNIT_TEST( ac_long_like );
            // Hmmm, I don't know if make sense
            // if problem: is thread, is atomic count, is test?
            //  CPPUNIT_TEST( ac_in_action );
            CPPUNIT_TEST_SUITE_END( );

            public:
            
                void  setUp();
                void  ac_in_action();
                void  ac_long_like();
                void  tearDown() ;
        };   
    } // end of TestOsThread
} // end  of Cdmw

#endif /* INCL_CDMW_OS_THREAD_TEST_ATOMIC_COUNT_HPP */
