/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "Foundation/osthreads/Thread.hpp"
#include "Foundation/osthreads/ReaderWriterRecursiveMutex.hpp"
#include "Foundation/osthreads/ReaderRecursiveLockGuard.hpp"
#include "Foundation/osthreads/WriterRecursiveLockGuard.hpp"
#include "Foundation/testutils/TestManager.hpp"

namespace Cdmw
{

    namespace OsSupport
    {

        /**
        *Purpose:
        *<p>    [class description]
        *
        *Features:
        *<p> [Thread safety, exception safety, performance]
        *    [if no pertinent write none ]
        *
        *@see  [if necessary] 
        *@link [if necessary] 
        *
        */

        class TestRecursiveReaderWriter : public Thread
        {

            public:

                /**
                * Purpose:
                * <p> [Constructor description if necessary]
                * 
                *@param
                *@exception
                */
                TestRecursiveReaderWriter(int num_th, int sec_sleep, int operation, Cdmw::OsSupport::ReaderWriterRecursiveMutex* th_lock);


                /**
                * Purpose:
                * <p> [ Destructor description if necessary]
                * 
                */
                virtual
                ~TestRecursiveReaderWriter()
                throw();





                /**
                * Purpose:
                * <p>
                * 
                *@param
                *@return
                *@exception
                */
                virtual
                void
                run()
                throw();
                
        bool isdone();

            private:
                /**
                * Purpose:
                * <p>  [Copy constructor description if necessary]
                * 
                *@param
                *@exception
                */
                TestRecursiveReaderWriter(const TestRecursiveReaderWriter& rhs)
                throw();

                /**
                * Purpose:
                * <p> [ Assignement operator description if necessary]
                * 
                *@param
                *@return
                *@exception
                */
                TestRecursiveReaderWriter&
                operator=(const TestRecursiveReaderWriter& rhs)
                throw();
        
        
                Cdmw::OsSupport::ReaderWriterRecursiveMutex* th_my_lock;    
                int m_operation;    
                int sleep_time;  
                int m_num_th;
                bool done;
        }

        ; // End class TestRecursiveReaderWriter

    } // End namespace OsSupport
} // End namespace Cdmw


