/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testosthreads/TestRecursiveReaderWriter.hpp"
#include <iostream>

namespace Cdmw
{

    namespace OsSupport
    {

        /**
        *Implementation notes: [if no pertinent write none ]
        *<p>
        *Portability issues: [if no pertinent write none ]
        *<p>
        */


        TestRecursiveReaderWriter::TestRecursiveReaderWriter(int num_th, int sec_sleep, int operation, Cdmw::OsSupport::ReaderWriterRecursiveMutex* th_lock)
        {
            th_my_lock=th_lock;
            m_operation = operation;
            sleep_time=sec_sleep;
            m_num_th = num_th;
        }


        TestRecursiveReaderWriter::~TestRecursiveReaderWriter()
        throw()
        {
        }

        bool TestRecursiveReaderWriter::isdone(){
            return done;
        }
        void
        TestRecursiveReaderWriter::run()
        throw()
            {
            done = false;
            std::string space = "";
            for(int x=0;x<m_num_th*10;x++) space = space + "-";
            std::cout << space << "thread num " << m_num_th << " START "<<std::endl;
            if(m_operation == 1 ){//RS
               //READ
               std::cout << space << "thread num " << m_num_th << " try to take read lock"<<std::endl;
               CDMW_READER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took read lock"<<std::endl;
               sleep(sleep_time*1000);
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
            }
            else if (m_operation ==2 ){//WS
               //WRITE
               std::cout << space << "thread num " << m_num_th << " try to take write lock"<<std::endl;
               CDMW_WRITER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took write lock"<<std::endl;
               sleep(sleep_time*1000);
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
           }
           else if (m_operation ==3 ){//RR
               //READ
               std::cout << space << "thread num " << m_num_th << " try to take read lock"<<std::endl;
               CDMW_READER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took read lock"<<std::endl;
               sleep(sleep_time*1000);
               //READ
               std::cout << space << "thread num " << m_num_th << " try to take read lock"<<std::endl;
               CDMW_READER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took read lock"<<std::endl;
               sleep(sleep_time*1000);
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
               done=true;
           }
           else if (m_operation ==4 ){//WR                
               //WRITE
               std::cout << space << "thread num " << m_num_th << " try to take write lock"<<std::endl;
               CDMW_WRITER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took write lock"<<std::endl;
               sleep(sleep_time*1000);
               //READ
               std::cout << space << "thread num " << m_num_th << " try to take read lock"<<std::endl;
               CDMW_READER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took read lock"<<std::endl;
               sleep(sleep_time*1000);
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
               done=true;
           }
           else if (m_operation ==5 ){//RW                
               //READ
               std::cout << space << "thread num " << m_num_th << " try to take read lock"<<std::endl;
               CDMW_READER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took read lock"<<std::endl;
               sleep(sleep_time*1000);
               //WRITE
               std::cout << space << "thread num " << m_num_th << " try to take write lock"<<std::endl;
               CDMW_WRITER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took write lock"<<std::endl;
               sleep(sleep_time*1000);
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
               done=true;
           }
           else if (m_operation ==6 ){//WW              
               //WRITE
               std::cout << space << "thread num " << m_num_th << " try to take write lock"<<std::endl;
               CDMW_WRITER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took write lock"<<std::endl;
               sleep(sleep_time*1000);
               //WRITE
               std::cout << space << "thread num " << m_num_th << " try to take write lock"<<std::endl;
               CDMW_WRITER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took write lock"<<std::endl;
               sleep(sleep_time*1000);
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
               done=true;
           }
           else if (m_operation ==7 ){//RSS              
               //READ
               std::cout << space << "thread num " << m_num_th << " try to take read lock"<<std::endl;
               CDMW_READER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took read lock"<<std::endl;
               sleep(sleep_time*1000);
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
               done=true;
           }
           else if (m_operation ==8 ){//SRS         
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //READ
               std::cout << space << "thread num " << m_num_th << " try to take read lock"<<std::endl;
               CDMW_READER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took read lock"<<std::endl;
               sleep(sleep_time*1000);
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
               done=true;
           }    
           else if (m_operation ==9 ){//SWS
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //WRITE
               std::cout << space << "thread num " << m_num_th << " try to take write lock"<<std::endl;
               CDMW_WRITER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took write lock"<<std::endl;
               sleep(sleep_time*1000);
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
               done=true;
           }
           else if (m_operation ==10 ){//WSS        
               //WRITE
               std::cout << space << "thread num " << m_num_th << " try to take write lock"<<std::endl;
               CDMW_WRITER_RECURSIVE_MUTEX_GUARD(*th_my_lock);
               std::cout << space << "thread num " << m_num_th << " took write lock"<<std::endl;
               sleep(sleep_time*1000);           
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //SLEEP
               std::cout << space << "thread num " << m_num_th << " sleep"<<std::endl;
               sleep(sleep_time*1000);
               std::cout << space << "thread num " << m_num_th << " wake up"<<std::endl;
               //UNLOCK
               std::cout << space << "thread num " << m_num_th << " realase all lock"<<std::endl;
               done=true;
           }
       }
    } // End namespace OsSupport
} // End namespace Cdmw

