/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testutils.threadtestengine;


/**
 * The interface is an important part of architecture decision is designed with the purpose to provide developers 
 * with ability to create threaded tests.
 * This inteface should be used in tests which start running other test in separated threads of execution.
 * A test that run other test in separated threads must contain field of type TestContext. 
 * All implementors of the interface should have "package visibility" so that a developer 
 * will not be able to create an instance of any child of this interface explicitly. 
 * Field of type TestContext will be initialized by the test framework during execution of the test.
 * Such field is initialized by class ({@link CdmwThreadedTestClassRunner} (in order to use this class a develper 
 * must specify such test with JUnit-specific annotation @runWith and point class {@link CdmwThreadedTestClassRunner}
 * as parameter of the annotation.
 * Instance of a descendant of TestContext is used inside test methods in order to obtain an instance TestProcessor - class that 
 * can collect tests and run them.
 * If a test contains several fields with type TestContext then all of them will be initialized by 
 * {@link CdmwThreadedTestClassRunner} with the same instance of ThreadedContext class.
 */
public interface TestContext {
    public TestProcessor getTestProcessor();
}
