/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testutils.threadtestengine;

import java.util.*;

import cdmw.testutils.TestManager;

/**
 * @see TestContext
 * The class should be is used in tests that run other tests in separated threads. 
 * The class provide obtaining an instance of ThreadedTestProcessor - class that run
 * tests in separated threads of execution. 
 *
 */
/*package*/ class ThreadedTestContext implements TestContext {

    private List<ThreadedTestProcessor> processors = new ArrayList<ThreadedTestProcessor>();
    
    public TestProcessor getTestProcessor() {
        ThreadedTestProcessor thTestProcessor = new ThreadedTestProcessor(TestManager.instance().getRunningListener());
        this.processors.add(thTestProcessor);
        return thTestProcessor;
    }
    
    /**
     * Joins with all ThreadedTestProcessors have been started during the test.
     *
     */
    /*package*/ void joinWithProcessors() {
        for (ThreadedTestProcessor testProcessor: this.processors) {
            testProcessor.join();
        }
    }

}
