/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_LIFECYCLE_ERROR_MESSAGES_HPP
#define INCL_LIFECYCLE_ERROR_MESSAGES_HPP

#include <string>

/**
* Root namespace for CDMW runtime.
*/

namespace Cdmw
{
    /**
    * Namespace for CDMW LifeCycle Frameworks types and data.
    */

    namespace LifeCycle
    {

        /**
        *Purpose:
        *<p> This class provides string representations for some error messages from
        * the CDMW LifeCycle Frameworks.
        *
        */

        class ErrorMessages
        {

            public:

                static const std::string NoNameDomainMessage; // "Not a NameDomain"
                static const std::string InvalidNameMessage; // "Name Not valid"
                static const std::string FactoryExistsMessage; // "Factory already exists"
                static const std::string FactoryInUseMessage; // "Factory servant already in use"
        };

    }

    ; // End namespace LifeCycle

}

; // End namespace Cdmw

#endif // INCL_LIFECYCLE_ERROR_MESSAGES_HPP

