/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.validation;

public class TestData {

    public static final String ENTITY_FACTORY_NAME
        = "Entity Resource.factory";
    public static final String UNMANAGED_ENTITY_FACTORY_NAME
        = "Unmanaged Entity Resource.factory";
    public static final String SESSION_FACTORY_NAME
        = "Session Resource.factory";
    public static final String SERVICE_FACTORY_NAME
        = "Service Resource.factory";

    public static final String RESOURCES_DOMAIN_NAME
        = "System.resources";
    public static final String FACTORIES_DOMAIN_NAME
        = "Resource.Factories";

    public static final String ENTITY_DEVICE_KEY
        = "USB device.dev";
    public static final String ENTITY_DEVICE_LABEL
        = "K1 203";
    public static final String ENTITY_APPLICATION_I_KEY
        = "XLOGO.appl";
    public static final String ENTITY_APPLICATION_II_KEY
        = "XLOGO\\.2.appl";

    public static final String UNMANAGED_ENTITY_DEVICE_KEY
        = "unmanaged - USB device.dev";
    public static final String UNMANAGED_ENTITY_DEVICE_LABEL
        = "unmanaged - K1 203";
    public static final String UNMANAGED_ENTITY_APPLICATION_I_KEY
        = "unmanaged - XLOGO.appl";
    public static final String UNMANAGED_ENTITY_APPLICATION_II_KEY
        = "unmanaged - XLOGO\\.2.appl";

    public static final String SESSION_DEVICE_LABEL = "K1 203";

    public static final String SERVICE_DEVICE_LABEL = "K1 203";

    // WIN32 platform
    public static final String PROGRAM_EXECUTABLE_1 = "notepad.exe";
    public static final String PROGRAM_EXECUTABLE_2 = "welcome.exe";

    public final static String get_ENTITY_FACTORY_NAME() {
        return ENTITY_FACTORY_NAME;
    }

    public final static String get_UNMANAGED_ENTITY_FACTORY_NAME() {
        return UNMANAGED_ENTITY_FACTORY_NAME;
    }

    public final static String get_SESSION_FACTORY_NAME() {
        return SESSION_FACTORY_NAME;
    }

    public final static String get_SERVICE_FACTORY_NAME() {
        return SERVICE_FACTORY_NAME;
    }

    public final static String get_RESOURCES_DOMAIN_NAME() {
        return RESOURCES_DOMAIN_NAME;
    }

    public final static String get_FACTORIES_DOMAIN_NAME() {
        return FACTORIES_DOMAIN_NAME;
    }

    public final static String get_ENTITY_DEVICE_KEY() {
        return ENTITY_DEVICE_KEY;
    }

    public final static String get_ENTITY_DEVICE_LABEL() {
        return ENTITY_DEVICE_LABEL;
    }

    public final static String get_ENTITY_APPLICATION_I_KEY() {
        return ENTITY_APPLICATION_I_KEY;
    }

    public final static String get_ENTITY_APPLICATION_II_KEY() {
        return ENTITY_APPLICATION_II_KEY;
    }

    public final static String get_UNMANAGED_ENTITY_DEVICE_KEY() {
        return UNMANAGED_ENTITY_DEVICE_KEY;
    }

    public final static String get_UNMANAGED_ENTITY_DEVICE_LABEL() {
        return UNMANAGED_ENTITY_DEVICE_LABEL;
    }

    public final static String get_UNMANAGED_ENTITY_APPLICATION_I_KEY() {
        return UNMANAGED_ENTITY_APPLICATION_I_KEY;
    }

    public final static String get_UNMANAGED_ENTITY_APPLICATION_II_KEY() {
        return UNMANAGED_ENTITY_APPLICATION_II_KEY;
    }

    public final static String get_SESSION_DEVICE_LABEL() {
        return SESSION_DEVICE_LABEL;
    }

    public final static String get_SERVICE_DEVICE_LABEL() {
        return SERVICE_DEVICE_LABEL;
    }

    public final static String get_PROGRAM_EXECUTABLE_1() {
        return PROGRAM_EXECUTABLE_1;
    }

    public final static String get_PROGRAM_EXECUTABLE_2() {
        return PROGRAM_EXECUTABLE_2;
    }

}

