/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMADMIN_LB_CONFIGELEMENTPARSER_HPP
#define INCL_PLATFORMADMIN_LB_CONFIGELEMENTPARSER_HPP
 
#include <string>
#include <xercesc/dom/deprecated/DOM.hpp>
#include <xercesc/dom/deprecated/DOM_DOMException.hpp>
#include <xercesc/util/XMLException.hpp>
#include "Foundation/common/Exception.hpp"

using namespace xercesc;

namespace Cdmw {         // Begin namespace Cdmw
namespace LB { // Begin namespace LB

class ConfigException : public Exception
{
public:
    ConfigException(
        const std::string& errorMsg )
    : Exception( Exception::SAFE, errorMsg )
    {};
};

class NotFoundException : public Exception
{
public:
    NotFoundException()
    : Exception( Exception::SAFE, "Configuration parser not found exception" )
    {};
};

class ConfigElementParser
{
private:
    DOM_Element m_element;
    
protected:
    ConfigElementParser(
        const DOM_Node& element );
  
    unsigned int get_child_count(
        const char* elementTypeName ) const;

    DOM_Node get_child_element(
        const char* elementTypeName,
        unsigned int elementIndex ) const;

    std::string get_attribute_value(
        const char* attributeName ) const;
};

std::string to_string(
    const DOMString& s );

} // End namespace LB
} // End namespace Cdmw

#endif //INCL_PLATFORMADMIN_LB_CONFIGELEMENTPARSER_HPP

