/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "lbgroupcreator/GroupsParser.hpp"
#include "lbgroupcreator/ObjectGroupParser.hpp"
namespace Cdmw {         // Begin namespace Cdmw
namespace LB { // Begin namespace LB

GroupsParser::GroupsParser(
    const DOM_Node& groupsParser )
: ConfigElementParser( groupsParser )
{
}

unsigned int GroupsParser::get_objectgroup_count() const
{
    return get_child_count( "object-group" );
}

ObjectGroupParser GroupsParser::get_Objectgroup(
    unsigned int objectgroupIndex ) const
{
    DOM_Node objectgroup_parser(
        get_child_element( "object-group", objectgroupIndex ) );

    return ObjectGroupParser ( objectgroup_parser );
}

} // End namespace LB
} // End namespace Cdmw

