/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/**
 * @brief implementation for TestLBGroupCreator with cppUnit library.
 *
 * @author Raffaella Panella <rpanella@amjsv.it>
 *
 */

// Standard Files
#include <string>

// Cdmw Files
#include <Foundation/common/String.hpp>
#include <Foundation/ossupport/OS.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <testlbgroupcreator/TestLBGroupCreator.hpp>
#include <iostream>
#include "lbcommon/config.hpp"
#include "Foundation/logging/Logger.hpp"
#include "Foundation/logging/LogManager.hpp"
using namespace std;

using namespace Cdmw;


#define ECHO_HEADER() \
    "[Debug] "

#define ECHO_ERROR(comment) \
do {\
    std::cerr << ECHO_HEADER() << " --> " << comment << std::endl;\
} while(0)


/*****************************************************************************/

CPPUNIT_TEST_SUITE_REGISTRATION( TestLBGroupCreator );

/*****************************************************************************/

void
TestLBGroupCreator::setUp()
{
}
void
TestLBGroupCreator::tearDown()
{
}

/**
 * @brief test lb group creator operation.
 *
 */
void TestLBGroupCreator::lb_group_creator ()


{

    OsSupport::OS::create_process ("test_lb_group_creator"," -ORBInitRef LBGroupManager=corbaloc::localhost:5040/group_mgr");

    OsSupport::OS::sleep(3000);
}



 
