/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw;

import java.io.IOException;
import cdmw.ossupport.ThreadedProcess;
import cdmw.testutils.Testable;

public class TestLBGroupCreator extends Testable
{

    /**
     * @brief test lb group creator operation.
     * 
     */

    public TestLBGroupCreator()
    {
        this.name = "TestLBGroupCreator";
        this.out = System.out;
    }

    public boolean lb_group_creator()
    {
        System.out.println("\n");
        ThreadedProcess p = null;
        String param = "";
        param = "-ORBInitRef"
                + " LBGroupManager=corbaloc::localhost:5040/group_mgr";

        try
        {
            p = cdmw.ossupport.OS.createProcess("test_lb_group_creator "
                    + param);
            cdmw.ossupport.OS.sleep(5000);
        }
        catch (IOException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return Macro.TEST_NOK;
        }
        catch (InterruptedException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return Macro.TEST_NOK;
        }
        p.killProcess();
        return Macro.TEST_OK;
    }

    public void doTests()
    {
        // TODO Auto-generated method stub
        setNbOfRequestedTestOK(1);
        check(lb_group_creator());
    }
}
