/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.clock.test;

import java.util.*;
import java.lang.String;

public class GenericCatalog<E>
{
    private  Hashtable<String, E> m_catalog;

    public GenericCatalog()
    {
        m_catalog = new Hashtable<String, E>();
    }

    public void add(String name, E ref)
    {
        m_catalog.put(name, ref);
    }

    public E search(String name)
    {
        return  m_catalog.get(name);
    }

    public void remove(String name)
    {
        m_catalog.remove(name);
    }

    public Collection<E> getValues()
    {
        return m_catalog.values();
    }

    public Iterator<E> getIterator()
    {
        return m_catalog.values().iterator();
    }
}
