/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.lb;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;

import org.omg.CORBA.Any;
import org.omg.CORBA.AnyHolder;
import org.omg.CosNaming.NameComponent;
import org.omg.PortableGroup.Property;

import CdmwLB.LBGroupManager;

public class TestUtils
{

    public static final String[] M_locations = { "host1", "host2", "host3" };
    public static final String[] M_files     = { "hello1", "hello2", "hello3" };

    //
    public static CdmwLBGroupCreator.HelloInterface getHelloRefFromFile(
            org.omg.CORBA.ORB orb, String file_name)
            throws org.omg.CORBA.SystemException
    {

        org.omg.CORBA.Object objref = null;
        CdmwLBGroupCreator.HelloInterface hello_ref = null;

        try
        {
            // import the object reference from the file
            BufferedReader in = new BufferedReader(new FileReader(file_name));
            String objref_str = in.readLine();
            objref = orb.string_to_object(objref_str);
            hello_ref = CdmwLBGroupCreator.HelloInterfaceHelper.narrow(objref);
        }
        catch (org.omg.CORBA.SystemException e)
        {
            System.out.println(" CORBA System Exception raised: " + e);
            System.out.println(" **** TEST FAILED AT LINE... ");
        }
        catch (IOException e)
        {
            System.out.println(" Error opening reference filename: "
                    + file_name + " " + e);
        }
        catch (Exception e)
        {
            throw new org.omg.CORBA.INTERNAL();
        }
        return hello_ref;
    }
}
