/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef __CDMW_SERVICE_LOCATOR_IMPL_HPP__
#define __CDMW_SERVICE_LOCATOR_IMPL_HPP__


#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/idllib/CdmwServiceLocator.skel.hpp"
#include "LoadBalancing/idllib/CdmwLBGroupManager.stub.hpp"
#include <iostream>


namespace Cdmw {
namespace LB {

class  ServiceLocator_impl :
         public virtual POA_CdmwServiceLocator::ServiceLocator,
         public virtual PortableServer::RefCountServantBase
{
   public :
      ServiceLocator_impl(CORBA::ORB_ptr orb, const char* group_domain, CdmwLB::LBGroupManager_ptr lb_group_manager);
      ~ServiceLocator_impl();
      /**
       *Purpose:
       *<p>
       * Implements the
       * IDL:thalesgroup.com/CdmwServiceLocator/locate_service:1.0
       * operation
       */    
      virtual void locate_service (const char * name,
                                   const char * sender)
         throw(CORBA::SystemException);
   private:
      CORBA::ORB_var       m_orb;
      std::string          m_group_domain;
      CdmwLB::LBGroupManager_var m_lb_group_manager;
};
    
}
}

#endif
