/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.lb.lbinit;

public class LBServiceInit {
    public LBServiceInit() {}

    public static void init(String[] args) throws org.omg.CORBA.INTERNAL
    {
        String str = cdmw.ossupport.OS.getOptionValue(args,"--LBInterceptorSide");
        String gm_corbaloc = cdmw.ossupport.OS.getOptionValue(args,"--LBGroupManager");
        String nr_corbaloc = cdmw.ossupport.OS.getOptionValue(args,"--namingRepos-url");
        
       if ( (gm_corbaloc.equals("no") || gm_corbaloc.equals("yes")) && (nr_corbaloc.equals("no") || nr_corbaloc.equals("yes")) )
        {
            System.out.println("ERROR: namingReposUrl or LBGroupManager options are mandatory.");
            System.out.println("       Please use: --LBGroupManager=<LBGroupManager object reference>");
            System.out.println("       or");
            System.out.println("                   --namingRepos-url=<namingRepos object reference>");
            
            throw new org.omg.CORBA.INTERNAL(cdmw.orbsupport.ExceptionMinorCodes.INTERNALLoadBalancingError
                    , org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        }
        
        System.setProperty("cdmw.lb.LBGroupManager", gm_corbaloc);
        System.setProperty("cdmw.lb.namingRepos", nr_corbaloc);
        
        if(str.equals("Server"))
        {
            System.setProperty("org.omg.PortableInterceptor.ORBInitializerClass.a"
                    ,"cdmw.lb.lbinit.ORBInitializerImpl");
        }
        else
        {
            System.out.println("ERROR: Unsupported option for LBInterceptorSide."); 
            System.out.println("       Please use: --LBInterceptorSide=Server ");
            throw new org.omg.CORBA.INTERNAL(cdmw.orbsupport.ExceptionMinorCodes.INTERNALLoadBalancingError
                    , org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        }
    }
}



