/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.lb.test;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

public class TestUtils
{

    public TestUtils()
    {
    }

    static int tentativi_lettura = 100;
    static int time              = 500;

    public static CdmwLBInit.HelloInterfaceReturn getHelloRefFromFile(
            org.omg.CORBA.ORB orb, String file_name)
            throws org.omg.CORBA.SystemException
    {
        org.omg.CORBA.Object objref;
        CdmwLBInit.HelloInterfaceReturn hello_ref = null;

        // import the object reference from the file
        try
        {
            try
            {
                File sin = new File(file_name);
                while (!sin.exists() && tentativi_lettura > 0)
                {
                    tentativi_lettura--;
                    try
                    {
                        cdmw.ossupport.OS.sleep(time);
                    }
                    catch (InterruptedException e)
                    {
                        e.printStackTrace();
                    }
                }

                BufferedReader in = new BufferedReader(
                        new FileReader(file_name));
                String objref_str = in.readLine();
                objref = orb.string_to_object(objref_str);
                hello_ref = CdmwLBInit.HelloInterfaceReturnHelper.narrow(objref);
            }
            catch (org.omg.CORBA.SystemException e)
            {
                System.out.println(" **** TEST FAILED AT LINE &  FILE: ......");
                Thread.dumpStack();
                System.out.println("CORBA System Exception raised: " + e);
            }
            catch (Exception e)
            {
                e.printStackTrace();
                System.exit(1);
            }
        }
        catch (java.lang.NullPointerException npe)
        {
            System.out.println(npe);
        }

        return hello_ref;
    }
}
