/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/**
 * @file
 * @brief IDL Hello Interface implementation
 *
 * @author Raffaella Panella <rpanella@amjsv.it>
 */

// Cdmw Files
#include <testlbrequesttimeout/TestHello_impl.hpp>
#include <Foundation/ossupport/OS.hpp>

namespace Cdmw
{

    HelloInterface_impl::HelloInterface_impl(std::string location)
        throw(CORBA::SystemException)
        :m_location(location)
    {
    }
    

    HelloInterface_impl::~HelloInterface_impl()
        throw()
    {
    }

    void HelloInterface_impl::send_exception (int value)
        throw(CORBA::SystemException)
    {
        CORBA::ULong minor_code = 0;
        int exception_number = value;
        switch (exception_number)
        {
           /* case 1:
                {
                    std::cout<<"throw CORBA::COMM_FAILURE("<<minor_code<<", CORBA::COMPLETED_NO)"<<std::endl;
                    throw CORBA::COMM_FAILURE(minor_code, CORBA::COMPLETED_NO);
                }*/
            case 1:
                {
                    //std::cout<<"throw CORBA::COMM_FAILURE("<<minor_code<<", CORBA::COMPLETED_MAYBE)"<<std::endl;
                    throw CORBA::COMM_FAILURE(minor_code, CORBA::COMPLETED_MAYBE);
                }
            /*case 10:
                {
                    std::cout<<"throw CORBA::TRANSIENT("<<minor_code<<", CORBA::COMPLETED_NO)"<<std::endl;
                    throw CORBA::TRANSIENT(minor_code, CORBA::COMPLETED_NO);
                }*/
            /*case 15:
                {
                    std::cout<<"throw CORBA::TRANSIENT("<<minor_code<<", CORBA::COMPLETED_MAYBE)"<<std::endl;
                    throw CORBA::TRANSIENT(minor_code, CORBA::COMPLETED_MAYBE);
                }*/
            /*
            case 20:
                {
                    std::cout<<"throw CORBA::NO_RESPONSE("<<minor_code<<", CORBA::COMPLETED_NO)"<<std::endl;
                    throw CORBA::NO_RESPONSE(minor_code, CORBA::COMPLETED_NO);
                } */
            case 25:
                {
                    std::cout<<"throw CORBA::NO_RESPONSE("<<minor_code<<", CORBA::COMPLETED_MAYBE)"<<std::endl;
                    throw CORBA::NO_RESPONSE(minor_code, CORBA::COMPLETED_MAYBE);
                }
            /*
            case 36:
                {
                    std::cout<<"throw CORBA::OBJ_ADAPTER("<<minor_code<<", CORBA::COMPLETED_NO)"<<std::endl;
                    throw CORBA::OBJ_ADAPTER(minor_code, CORBA::COMPLETED_NO);
                } */
            case 40:
                {
                    std::cout<<"throw CORBA::OBJ_ADAPTER("<<minor_code<<", CORBA::COMPLETED_MAYBE)"<<std::endl;
                    throw CORBA::OBJ_ADAPTER(minor_code, CORBA::COMPLETED_MAYBE);
                }
             default :
                {
                     std::cerr << " <####### REQUEST OK ("<<m_location<<")###########> " << std::endl;
                }
        }

    }    
};
