/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <Foundation/common/Assert.hpp>
#include <Foundation/ossupport/OS.hpp>

#include <ccm_lb/CCM_Client_impl.hpp>


//
// Testable do_tests() operation
//
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(CcmLbTest::test_ccm_lb_activate, "test_ccm_lb_activate");

//
// IDL:thalesgroup.com/CcmLbTest/CCM_Client:1.0
//
CcmLbTest::CCM_Client_impl::CCM_Client_impl()
    : //Testable("Test CCM with LB[client side]"),
      m_session_context(CcmLbTest::CCM_Client_Context::_nil()),
      //m_testThread(this)
      m_testThread()
{
}


CcmLbTest::CCM_Client_impl::~CCM_Client_impl()
{
    std::cout << "   ... CCM_Client_impl destructor called" << std::endl;
}



//
// set_session_context() sets the session context of the component
// (called by the container)
//
void
CcmLbTest::CCM_Client_impl::set_session_context(
        Components::SessionContext_ptr ctx)
    throw(CORBA::SystemException)
{
    std::cout << "   ... CCM_Client_impl::set_session_context() called"
              << std::endl;

    m_session_context = ::CcmLbTest::CCM_Client_Context::_narrow(ctx);
}


//
// ccm_activate() activates the component (called by the container)
//
void
CcmLbTest::CCM_Client_impl::ccm_activate()
   throw(CORBA::SystemException)
{
    std::cout << "   ... CCM_Client_impl::ccm_activate() called" << std::endl;    
    Cdmw::TestUtils::CORBATestManager::instance()->add("client_context", get_context());
    Cdmw::TestUtils::CORBATestManager::instance()->add("user_ccm_client", static_cast< ::UserCcmLbTest::User_CCM_Client_ptr > (this));
    m_testThread.start();


}


//
// ccm_passivate() stops the component (called by the container)
//
void
CcmLbTest::CCM_Client_impl::ccm_passivate()
   throw(CORBA::SystemException)
{
    std::cout << "   ... CCM_Client_impl::ccm_passivate() called" << std::endl;
}


//
// ccm_remove() destroys the component (called by the container)
//
void
CcmLbTest::CCM_Client_impl::ccm_remove()
   throw(CORBA::SystemException)
{
    std::cout << "   ... CCM_Client_impl::ccm_remove() called" << std::endl;
}


void
CcmLbTest::test_ccm_lb_activate::do_tests()
// void
// CcmLbTest::CCM_Client_impl::do_tests()
{
    Cdmw::OsSupport::OS::sleep(2000);
// // //     set_nbOfRequestedTestOK(70);

    CORBA::Object_var obj2 = Cdmw::TestUtils::CORBATestManager::instance()->get_object("user_ccm_client");
    ::UserCcmLbTest::User_CCM_Client_var user_ccm_client = ::UserCcmLbTest::User_CCM_Client::_narrow(obj2.in());
    m_user_ccm_client = reinterpret_cast< CcmLbTest::CCM_Client_impl* > (user_ccm_client.in());



    CORBA::String_var temp = CORBA::string_dup("");
     
    // perform 10 request with the RoundRobin policy
    for (int i = 0; i<10; i++)
    {
    CORBA::String_var process_name =
        CORBA::string_dup(test_connections());
    TEST_INFO("REQUEST " << i << "...check the RoundRobin policy...") ;
    TEST_INFO("the process called is ==> " << process_name.in());
    if((strcmp(temp, process_name) == 0) && (!(i==5)))
        CPPUNIT_ASSERT(false);
    else
    {
        temp = process_name;
        CPPUNIT_ASSERT(true);
    }
    }
    std::string dummy;
    TEST_INFO("Test the crash of a replica...");
    TEST_INFO("kill process ServerProcess11");
    std::cout<<"Press any key and Enter"<<std::endl;
    std::cin >> dummy;
    
    temp = CORBA::string_dup("");
    // perform 10 request with the RoundRobin policy
    for (int i = 0; i<10; i++)
    {
    CORBA::String_var process_name =
        CORBA::string_dup(test_connections());
    TEST_INFO("REQUEST " << i << "...check the RoundRobin policy...") ;
    TEST_INFO("the process called is ==> " << process_name.in());
    if((strcmp(temp, process_name) == 0) && (!(i==5)) || (strcmp(process_name, "ServerProcess11") == 0))
        CPPUNIT_ASSERT(false);
    else
    {
        temp = process_name;
        CPPUNIT_ASSERT(true);
    }      
    }

    TEST_INFO("Test the crash of an application...");
    TEST_INFO("kill the application CcmLbApplication1");
    std::cout<<"Press any key and Enter"<<std::endl;
    std::cin >> dummy;

    temp = CORBA::string_dup("");
    // perform 10 request with the RoundRobin policy
    for (int i = 0; i<10; i++)
    {
    CORBA::String_var process_name =
            CORBA::string_dup(test_connections());
    TEST_INFO("REQUEST " << i << "...check the RoundRobin policy...") ;
    TEST_INFO("the process called is ==> " << process_name.in());
        if((strcmp(temp, process_name) == 0) && (!(i==5)) || (strcmp(process_name, "ServerProcess12") == 0))
            CPPUNIT_ASSERT(false);
        else
        {
            temp = process_name;
            CPPUNIT_ASSERT(true);
        }
    }

    TEST_INFO("Test the crash of an host...");
    TEST_INFO("kill the HOST3");

    std::cout<<"Press any key and Enter"<<std::endl;
    std::cin >> dummy;
    
    temp = CORBA::string_dup("");
    // perform 10 request with the RoundRobin policy
    for (int i = 0; i<10; i++)
    {
    CORBA::String_var process_name =
        CORBA::string_dup(test_connections());
    TEST_INFO("REQUEST " << i << "...check the RoundRobin policy...") ;
    TEST_INFO("the process called is ==> " << process_name.in());
        if((strcmp(temp, process_name) == 0) && (!(i==5)) 
             || (strcmp(process_name, "ServerProcess31") == 0) 
                   || (strcmp(process_name, "ServerProcess32") == 0))
            CPPUNIT_ASSERT(false);
    else
    {
        temp = process_name;
        CPPUNIT_ASSERT(true);
    }      
    }

    TEST_INFO("Test the LoadBalancing Service with one replica alive in the component group...");
    TEST_INFO("kill the ServerProcess21");
    std::cout<<"Press any key and Enter"<<std::endl;
    std::cin >> dummy;

    temp = CORBA::string_dup("");
    // perform 10 request with the RoundRobin policy
     for (int i = 0; i<10; i++)
    {
    CORBA::String_var process_name =
            CORBA::string_dup(test_connections());
    TEST_INFO("REQUEST " << i << "...check the RoundRobin policy...there is only ServerProcess22 alive") ;
    TEST_INFO("the process called is ==> " << process_name.in());
        if(strcmp(process_name, "ServerProcess22"))
            CPPUNIT_ASSERT(false);
        else
        {
            CPPUNIT_ASSERT(true);
        }
    }
    TEST_INFO("Test the crash of LBGroupManager...");
    TEST_INFO("kill the LBGroupManager");
    std::cout<<"Press any key and Enter"<<std::endl;
    std::cin >> dummy;
    
    temp = CORBA::string_dup("");
    // perform 10 request with the RoundRobin policy
    for (int i = 0; i<10; i++)
    {
    CORBA::String_var process_name =
        CORBA::string_dup(test_connections());
    TEST_INFO("REQUEST " << i << "...check the RoundRobin policy...there is only ServerProcess22 alive") ;
    TEST_INFO("the process called is ==> " << process_name.in());
    if(strcmp(process_name, "ServerProcess22"))
        CPPUNIT_ASSERT(false);
    else
    {
        temp = process_name;
        CPPUNIT_ASSERT(true);
    }      
    }
    
    Cdmw::TestUtils::CORBATestManager::instance()->summary();
}

char*
CcmLbTest::test_ccm_lb_activate::test_connections(void)
{
// // //     add_nbOfRequestedTestOK(1);

    CORBA::String_var process_name = CORBA::string_dup("");

    try {
        TEST_INFO("Testing connections to ServerWithFacet group");

        // get the server HostInfo
        CcmLbTest::HostInfo_var hostInfo =
            m_session_context->get_connection_serverHostInfo();

        if (CORBA::is_nil(hostInfo.in())) {
            TEST_INFO("error: hostInfo is NIL!");
            CPPUNIT_ASSERT(false);
            return 0;
        }

        // read the hostname from the server HostInfo
        process_name = hostInfo->get_process_info();

        if (strcmp(process_name.in(), "") == 0) {
            TEST_INFO("error: hostname is empty string");
            CPPUNIT_ASSERT(false);
        } else {
            CPPUNIT_ASSERT(true);
        }
    } catch (const CORBA::SystemException& e) {
        TEST_INFO("Unexpected CORBA::SystemException: " << e);
        CPPUNIT_ASSERT(false);
    } catch (const CORBA::Exception& e) {
        TEST_INFO("Unexpected CORBA::Exception: " << e);
        CPPUNIT_ASSERT(false);
    } catch (...) {
        TEST_INFO("Unknown exception!");
        CPPUNIT_ASSERT(false);
    }

    return CORBA::string_dup(process_name);
}









