/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/**
 * @file
 * @brief IDL Hello Interface implementation
 *
 */

// Cdmw Files
#include <lbinitservant/TestHello_impl.hpp>
#include <Foundation/ossupport/OS.hpp>
// Standard Files
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <sstream>
using namespace std;

namespace Cdmw
{

    HelloInterfaceReturn_impl::HelloInterfaceReturn_impl(int location)
        throw(CORBA::SystemException)
        :m_location(location)
    {
    }
    

    HelloInterfaceReturn_impl::~HelloInterfaceReturn_impl()
        throw()
    {
    }

    
    int HelloInterfaceReturn_impl::hello ()
        throw(CORBA::SystemException)
    {
        std::cerr << "Replica nr. " << m_location <<  " (c++), say HELLO!!" << std::endl;
        return m_location;
    }
    
       
};
