/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.lb.test;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

public class TestUtils
{
   
    public static CdmwLBInit.HelloInterfaceReturn getHelloRefFromNamingRepository(
            org.omg.CORBA.ORB orb, String obj_name, String namingReposURL)
            throws org.omg.CORBA.SystemException
    {
         org.omg.CORBA.Object objref;
         CdmwLBInit.HelloInterfaceReturn hello_ref = null;
         
         // import the object reference from Naming Repository
         try
         {
              // ===================================================
            // Get the naming and repository
            //     from the input URL
            // ===================================================
            com.thalesgroup.CdmwNamingAndRepository.Repository repository = null;
                                      
            org.omg.CORBA.Object obj2 = orb.string_to_object(namingReposURL);
            repository = com.thalesgroup.CdmwNamingAndRepository.RepositoryHelper.narrow(obj2);            
            

            // ======================================================   
            // Initialise the repository interface
            //     "CDMW" has been chosen as the default domain name
            // ======================================================
            cdmw.namingandrepository.RepositoryInterface.init ("CDMW", repository);
             
             
            // ======================================================
            // Get Naming Interface of TUTORIAL name domain
            // ======================================================
            cdmw.commonsvcs.naming.NamingInterface ni =
                cdmw.namingandrepository.RepositoryInterface.getDomainNamingInterface("VALID/HELLO");
                
            // ===================================================
            // Get the HelloInterface object from repository
            // ===================================================
            objref = ni.resolve (obj_name);
            hello_ref = CdmwLBInit.HelloInterfaceReturnHelper.narrow(objref);      
         }
         catch (java.lang.NullPointerException npe)
         {
             npe.printStackTrace();
             System.out.println(npe);
         }
         catch (Exception e)
         {
             e.printStackTrace();
             System.exit(1);
         }

         return hello_ref;
    }
}
