/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_AGENT_IMPL_HPP
#define INCL_AGENT_IMPL_HPP

#include "Foundation/orbsupport/OrbSupport.hpp"
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"

class Agent_impl: public virtual POA_CdmwPlatformMngt::SupervisionObserver,
                public virtual PortableServer::RefCountServantBase
{

public:

  Agent_impl() {
    primary = false;
    master = false;
  };

  void notify( CdmwPlatformMngt::Event* an_event )
    throw( CORBA::SystemException );
  void set_primary();
  void set_master();

  void add_hello_member(const std::string hello_name, const std::string hello_name_grp,
            const std::string host_location);

private: 
  bool primary ;
  bool master ;

};


#endif //INCL_AGENT_IMPL_HPP

