/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_DEMO_CRASH_LOGGING_MECHANISM_HPP
#define INCL_DEMO_CRASH_LOGGING_MECHANISM_HPP

#include <list>
#include <Foundation/orbsupport/CORBA.hpp>
#include <FaultTolerance/idllib/FT.stub.hpp>


// This Logging Mechanism dispatch a new state to registered replicas

class LoggingMechanism {
    
    public:
    
        // Constructor
        LoggingMechanism()
        {
        };
            
        // To add a replica (It must implement the FT::Checkpointable interface)
        void add_replica(FT::Checkpointable_ptr replica);
    
        // To dispatch a new state to registered replicas 
        void log_state(const FT::State& state);
    
    
    private:
    
        // List of registered replicas
        std::list<FT::Checkpointable_var> m_replicas;

};

#endif // INCL_DEMO_CRASH_LOGGING_MECHANISM_HPP

