/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <iostream>
#include "Agent_impl.hpp"
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"


#include <Foundation/common/Options.hpp>
#include <Foundation/common/String.hpp>
#include <Foundation/ossupport/OS.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>
#include <Foundation/orbsupport/StrategyList.hpp>
#include <FaultTolerance/ftcommon/FTLocation.hpp>
#include <FaultTolerance/ftcommon/FactoryInfos.hpp>
#include <FaultTolerance/ftinit/FTServiceInit.hpp>
#include <SystemMngt/platforminterface/PlatformInterface.hpp>
#include <ConfAndPlug/cdmwinit/ProcessControl.hpp>
#include <Foundation/commonsvcs/naming/NamingInterface.hpp>
#include <Repository/repositoryinterface/RepositoryInterface.hpp>
#include <Repository/idllib/CdmwNamingAndRepository.stub.hpp>
#include "FaultTolerance/idllib/FT.stub.hpp"
#include "TestHello.stub.hpp"

void
Agent_impl::notify( CdmwPlatformMngt::Event* an_event )
  throw( CORBA::SystemException )
{
  CORBA::String_var message = an_event->to_string();
  std::cout << message.in() << std::endl;

  //To be completed 
  // Filter the received event and then take the appropriate action such the re-creation of a new hello object to be added in a FT group
}




void 
Agent_impl::add_hello_member(const std::string hello_name, const std::string hello_name_grp,
              const std::string host_location)
{
  // This method will consist to add a new hello member when the crash of the hello primary object is detected
  //to be completed 
}




void 
Agent_impl::set_primary()
{
  primary = true;
  std::cout << " Agent set to Primary ..." << std::endl;
}

void 
Agent_impl::set_master()
{
  master = true;
  std::cout << " Agent set to Master ..." << std::endl;
}
