/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___DANCE_CCM_CLIENTHOSTINFO_IMPL_HPP__
#define ___DANCE_CCM_CLIENTHOSTINFO_IMPL_HPP__

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"

#include <ccm_dance1_cif.skel.hpp>


namespace CcmDance1Test
{
namespace FacetModule 
{
//
// IDL:thalesgroup.com/CcmDance1Test/FacetModule/CCM_ClientHostInfo:1.0
//
class CCM_ClientHostInfo_impl : virtual public ::CcmDance1Test::FacetModule::CCM_ClientHostInfo,
                         virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    CCM_ClientHostInfo_impl(const CCM_ClientHostInfo_impl&);
    void operator=(const CCM_ClientHostInfo_impl&);

public:

    CCM_ClientHostInfo_impl();
    ~CCM_ClientHostInfo_impl();

    //
    // IDL:thalesgroup.com/CcmDance1Test/FacetModule/ClientHostInfo/get_hostname:1.0
    //
    virtual char* get_hostname()
        throw (CORBA::SystemException);
};
}; // End of namespace FacetModule
}; // End of namespace CcmDance1Test

#endif // ___DANCE_CCM_CLIENTHOSTINFO_IMPL_HPP__

