/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___CCM_SERVERDANCE_IMPL_HPP__
#define ___CCM_SERVERDANCE_IMPL_HPP__

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"

#include <User_ccm_dance_1.skel.hpp>
#include <CCM_HostInfo_impl.hpp>

namespace Cdmw {
    namespace Logging {
        class Logger;
    }
}


namespace CcmDance1Test
{
//
// IDL:thalesgroup.com/CcmDance1Test/ServerModule/CCM_ServerDance:1.0
//
class CCM_ServerDance_impl : 
    virtual public ::UserCcmDance1Test::User_CCM_ServerDance,
    virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    
    CCM_ServerDance_impl(const CCM_ServerDance_impl&);
    void operator=(const CCM_ServerDance_impl&);

    CORBA::String_var m_expectedClientHostname1;
    CORBA::String_var m_expectedClientHostname2;

    bool m_bCheckResult;

    ::CcmDance1Test::ServerModule::CCM_ServerDance_Context_var m_session_context;
    ::CcmDance1Test::FacetModule::CCM_HostInfo_var m_hostInfo;

    Cdmw::Logging::Logger* m_logger;
    
public:

    CCM_ServerDance_impl();
    ~CCM_ServerDance_impl();

    
    //
    // attribute expectedClientHostname1
    //
    virtual char * expectedClientHostname1 ()
        throw (CORBA::SystemException);
    virtual void expectedClientHostname1 (const char * a)
        throw (CORBA::SystemException);

    //
    // attribute expectedClientHostname2
    //
    virtual char * expectedClientHostname2 ()
        throw (CORBA::SystemException);
    virtual void expectedClientHostname2 (const char * a)
        throw (CORBA::SystemException);
        
    //
    // consumer commands
    //
    virtual void push_commands (CcmDance1Test::EventTypeModule::Command * event)
        throw (CORBA::SystemException);


    //
    // Session component specific operations
    //
    void set_session_context(Components::SessionContext_ptr ctx)
        throw(CORBA::SystemException);
    void ccm_activate()
        throw(CORBA::SystemException);
    void ccm_passivate()
        throw(CORBA::SystemException);
    void ccm_remove()
        throw(CORBA::SystemException);

    //
    // facet serverHostInfo1
    //
    virtual ::CcmDance1Test::FacetModule::CCM_HostInfo_ptr get_serverHostInfo1 ()
        throw (CORBA::SystemException);
    
    //
    // facet serverHostInfo2
    //
    virtual ::CcmDance1Test::FacetModule::CCM_HostInfo_ptr get_serverHostInfo2 ()
        throw (CORBA::SystemException);
 
    //
    // supported interface HelloInterface 
    //
    virtual char * say_hello(const char*)
        throw (CORBA::SystemException);
        
    //
    // supported interface TestableComponent
    // 
    virtual char * get_property(const char * prop_name) 
        throw (CORBA::SystemException);
    virtual void reset() 
        throw (CORBA::SystemException);
    virtual CORBA::Boolean check(const char * ref) 
        throw (CORBA::SystemException);
    virtual void do_test(CORBA::Long idx) 
        throw (CORBA::SystemException);
    
    ::CcmDance1Test::ServerModule::CCM_ServerDance_Context* get_context()
    {
        return ::CcmDance1Test::ServerModule::CCM_ServerDance_Context::_duplicate(m_session_context.in());
    }

};


}; // End of namespace CcmDance1Test

#endif // ___CCM_SERVERDANCE_IMPL_HPP__

