/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include "Foundation/ossupport/OS.hpp"

#include <CCM_ClientHostInfo_impl.hpp>

//
// IDL:thalesgroup.com/CcmDance2Test/FacetModule/CCM_Display:1.0
//
CcmDance2Test::FacetModule::CCM_ClientHostInfo_impl::CCM_ClientHostInfo_impl()
{
}

CcmDance2Test::FacetModule::CCM_ClientHostInfo_impl::~CCM_ClientHostInfo_impl()
{
    std::cout << "CCM_ClientHostInfo_impl::~CCM_ClientHostInfo_impl called!" << std::endl;
}

//
// IDL:thalesgroup.com/BasicDemo/Display/print:1.0
//
CcmDance2Test::HostData* CcmDance2Test::FacetModule::CCM_ClientHostInfo_impl::get_hostdata()
    throw (CORBA::SystemException)
{
    std::string hostname = Cdmw::OsSupport::OS::get_hostname();
    Cdmw::OsSupport::OS::ProcessId pid = Cdmw::OsSupport::OS::get_processId();
    
    CcmDance2Test::HostData_var hostdata = new CcmDance2Test::HostData;
    hostdata->hostname = CORBA::string_dup(hostname.c_str());
    hostdata->pid = pid;
    
    return hostdata._retn();
}   

