/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <CCM_TestDriverHome_impl.hpp>
#include <CCM_TestDriver_impl.hpp>

//
// IDL:thalesgroup.com/CcmDance2Test:1.0
//

extern "C" {

//
// create a new client home
//
::Components::HomeExecutorBase* create_CCM_TestDriverHome()
{
  return new CcmDance2Test::CCM_TestDriverHome_impl();
};

};  // End extern C


//
// IDL:thalesgroup.com/CcmDance2Test/CCM_ClientHome:1.0
//
CcmDance2Test::CCM_TestDriverHome_impl::CCM_TestDriverHome_impl()
{
}

CcmDance2Test::CCM_TestDriverHome_impl::~CCM_TestDriverHome_impl()
{
}

//
// IDL:thalesgroup.com/CcmDance2Test/CCM_TestDriverHomeImplicit/create:1.0
//
Components::EnterpriseComponent_ptr
CcmDance2Test::CCM_TestDriverHome_impl::create()
    throw(Components::CCMException,
          CORBA::SystemException)
{
  // creation of a new component in the driver home
  return new CCM_TestDriver_impl();
}




