/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include "Foundation/ossupport/OS.hpp"
#include "Foundation/logging/Logger.hpp"

#include <HostnameResult_impl.hpp>
#include <FooValueType_impl.hpp>
#include <CCM_HostInfo_impl.hpp>
#include <CCM_ServerDance_impl.hpp>



using Cdmw::Logging::Logger;
//
// IDL:thalesgroup.com/CcmDance2WithLBTest/ServerModule/CCM_ServerDance:1.0
//
CcmDance2WithLBTest::CCM_ServerDance_impl::CCM_ServerDance_impl()
{
    m_bCheckResult = false;
    
    m_expectedClientHostname1 = CORBA::string_dup("");
    m_expectedClientHostname2 = CORBA::string_dup("");
    m_hostInfo = new CcmDance2WithLBTest::FacetModule::CCM_HostInfo_impl();
   
    m_logger = Cdmw::Logging::Logger::Get_Logger("ServerDance");
}

CcmDance2WithLBTest::CCM_ServerDance_impl::~CCM_ServerDance_impl()
{
    CDMW_INFO(m_logger, "CCM_ServerDance_impl::~CCM_ServerDance_impl called!");
}



//
// attribute fooStruct
//
CcmDance2WithLBTest::FooStruct* 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooStruct()
    throw (CORBA::SystemException)
{
    FooStruct_var l_fooStruct = new FooStruct(m_fooStruct);
    return l_fooStruct._retn();
}

void 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooStruct(const CcmDance2WithLBTest::FooStruct& in_var)
    throw (CORBA::SystemException)
{
    m_fooStruct = new FooStruct(in_var);
}
/* ValueType not yet supported by Jacorb
//
// attribute fooValueType
//
CcmDance2WithLBTest::FooValueType* 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooValueType()
    throw (CORBA::SystemException)
{
    FooValueType_var l_fooValueType = new CcmDance2WithLBTest::FooValueType_impl();
    l_fooValueType->text(m_fooValueType->text());
    return l_fooValueType._retn();
}

void 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooValueType(CcmDance2WithLBTest::FooValueType* in_val)
    throw (CORBA::SystemException)
{
    m_fooValueType = new CcmDance2WithLBTest::FooValueType_impl();
    m_fooValueType->text(in_val->text());
}
*/
//
// attribute fooEnum;
//
CcmDance2WithLBTest::FooEnum 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooEnum()
    throw (CORBA::SystemException) 
{
    return m_fooEnum;
}

void 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooEnum(CcmDance2WithLBTest::FooEnum in_val)
    throw (CORBA::SystemException)
{
    m_fooEnum = in_val;
}

//
//attribute fooStructSeq
//
CcmDance2WithLBTest::FooStructSequence* 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooStructSeq()
    throw (CORBA::SystemException)
{
    FooStructSequence_var l_fooStructSeq = new FooStructSequence(m_fooStructSeq);
    return l_fooStructSeq._retn();
}

void 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooStructSeq(const CcmDance2WithLBTest::FooStructSequence& in_val)
    throw (CORBA::SystemException)
{
    m_fooStructSeq = new FooStructSequence(in_val);
}
/* ValueType not yet supported by Jacorb
//
//attribute fooValueSeq
//
CcmDance2WithLBTest::FooValueTypeSequence* 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooValueSeq()
    throw (CORBA::SystemException)
{
    FooValueTypeSequence_var l_fooValueSeq = new FooValueTypeSequence(m_fooValueSeq);
    return l_fooValueSeq._retn();
}

void 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooValueSeq(const CcmDance2WithLBTest::FooValueTypeSequence& in_val)
    throw (CORBA::SystemException)
{
    m_fooValueSeq = new FooValueTypeSequence(in_val);
}

//
//attribute fooValueSeqSeq
//
CcmDance2WithLBTest::FooValueTypeSequenceSequence* 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooValueSeqSeq()
    throw (CORBA::SystemException)
{
    FooValueTypeSequenceSequence_var l_fooValueSeqSeq = new FooValueTypeSequenceSequence(m_fooValueSeqSeq);
    return l_fooValueSeqSeq._retn();
}
    
void 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooValueSeqSeq(const CcmDance2WithLBTest::FooValueTypeSequenceSequence& in_val)
    throw (CORBA::SystemException)
{
    m_fooValueSeqSeq = new FooValueTypeSequenceSequence(in_val);
}
*/
//
//attribute fooEnumSeq
//
CcmDance2WithLBTest::FooEnumSequence* 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooEnumSeq()
    throw (CORBA::SystemException)
{
    FooEnumSequence_var l_fooEnumSeq = new FooEnumSequence(m_fooEnumSeq);
    return l_fooEnumSeq._retn();
}

void 
CcmDance2WithLBTest::CCM_ServerDance_impl::fooEnumSeq(const CcmDance2WithLBTest::FooEnumSequence& in_val)
    throw (CORBA::SystemException)
{
    m_fooEnumSeq = new FooEnumSequence(in_val);
}
    



//
// attribute expectedClientHostname1
//
char*
CcmDance2WithLBTest::CCM_ServerDance_impl::expectedClientHostname1()
    throw(CORBA::SystemException)
{
    return CORBA::string_dup(m_expectedClientHostname1);
}

void
CcmDance2WithLBTest::CCM_ServerDance_impl::expectedClientHostname1(const char* a)
    throw(CORBA::SystemException)
{
    m_expectedClientHostname1 =  CORBA::string_dup(a);
}

//
// attribute expectedClientHostname2
//
char*
CcmDance2WithLBTest::CCM_ServerDance_impl::expectedClientHostname2()
    throw(CORBA::SystemException)
{
    return CORBA::string_dup(m_expectedClientHostname2);
}

void
CcmDance2WithLBTest::CCM_ServerDance_impl::expectedClientHostname2(const char* a)
    throw(CORBA::SystemException)
{
    m_expectedClientHostname2 =  CORBA::string_dup(a);
}




//
// consumer commands
//
void 
CcmDance2WithLBTest::CCM_ServerDance_impl::push_commands (CcmDance2WithLBTest::EventTypeModule::Command * event)
    throw (CORBA::SystemException)
{
    CDMW_INFO(m_logger, "CCM_ServerDance_impl::push_commands called with command " << event->commandName() );
    
    if (strcmp(event->commandName(), CcmDance2WithLBTest::EventTypeModule::COMMAND_CHECK_HOSTNAME) == 0) {
        try {
            CcmDance2WithLBTest::FacetModule::ClientHostInfo_var hostInfo1 = 
                m_session_context->get_connection_clientHostInfo1();
            if (CORBA::is_nil(hostInfo1.in())) {
                CDMW_ERROR(m_logger, "hostInfo1 is NIL !!!!");
                return;
            }
            
            CcmDance2WithLBTest::HostData_var hostdata1 = hostInfo1->get_hostdata();
            CORBA::String_var hostname1 = CORBA::string_dup(hostdata1->hostname);
            CORBA::ULong pid1 = hostdata1->pid;
            
            if (strcmp(m_expectedClientHostname1, hostname1.in()) == 0) {
                CDMW_INFO(m_logger, "Client1's hostname OK (" << hostname1.in() << ") PID is " << pid1 << "!");
            } else {
                CDMW_ERROR(m_logger, "Client1's hostname is not the one expected: " << hostname1.in() );
                return;
            }
            
            CcmDance2WithLBTest::FacetModule::ClientHostInfo_var hostInfo2 = 
                m_session_context->get_connection_clientHostInfo2();
            if (CORBA::is_nil(hostInfo2.in())) {
                CDMW_ERROR(m_logger, "hostInfo2 is NIL !!!!");
                return;
            }
            
            CcmDance2WithLBTest::HostData_var hostdata2 = hostInfo2->get_hostdata();
            CORBA::String_var hostname2 = CORBA::string_dup(hostdata2->hostname);
            CORBA::ULong pid2 = hostdata2->pid;
            
            if (strcmp(m_expectedClientHostname2, hostname2.in()) == 0) {
                CDMW_INFO(m_logger, "Client2's hostname OK (" << hostname2.in() << ") PID is " << pid2 << "!");
            } else {
                CDMW_ERROR(m_logger, "Client2's hostname is not the one expected: " << hostname2.in() );
                return;
            }
        } catch (const CORBA::SystemException& e) {
            CDMW_ERROR(m_logger, "Unexpected CORBA::SystemException: " << e );
        } catch (const CORBA::Exception& e) {
            CDMW_ERROR(m_logger, "Unexpected CORBA::Exception: " << e );
        } catch (...) {
            CDMW_ERROR(m_logger, "Unknown exception !!");
        }
        m_bCheckResult = true;
    } 

    else {
        if (strcmp(event->commandName(), CcmDance2WithLBTest::EventTypeModule::COMMAND_GET_HOSTNAME) == 0) {
            std::string hostname = Cdmw::OsSupport::OS::get_hostname();
            CDMW_INFO(m_logger, "CCM_ServerDance_impl:  return result " << hostname );
            
            CcmDance2WithLBTest::EventTypeModule::HostnameResult_var result = new CcmDance2WithLBTest::HostnameResult_impl();
            result->hostname(CORBA::string_dup(hostname.c_str()));
            
            CDMW_INFO(m_logger, "CCM_ServerDance_impl:  emits HostnameResult");
            m_session_context->push_hostnamePublishes(result.in());
        }
        else
            CDMW_ERROR(m_logger, "CCM_ServerDance_impl:  Unkown Command !!!!");
    }
};

//
// facet serverHostInfo
//
CcmDance2WithLBTest::FacetModule::CCM_HostInfo_ptr 
CcmDance2WithLBTest::CCM_ServerDance_impl::get_serverHostInfo ()
    throw (CORBA::SystemException)
{
    CDMW_INFO(m_logger, "CCM_ServerDance_impl::get_serverHostInfo");
    return CcmDance2WithLBTest::FacetModule::CCM_HostInfo::_duplicate(m_hostInfo.in());
}

//
// supported interface HelloInterface 
//
char * 
CcmDance2WithLBTest::CCM_ServerDance_impl::say_hello(const char* msg)
    throw (CORBA::SystemException)
{
    CDMW_INFO(m_logger, "Hello ! " << msg);
    return CORBA::string_dup(msg);
}


//
// set_session_context function : it fixes the session context of the component (call by the container)
//
void
CcmDance2WithLBTest::CCM_ServerDance_impl::set_session_context(Components::SessionContext_ptr ctx)
    throw(CORBA::SystemException)
{
    CDMW_INFO(m_logger, "CCM_ServerDance_impl::Set_session_context called!");
   
    m_session_context = ::CcmDance2WithLBTest::ServerModule::CCM_ServerDance_Context::_narrow(ctx); 
}


//
// ccm_activate function : it actives the component (call by the container)
//
void
CcmDance2WithLBTest::CCM_ServerDance_impl::ccm_activate()
    throw(CORBA::SystemException)
{
    CDMW_INFO(m_logger, "CCM_ServerDance_impl::Ccm_activate called!");
}


//
// ccm_passivate function : it makes stop the component (call by the container)
//

void
CcmDance2WithLBTest::CCM_ServerDance_impl::ccm_passivate()
    throw(CORBA::SystemException)
{
    CDMW_INFO(m_logger, "CCM_ServerDance_impl::Ccm_passivate called!");
} 



//
// ccm_remove function : it destroys the component (call by the container)
void
CcmDance2WithLBTest::CCM_ServerDance_impl::ccm_remove()
    throw(CORBA::SystemException)
{
    CDMW_INFO(m_logger, "CCM_ServerDance_impl::Ccm_remove called!");
}


    
char * 
CcmDance2WithLBTest::CCM_ServerDance_impl::get_property(const char * prop_name) 
throw (CORBA::SystemException) 
{
    throw CORBA::NO_IMPLEMENT();
};

void 
CcmDance2WithLBTest::CCM_ServerDance_impl::reset() 
throw (CORBA::SystemException) 
{
    CDMW_INFO(m_logger, "CCM_ServerDance_impl::reset");
    m_bCheckResult = false;
};

CORBA::Boolean 
CcmDance2WithLBTest::CCM_ServerDance_impl::check(const char * ref) 
    throw (CORBA::SystemException) 
{
    return m_bCheckResult;
};

void 
CcmDance2WithLBTest::CCM_ServerDance_impl::do_test(CORBA::Long idx) 
    throw (CORBA::SystemException) 
{
    m_bCheckResult = true;
    //perform auto-test on complex attributes
    // fooStruct
    CORBA::String_var string1 = CORBA::string_dup(m_fooStruct->fooString);
    CORBA::Long long1 = m_fooStruct->fooLong;
    CDMW_INFO( m_logger,"Values for attribute fooStruct : " << string1.in() << " : " << long1);
    if ((strcmp("hello", string1.in()) == 0) &&
        (250 == long1)) {
        CDMW_INFO( m_logger,"Attribute fooStruct OK !");
    } else {
        CDMW_INFO( m_logger,"Attribute fooStruct KO !");
        m_bCheckResult = false;
    }
/* ValueType not yet supported by Jacorb
    // fooValueType
    string1 = CORBA::string_dup(m_fooValueType->text());
    CDMW_INFO( m_logger,"Values for attribute fooValueType : " << string1.in() );
    if (strcmp("fooValueText", string1.in()) == 0) {
        CDMW_INFO( m_logger,"Attribute fooValueType OK !");
    } else {
        CDMW_INFO( m_logger,"Attribute fooValueType KO !");
        m_bCheckResult = false;
    }
*/    
    // fooEnum
    CDMW_INFO( m_logger,"Values for attribute fooEnum : " << m_fooEnum );
    if (CcmDance2WithLBTest::B == m_fooEnum) {
        CDMW_INFO( m_logger,"Attribute fooEnum OK !");
    } else {
        CDMW_INFO( m_logger,"Attribute fooEnum KO !");
        m_bCheckResult = false;
    }
    
    // fooStructSeq
    FooStruct l_myFooStruct = m_fooStructSeq->operator[](0);
    string1 = CORBA::string_dup(l_myFooStruct.fooString);
    long1 = l_myFooStruct.fooLong;
    l_myFooStruct = m_fooStructSeq.operator[](1);
    CORBA::String_var string2 = CORBA::string_dup(l_myFooStruct.fooString);
    CORBA::Long long2 = l_myFooStruct.fooLong;
    
    CDMW_INFO( m_logger,"Values for attribute fooStructSeq : " 
                        << string1.in() << " : " << long1 << " :: "
                        << string2.in() << " : " << long2);
                        
    if ((strcmp("hello1", string1.in()) == 0) &&
        (123 == long1) &&
        (strcmp("hello2", string2.in()) == 0) &&
        (456 == long2)) {
        CDMW_INFO(m_logger,"Attribute fooStructSeq OK !");
    } else {
        CDMW_INFO(m_logger,"Attribute fooStructSeq KO !");
        m_bCheckResult = false;
    }
/* ValueType not yet supported by Jacorb
    // fooValueSeq
    FooValueType* l_myFooValue = m_fooValueSeq->operator[](0).in();
    string1 = CORBA::string_dup(l_myFooValue->text());
    l_myFooValue = m_fooValueSeq->operator[](1).in();
    string2 = CORBA::string_dup(l_myFooValue->text());
    CDMW_INFO( m_logger,"Values for attribute fooValueSeq : " 
                        << string1.in() << " : " << string2.in() );
                        
    if ((strcmp("fooValueText1Seq", string1.in()) == 0) &&
        (strcmp("fooValueText2Seq", string2.in()) == 0)) {
        CDMW_INFO(m_logger,"Attribute fooValueSeq OK !");
    } else {
        CDMW_INFO(m_logger,"Attribute fooValueSeq KO !");
        m_bCheckResult = false;
    }
    
    // fooValueSeqSeq
    FooValueTypeSequence l_fooValueSeq = m_fooValueSeqSeq->operator[](0);
    l_myFooValue = l_fooValueSeq[0]in();
    string1 = CORBA::string_dup(l_myFooValue->text());
    l_myFooValue = l_fooValueSeq[1].in();
    string2 = CORBA::string_dup(l_myFooValue->text());
    l_fooValueSeq = m_fooValueSeqSeq->operator[](1);
    l_myFooValue = l_fooValueSeq[0].in();
    CORBA::String_var string3 = CORBA::string_dup(l_myFooValue->text());
    l_myFooValue = l_fooValueSeq[1].in();
    CORBA::String_var string4 = CORBA::string_dup(l_myFooValue->text());
    CDMW_INFO( m_logger,"Values for attribute fooValueSeqSeq : " 
                        << string1.in() << " : " << string2.in() << " :: " 
                        << string3.in() << " : " << string4.in() );

    if ((strcmp("fooValueText1Seq1", string1.in()) == 0) &&
        (strcmp("fooValueText2Seq1", string2.in()) == 0) &&
        (strcmp("fooValueText1Seq2", string3.in()) == 0) &&
        (strcmp("fooValueText2Seq2", string4.in()) == 0)) {
        CDMW_INFO(m_logger,"Attribute fooValueSeqSeq OK !");
    } else {
        CDMW_INFO(m_logger,"Attribute fooValueSeqSeq KO !");
        m_bCheckResult = false;
    }
*/
    // fooEnumSeq
    CDMW_INFO( m_logger,"Values for attribute fooEnumSeq : " 
                        << m_fooEnumSeq->operator[](0) << " : " << m_fooEnumSeq->operator[](1) );
    if ((CcmDance2WithLBTest::A == m_fooEnumSeq->operator[](0)) && 
        (CcmDance2WithLBTest::C == m_fooEnumSeq->operator[](1))){
        CDMW_INFO( m_logger,"Attribute fooEnumSeq OK !");
    } else {
        CDMW_INFO( m_logger,"Attribute fooEnumSeq KO !");
        m_bCheckResult = false;
    }

};
