/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <FooValueType_impl.hpp>

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createFooValueTypeFactory () {
        return new CcmDance2WithLBTest::FooValueTypeFactory();
    }
};



// Constructor
CcmDance2WithLBTest::FooValueType_impl::FooValueType_impl ()
{
}

// Copy Constructor
CcmDance2WithLBTest::FooValueType_impl::FooValueType_impl (const FooValueType_impl& right)
{
    text(right.text());
}

// Destructor
CcmDance2WithLBTest::FooValueType_impl::~FooValueType_impl ()
{
}

CORBA::ValueBase* 
CcmDance2WithLBTest::FooValueType_impl::_copy_value()
{
    CcmDance2WithLBTest::FooValueType_impl* result = new FooValueType_impl();
    result->text(text());
    
    return result;
}

/******************************/
/*         Factory            */
/******************************/


CcmDance2WithLBTest::FooValueTypeFactory::FooValueTypeFactory()
{
}

CcmDance2WithLBTest::FooValueTypeFactory::~FooValueTypeFactory()
{
}

CORBA::ValueBase * 
CcmDance2WithLBTest::FooValueTypeFactory::create_for_unmarshal ()
{
    return new CcmDance2WithLBTest::FooValueType_impl();
}

