/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CLIENT_THREAD_HPP
#define INCL_CLIENT_THREAD_HPP

// Cdmw Files
#include <Foundation/osthreads/Thread.hpp>
#include <Foundation/osthreads/SchedulerBase.hpp>

// Demo Files
#include <LogCollector.stub.hpp>
#include "Common.hpp"


class ClientThread : public Cdmw::OsSupport::Thread
{
public:
    
      ClientThread(Demo::LogCollector_ptr loc_collector,
                   unsigned short nbthreads,
                   unsigned short nbrecords,
                   unsigned int sleeptime)
         : m_collector(Demo::LogCollector::_duplicate(loc_collector)),
           m_stopped(false),
           m_scheduler(nbthreads),
           m_nb_threads(nbthreads),
           m_nb_records(nbrecords),
           m_sleep_time(sleeptime)
    {
    }

    virtual ~ClientThread()
        throw()
    {
    }
    
    void stop() throw()
    {
        m_stopped = true;
    }
    
protected:

    void run() throw();
    
    
private:
      Demo::LogCollector_var m_collector;
      volatile bool m_stopped;
      Cdmw::OsSupport::SchedulerBase m_scheduler;
      unsigned short m_nb_threads;
      unsigned short m_nb_records;
      unsigned int m_sleep_time;
};

#endif // INCL_CLIENT_THREAD_HPP

