/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_DEMO_COMMON_HPP
#define INCL_DEMO_COMMON_HPP

#include <Foundation/logging/Logger.hpp>

namespace Demo
{

   const unsigned short DEFAULT_NB_CLIENT_SCHEDULER_THREADS = 2;
/**
 * Name of the database object group.
 */
   const char* const LOG_COLLECTOR_GROUP_NAME = "LogCollector";

/**
 * Identifier of the Data Store for DataPart1 type.
 */
   const int DATA_STORE_IDENTIFIER = 123;

   const int DEFAULT_NUMBER_OF_RECORDS = 100;

   const char* const CLIENT_LOG_DOMAINE = "Demo.Client";
   const char* const SERVER_LOG_DOMAINE = "Demo.Server";

   const char* const CLIENT_SLEEP_TIME_PROPERTY_NAME="Demo_Client_SleepTime";
   const char* const CLIENT_NUMBER_OF_RECORDS_PROPERTY_NAME="Demo_Client_NumberOfRecords";
   const char* const CLIENT_NUMBER_OF_SCHEDULER_THREADS_PROPERTY_NAME="Demo_Client_NumberOfThreads";

   extern Cdmw::Logging::Logger *
   GetLogger();

}; // namespace Demo

#define ECHO(X) CDMW_INFO(::Demo::GetLogger(),X)
//#define ECHO(X) std::cerr << X << std::endl

#endif // INCL_DEMO_COMMON_HPP

