/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_STP_COMMON_HPP
#define INCL_STP_COMMON_HPP

#include <iostream>
#include <Foundation/common/Assert.hpp>
#include <Foundation/logging/Logger.hpp>

//#define ECHO(xxx) std::cout << xxx << std::endl
#define ECHO(xxx) \
    CDMW_DEBUG( StateTransferPerf::STP_Logger::GetLogger(), xxx );
    
#define INFO(xxx) \
    std::cout << xxx << std::endl; \
    CDMW_INFO( StateTransferPerf::STP_Logger::GetLogger(), xxx );


namespace StateTransferPerf
{

/**
 * Name of the State Transfer Perf object.
 */
   const char* const STATE_TRANSFER_PERF_NAME = "StateTransferPerf";

/**
 * Identifier of the Data Store Type1.
 */
   const int DATA_STORE_IDENTIFIER = 123;
   const int DATA_STORE_IDENTIFIER_SUPERVISION = 124;

   const int DEFAULT_NUMBER_OF_RECORDS = 500;
   const int DEFAULT_NUMBER_OF_ITERATIONS = 1000;

    class STP_Logger
    {
        public:
        inline static Cdmw::Logging::Logger * GetLogger() throw () 
        {
            static Cdmw::Logging::Logger * Logger__ = Cdmw::Logging::Logger::Get_Logger("STP.FTMGR");
            CDMW_ASSERT(Logger__ != 0);
            return Logger__;
        }
    };
        
}; // namespace Demo

#endif // INCL_STP_COMMON_HPP

