#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

SELF=`basename $0`

#USE_TERM=yes
#USE_DDD=yes

if [ "$#" = "0" ]; then

cat >&2 <<EOF
Usage : $SELF [arg1 ...] program
 
EOF
    exit 1
fi

DIRECTORY="`dirname $0`"

PROGRAM=`eval echo '${'$#'}'` # !!! the last argument must be the program to launch
SITE_CONFIG="$DIRECTORY/../site.mk"
HOSTNAME="`uname -n`"

if test ! -x `which $TERM`
then
    TERM=xterm
fi

CDMW_HOME="`cat $SITE_CONFIG | grep CDMW_HOME |cut -d= -f2`"
HOST_TYPE="`$CDMW_HOME/bin/config.guess`"

#logfile=`eval echo '${'$(($#-2))'}'`
#logfile=`basename $logfile .xml`.log

COMMAND="$DIRECTORY/../$HOST_TYPE/$PROGRAM $*"
#COMMAND="$DIRECTORY/../$HOST_TYPE/$PROGRAM --CdmwLogLevel=ALL $*"

if [ "$USE_DDD" = "yes" ]
then
    COMMAND="ddd --args $COMMAND"
fi

if [ "$USE_TERM" = "yes" ]
then
     COMMAND="$TERM -ls -sb -sl 5000 -hold -T $PROGRAM_on_$HOSTNAME -e $COMMAND"
fi

echo ""
#echo "Launch ... exec $COMMAND"
echo "Launch ... '$PROGRAM' on '$HOSTNAME'"
exec $COMMAND

