/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

import org.omg.CORBA.ORB;
import org.omg.CORBA.SystemException;
import org.omg.CORBA.ORBPackage.InvalidName;
import org.omg.CosClockService.*;

import org.omg.CosClockService.ClockCatalogPackage.ClockEntry;
import org.omg.CosClockService.ClockCatalogPackage.UnknownEntry;
import org.omg.CosClockService.ControlledClockHelper;

import cdmw.clock.*;
import cdmw.common.BadParameterException;
import cdmw.orbsupport.ORBSupport;
import cdmw.orbsupport.StrategyList;
import cdmw.ossupport.OS;

import Cdmw.clock.ControlledExecutor;
import Cdmw.clock.ControlledExecutorHelper;

import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;
import org.omg.PortableServer.POAManager;
import org.omg.PortableServer.POAManagerPackage.AdapterInactive;
/*class ORBWorker extends Thread
{
   private ORB m_ORB;

   public ORBWorker(ORB orb)
   {
      m_ORB = orb;
   }

   public void run()
   {
      try
      {
         m_ORB.run();
      }
      catch (SystemException ex)
      {
         ex.printStackTrace();
      }
   }
}
*/
public class TimeoutHandler extends org.omg.CosClockService.PeriodicExecution.PeriodicPOA
{

   public TimeoutHandler()
   {
   }
   
   final String CLOCK_NAME_OPTION = "--CdmwClockName";
   
   private static ORB m_orb;

   private static ClockCatalog m_catalog;

   private static ControlledExecutor fed_ctrl_executor, m_ctrlClock;


   public boolean do_work(org.omg.CORBA.Any params) 
   {
      try 
      {
           System.out.println("current time : " + fed_ctrl_executor.current_time());
      }
      catch(org.omg.CosClockService.TimeUnavailable tu)
      {
            tu.printStackTrace();
      }
      
      return true;
   } 


   public static void main(String[] args)
   {


      StrategyList strategyList = new StrategyList();
      strategyList.addORBThreaded();
      try
      {
          strategyList.addPOAThreadPerConnection();
      }
      catch (BadParameterException e)
      {
          e.printStackTrace();
          System.exit(-1);
      }

      //m_orb =  org.omg.CORBA.ORB.init(args, null);
      m_orb = ORBSupport.ORBInit(args, strategyList);

      // ORB in a thread

       try 
       {
            org.omg.CORBA.Object poaobj = m_orb.resolve_initial_references("RootPOA");
            POA root = POAHelper.narrow(poaobj);
            POAManager poaManager = root.the_POAManager();
            poaManager.activate();
  
       }
       catch (org.omg.PortableServer.POAManagerPackage.AdapterInactive ai)
       {
            ai.printStackTrace();
       }
       catch (org.omg.CORBA.ORBPackage.InvalidName in) 
       {
            in.printStackTrace();
       }
       ORBWorker orb_worker = new ORBWorker(m_orb);
       orb_worker.start();

      try
      {
          OS.sleep(2000);
      }
      catch (InterruptedException e)
      {
          e.printStackTrace();
          System.exit(-1);
      }

//      CdmwCosClock.init(m_orb,args);
      try
      {
          OS.sleep(5000);
      }
      catch (InterruptedException e)
      {
          e.printStackTrace();
          System.exit(-1);
      }


      String clock_name = 
      cdmw.ossupport.OS.getOptionValue(args, "--CdmwClockName");

      if (clock_name == "no")
      {      
          System.out.println("TimeoutHandler:>>  The Clock Name must be defined ");
          CdmwCosClock.close();
          System.exit(-1);
      }

     if (  (clock_name.compareTo("FederatedControlledClock")    != 0) &&  
           (clock_name.compareTo("FederatedControlledExecutor") != 0) )
      {      
          System.out.println("TimeoutHandler:>> Invalid clock type specified <" + clock_name +">");
          CdmwCosClock.close();
          System.exit(-1);
      }


      try 
      {      
          if (clock_name.compareTo("FederatedControlledClock") == 0)
          {
          orb_worker.wait();
          }
          org.omg.CORBA.Object obj = null;

          if ((clock_name.compareTo("FederatedControlledExecutor") == 0) )
          {
              try
              {
                  obj = m_orb.resolve_initial_references("ClockService");
              }
              catch (Exception e1)//(InvalidName e1)
              {
                  System.out.println("TimeoutHandler:>> Unable to resolve ClockService");
                  e1.printStackTrace();
                  System.exit(-1);
              }
              if (obj == null) 
               System.out.println("Error : clock catalog null ");
              m_catalog = ClockCatalogHelper.narrow(obj);
              if (m_catalog == null)
              {
                  System.out.println("Error : Unable to resolve clock catalog");
              }

              ClockEntry entry = null;
              org.omg.CosClockService.PeriodicExecution.Executor executor = null;
              try
              {
                  entry = m_catalog.get_entry("FederatedControlledExecutor");                             
                  fed_ctrl_executor = ControlledExecutorHelper.narrow(entry.subject);

 //                 entry = m_catalog.get_entry("LocalExecutor");
 //                 executor = 
 //                    org.omg.CosClockService.PeriodicExecution.ExecutorHelper.narrow(entry.subject);

              }
              catch (UnknownEntry ex)
              {
                  System.out.println("ClockCatalog::UnknownEntry");
              }

              if (fed_ctrl_executor == null)
              {
                  System.err.println(
                    "Unable to resolve FederatedControlledExecutor, Aborting!");
                  ORBSupport.ORBCleanup(m_orb);
                  System.exit(-1);
              }
              TimeoutHandler handler = new TimeoutHandler();            
              org.omg.CosClockService.PeriodicExecution.Periodic periodic 
                  = handler._this(m_orb);
              org.omg.CosClockService.PeriodicExecution.Controller controller = null; 

           
 //          controller = executor.enable_periodic_execution(periodic);


              String timer_policy = 
              cdmw.ossupport.OS.getOptionValue(args, "TimerPolicy");

              System.out.println("You have chosen " +   timer_policy);
              try 
              {
                  if (timer_policy.compareTo("ENFORCE_INTERVAL")==0)
                    controller = 
                      fed_ctrl_executor.enable_periodic_execution_with_policy
                      (periodic, Cdmw.clock.policy.ENFORCE_INTERVAL.value);
                  else 
                    if (timer_policy.compareTo("ENFORCE_DEADLINE")==0)
                     controller = fed_ctrl_executor.enable_periodic_execution_with_policy
                     (periodic, Cdmw.clock.policy.ENFORCE_DEADLINE.value);
                    else 
                     controller = fed_ctrl_executor.enable_periodic_execution(periodic);          
              }
              catch (Cdmw.clock.policy.ControllerUpdateAdminPackage.Unavailable un)
              {
              }          

              int exec_limit = 0;
              long the_period = 10000000;
              long offset=10;
              org.omg.CORBA.Any params = m_orb.create_any();

              long  start_time = 0;

              try 
              {
                  start_time = fed_ctrl_executor.current_time() + 50000000 ;
              }
              catch (TimeUnavailable un)
              {
              }
               
              //controller.start(the_period,offset,exec_limit,params);
              try 
              {
                  controller.start_at(the_period,start_time,exec_limit,params);
              }
              catch (org.omg.CosClockService.PeriodicExecution.ControllerPackage.TimePast tp)
              {
                  System.out.println("ATTENTION!! You are tying to start timer at time in the PAST!");  
              } 

              //orb_worker.wait();
              try
              {
                  OS.sleep(500);
              }
              catch (InterruptedException e)
              {
                  e.printStackTrace();
                  System.exit(-1);
              }
              while (true){}

        } // if
      } 
      catch (InterruptedException e)
      {
          e.printStackTrace();
          System.exit(-1);
      }

    }// main
      
}
