/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.perftest.CDMWInvocationC;

import java.util.Calendar;

import org.omg.CORBA.SystemException;

public class TestPingI extends POA_Invocation.TestPing {
        //record of data
    private double res[];
        //number of iteration
    private int dim;
    private int count;
    
    //syncronous test
    public void ping() {}

    //asyncronous test
    public void init_sdump(int dim) throws SystemException {
      //if array already exists
      if(this.res != null){
        res = null;
      }
      //array and variables inizialization
      this.res = new double[dim];
      this.dim = dim;
      this.count = 0;
    }

    public void pos_ping_sdump(int pos) {
      //record of server time
      this.res[pos] = ClockTime.getTime();
      this.count++;
    }

    public void save_sdump(String name) {
      //wait misures complete
      if(this.count != this.dim){
        //stop for 1 sec
        Thread.sleep(1000);
      }
      //write file...
      java.io.FileWriter fp = new java.io.FileWriter(name);

      for(int i = 0; i < this.dim; i++)
        fp.write(String.format("%1.6f",this.res[i]));
      fp.close();
    }
}
