/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.perftest.CDMWLBinvocation;

import org.omg.CORBA.*;

public class CORBAManager {
    
    private boolean isInitialized;
    private ORB orb = null;

    private static CORBAManager instance = new CORBAManager();

    public class InvalidObject extends java.lang.Exception {
        public InvalidObject() {
            super("Not valid object!.");
        }
    }

    public static CORBAManager instance() {
        return instance;
    }
    
    private CORBAManager() {
        this.isInitialized = false;
    }

    public ORB getOrb() throws InvalidObject {
        if (!isInitialized) {
            System.err.println("Orb is non initialized!");
            throw new InvalidObject();
        }

        return orb;
    }

    public void init(ORB orb) {
        this.orb = orb;
        this.isInitialized = true;
    }
}
