/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.perftests.CDMWSMGnotification;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class HelloProcessKiller {
    
    public static void main (String args[]) {
        try {
            cdmw.ossupport.Timeval tv;
            //cdmw.ossupport.timezone tz;

            // wait for actviation of other process
            Thread.sleep(2);

            System.err.println("-------------------------");
            System.err.println("      Start Killer");
            System.err.println("-------------------------");
            for (int n=0; n < args.length; n++)
                System.err.println("args[" + n +"]: " + args[n]);
            System.err.println("-------------------------");
            // Read the HelloProcess PID
            String filePidStr = "/tmp/CdmwDaemon_";
            filePidStr = filePidStr + args[1] +  "/SmgPerfApplication/HelloProcess.pid";
            
            StringBuilder sb = new StringBuilder();
            char ch = 0;
            int i = 0;
            try {
                InputStreamReader isr = new FileReader("client.cfg");
                while (i != -1) {
                    i = isr.read();
                    ch = (char) i;
                    sb.append(ch);
                }
                isr.close();
            }
            catch (FileNotFoundException e) {
                System.err.println("*** ERROR: Cannot open PID input file "
                    + filePidStr
                    + " ***");
                    System.exit(1);
            }
            catch (IOException e) {
                e.printStackTrace();
            }
            
            int pid;
            String[] tokens = sb.toString().split("\\s+");
            try {
                pid = Integer.parseInt(tokens[0]);
            }
            catch (NumberFormatException e) {
                e.printStackTrace();
                System.exit(1);
            }
            
            
            if (pid > 0) {
                System.err.println("HelloProcess PID: "
                + pid);
                cdmw.ossupport.OS.killProcess(pid);
                // read killing time from the OS
                std::ofstream of("time2process.dat",std::ios::out|std::ios::app);
                gettimeofday(&tv, &tz);
                if (of) {
                    System.err.println("*** WRITING FILE time2process.dat ***");
                    of  ("Sec "
                    + tv.tv_sec
                    + " Usec "
                    + tv.tv_usec);
                  of.close();
                }
                else {
                    System.err.println("*** ERROR IN WRITING FILE time2process.dat ***");
                }
            }
            else {
                System.err.println("*** ERROR: Invalid PID from "
                + filePidStr
                + " ***");
              }

            filePid.close();
            System.exit(0);

        }
        catch (Exception ex) {
            System.err.println("Caught generic exception :" + ex.toString());
        }
    }
}
