/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.perftests.CDMWSMGnotification;

import cdmw.ossupport.OS;

import com.thalesgroup.CdmwPlatformMngt.*;

public class SupervisionObserverPerfImpl extends PortableServer.RefCountServantBase
    implements POA_CdmwPlatformMngt.SupervisionObserver {
    
    public void notify(Event anEvent ) {
        
      try {
          ProcessStatusChange prcChg = (ProcessStatusChange)anEvent;

          if (((prcChg!=0))&&(prcChg.process_status()==8)) {
              cdmw.ossupport.Timeval tv = OS.getTime();
              //struct timezone tz;
              //gettimeofday(&tv,&tz);
              std::ofstream crash_obs("time2observer.dat",std::ios::out|std::ios::app);
              if (!crash_obs) 
                  System.err.println("*** ERROR IN WRITING FILE time2observer.dat ***");
              else
                  System.err.println("*** WRITING FILE time2observer.dat ***");

              crash_obs <<"Sec " << tv.tv_sec <<" Usec " << tv.tv_usec <<std::endl;
              crash_obs.close();
            }
      }
      catch (Exception ex) {
          System.err.println(" Perf observer exception  " + ex.toString());
      }

    }
}
