/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___CCM_ALL_CAPABILITIES_TEST_CCM_SERVERLB_IMPL_HPP__
#define ___CCM_ALL_CAPABILITIES_TEST_CCM_SERVERLB_IMPL_HPP__


#include <Foundation/logging/Logger.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <XMLServer/idllib/CdmwXML.stub.hpp>

#include <ccm_all_capabilities/ccm_all_capabilities_cif.skel.hpp>
#include <ccm_all_capabilities/User_ccm_all_capabilities.skel.hpp>


namespace CcmAllCapabilitiesTest
{

    //
    // IDL:thalesgroup.com/CcmAllCapabilitiesTest/CCM_ServerLB:1.0
    //
    class CCM_ServerLB_impl :
        virtual public ::UserCcmAllCapabilitiesTest::User_CCM_ServerLB,
        virtual public Cdmw::OrbSupport::RefCountLocalObject
    {
    private:
        CCM_ServerLB_impl(const CCM_ServerLB_impl&);
        void operator=(const CCM_ServerLB_impl&);

        ::CcmAllCapabilitiesTest
        ::CCM_ServerLB_Context_var m_session_context;

    public:
        CCM_ServerLB_impl();
        ~CCM_ServerLB_impl();

        //
        // attribute expectedClientHostname
        //
        virtual char * expectedClientHostname ()
            throw (CORBA::SystemException);
        virtual void expectedClientHostname (const char * a)
            throw (CORBA::SystemException);

        //
        // facet serverXMLValidator
        //
        virtual
        ::CcmAllCapabilitiesTest::CCM_XMLValidator_ptr get_serverXMLValidator()
            throw (CORBA::SystemException);
    
        virtual bool
        parse(const char* file_name, ::CORBA::String_out process_name)
            throw (CORBA::SystemException);

        //
        // Session component specific operations
        //
        void set_session_context(Components::SessionContext_ptr ctx)
            throw(CORBA::SystemException);

        void cdmw_initialise_component(const ::CdmwPlatformMngtBase::StartupKind& startup_kind)
            throw(CdmwPlatformMngt::ManagedComponent::BadOrder, CORBA::SystemException);
  
        void ccm_activate()
            throw(CORBA::SystemException);

        void ccm_passivate()
            throw(CORBA::SystemException);

        void ccm_remove()
            throw(CORBA::SystemException);

        ::CcmAllCapabilitiesTest::CCM_ServerLB_Context* get_context()
        {
            return ::CcmAllCapabilitiesTest::CCM_ServerLB_Context::_duplicate(
                m_session_context.in());
        }

    private:
        CdmwXML::XMLParser_var m_parser;
        Cdmw::Logging::Logger* m_logger;

        CORBA::String_var m_expectedClientHostname;
        bool m_is_facet_called;
    };

}; // End of namespace CcmAllCapabilitiesTest

#endif // ___CCM_ALL_CAPABILITIES_TEST_CCM_SERVERLB_IMPL_HPP__
