/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <ccm_all_capabilities/Command_impl.hpp>

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createCommandFactory () {
        return new CcmAllCapabilitiesTest::CommandFactory();
    }
};



// Constructor
CcmAllCapabilitiesTest::Command_impl::Command_impl ()
{
}

// Copy Constructor
CcmAllCapabilitiesTest::Command_impl::Command_impl (const Command_impl& right)
{
    name(right.name());
}

// Destructor
CcmAllCapabilitiesTest::Command_impl::~Command_impl ()
{
}

CORBA::ValueBase* 
CcmAllCapabilitiesTest::Command_impl::_copy_value()
{
    CcmAllCapabilitiesTest::Command_impl* result = new Command_impl();
    result->name(name());
    
    return result;
}


/******************************/
/*         Factory            */
/******************************/

CcmAllCapabilitiesTest::CommandFactory::CommandFactory()
{
}

CcmAllCapabilitiesTest::CommandFactory::~CommandFactory()
{
}

CORBA::ValueBase * 
CcmAllCapabilitiesTest::CommandFactory::create_for_unmarshal ()
{
    return new CcmAllCapabilitiesTest::Command_impl();
}

