/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___AUTORECONNECTDEMO_CCM_SERVER_IMPL_HPP__
#define ___AUTORECONNECTDEMO_CCM_SERVER_IMPL_HPP__

#include <Foundation/ossupport/OS.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <Foundation/logging/Logger.hpp>

#include <ccm_auto_reconnect/UserAutoReconnectDemo.skel.hpp>

namespace AutoReconnectDemo
{

class SuicideThread : public Cdmw::OsSupport::Thread 
{
public: 
    SuicideThread(unsigned int timeToKill, Cdmw::Logging::Logger* logger);
        
protected:
    void run() throw();
    
private:
    SuicideThread();
    SuicideThread(const SuicideThread&);
    SuicideThread& operator = (const SuicideThread&);
   
    unsigned int m_timeToKill;    
    Cdmw::Logging::Logger* m_logger;
};


//
// IDL:thalesgroup.com/AutoReconnectDemo/CCM_Server:1.0
//
class CCM_Server_impl : virtual public ::UserAutoReconnectDemo::User_CCM_Server, 
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    CCM_Server_impl(const CCM_Server_impl&);
    void operator=(const CCM_Server_impl&);

    ::AutoReconnectDemo::CCM_EventChecking_var  m_facet;
    ::AutoReconnectDemo::CCM_Server_Context_var m_session_context;

    Cdmw::Logging::Logger* m_logger;

public:

    CCM_Server_impl();
    ~CCM_Server_impl();

    void set_session_context(Components::SessionContext_ptr ctx)
                 throw(CORBA::SystemException);
    void ccm_activate()
                 throw(CORBA::SystemException);
    void ccm_passivate()
                 throw(CORBA::SystemException);
    void ccm_remove()
                 throw(CORBA::SystemException);

                 //
    // IDL:thalesgroup.com/AutoReconnectDemo/CCM_Server/get_for_clients:1.0
    //
    virtual ::AutoReconnectDemo::CCM_EventChecking_ptr get_for_clients()
        throw(CORBA::SystemException);

    //
    // IDL:thalesgroup.com/AutoReconnectDemo/CCM_Server/push_event_sink:1.0
    //
   virtual void push_event_sink(AutoReconnectDemo::TestEvent*)
        throw(CORBA::SystemException);

    //
    // IDL:thalesgroup.com/AutoReconnectDemo/Supported/test_supported:1.0
    //
    virtual void test_supported()
        throw(CORBA::SystemException);
};


}; // End of namespace AutoReconnectDemo

#endif // ___AUTORECONNECTDEMO_CCM_SERVER_IMPL_HPP__

