/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <ccm_ft_events/EventTest_impl.hpp>

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createEventTestFactory () {
        return new CcmFtEventsTest::EventTestFactory();
    }
};



// Constructor
CcmFtEventsTest::EventTest_impl::EventTest_impl ()
{
}

// Copy Constructor
CcmFtEventsTest::EventTest_impl::EventTest_impl (const EventTest_impl& event)
{
    numOfEvent(event.numOfEvent());
}

// Destructor
CcmFtEventsTest::EventTest_impl::~EventTest_impl ()
{
}

CORBA::ValueBase* 
CcmFtEventsTest::EventTest_impl::_copy_value()
{
    CcmFtEventsTest::EventTest_impl* result = new EventTest_impl();
    result->numOfEvent(numOfEvent());
    
    return result;
}

/******************************/
/*         Factory            */
/******************************/


CcmFtEventsTest::EventTestFactory::EventTestFactory()
{
}

CcmFtEventsTest::EventTestFactory::~EventTestFactory()
{
}

CORBA::ValueBase * 
CcmFtEventsTest::EventTestFactory::create_for_unmarshal ()
{
    return new CcmFtEventsTest::EventTest_impl();
}

