/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <Foundation/logging/LogManager.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <ccm_ft_perf/CCM_ServerWithFacetHome_impl.hpp>
#include <ccm_ft_perf/CCM_ServerWithFacet_impl.hpp>

//
// IDL:thalesgroup.com/CcmFtTest:1.0
//

extern "C" {

//
// create a new server home
//
Components::HomeExecutorBase* create_CCM_ServerWithFacetHome()
{
    return new CcmFtTest::CCM_ServerWithFacetHome_impl();
};

};  // End extern C


//
// IDL:thalesgroup.com/CcmFtTest/CCM_ServerWithFacetHome:1.0
//
CcmFtTest::CCM_ServerWithFacetHome_impl::CCM_ServerWithFacetHome_impl()
    : m_logger(Cdmw::Logging::Logger::Get_Logger(
                   Cdmw::Logging::LogManager::Instance()->get_process_name(),
                   "CDMW.QUALIF.CcmFtPerf"))
{
    CDMW_LOG_FUNCTION(m_logger, "");
}

CcmFtTest::CCM_ServerWithFacetHome_impl::~CCM_ServerWithFacetHome_impl()
{
    CDMW_LOG_FUNCTION(m_logger, "");
}

//
// IDL:thalesgroup.com/CcmFtTest/CCM_ServerWithFacetHomeImplicit/create:1.0
//
Components::EnterpriseComponent_ptr
CcmFtTest::CCM_ServerWithFacetHome_impl::create()
    throw(Components::CCMException,
          CORBA::SystemException)
{
    // creation of a new component in the server home
    CDMW_LOG_FUNCTION(m_logger, "");
    return new CCM_ServerWithFacet_impl();
}

