/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <ccm_ft_publisher_crash/EmittedEvent_impl.hpp>

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createEmittedEventFactory () {
        return new CcmFtPublisherCrash::EmittedEventFactory();
    }
};



// Constructor
CcmFtPublisherCrash::EmittedEvent_impl::EmittedEvent_impl()
{
}

CcmFtPublisherCrash::EmittedEvent_impl::EmittedEvent_impl(const char* emitter_name)
{
    this->emitter_name(emitter_name);
}

// Copy Constructor
CcmFtPublisherCrash::EmittedEvent_impl::EmittedEvent_impl (const EmittedEvent_impl& right)
{
    emitter_name(right.emitter_name());
}

// Destructor
CcmFtPublisherCrash::EmittedEvent_impl::~EmittedEvent_impl ()
{
}

CORBA::ValueBase* 
CcmFtPublisherCrash::EmittedEvent_impl::_copy_value()
{
    CcmFtPublisherCrash::EmittedEvent_impl* result = new EmittedEvent_impl();
    result->emitter_name(emitter_name());
    
    return result;
}

/******************************/
/*         Factory            */
/******************************/


CcmFtPublisherCrash::EmittedEventFactory::EmittedEventFactory()
{
}

CcmFtPublisherCrash::EmittedEventFactory::~EmittedEventFactory()
{
}

CORBA::ValueBase * 
CcmFtPublisherCrash::EmittedEventFactory::create_for_unmarshal ()
{
    return new CcmFtPublisherCrash::EmittedEvent_impl();
}

