/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <ccm_ft_publisher_crash/PublishedEvent_impl.hpp>

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createPublishedEventFactory () {
        return new CcmFtPublisherCrash::PublishedEventFactory();
    }
};



// Constructor
CcmFtPublisherCrash::PublishedEvent_impl::PublishedEvent_impl()
{
}

CcmFtPublisherCrash::PublishedEvent_impl::PublishedEvent_impl(const char* publisher_name)
{
    this->publisher_name(publisher_name);
}

// Copy Constructor
CcmFtPublisherCrash::PublishedEvent_impl::PublishedEvent_impl (const PublishedEvent_impl& right)
{
    publisher_name(right.publisher_name());
}

// Destructor
CcmFtPublisherCrash::PublishedEvent_impl::~PublishedEvent_impl ()
{
}

CORBA::ValueBase* 
CcmFtPublisherCrash::PublishedEvent_impl::_copy_value()
{
    CcmFtPublisherCrash::PublishedEvent_impl* result = new PublishedEvent_impl();
    result->publisher_name(publisher_name());
    
    return result;
}

/******************************/
/*         Factory            */
/******************************/


CcmFtPublisherCrash::PublishedEventFactory::PublishedEventFactory()
{
}

CcmFtPublisherCrash::PublishedEventFactory::~PublishedEventFactory()
{
}

CORBA::ValueBase * 
CcmFtPublisherCrash::PublishedEventFactory::create_for_unmarshal ()
{
    return new CcmFtPublisherCrash::PublishedEvent_impl();
}

