/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef ___CCM_TEST_CCM_RECORDING_CCM_SERVER_IMPL_HPP__
#define ___CCM_TEST_CCM_RECORDING_CCM_SERVER_IMPL_HPP__

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <Foundation/osthreads/Mutex.hpp>

#include <ccm_ft_recorder/TestCcmFtRecorderLocal.skel.hpp>
#include <TraceAndPerf/recordingidl/CdmwRecordingData.stub.hpp>

namespace TestCcmFtRecorder
{

class CCM_Server_impl;
    

//
// IDL:thalesgroup.com/TestCcmFtRecorder/Session_CCM_MyRecorder:1.0
//
class CCM_Server_impl : virtual public ::TestCcmFtRecorder::Session_CCM_Server,
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
public:

    CCM_Server_impl();
    ~CCM_Server_impl();
     
    ::TestCcmFtRecorder::TestStruct * test_operation (
        const ::TestCcmFtRecorder::TestStruct & a,
        ::TestCcmFtRecorder::TestStruct & b,
        ::TestCcmFtRecorder::TestStruct_out c)
        throw(CORBA::SystemException);   
      
    //
    // Session component specific operations
    //
    void set_session_context(Components::SessionContext_ptr ctx)
        throw(CORBA::SystemException);
    void ccm_activate()
        throw(CORBA::SystemException);
    void ccm_passivate()
        throw(CORBA::SystemException);
    void ccm_remove()
        throw(CORBA::SystemException);


    ::TestCcmFtRecorder::CCM_Server_Context* get_context();
    ::TestCcmFtRecorder::CCM_Test* get_test_facet() throw(CORBA::SystemException);

private:
    

    // session context
    ::TestCcmFtRecorder::CCM_Server_Context_var m_session_context;
    
    
};

}; // End of namespace TestCcmFtRecorder


#endif // ___CCM_TEST_CCM_RECORDING_CCM_SERVER_IMPL_HPP__

