/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef ___CCM_TEST_CCM_RECORDING_TEST_EVENT_IMPL_HPP__
#define ___CCM_TEST_CCM_RECORDING_TEST_EVENT_IMPL_HPP__


#include <Foundation/orbsupport/CORBA.hpp>
#include <ccm_ft_recorder/TestCcmFtRecorder_cif.skel.hpp>




namespace TestCcmFtRecorder {


//
// IDL:omg.org/TestCcmFtRecorder/RecordedOperationEvent:1.0
//
class RecordedOperationEvent_impl : virtual public OBV_TestCcmFtRecorder::RecordedOperationEvent,
                       virtual public CORBA::DefaultValueRefCountBase
{
    void operator=(const RecordedOperationEvent_impl&);

public:

    RecordedOperationEvent_impl();
    RecordedOperationEvent_impl(const RecordedOperationEvent_impl&);
    ~RecordedOperationEvent_impl();

    virtual CORBA::ValueBase* _copy_value();
    
};


class RecordedOperationEventFactory : virtual public CORBA::ValueFactoryBase
{
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    RecordedOperationEventFactory();
    virtual ~RecordedOperationEventFactory();
};


} // End namespace TestCcmFtRecorder

#endif // ___CCM_TEST_CCM_RECORDING_TEST_EVENT_IMPL_HPP__

