/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <ccm_ft_recorder/RecordedOperationEvent_impl.hpp>

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createRecordedOperationEventFactory () {
        return new TestCcmFtRecorder::RecordedOperationEventFactory();
    }
};



// Constructor
TestCcmFtRecorder::RecordedOperationEvent_impl::RecordedOperationEvent_impl()
{
}

// Copy Constructor
TestCcmFtRecorder::RecordedOperationEvent_impl::RecordedOperationEvent_impl (const RecordedOperationEvent_impl& right)
{
    recorder_name(right.recorder_name());
    operation_name(right.operation_name());
    a_value(right.a_value());
    b1_value(right.b1_value());
    b2_value(right.b2_value());
    c_value(right.c_value());
    ret_value(right.ret_value());
}

// Destructor
TestCcmFtRecorder::RecordedOperationEvent_impl::~RecordedOperationEvent_impl ()
{
}

CORBA::ValueBase* 
TestCcmFtRecorder::RecordedOperationEvent_impl::_copy_value()
{
    TestCcmFtRecorder::RecordedOperationEvent_impl* result = new RecordedOperationEvent_impl();
    result->recorder_name(recorder_name());
    result->operation_name(operation_name());
    result->a_value(a_value());
    result->b1_value(b1_value());
    result->b2_value(b2_value());
    result->c_value(c_value());
    result->ret_value(ret_value());
    
    return result;
}

/******************************/
/*         Factory            */
/******************************/


TestCcmFtRecorder::RecordedOperationEventFactory::RecordedOperationEventFactory()
{
}

TestCcmFtRecorder::RecordedOperationEventFactory::~RecordedOperationEventFactory()
{
}

CORBA::ValueBase * 
TestCcmFtRecorder::RecordedOperationEventFactory::create_for_unmarshal ()
{
    return new TestCcmFtRecorder::RecordedOperationEvent_impl();
}

