/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef ___CCM_FT_TEST_CCM_CLIENT_EVENTS_IMPL_HPP__
#define ___CCM_FT_TEST_CCM_CLIENT_EVENTS_IMPL_HPP__

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/osthreads/ThreadHandle.hpp>

#include <ccm_local_event_manager/User_ccm_local_event_manager.skel.hpp>

namespace CcmLocalEventManagerTest
{

 #define MAX_NB_EVENTS 40

//
// IDL:thalesgroup.com/UserCcmLocalEventManagerTest/CCM_ClientEvents:1.0
//
class CCM_ClientEvents_impl : virtual public ::UserCcmLocalEventManagerTest::User_CCM_ClientEvents,
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    CCM_ClientEvents_impl(const CCM_ClientEvents_impl&);
    void operator=(const CCM_ClientEvents_impl&);

    ::CcmLocalEventManagerTest::CCM_ClientEvents_Context_var m_session_context;

public:

    CCM_ClientEvents_impl();
    ~CCM_ClientEvents_impl();
     
    //
    // consumer EventTest
    //
    virtual void push_eventServ1Consumes (CcmLocalEventManagerTest::EventTest * event)
        throw (CORBA::SystemException);

    //
    // consumer EventTest
    //
    virtual void push_eventServ2Consumes (CcmLocalEventManagerTest::SecondEventTest* event)
        throw (CORBA::SystemException);
     

    //
    // Session component specific operations
    //
    void set_session_context(Components::SessionContext_ptr ctx)
        throw(CORBA::SystemException);
    void ccm_activate()
        throw(CORBA::SystemException);
    void ccm_passivate()
        throw(CORBA::SystemException);
    void ccm_remove()
        throw(CORBA::SystemException);


    ::CcmLocalEventManagerTest::CCM_ClientEvents_Context* get_context()
    {
        return ::CcmLocalEventManagerTest::CCM_ClientEvents_Context::_duplicate(m_session_context.in());
    }

};

}; // End of namespace CcmLocalEventManagerTest


#endif // ___CCM_FT_TEST_CCM_CLIENT_EVENTS_IMPL_HPP__

