/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#include "ccm_local_event_manager/CCM_ClientEventsHome_impl.hpp"
#include "ccm_local_event_manager/CCM_ClientEvents_impl.hpp"

//
// IDL:thalesgroup.com/CcmLocalEventManagerTest:1.0
//

extern "C" {

//
// create a new client home
//
Components::HomeExecutorBase* create_CCM_ClientEventsHome()
{
  return new CcmLocalEventManagerTest::CCM_ClientEventsHome_impl();
};

};  // End extern C


//
// IDL:thalesgroup.com/CcmLocalEventManagerTest/CCM_ClientEventsHome:1.0
//
CcmLocalEventManagerTest::CCM_ClientEventsHome_impl::CCM_ClientEventsHome_impl()
{
}

CcmLocalEventManagerTest::CCM_ClientEventsHome_impl::~CCM_ClientEventsHome_impl()
{
}

//
// IDL:thalesgroup.com/CcmLocalEventManagerTest/CCM_ClientEventsHomeImplicit/create:1.0
//
Components::EnterpriseComponent_ptr
CcmLocalEventManagerTest::CCM_ClientEventsHome_impl::create()
    throw(Components::CCMException,
          CORBA::SystemException)
{
  // creation of a new component in the client home
  return new CCM_ClientEvents_impl();
}





