/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/ossupport/OS.hpp>
#include "ccm_local_event_manager/CCM_HostInfo_impl.hpp"
#include "ccm_local_event_manager/CCM_Server_impl.hpp"

CcmLocalEventManagerTest::CCM_HostInfo_impl::CCM_HostInfo_impl()
{
}

CcmLocalEventManagerTest::CCM_HostInfo_impl::~CCM_HostInfo_impl()
{
    std::cout << "CCM_HostInfo_impl::~CCM_HostInfo_impl called!"
              << std::endl;
}

//
// IDL:thalesgroup.com/CcmLocalEventManagerTest/CCM_HostInfo/display_info:1.0
//
void
CcmLocalEventManagerTest::CCM_HostInfo_impl::display_info( const char * hostname, ::CORBA::ULong numOfEvent )
    throw(CORBA::SystemException)
{
  int event_index = numOfEvent - 1;
  
  if ( CCM_Server_impl::M_event_infos.events [ event_index ] == true ) {
    std::cout << "\nINFO: Event #" << numOfEvent
          << " was previously received on "
          << CCM_Server_impl::M_event_infos.hostname [ event_index ]
          << " and has just been received on "
          << hostname 
          << " . A client component crash has had to occured on " 
          << CCM_Server_impl::M_event_infos.hostname [ event_index ]
          << "\n" << std::endl;

    // backup of two different hostnames
    CCM_Server_impl::M_host1 = CCM_Server_impl::M_event_infos.hostname [ event_index ];
    CCM_Server_impl::M_host2 = hostname;

  }

  // fill in progressively the server structure
  CCM_Server_impl::M_event_infos.events [ event_index ] = true;
  CCM_Server_impl::M_event_infos.hostname [ event_index ] = hostname;

  if ( numOfEvent == MAX_NB_EVENTS  ){
    CDMW_MUTEX_GUARD(CCM_Server_impl::M_mutex);
    try {
      CCM_Server_impl::M_ack_evts = true;
      CCM_Server_impl::M_condition.broadcast();
    } catch (const Cdmw::InternalErrorException& ex) {
      CDMW_ASSERT(false);
    }
  }
}
