/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "ccm_local_event_manager/SecondEventTest_impl.hpp"

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createSecondEventTestFactory () {
        return new CcmLocalEventManagerTest::SecondEventTestFactory();
    }
};



// Constructor
CcmLocalEventManagerTest::SecondEventTest_impl::SecondEventTest_impl ()
{
}

// Copy Constructor
CcmLocalEventManagerTest::SecondEventTest_impl::SecondEventTest_impl (const SecondEventTest_impl& event)
{
    numOfEvent(event.numOfEvent());
}

// Destructor
CcmLocalEventManagerTest::SecondEventTest_impl::~SecondEventTest_impl ()
{
}

CORBA::ValueBase* 
CcmLocalEventManagerTest::SecondEventTest_impl::_copy_value()
{
    CcmLocalEventManagerTest::SecondEventTest_impl* result = new SecondEventTest_impl();
    result->numOfEvent(numOfEvent());
    
    return result;
}

/******************************/
/*         Factory            */
/******************************/


CcmLocalEventManagerTest::SecondEventTestFactory::SecondEventTestFactory()
{
}

CcmLocalEventManagerTest::SecondEventTestFactory::~SecondEventTestFactory()
{
}

CORBA::ValueBase * 
CcmLocalEventManagerTest::SecondEventTestFactory::create_for_unmarshal ()
{
    return new CcmLocalEventManagerTest::SecondEventTest_impl();
}

