/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "ccm_logging/FatalClientExecutor_impl.hpp"
#include "ccm_logging/FatalClientHomeExecutor_impl.hpp"


/**
 * IDL:thalesgroup.com/Hello:1.0
 */

extern "C"
{
    /**
     * Create a new client home.
     */
    Components::HomeExecutorBase*
    create_FatalClientHomeExecutor()
    {
        return new Hello::FatalClientHomeExecutor_impl();
    };
}; // extern C


namespace Hello
{
    /**
     * IDL:thalesgroup.com/Hello/CCM_ClientHome:1.0
     */


    /**
     * Default constructor.
     */
    FatalClientHomeExecutor_impl::FatalClientHomeExecutor_impl()
    {
    }


    /**
     * Destructor.
     */
    FatalClientHomeExecutor_impl::~FatalClientHomeExecutor_impl()
    {
    }


    /**
     * IDL:thalesgroup.com/Hello/CCM_ClientHomeImplicit/create:1.0
     */
    Components::EnterpriseComponent_ptr
    FatalClientHomeExecutor_impl::create()
        throw(Components::CCMException,
              CORBA::SystemException)
    {
        // create a new component in the client home.
        return new FatalClientExecutor_impl();
    }
}; // namespace Hello
