/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _CDMW_PIQ_CCM_PERF_INVOC_PINGFACETEXECUTOR_IMPL_HPP_
#define _CDMW_PIQ_CCM_PERF_INVOC_PINGFACETEXECUTOR_IMPL_HPP_


#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#include "TestPerf_cif.skel.hpp"


namespace TestPerf
{
    /**
     * IDL:thalesgroup.com/TestPerf/CCM_Ping:1.0
     */
    class CCM_Ping_impl
            : virtual public CCM_Ping,
              virtual public Cdmw::OrbSupport::RefCountLocalObject
    {
        public:
            CCM_Ping_impl();

            ~CCM_Ping_impl();

            /**
             * IDL:thalesgroup.com/TestPerf/Ping/synchronous_ping:1.0
             */
            virtual void
            synchronous_ping()
                throw(CORBA::SystemException);

        private:
            CCM_Ping_impl(const CCM_Ping_impl&);

            void
            operator=(const CCM_Ping_impl&);

    };
}; // namespace TestPerf


#endif // _CDMW_PIQ_CCM_PERF_INVOC_PINGFACETEXECUTOR_IMPL_HPP_
