/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>

#include "ccm_perf_invocations/CCM_ServerHome_impl.hpp"
#include "ccm_perf_invocations/CCM_Server_impl.hpp"

//
// IDL:thalesgroup.com/TestPerf:1.0
//

extern "C" {

//
// create a new server home
//
TestPerf::CCM_ServerHome_impl* create_CCM_ServerHome() 
{
    return new TestPerf::CCM_ServerHome_impl();
};

};  // End extern C


//
// IDL:thalesgroup.com/TestPerf/CCM_ServerHome:1.0
//
TestPerf::CCM_ServerHome_impl::CCM_ServerHome_impl()
{
}

TestPerf::CCM_ServerHome_impl::~CCM_ServerHome_impl()
{
}

//
// IDL:thalesgroup.com/TestPerf/CCM_ServerHomeImplicit/create:1.0
//
TestPerf::CCM_Server_ptr
TestPerf::CCM_ServerHome_impl::create()
  throw (CORBA::SystemException, Components::CCMException)
{
  // creation of a new component in the home
  return TestPerf::CCM_Server::_narrow(new CCM_Server_impl());
}


