/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>

#include "ccm_perf_invocations/CCM_Server_impl.hpp"
#include "ccm_perf_invocations/CCM_Ping_impl.hpp"

//
// IDL:thalesgroup.com/CCM_TestPerf/CCM_Server:1.0
//
TestPerf::CCM_Server_impl::CCM_Server_impl()
{
  m_ping_facet = new TestPerf::CCM_Ping_impl();
}

TestPerf::CCM_Server_impl::~CCM_Server_impl()
{
    std::cout << "CCM_Server_impl::~CCM_Server_impl called!" << std::endl;
}


::TestPerf::CCM_Ping_ptr
TestPerf::CCM_Server_impl::get_ping_facet ( )
  throw ( CORBA::SystemException )
{
  return  TestPerf::CCM_Ping::_duplicate(m_ping_facet.in());
}

