package cdmw.dinnerdemo;


import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.*;

import cdmw.ossupport.OS;
import cdmw.testutils.CORBATestManager;
import cdmw.testutils.TestManager;

import org.omg.Components.CCMObject;

 /**
     * This class provides an object to test Components and Ports registration in the Naming Service
     */
     
    public class CCMRegistrationTest {

        org.omg.Components.CCMObject component_ref;
        String instance_name;
   
        String createPortNSName(String port_name){
            //        String cdmw.ossupport.OS.getHostname()
            String name="DeploymentPlans/Q-406-2.DeploymentPlan/"+this.instance_name+"/"+port_name+".Port";
            return name;
        }

        String createComponentNSName(){
            return "DeploymentPlans/Q-406-2.DeploymentPlan/"+this.instance_name+".Component";
        }


        @Before
        public void init() {
          cdmw.common.Assert.check(CORBATestManager.getLocalInstance() != null);
          int counter=((Integer)CORBATestManager.instance().getLocalProperty("threadNb")).intValue();
           this.component_ref=(CCMObject)CORBATestManager.instance().getLocalProperty("ComponentRef"+counter);
           this.instance_name=(String)CORBATestManager.instance().getLocalProperty("ComponentInstanceName"+counter);

        }

        @Test
        public void doTests() {

         boolean testOk = false;
        cdmw.common.Assert.check(this.component_ref != null);

            System.out.println("/** Component and Facets Registration Test for component "+this.instance_name+ "**/");
            String system_port = System.getProperty(cdmw.orbsupport.ORBSupport.SYSTEM_PORT_PROPERTY_NAME);
            cdmw.common.Assert.check(!system_port.trim().equals(""));
           
               String corbaloc = "corbaloc::";
               corbaloc += "localhost";
               corbaloc += ":";
               corbaloc += system_port;
               corbaloc +="/NameService";

               cdmw.commonsvcs.naming.NamingInterface ni=null;
               org.omg.CORBA.Object o=null;

               try {
                   org.omg.CORBA.Object obj = cdmw.testutils.CORBATestManager.instance().getORB().string_to_object(corbaloc) ;
                   cdmw.common.Assert.check(obj!=null);

                   org.omg.CosNaming.NamingContext nc = org.omg.CosNaming.NamingContextHelper.narrow(obj);
                   ni= new cdmw.commonsvcs.naming.NamingInterface(nc);

               } catch (Exception ex) {
                   System.out.println("Unable to get NamingInterface reference");
                   ex.printStackTrace();                  
               }
               try{

               //checking facets registration
                  
                   org.omg.Components.FacetDescription[] facets=this.component_ref.get_all_facets();
                   if(facets.length==0) {
                           testOk=true;
                           System.out.println("Test: No Facets for component "+this.instance_name+"...");
                   }
               for(int i=0;i<facets.length;i++){
                   String name=createPortNSName(facets[i].name);
                   System.out.println("Looking for facet "+name+" in the Naming Service...");
                   o=ni.resolve(name);
                   if(o!=null)
                   {
                       System.out.println("Facet "+facets[i].name+" has been registered as "+name+"...");
                       testOk=true;
                   }
              
               }
               Assert.assertTrue(testOk);
               }
               catch(Exception e){
                   System.out.println("Facets names resolution FAILED");
                   e.printStackTrace();
               }

               //checking components registration
               try{
                   String name=createComponentNSName();
                   System.out.println("Test: looking for Component "+this.instance_name+" in the Naming Service...");
                   o=ni.resolve(name);
                   if(o==null) {
                   System.out.println("Test: "+this.instance_name+" has not been registered!!!");
                   testOk=false;
               }
               else System.out.println("Test "+this.instance_name+" has been registred as "+name+"...");
               Assert.assertTrue(testOk);
               
               }catch(Exception e){
                    System.out.println("Component name resolution FAILED!!!");
                   e.printStackTrace();                   
               }

}
}
