/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___TESTTIMEOUT_TIMEOUTTESTER_IMPL_HPP__
#define ___TESTTIMEOUT_TIMEOUTTESTER_IMPL_HPP__

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"
#include "ccm_receptacle_without_default_timeout/TestWithoutDefaultTimeout_cif.skel.hpp"


namespace TestWithoutDefaultTimeout
{


//
// IDL:thalesgroup.com/TestWithoutDefaultTimeout/CCM_TimeoutTester:1.0
//
class CCM_TimeoutTester_impl : virtual public ::TestWithoutDefaultTimeout::CCM_TimeoutTester,
                         virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    CCM_TimeoutTester_impl(const CCM_TimeoutTester_impl&);
    void operator=(const CCM_TimeoutTester_impl&);

public:

    CCM_TimeoutTester_impl();
    ~CCM_TimeoutTester_impl();

    //
    // IDL:thalesgroup.com/TestWithoutDefaultTimeout/CCM_TimeoutTester/sleep:1.0
    //
    virtual void sleep(CORBA::ULong)
        throw(CORBA::SystemException);

};

}; // End of namespace TestWithoutDefaultTimeout

#endif // ___TESTTIMEOUT_TIMEOUTTESTER_IMPL_HPP__

