/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <ccm_reconnect/TestEvent_impl.hpp>

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createTestEventFactory () {
        return new ReconnectDemo::TestEventFactory();
    }
};



// Constructor
ReconnectDemo::TestEvent_impl::TestEvent_impl ()
{
}

// Copy Constructor
ReconnectDemo::TestEvent_impl::TestEvent_impl (const TestEvent_impl& right)
{
    name(right.name());
}

// Destructor
ReconnectDemo::TestEvent_impl::~TestEvent_impl ()
{
}

CORBA::ValueBase* 
ReconnectDemo::TestEvent_impl::_copy_value()
{
    ReconnectDemo::TestEvent_impl* result = new TestEvent_impl();
    result->name(name());
    
    return result;
}

/******************************/
/*         Factory            */
/******************************/


ReconnectDemo::TestEventFactory::TestEventFactory()
{
}

ReconnectDemo::TestEventFactory::~TestEventFactory()
{
}

CORBA::ValueBase * 
ReconnectDemo::TestEventFactory::create_for_unmarshal ()
{
    return new ReconnectDemo::TestEvent_impl();
}

