/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.simpleccmserver;

import org.omg.CORBA.ORB;

import com.thalesgroup.CdmwPlatformMngt.ProcessDelegatePackage.NotReadyToRun;
import com.thalesgroup.CdmwPlatformMngtBase.StartupKind;

public class ClientProcessControl extends cdmw.cdmwinit.ProcessControl {
    private ORB orb;
    String serverHost;
    String pathToServer;
    public ClientProcessControl(ORB orb, String serverHost, String pathToServer) {
        this.orb = orb;
        this.serverHost = serverHost;
        this.pathToServer = pathToServer;
    }
    
    @Override
    public void onInitialise(StartupKind startupKind) {
        // TODO Auto-generated method stub
        
    }

    @Override
    public void onRun() throws NotReadyToRun {
    
        cdmw.testutils.CORBATestManager testManager = new cdmw.testutils.CORBATestManager();
        cdmw.testutils.CORBATestManager.activateLocalInstance(testManager);
        org.omg.CORBA.Object obj = this.orb.string_to_object("corbaname::" + this.serverHost + "/NameService#DeploymentPlans");
        org.omg.CosNaming.NamingContext root = org.omg.CosNaming.NamingContextHelper.narrow(obj);
        testManager.setLocalProperty("cdmw.simpleccmserver.rooot", root);

        testManager.setProperty("cdmw.simpleccmserver.pathToServer", pathToServer);
        testManager.addTest(TestCcmUnaware.class);
        testManager.runTests();
        testManager.printSummary();
    }

    @Override
    public void onStop() {
        // TODO Auto-generated method stub
        
    }

}
