/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _CDMW_PIQ_CCM_WITH_FEDERATED_CLOCKS_DISPLAYFACETEXECUTOR_IMPL_HPP_
#define _CDMW_PIQ_CCM_WITH_FEDERATED_CLOCKS_DISPLAYFACETEXECUTOR_IMPL_HPP_


#include <Foundation/logging/Logger.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#include "ServerExecutor_impl.hpp"
#include "CcmWithFederatedClocks_cif.skel.hpp"


namespace CcmWithFederatedClocks
{
    /**
     * IDL:thalesgroup.com/CcmWithFederatedClocks/CCM_Display:1.0
     */
    class DisplayFacetExecutor_impl
            : virtual public CCM_Display,
              virtual public Cdmw::OrbSupport::RefCountLocalObject
    {
        public:
            DisplayFacetExecutor_impl(ServerExecutor_impl *server);

            ~DisplayFacetExecutor_impl();

            /**
             * IDL:thalesgroup.com/CcmWithFederatedClocks/Display/print:1.0
             */
            virtual void
            display_hello(timingData_out outputData)
                throw(CORBA::SystemException);

        private:
            DisplayFacetExecutor_impl(const DisplayFacetExecutor_impl&);

            void
            operator=(const DisplayFacetExecutor_impl&);


        private:
            Cdmw::Logging::Logger* m_logger;
            ServerExecutor_impl *m_server;
    };
}; // namespace CcmWithFederatedClocks


#endif // _CDMW_PIQ_CCM_WITH_FEDERATED_CLOCKS_DISPLAYFACETEXECUTOR_IMPL_HPP_
