/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _CDMW_PIQ_CCM_XMS_CLIENTHOMEEXECUTOR_IMPL_HPP_
#define _CDMW_PIQ_CCM_XMS_CLIENTHOMEEXECUTOR_IMPL_HPP_


#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#include "XMLValidate_cif.skel.hpp"


namespace XMLValidate
{
    /**
     * IDL:thalesgroup.com/XMLValidate/CCM_ClientHome:1.0
     */
    class ClientHomeExecutor_impl
            : virtual public CCM_ClientHome,
              virtual public Cdmw::OrbSupport::RefCountLocalObject
    {
        public:
            ClientHomeExecutor_impl();

            ~ClientHomeExecutor_impl();

            /**
             * IDL:thalesgroup.com/XMLValidate/CCM_ClientHomeImplicit/create:1.0
             */
            virtual Components::EnterpriseComponent_ptr
            create()
                throw(Components::CCMException,
                      CORBA::SystemException);

        private:
            ClientHomeExecutor_impl(const ClientHomeExecutor_impl&);

            void
            operator=(const ClientHomeExecutor_impl&);
    };
}; // namespace XMLValidate


#endif // _CDMW_PIQ_CCM_XMS_CLIENTHOMEEXECUTOR_IMPL_HPP_
