/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _CDMW_PIQ_CCM_XMS_VALIDATORFACETEXECUTOR_IMPL_HPP_
#define _CDMW_PIQ_CCM_XMS_VALIDATORFACETEXECUTOR_IMPL_HPP_


#include <Foundation/logging/Logger.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <XMLServer/idllib/CdmwXML.stub.hpp>
#include "XMLValidate_cif.skel.hpp"


namespace XMLValidate
{
    /**
     * IDL:thalesgroup.com/XMLValidate/CCM_Validator:1.0
     */
    class ValidatorFacetExecutor_impl
            : virtual public CCM_Validator,
              virtual public Cdmw::OrbSupport::RefCountLocalObject
    {
        public:
            ValidatorFacetExecutor_impl();

            ~ValidatorFacetExecutor_impl();

            /**
             * IDL:thalesgroup.com/XMLValidate/Validator/print:1.0
             */
            virtual bool
            parse(const char* file)
                throw(CORBA::SystemException);

        private:
            ValidatorFacetExecutor_impl(const ValidatorFacetExecutor_impl&);

            void
            operator=(const ValidatorFacetExecutor_impl&);


        private:
            Cdmw::Logging::Logger* m_logger;
            CdmwXML::XMLParser_var m_parser;
    };

}; // namespace XMLValidate


#endif // _CDMW_PIQ_CCM_XMS_VALIDATORFACETEXECUTOR_IMPL_HPP_
