#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

echo "========================================================="
echo "=     CCM Java Code Generation Qualification Test       ="
echo "========================================================="
echo ""

VALIDATION_HOME=@config.install.dir@/share
RESULTS_DIR=$VALIDATION_HOME/Q-027-2-results

if [ -d "$RESULTS_DIR" ]; then
   echo "Cleanup results directory"
   rm -rf $RESULTS_DIR
fi
mkdir -p $RESULTS_DIR

cd $VALIDATION_HOME

echo "===== Executing code generation ====="

cdmw_code_generator.sh \
   --xml=$VALIDATION_HOME/Q-027-data/Q-027-2.xml \
   --dir=$RESULTS_DIR \
   --lang=java --validate

echo "===== Check the created file ====="

file_list="$RESULTS_DIR/CdmwInterface.java \
$RESULTS_DIR/Proc_desc.dtd \
$RESULTS_DIR/SessionServerImpl.java \
$RESULTS_DIR/SessionClientImpl.java \
$RESULTS_DIR/SessionNamedComponentImpl.java \
$RESULTS_DIR/SessionServerHome_impl.java \
$RESULTS_DIR/SessionClientHome_impl.java \
$RESULTS_DIR/SessionNamedComponentHome_impl.java \
$RESULTS_DIR/CCM_Server_SessionContextImpl.java \
$RESULTS_DIR/CCM_Client_SessionContextImpl.java \
$RESULTS_DIR/CCM_NamedComponent_SessionContextImpl.java \
$RESULTS_DIR/DisplayImpl.java \
$RESULTS_DIR/Cdmw_Q-027_cif.idl \
$RESULTS_DIR/Q-027_cif.idl"



all_is_generated="true"

for file in $file_list
do
if test -f $file
then
    echo "the file $file is generated"
else
    echo "##### the file $file is not generated #####"
    all_is_generated=false
fi
done
echo ""

echo "===== Global test result ====="

if test "$all_is_generated" = false
then
    echo "    The test is NOT OK"
else
    echo "    The test is OK"
fi
