#!/bin/ksh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

# name of current test
export CDMW_TEST_ID=Q-XXX

TODAY=$(date +%Y%m%d)

# directory for traces
CDMW_TEST_OUT=${CDMW_TEST_OUT:-@config.install.dir@/TEST-RESULTS}

export OUT=${CDMW_TEST_OUT}/${CDMW_TEST_ID}_${TODAY}

if [ ! -d ${OUT} ]; then
    echo "create dir ${OUT}"
    mkdir -p ${OUT}
    chmod 777 ${OUT}
fi

# get current pid (this will be program pid)
PID=$$

# get program name
PROGNAME=`basename ${1} | sed s%[.]%_%g`

# get host name
HOSTNAME=${HOSTNAME:-`hostname`}

# logfile name
LOGFILE=${OUT}/${HOSTNAME}_${PROGNAME}__${PID}.log
rm -f ${LOGFILE}


echo
echo "______ ${CDMW_TEST_ID} ________"
echo
echo "Log file is: ${LOGFILE}"


# log command line in logfile
echo "" > ${LOGFILE}
echo "> ${*}" >> ${LOGFILE}
echo "" >> ${LOGFILE}

# start tail on logfail in background to display log
tail -f --pid=$$ ${LOGFILE} &

# exec program
exec ${*} >> ${LOGFILE} 2>&1

