/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.faulttoleranceclient1;

import org.omg.CORBA.*;

public class TestUtils {
    private static final int NO_PRIMARY = -1;

    private TestUtils() {
    }

    public static int get_object_group_version(ORB orb,
        org.omg.CORBA.Object object_group) throws UserException {

        cdmw.ft.JacORBIOGRFactory iogrFactory = new cdmw.ft.JacORBIOGRFactory(orb);

        org.omg.FT.TagFTGroupTaggedComponent tag = iogrFactory
            .decode_profile_with_group_tag(object_group, 0);
        return tag.object_group_ref_version;

    }

    public static int get_number_of_member(ORB orb,
        org.omg.CORBA.Object object_group) throws UserException {

        cdmw.ft.JacORBIOGRFactory iogrFactory = new cdmw.ft.JacORBIOGRFactory(orb);

        int nb_profile = iogrFactory.profile_count(object_group);

        return (nb_profile - 2);
    }

    // public static org.omg.CORBA.Object
    // update_group_with_primary_outside_cdmw_ft
    // (ORB orb,
    // org.omg.CORBA.Object object_group,
    // com.thalesgroup.CdmwFT.ReplicationManager replication_manager,
    // NameComponent[] primary_location)
    // throws UserException {
    // // get members of the group
    // GroupInfo group_info =
    // replication_manager.get_object_group_info(object_group);
    //
    // // create object group
    // org.omg.CORBA.Object new_object_group = null;
    // org.omg.CORBA.Object[] no_fallBack = new org.omg.CORBA.Object[8];
    //
    // com.thalesgroup.Cdmw.FT.IOGRFactory iogrFactory = new
    // com.thalesgroup.Cdmw.FT.IOGRFactory();
    //        
    // new_object_group = iogrFactory.build_iogr(group_info.members,
    // primary_location,
    // group_info.object_group_id,
    // "type_id",
    // "My_FTdomain",
    // group_info.object_group_ref_version,
    // no_fallBack);
    //
    //
    // return new_object_group;
    // }
}
