/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testftperffailure/TestHello_impl.hpp"
#include <Foundation/common/Assert.hpp>
namespace Cdmw
{
    
    server_impl::server_impl ( bool kill, FT::client_ptr client)
        : m_kill(kill),
          m_client(FT::client::_duplicate(client))
    {
    }
    


   server_impl::~server_impl ()
       throw()
   {
   }

    void server_impl::kill_primary()
        throw(CORBA::SystemException)                  
    {
        if (m_kill)
        {
            m_client->kill_pirmary();
            exit(0);
        }
        
    }

    client_impl::client_impl ()
    {
    }
    


   client_impl::~client_impl ()
       throw()
   {
   }

    void client_impl::is_primary (const char* host)
        throw(CORBA::SystemException)                  
    {
        m_time_primary = Cdmw::OsSupport::OS::get_time();
        std::cout<< "***m_time exit"<<m_time_exit.seconds <<":"<<m_time_exit.microseconds<<std::endl;;
        std::cout<< "***m_time activation"<<m_time_primary.seconds <<":"<<m_time_primary.microseconds<<std::endl;        

        m_elapse_time = (unsigned long)((m_time_primary.seconds - m_time_exit.seconds)*1000000 + (m_time_primary.microseconds- m_time_exit.microseconds))/1000;
        //std::cout<<"m_elapse time :"<<m_elapse_time<< " ms"<<std::endl;
        
    }


    void client_impl::kill_pirmary()
        throw(CORBA::SystemException)
    {
        m_time_exit = Cdmw::OsSupport::OS::get_time();
    }
    

}; // End namespace Cdmw

