/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CDMW_TEST_HELLO_INTERFACE_IMPL_HPP 
#define INCL_CDMW_TEST_HELLO_INTERFACE_IMPL_HPP 


#include <testfttimeoutrequest/TestHello.skel.hpp>

#include <FaultTolerance/idllib/CdmwFTActivation.stub.hpp>



namespace Cdmw
{

namespace Test
{

class HelloInterface_impl :
public virtual POA_CdmwFT::Test::HelloInterface,
        virtual public PortableServer::RefCountServantBase
{

    public:

        /**
        * Purpose:
        * <p> [Constructor description if necessary]
        * 
        *@param
        *@exception
        */ 
        HelloInterface_impl(CORBA::ORB_ptr orb, 
                            std::string location,
                            CdmwFT::Location::ActivationHandler_ptr activation_handler)
            throw(CORBA::SystemException);

        /**
        * Purpose:
        * <p> [ Destructor description if necessary]
        * 
        */ 
        virtual 
        ~HelloInterface_impl()
                throw();
    
        //
        // IDL:thalesgroup.com/CdmwFT/Test/Hello/hello:1.0
        //
        virtual void hello (CdmwFT::Test::ComputInterface_ptr comput, 
                            CORBA::ULong time_ms)
            throw(CORBA::SystemException);
                  
        //
        // IDL:thalesgroup.com/CdmwFT/Test/Hello/init:1.0
        //
        virtual void init (::FT::ObjectGroup_ptr group_ref)
            throw(CORBA::SystemException);


    virtual void HelloInterface_impl::send_TRANSIENT_exception ()
        throw(CORBA::SystemException);
      
    
    private:

        // Hide copy constructor/assignment operator
        HelloInterface_impl(const HelloInterface_impl& rhs)
                throw();
        
        HelloInterface_impl&
        operator=(const HelloInterface_impl& rhs)
                throw();

        CORBA::ORB_var m_orb;

        unsigned long m_nb_hello;

        std::string m_location;

        CdmwFT::Location::ActivationHandler_var m_activation_handler;



}; // End class HelloInterface_impl 

}; // End namespace Test

}; // End namespace Cdmw

#endif // INCL_CDMW_TEST_HELLO_INTERFACE_IMPL_HPP 

