/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CDMW_TEST_COMPUT_INTERFACE_IMPL_HPP 
#define INCL_CDMW_TEST_COMPUT_INTERFACE_IMPL_HPP 


#include <testtimeoutrequest/TestHelloNonFT.skel.hpp>

#include <FaultTolerance/idllib/CdmwFTActivation.stub.hpp>



namespace Cdmw
{

namespace Test
{

class ComputInterface_impl :
public virtual POA_CdmwFT::Test::ComputInterface,
        virtual public PortableServer::RefCountServantBase
{

    public:

        /**
        * Purpose:
        * <p> [Constructor description if necessary]
        * 
        *@param
        *@exception
        */ 
        ComputInterface_impl(CORBA::ORB_ptr orb, 
                            std::string location)
            throw(CORBA::SystemException);

        /**
        * Purpose:
        * <p> [ Destructor description if necessary]
        * 
        */ 
        virtual 
        ~ComputInterface_impl()
                throw();
    
        //
        // IDL:thalesgroup.com/CdmwFT/Test/Comput/get_result:1.0
        //
        virtual CORBA::Long get_result (CORBA::ULong time_ms)
            throw(CORBA::SystemException);
        

        //
        // IDL:thalesgroup.com/CdmwFT/Test/Comput/get_result_forward:1.0
        //
        virtual CORBA::Long get_result_forward (CORBA::ULong time_ms)
            throw(CORBA::SystemException);      

    private:

        // Hide copy constructor/assignment operator
        ComputInterface_impl(const ComputInterface_impl& rhs)
                throw();
        
        ComputInterface_impl&
        operator=(const ComputInterface_impl& rhs)
                throw();

        CORBA::ORB_var m_orb;

        std::string m_location;
    

}; // End class ComputInterface_impl 

}; // End namespace Test

}; // End namespace Cdmw

#endif // INCL_CDMW_TEST_COMPUT_INTERFACE_IMPL_HPP 

