/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testtimeoutrequest/HelloServantLocator.hpp"

#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>


#include <Foundation/ossupport/OS.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>             

#include <fstream>

        

PortableServer::Servant
HelloServantLocator::preinvoke(
        const PortableServer::ObjectId& oid,
        PortableServer::POA_ptr poa,
        const char* operation,
        PortableServer::ServantLocator::Cookie& the_cookie)
   throw (CORBA::SystemException, PortableServer::ForwardRequest)
{
    std::cout << " test_server : HelloServantLocator::preinvoke of '" << operation << "'" << std::endl;
    CORBA::String_var oid_string = PortableServer::ObjectId_to_string(oid);
    std::string oid_str(oid_string);
    
    if( oid_str.compare("Hello") == 0 )
    {
        return m_hello_servant;
    }
    
    if( oid_str.compare("Comput") == 0 )
    {
    
    if( (strcmp(operation, "get_result_forward") != 0) || (m_process_name.compare("P21") != 0) ) 
    {
       return m_comput_servant;  // normal case
    }

    CORBA::Object_var obj;

    try
    {
            obj = m_naming_interface.resolve ("dom3/P41ComputInterface");
    }
    catch (const CORBA::SystemException& e)
    {
            std::cout<< e << std::endl;
            throw CORBA::OBJECT_NOT_EXIST(Cdmw::OrbSupport::OBJECT_NOT_EXIST, CORBA::COMPLETED_NO);
    }    
        std::cout << " test_server : HelloServantLocator::preinvoke forwarding" << std::endl;

    throw PortableServer::ForwardRequest(obj); 
    }
    std::cout<< "throw CORBA::OBJECT_NOT_EXIST" << std::endl;        
    throw CORBA::OBJECT_NOT_EXIST(Cdmw::OrbSupport::OBJECT_NOT_EXIST, CORBA::COMPLETED_NO);
}

void 
HelloServantLocator::postinvoke(
        const PortableServer::ObjectId& oid,
        PortableServer::POA_ptr poa,
        const char* operation,
        PortableServer::ServantLocator::Cookie the_cookie,
        PortableServer::Servant the_servant)
    throw(CORBA::SystemException)
{
    //nothing to do
}



