/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testAMI;

import org.omg.CORBA.*;

import com.thalesgroup.CdmwPlatformMngt.ProcessDelegatePackage.NotReadyToRun;
import com.thalesgroup.CdmwPlatformMngtBase.StartupKind;

public class ClientProcessControl extends cdmw.cdmwinit.ProcessControl {
    /**
     * The orb reference.
     */
    private ORB orb;

    // TODO AMI.idl
    private Cdmw.TestAMI.Server server;

    public ClientProcessControl(
        ORB orb) {
        this.orb = orb;
    }

    @Override
    public void onInitialise(StartupKind startupKind) {
    }

    @Override
    public void onRun() throws NotReadyToRun {
        // 
        // Retrive Server
        //
        System.out.println("Retrive Server object from Repository");

        // Get the naming and repository from Repository interface
        try {
            com.thalesgroup.CdmwNamingAndRepository.Repository repository = null;
            repository = cdmw.namingandrepository.RepositoryInterface
                .getRepository();

            // Get Naming Interface of dom1 name domain
            cdmw.commonsvcs.naming.NamingInterface ni = cdmw.namingandrepository.RepositoryInterface
                .getDomainNamingInterface("dom1");

            // Get the Server object from repository
            org.omg.CORBA.Object objref = ni.resolve("Server");

            // get the Server proxy
            this.server = Cdmw.TestAMI.ServerHelper.narrow(objref);
        }
        catch (com.thalesgroup.CdmwNamingAndRepository.NoNameDomain ex1) {
            ex1.printStackTrace();
        }
        catch (org.omg.CosNaming.NamingContextPackage.NotFound ex2) {
            ex2.printStackTrace();
        }
        catch (com.thalesgroup.CdmwNamingAndRepository.InvalidName ex3) {
            ex3.printStackTrace();
        }
        catch (org.omg.CosNaming.NamingContextPackage.CannotProceed ex4) {
            ex4.printStackTrace();
        }
        catch (Exception e) {
            e.printStackTrace();
        }

        if (this.server == null) {
            (new Throwable()).printStackTrace();
            System.err.println("could not _narrow object to type Server");
            throw new com.thalesgroup.CdmwPlatformMngt.ProcessDelegatePackage.NotReadyToRun();
        }

        // 
        // start tests
        //
        try {
            System.out.println("Running the Client tests");
            cdmw.testutils.CORBATestManager.instance().add("server",
                this.server);
            cdmw.testutils.CORBATestManager.instance()
                .addTest(ClientTest.class);
            cdmw.testutils.CORBATestManager.instance().runTests();
            cdmw.testutils.CORBATestManager.instance().printSummary();
        }
        catch (Exception e) {
            e.printStackTrace();
        }

    }

    @Override
    public void onStop() {
    }
}
