/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testAMI;

import org.junit.Assert;
import org.junit.Test;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import Cdmw.TestAMI.*;

public class ClientTest {
    private ORB orb;

    private POA rootPOA;

    private ServerHandlerImpl pServerHandler_impl;

    private Cdmw.TestAMI.AMI_ServerHandler serverHandler;

    public ClientTest() {
        try {
            this.orb = cdmw.testutils.CORBATestManager.instance().getORB();
            this.rootPOA = POAHelper.narrow(cdmw.testutils.CORBATestManager
                .instance().getPOA());

            // create the ServerHandler servant
            pServerHandler_impl = new ServerHandlerImpl(this.orb);

            byte[] oid = this.rootPOA.activate_object(pServerHandler_impl);

            org.omg.CORBA.Object object = this.rootPOA.id_to_reference(oid);
            this.serverHandler = Cdmw.TestAMI.AMI_ServerHandlerHelper.narrow(object);            
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void doTests() {
        Cdmw.TestAMI.Server server = null;
        try {
            org.omg.CORBA.Object obj1 = cdmw.testutils.CORBATestManager
                .instance().getObject("server");
            server = Cdmw.TestAMI.ServerHelper.narrow(obj1);

        }
        catch (Exception e0) {
            e0.printStackTrace();
        }
        System.out
            .println("send asynchronous request request_sleeping() to server");
        ((Cdmw.TestAMI._ServerStub) server).sendc_request_sleeping(
            this.serverHandler, (short) 3000, (short) 3);

        try {
            System.out.println("waiting result...");
            cdmw.ossupport.OS.sleep(6000);

            if (pServerHandler_impl.checkRequestSleepingResult() != 1) {
                Assert.assertTrue(false);
            }

            System.out
                .println("send asynchronous request request_sending_exception() to server");
            ((Cdmw.TestAMI._ServerStub) server)
                .sendc_request_sending_exception(this.serverHandler);

            System.out.println("waiting result...");
            cdmw.ossupport.OS.sleep(8000);

            if (pServerHandler_impl.checkRequestSendingExceptionResult() != 1) {
                Assert.assertTrue(false);
            }
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}
