/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testAMI;

import org.omg.CORBA.ORB;
import org.omg.CORBA.ShortHolder;

import Cdmw.TestAMI.TestException;

public class ServerImpl extends Cdmw.TestAMI.ServerPOA {
    private static final short EXPECTED_RETURN_VALUE = 10;

    private static final short EXPECTED_A_VALUE = 20;

    private static final short EXPECTED_B_VALUE = 30;

    private ORB orb;

    public ServerImpl(
        ORB orb) {
        this.orb = orb;
    }

    public void request_sending_exception() throws Cdmw.TestAMI.TestException 
    {
        System.out.println("  receive request request_sending_exception()");
        try 
        {
        cdmw.ossupport.OS.sleep(3000);
        }
        catch (InterruptedException e) 
        {
        e.printStackTrace();
        }

        throw new Cdmw.TestAMI.TestException();
    }

    public short request_sleeping(short time_to_sleep, ShortHolder a,
        ShortHolder b) {
        System.out.println("  receive request request_sleeping()");
        short ret = EXPECTED_RETURN_VALUE;
        a.value = EXPECTED_A_VALUE;
        b.value = EXPECTED_B_VALUE;

        System.out.println("  server sleeping during " + time_to_sleep
            + " ms...");
        try {
            cdmw.ossupport.OS.sleep(time_to_sleep);
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }

        return ret;
    }

}