/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.testcodec;

import org.omg.CORBA.*;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.Servant;

import cdmw.orbsupport.Codec;

import Cdmw.TestCodec.*;

public class DataTransferImpl extends Cdmw.TestCodec.DataTransferPOA {
    private ORB orb = null;

    private DataManager dataMgr;

    private cdmw.orbsupport.Codec codec = new Codec();

    public DataTransferImpl(ORB orb) { 
        this.orb = orb;
        this.dataMgr = new DataManager(orb);
        Codec.init(this.orb);
    }

    public void send_data(byte[] data) throws Cdmw.TestCodec.DecodingFailure {
        //Create Any
        Any a = this.orb.create_any();
        OctetSeqHelper.insert(a, data);

        TestStruct testStruct = null;
        try {
            testStruct = (TestStruct) this.codec.decode(a);
        }
        catch (SystemException e) {
            System.err.println("ERROR during decode:\n"
                + cdmw.orbsupport.ORBSupport.exceptionToString(e));
            e.printStackTrace();
            throw new DecodingFailure();
        }
        catch (Exception e) {
            System.err.println("ERROR during decode:");
            e.printStackTrace();
            throw new DecodingFailure();
        }

        this.dataMgr.checkTestStruct(testStruct);
    }
}
