/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <string>
#include <iostream>
#include "Foundation/common/Exception.hpp"
#include "Foundation/ossupport/OS.hpp"

std::string timestr;

void testException()
{
    timestr = Cdmw::OsSupport::get_fmt_current_localtime("%Y-%m-%dT%H:%M:%S"); 
 
    CDMW_THROW(Cdmw::OutOfMemoryException);
}

int main()
{
    bool succeeded = true;
 
    std::cout << "\n   exception test Q-430-1 \n\n" ;
    try
    {
        testException();

        std::cout << "Error: no exception is thrown " << std::endl; 
        succeeded = false;        
    }
    catch (const Cdmw::Exception &ex)
    {
        std::cout << "checking what().. " << std::endl 
                  << ex.what() << "\n\n" ;

    std::string ex_what(ex.what()) ;
        int ti = ex_what.find("Time:");
        int ri = ex_what.find("Reason:");
        std::string ex_what_time = ex_what.substr(ti+5, ri-ti-6);

        if(ex_what_time != timestr) 
        {
           std::cout << "Error in what():" << std::endl 
                     << "timestamp in what(): " << ex_what_time << std::endl 
                     << "   etalon timestamp: " << timestr << std::endl ; 
           succeeded = false;
        } 

        //std::cout << "checking operator << .." << std::endl 
        //          << ex << "\n" ;

        std::cout << "checking get_timestamp().." << std::endl ;
        std::string ex_time = ex.get_timestamp();

        if(ex_time != timestr) 
        {
           std::cout << "Error in get_timestamp():" << std::endl 
                     << "   get_timestamp: " << ex_time << std::endl 
                     << "etalon timestamp: " << timestr << std::endl ; 
           succeeded = false;
        } 
    }
    if(succeeded) std::cout << "Test OK" << std::endl ;
    else          std::cout << "Test FAILED" << std::endl ;
}

