/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef ___FT_COMP_WITH_TIMERS_TEST_CCM_CLIENT_IMPL_HPP__
#define ___FT_COMP_WITH_TIMERS_TEST_CCM_CLIENT_IMPL_HPP__

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/osthreads/ThreadHandle.hpp>

#include <ft_comp_with_timers/User_ft_comp_with_timers.skel.hpp>

namespace FTCompWithTimersTest
{

 class CCM_Client_impl;
    

class test_ft_comp_with_timers_activate : public CppUnit::TestFixture
{
    CCM_Client_impl * m_user_ccm_client;

    ::FTCompWithTimersTest::CCM_Client_Context_var m_session_context;
    
public:
    test_ft_comp_with_timers_activate()
    {
        CORBA::Object_var obj1 = Cdmw::TestUtils::CORBATestManager::instance()->get_object("client_context");
        m_session_context = ::FTCompWithTimersTest::CCM_Client_Context::_narrow(obj1.in());
    };
    

    ~test_ft_comp_with_timers_activate()
    {
    };

    //
    // Testable operations
    //
    void do_tests();
    
    void test_connections();

    CPPUNIT_TEST_SUITE( test_ft_comp_with_timers_activate );
    CPPUNIT_TEST( do_tests );
    CPPUNIT_TEST_SUITE_END();

};
       
    
class TestThread : public Cdmw::OsSupport::Thread 
{
    public:
        TestThread()
         {};
        
    protected:
        void run() throw()
        {
            Cdmw::TestUtils::ThreadedTestRunner runner(Cdmw::TestUtils::CORBATestManager::instance()->get_controller());
            runner.addTest( CppUnit::TestFactoryRegistry::getRegistry("test_ft_comp_with_timers_activate").makeTest() );
            runner.start();
            runner.join();
        };
        
    private:
        TestThread(const TestThread&);
        TestThread& operator = (const TestThread&);
};

    
//
// IDL:thalesgroup.com/UserFTCompWithTimersTest/CCM_Client:1.0
//
class CCM_Client_impl : virtual public ::UserFTCompWithTimersTest::User_CCM_Client,
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    CCM_Client_impl(const CCM_Client_impl&);
    void operator=(const CCM_Client_impl&);


    ::FTCompWithTimersTest::CCM_Client_Context_var m_session_context;
     
public:

    CCM_Client_impl();
    ~CCM_Client_impl();
     

        
    virtual char* get_hostname()
        throw (CORBA::SystemException);
    
    
    
    //
    // consumer hostnameResults
    //
    virtual void push_hostnameResults (FTCompWithTimersTest::HostnameResult * event)
        throw (CORBA::SystemException);
     

    //
    // Session component specific operations
    //
    void set_session_context(Components::SessionContext_ptr ctx)
        throw(CORBA::SystemException);
    void ccm_activate()
        throw(CORBA::SystemException);
    void ccm_passivate()
        throw(CORBA::SystemException);
    void ccm_remove()
        throw(CORBA::SystemException);


    ::FTCompWithTimersTest::CCM_Client_Context* get_context()
    {
        return ::FTCompWithTimersTest::CCM_Client_Context::_duplicate(m_session_context.in());
    }

    //
    // get result of assynchronous getHostname command
    //
    char* getHostnameCommandResult();

private:
    
    
    TestThread m_testThread;
    
};

}; // End of namespace FTCompWithTimersTest


#endif // ___FT_COMP_WITH_TIMERS_TEST_CCM_CLIENT_IMPL_HPP__

