/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef __INCL_CDWM_PRODTESTS_CCMCLIENTHOMEIMPL_HPP__
#define __INCL_CDWM_PRODTESTS_CCMCLIENTHOMEIMPL_HPP__

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <Foundation/logging/Logger.hpp>

#include "test_ccm_container_virtual_size/container_virtual_size_cif.skel.hpp"

namespace ContainerVirtualSize
{

//
// IDL:thalesgroup.com/ContainerVirtualSize/CCM_ClientHome:1.0
//
/**
 * Component home implementation of Client
 */
class CCM_ClientHome_impl 
   : virtual public ContainerVirtualSize::CCM_ClientHome,
     virtual public Cdmw::OrbSupport::RefCountLocalObject
{
private:
    /**
     * Purpose:
     * <p> Copy constructor
     */
    CCM_ClientHome_impl(const CCM_ClientHome_impl&);

    /**
     * Purpose:
     * <p> Assignment operator
     */
    void operator=(const CCM_ClientHome_impl&);

    /**
     * Pupose:
     * <p> Class logger
     */
    Cdmw::Logging::Logger* m_logger;


public:
    /**
     * Purpose:
     * <p> Constructor
     */
    CCM_ClientHome_impl();
      
    /**
     * Purpose:
     * <p> Copy constructor
     */
    ~CCM_ClientHome_impl();

    //
    // IDL:thalesgroup.com/ContainerVirtualSize/CCM_ClientHomeImplicit/create:1.0
    //
    /**
     * Purpose:
     * <p> Create a component implementation
     *
     * @return a pointer on a newly allocated component implementation
     *
     * @exception Components::CCMException
     * @exception CORBA::SystemException
     */
    virtual Components::EnterpriseComponent_ptr create()
       throw(Components::CCMException,
             CORBA::SystemException);
};
    
} // End of namespace ContainerVirtualSize

#endif // __INCL_CDWM_PRODTESTS_CCMCLIENTHOMEIMPL_HPP__
