/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <Foundation/logging/FunctionLogger.hpp>

#include "test_ccm_container_virtual_size/CCM_ServerLBClientFTHome_impl.hpp"
#include "test_ccm_container_virtual_size/CCM_ServerLBClientFT_impl.hpp"

//
// IDL:thalesgroup.com/ContainerVirtualSize:1.0
//
namespace ContainerVirtualSize
{

CCM_ServerLBClientFTHome_impl::CCM_ServerLBClientFTHome_impl(const CCM_ServerLBClientFTHome_impl& impl)
{
    CDMW_LOG_FUNCTION(m_logger, "CCM_ServerLBClientFTHome_impl::CCM_ServerLBClientFTHome_impl Copy Constructor");
}

void CCM_ServerLBClientFTHome_impl::operator=(const CCM_ServerLBClientFTHome_impl& impl)
{
    CDMW_LOG_FUNCTION(m_logger, "CCM_ServerLBClientFTHome_impl::operator=");
}


//
// IDL:thalesgroup.com/ContainerVirtualSize/CCM_ServerLBClientFTHome:1.0
//
CCM_ServerLBClientFTHome_impl::CCM_ServerLBClientFTHome_impl()
  : m_logger(Cdmw::Logging::Logger::Get_Logger("QUALIF_CONTAINER_VIRTUAL_SIZE","CCM_ServerLBClientFTHome_impl"))
{
    CDMW_LOG_FUNCTION(m_logger, "CCM_ServerLBClientFTHome_impl::CCM_ServerLBClientFTHome_impl Constructor");
}

CCM_ServerLBClientFTHome_impl::~CCM_ServerLBClientFTHome_impl()
{
    CDMW_LOG_FUNCTION(m_logger, "CCM_ServerLBClientFTHome_impl::~CCM_ServerLBClientFTHome_impl Destructor");
}

//
// IDL:thalesgroup.com/ContainerVirtualSize/CCM_ServerLBClientFTHomeImplicit/create:1.0
//
Components::EnterpriseComponent_ptr
CCM_ServerLBClientFTHome_impl::create()
    throw(Components::CCMException,
          CORBA::SystemException)
{
    CDMW_LOG_FUNCTION(m_logger, "CCM_ServerLBClientFTHome_impl::create");

    // creation of a new component in the server home
    return new CCM_ServerLBClientFT_impl();
}

} // End of namespace ContainerVirtualSize



extern "C" 
{
    /**
     * create a new server home
     *
     * @return a pointer on a newly allocated component home implementation
     */
    Components::HomeExecutorBase* create_CCM_ServerLBClientFTHome()
    {
        return new ContainerVirtualSize::CCM_ServerLBClientFTHome_impl();
    };

};  // End extern C
