##################################################
## QTPDR requirements
##################################################
LB_OH <- 10

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
##################################################
## return number x with dec decimal
##################################################
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

##################################################
## local definitions
##################################################

warmup <- 10      # if warmup=N then the first N samples are filtered out (warm up stage)
threshold <- 1    # if threshold=N then N% of samples is filtered out
results <- "test_summary.result.Q-340-2"

## Get data
data_lb<-scan("Q-340_CR_0_DELTA_C_LB.dat")
data<-scan("Q-340_CR_0_DELTA_C.dat")

## filtering data 
data_lb_f<-filter(data_lb)
data_f<-filter(data)

## media

media_lb<-mean(data_lb_f)
media<-mean(data_f)

## standard deviation

std_dev<-sd(data_f)
std_dev_lb<-sd(data_lb_f)

## calculate difference in percentage

diff_perc <- ((media_lb-media)/media) * 100

## write results
write("***** PERFORMANCE TEST Q-340-2 *******", results)
write("**************************************", results, append=TRUE);
write(ncolumns=3,c(" result: LB invocation overhead:",
                   num_dec(diff_perc,2),
           " %"),
                   results,append=TRUE);
write("**************************************",results,append=TRUE);

##################################################
## write test OK/NOK to a file 
##################################################

if (diff_perc <= LB_OH) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-340-2")
