##################################################
## QTPDR requirements
##################################################
LB_START_TIME <- 10 # msec

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-357-2"
serverdatafile <- "Q-357-2_LBInitServerStartTime.txt"

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

## Acquisition data
DATASET1<-scan(serverdatafile)
ServerStartTime<-mean(DATASET1) # from usec to msec

write("******** PERFORMANCE TEST Q-357-2 ******", results)
write("", results, append=TRUE)
write("Results:", results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)
write(ncolumns=2, c("Number of samples.....: ",length(DATASET1)),results, append=TRUE)
write(ncolumns=2, c("LB Start Time (server): ",ServerStartTime),results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)

##################################################
## write test OK/NOK to a file 
##################################################

if (ServerStartTime <= LB_START_TIME) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-357-2")
