/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.lb.test;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class MainStartLBTime {

        static long time_start = 0; //millisec
        static long time_stop = 0; //millisec
        static long time_elapsed = 0; //millisec
        static String fileServerStart = "LBInitServerStartTime.txt";
        
    public static void main(String[] args) { 
        //get host name
        String LBGroupManagerCorbaloc = cdmw.ossupport.OS.getOptionValue(args,
                "--LBGroupManager");
        String PrefixFile = cdmw.ossupport.OS.getOptionValue(args,
        "--FilePrefix");
        String SIteration = cdmw.ossupport.OS.getOptionValue(args,
        "--Iteration");
        int iteration = Integer.parseInt(SIteration);
        
        if(LBGroupManagerCorbaloc.equalsIgnoreCase("") || LBGroupManagerCorbaloc == null     
           || LBGroupManagerCorbaloc.equalsIgnoreCase(null)){
                System.out.println("Error, i need --LBGroupManager option to tun!!!");
        }
        if(PrefixFile.equalsIgnoreCase("") || PrefixFile == null || PrefixFile.equalsIgnoreCase(null)){
                System.out.println("Error, i need --PrefixFile option to tun!!!");
        }
        if(SIteration.equalsIgnoreCase("") || SIteration == null || SIteration.equalsIgnoreCase(null)){
                System.out.println("Error, i need --Iteration option to tun!!!");
        }
        
        fileServerStart = PrefixFile + fileServerStart;
        File fOut = new File(fileServerStart);
        if(fOut.exists()) fOut.delete();
        String[] ORB_init_args = new String[(args.length) + 2];
        for (int i = 0; i < args.length; i++)
        {
            ORB_init_args[i] = args[i];
        }
        ORB_init_args[args.length  ] = "--LBInterceptorSide=Server";
        ORB_init_args[args.length+1] = LBGroupManagerCorbaloc;
        
        System.out.println("LBInit server side");
        System.out.println("Num invocation: "+iteration);
        for(int i=0;i<iteration;i++){
            time_start = System.currentTimeMillis();
            cdmw.lb.lbinit.LBServiceInit.init(ORB_init_args);
            time_stop = System.currentTimeMillis();
            time_elapsed = time_stop - time_start;
            writeInFile(fileServerStart,time_elapsed);
        }
        
        System.out.println("LBInit server side OK");
        System.out.println("Writed millisec file "+fileServerStart);
    }
        
        private static void writeInFile(String nameFile, long value) {
            File fOut = new File(nameFile);
            PrintWriter out = null;
            try {
                    fOut.createNewFile();
                    out = new PrintWriter(new FileWriter(nameFile,true));
            } catch (IOException e) {
                    e.printStackTrace();
                    return;
            }
            out.println(value);
            out.flush();
            out.close();
        }

}
