##################################################
## QTPDR requirements
##################################################
SYNCH_DIFF <- 100 # msec

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-358-1"
datafile <- "Q-358-1_ntp_sync_offset.dat"

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

## Acquisition data
DATASET1<-scan(datafile)
ntp_sync_diff<-DATASET1[1]
write("******** PERFORMANCE TEST Q-358-1 ******", results)
write("", results, append=TRUE)
write("Results:", results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)
write(ncolumns=3, c("NTP synch diff....: ",ntp_sync_diff, "ms"),results, append=TRUE)
write(ncolumns=3, c("QTPDR Requirement.: ",SYNCH_DIFF, "ms"),results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)

##################################################
## write test OK/NOK to a file 
##################################################

if (ntp_sync_diff <= SYNCH_DIFF) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-358-1")
