#!/bin/sh
# 
ID_=[28/09/2007]

if [ -z $1 ]
then
  echo "Usage: $0 [output file]"
  echo $ID_
  exit 1
fi

OUTFILE="$1"
NTPQ_EXE="/usr/sbin/ntpq"

if [ ! -x $NTPQ_EXE ]
then
  echo "$0:"
  echo "ERROR: Unable to find or execute $NTPQ_EXE"
  exit 1
fi

OFFSET=`$NTPQ_EXE -p | tr -s [:blank:] | grep -e "^\*" | sed 's/^[ ]*//' | cut -d' ' -f 9 | tail -1`

if [ -z $OFFSET ]
then
  echo "$0:"
  echo "ERROR: Unable to check NTP synchronization."
  exit 1
fi

echo "=============================================================================="
$NTPQ_EXE -p
echo "=============================================================================="
echo "Host synch diff from server: $OFFSET ms"

if [ -f $OUTFILE ]
then
    echo "Overwriting file $OUTFILE..."
else
    echo "Creating file $OUTFILE..."
fi

echo $OFFSET > $OUTFILE
exit 0
