##################################################
## QTPDR requirements
##################################################
OBJ_COLL <- 0.2 # (20 %)

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-302"
warmup <- 10      # if warmup=N then the first N samples are filtered out (warm up stage)
threshold <- 1    # if threshold=N then N% of samples is filtered out

## main

write("******** PERFORMANCE TEST Q-302 ******", results)
write("*** please note:  unit is (1 msec) ***", results, append=TRUE)


###ACQUISITION OF DELTA_C.dat
DC_CR_0<-scan("Q-300_CR_0_DELTA_C.dat")
DC_CR_10<-scan("Q-300_CR_10_DELTA_C.dat")
DC_CR_100<-scan("Q-300_CR_100_DELTA_C.dat")
DC_COL_CR_0<-scan("Q-302_CR_0_DELTA_C.dat")
DC_COL_CR_10<-scan("Q-302_CR_10_DELTA_C.dat")
DC_COL_CR_100<-scan("Q-302_CR_100_DELTA_C.dat")

### DELTA_C FILTERING
DC_CR_0f<-filter(DC_CR_0/1000);
DC_CR_10f<-filter(DC_CR_10/1000);
DC_CR_100f<-filter(DC_CR_100/1000);
#DC_CR_500f<-filter(DC_CR_500/1000);
DC_COL_CR_0f<-filter(DC_COL_CR_0/1000);
DC_COL_CR_10f<-filter(DC_COL_CR_10/1000);
DC_COL_CR_100f<-filter(DC_COL_CR_100/1000);
#DC_COL_CR_500f<-filter(DC_COL_CR_500/1000);


write("", results, append=TRUE)
##################################################
## calculate result 
##################################################

write("CR-0 results", results, append=TRUE)
write("------------", results, append=TRUE)
avg1 <- mean(DC_COL_CR_0f)
avg2 <- mean(DC_CR_0f)
RES_CR_0 <- avg1/avg2
write(ncolumns=2, c("AVG1 (Collocated) =", avg1), results, append=TRUE)
write(ncolumns=2, c("AVG2 (Not-Collocated) =", avg2), results, append=TRUE)
write(ncolumns=2, c("AVG1/AVG2 =", RES_CR_0), results, append=TRUE)
write("", results, append=TRUE)

##################################################
## calculate result 
##################################################
write("CR-10 results", results, append=TRUE)
write("-------------", results, append=TRUE)
avg1 <- mean(DC_COL_CR_10f)
avg2 <- mean(DC_CR_10f)
RES_CR_10 <- avg1/avg2
write(ncolumns=2, c("AVG1 (Collocated) =", avg1), results, append=TRUE)
write(ncolumns=2, c("AVG2 (Not-Collocated) =", avg2), results, append=TRUE)
write(ncolumns=2, c("AVG1/AVG2 =", RES_CR_10), results, append=TRUE)
write("", results, append=TRUE)

##################################################
## calculate result 
##################################################
write("CR-100 results", results, append=TRUE)
write("--------------", results, append=TRUE)
avg1 <- mean(DC_COL_CR_100f)
avg2 <- mean(DC_CR_100f)
RES_CR_100 <- avg1/avg2
write(ncolumns=2, c("AVG1 (Collocated) =", avg1), results, append=TRUE)
write(ncolumns=2, c("AVG2 (Not-Collocated) =", avg2), results, append=TRUE)
write(ncolumns=2, c("AVG1/AVG2 =", RES_CR_100), results, append=TRUE)
write("", results, append=TRUE)

##################################################
## write test OK/NOK to a file 
##################################################

if ((RES_CR_0 <= OBJ_COLL) && (RES_CR_10 <= OBJ_COLL) && (RES_CR_100 <= OBJ_COLL)) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-302")
