/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#ifndef INCL_TEST_REPOSITORY_BIND_READER_HPP
#define INCL_TEST_REPOSITORY_BIND_READER_HPP 

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/osthreads/ThreadHandle.hpp"
#include "Foundation/osthreads/Condition.hpp"
#include "Repository/idllib/CdmwNamingAndRepository.stub.hpp"
#include <iostream>
#include <string>


namespace{
    const char * BIND_OBJECT_ID = "bindTestObject";
};

namespace Cdmw 
{

class BindReaderThread : public OsSupport::Thread
{
public:
    BindReaderThread(Cdmw::OsSupport::Condition *cond)
                 throw (CORBA::SystemException);
    
    void terminate() throw();
    
    void set_binded();

protected:
    void
    run() throw();
    
private:
    
    BindReaderThread() throw();
    BindReaderThread(const BindReaderThread&);
    BindReaderThread& operator = (const BindReaderThread&);
    
    bool m_terminated;
    bool m_is_binded; //set to "true" by TestRepositoryBinder, to notify that bind was done
    Cdmw::OsSupport::Condition * m_bindAvailable;
};

}; // End namespace Cdmw 

#endif // INCL_TEST_REPOSITORY_BIND_READER_HPP 


