/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TEST_REPOSITORY_BINDER_HPP
#define INCL_TEST_REPOSITORY_BINDER_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/osthreads/Mutex.hpp>
#include <Foundation/osthreads/Condition.hpp>
#include <Foundation/ossupport/OS.hpp>

namespace
{ 
    const int POA_THREAD_POOL_SIZE = 3;

    const std::string BIND_TIMEOUT_OPTION = "--bind-timeout";

    const long int DEFAULT_BIND_TIMEOUT = 5000; // 5 seconds

    const long int N_ITERATION = 1000;  // number of iterations (binding/unbinding)

}; // anonymous namespace


namespace Cdmw {

class TestRepositoryBinder : public CppUnit::TestFixture
{
public:
    // constructor
    TestRepositoryBinder();
    
    // destructor
    virtual ~TestRepositoryBinder();

protected:
    // do_tests
    virtual void do_tests();

private:
    CORBA::ORB_var m_orb;
    PortableServer::POA_var m_rootPOA;
    //std::string m_bind_timeout;
    long int m_bind_timeout;

CPPUNIT_TEST_SUITE( TestRepositoryBinder );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();

};

}; // namespace Cdmw

#endif // INCL_TEST_REPOSITORY_BINDER_HPP

