##################################################
## QTPDR requirements
##################################################
TIME_REQ <- 1000

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
## return numember x with dec decimal
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-331-1"
warmup <- 10      # if warmup=N then the first N samples are filtered out (warm up stage)
threshold <- 1    # if threshold=N then N% of samples is filtered out


## main

write("****** PERFORMANCE TEST Q-331-1 ********", results)

### computations

DC_CR_0<-scan("Q-331-1_1000_DELTA_C.dat")

DC_MEAN <- mean(DC_CR_0)

## write results

write("", results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)
write(ncolumns=7,c(" Results:\n - mean of Time readouts:",
           num_dec(DC_MEAN,3),
           "usec\n",
           "- SSS Requirements is:\n",
           "OS resolution in getting a readout of time is not worse than ",
           TIME_REQ,
           " usec"),
           results,append=TRUE);
write("------------------------------------------------------------------------",results,append=TRUE);

##################################################
## write test OK/NOK to a file 
##################################################

if (DC_MEAN <= TIME_REQ) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-331-1")
