##################################################
## QTPDR requirements
##################################################
CLOCK_RES <- 1 # msec

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-338-1"
datafile <- "Q-338-1.dat"

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

## Acquisition data
clockRes <- scan(datafile)
write("******** PERFORMANCE TEST Q-338-1 ******", results)
write("", results, append=TRUE)
write("Results:", results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)
write(ncolumns=3, c("CLOCK resolution.:\n",clockRes[1], "s,",clockRes[2],"us"),results, append=TRUE)
write(ncolumns=3, c("QTPDR Requirement: ",CLOCK_RES, "ms"),results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)

##################################################
## write test OK/NOK to a file 
##################################################

if ((clockRes[1] == 0) && (clockRes[2] <= (CLOCK_RES*1000))) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-338-1")
