##################################################
## QTPDR requirements
##################################################
CLOCK_SIZE <- 6*1024

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-352"

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

## Acquisition of memory data
DATASET<-scan("Q-352_pmap.dat")
TotalMemory<-DATASET[4]

system("cp -f Q-352_pmap.txt test_summary.result.Q-352")

write("", results, append=TRUE)
write("******** PERFORMANCE TEST Q-352 ******", results, append=TRUE)
write("", results, append=TRUE)
##################################################
## write test OK/NOK to a file 
##################################################

if (TotalMemory <= CLOCK_SIZE) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-352")
