##################################################
## QTPDR requirements
##################################################
TIME_REQ <- 100
MOST_CASES <- 95

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[2:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
## return numember x with dec decimal
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)
###################################################

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-330-2_cs"
warmup <- 1      # if warmup=N then the first N samples are filtered out (warm up stage)
threshold <- 1    # if threshold=N then N% of samples is filtered out


## main

write("****** PERFORMANCE TEST Q-330 ********", results)

###ACQUISITION OF DELTA_C.dat
DC_CR_0<-scan("Q_330_cl_0_250000.dat")

## filter warmup stage (1st sample)
DC_CR_0v <- DC_CR_0[10:length(DC_CR_0)]


## convert from nsec to usec
DC_CR_0v <- DC_CR_0v/1000

## filter data that satisfy the SSS requirements
DC_CR_0f <- DC_CR_0v[ DC_CR_0v < TIME_REQ]

## calculate the percentage
PERCENT <- (length(DC_CR_0f)/length(DC_CR_0v))*100

write("", results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)
write(ncolumns=14,c(" Results:\n - Elapsed time is shorter than",
           TIME_REQ,
           "usec in",
           num_dec(PERCENT,2),
           "% of cases.\n",
           "- SSS Requirements is:",
           MOST_CASES,
           " %\n\n\n",
           "Mean value:",
           num_dec(mean(DC_CR_0v),2),
           " usec\n",
           "Std Dev   :",
           num_dec(sd(DC_CR_0v),2),
           " usec\n"),
           results,append=TRUE);
write("------------------------------------------------------------------------",results,append=TRUE);

##################################################
## write test OK/NOK to a file 
##################################################

if (PERCENT >= MOST_CASES) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-330-2_cs")
