#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

if [ -z $JACORBHOME ]; then
    echo "Please define JACORBHOME environment variable"
    exit 1
fi
if [ -z $CDMW_ROOT ]; then
    echo "Please define CDMW_ROOT environment variable"
    exit 1
fi


JAVAORB_ROOT="$JACORBHOME"
echo "** current ORB: $JAVAORB_ROOT"
case JacORB in
    ORBacusJAVA)
    __ORB_CLASSPATH__=@config.ORBacusJAVA.classpath@
    ;;

    JacORB)
        __ORB_CLASSPATH__=$JAVAORB_ROOT/lib/build/javacc-4.0/bin/lib/javacc.jar:$JAVAORB_ROOT/lib/build/commons-collections-2.0.jar:$JAVAORB_ROOT/lib/build/commons-logging.jar:$JAVAORB_ROOT/lib/build/java_cup.jar:$JAVAORB_ROOT/lib/build/xdoclet-1.2.3.jar:$JAVAORB_ROOT/lib/build/xdoclet-ejb-module-1.2.3.jar:$JAVAORB_ROOT/lib/build/xdoclet-jboss-module-1.2.3.jar:$JAVAORB_ROOT/lib/build/xdoclet-jmx-module-1.2.3.jar:$JAVAORB_ROOT/lib/build/xdoclet-mx4j-module-1.2.3.jar:$JAVAORB_ROOT/lib/build/xdoclet-web-module-1.2.3.jar:$JAVAORB_ROOT/lib/build/xjavadoc-1.1.jar:$JAVAORB_ROOT/lib/avalon-framework-4.1.5.jar:$JAVAORB_ROOT/lib/idl.jar:$JAVAORB_ROOT/lib/jacorb.jar:$JAVAORB_ROOT/lib/logkit-1.2.jar:$JAVAORB_ROOT/lib/wrapper-3.1.0.jar

        ;;

    *)
    echo " invalid ORB constraint...";
    exit 1;
    ;;
esac

__TOOLS_CLASSPATH__=$__ORB_CLASSPATH__:/tools/exec/xerces-2.0.1/xercesImpl.jar:/tools/exec/xerces-2.0.1/xmlParserAPIs.jar


__CLASSPATH__=""

# add jars
for jar in `find $CDMW_ROOT -name "*.jar"`
do
    __CLASSPATH__=$__CLASSPATH__$jar:
done

__CLASSPATH__=$__CLASSPATH__$__TOOLS_CLASSPATH__

# set library path for java native libraries
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$CDMW_ROOT/lib/c++
LIBPATH=$LIBPATH:$CDMW_ROOT/lib/c++

exec java -client -Xbootclasspath/p:$__CLASSPATH__ javaclock.server_Q330 $*

