/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef INCL_PERIODIC_HPP_
#define INCL_PERIODIC_HPP_

// std C++ include
#include <iostream>
#include <valarray>

// OMG EVoT include
#include "Time/idllib/CosClockService.skel.hpp"

// cTools include
#include "qualif/perftests/testperfcommon/HighResTimer.hpp"
#include "qualif/perftests/testperfcommon/HighResTime.hpp"
#include "qualif/perftests/testperfcommon/HighResClock.hpp"

namespace perfPeriodic {

class myPeriodic:
public POA_CosClockService::PeriodicExecution::Periodic
{
public:
    CORBA::Boolean do_work (const CORBA::Any&)
        throw (CORBA::SystemException);
    
    myPeriodic::myPeriodic(const int);
    void writeRes(long double period, std::string fname);
private:
    std::valarray<long double> m_res;
    unsigned int m_count;
    unsigned int m_size;
};


#define PERF_EOF "perf_timer.eof"
#define TEST_EOF "end_of_test.log"

} // perfPeriodic

#endif
