##################################################
## QTPDR requirements
##################################################
REQ_SEC <- 100

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-337"

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

## Acquisition of configuration file
client_cfg <- scan("client_Q-337.cfg")

## Acquisition of DELTA_C.dat
DATASET<-scan("Q-337_COUNTER.dat")
RequestPerSec<-DATASET[3]

write("******** PERFORMANCE TEST Q-337 ******", results)
write("", results, append=TRUE)
write("Results:", results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)
write(ncolumns=2, c("Number of Timers expiration performed: ",DATASET[1]),results, append=TRUE)
write(ncolumns=3, c("Total time elapsed ..................: ",DATASET[2], "sec"),results, append=TRUE)
write(ncolumns=2, c("Request/seconds......................: ",RequestPerSec),results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)

##################################################
## write test OK/NOK to a file 
##################################################

if (RequestPerSec >= REQ_SEC) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-337")
