##################################################
## QTPDR requirements
##################################################
USE_CPU <- 10 # usec

##################################################
## local definitions
##################################################
results <- "test_summary.result.Q-354"
datafile <- "cpu_vtime_use.txt"

##################################################
## filter functions: exclude outliers and/or 
## warm up stage samples from the data set
##################################################
filter_warmup <- function(x) x[warmup:length(x)]
filter_top <- function(x) sort(x)[0:ceiling((length(x)*(100-(threshold%%100)))/100)]
filter <- function(x) filter_top(filter_warmup(x))
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

## Acquisition data
DATASET<-scan(datafile)
CpuUsage<-mean(DATASET)

write("******** PERFORMANCE TEST Q-354 ******", results)
write("", results, append=TRUE)
write("Results:", results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)
write(ncolumns=2, c("Number of CPU samples: ",length(DATASET)),results, append=TRUE)
write(ncolumns=2, c("CPU usage mean.......: ",CpuUsage),results, append=TRUE)
write("------------------------------------------------------------------------", results, append=TRUE)

##################################################
## write test OK/NOK to a file 
##################################################

if (CpuUsage <= USE_CPU) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-354")
