#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================


function echoc(){
  local str=$*
  if [ ! "$str" == "" ]; then
    echo -e "\e[32;40m$str\e[0m"
  fi
}

function echos(){
  local str=$*
  if test "`echo -e xxx`" = "xxx"
  then
      echoc $str
  else
      echo $str
  fi
}


## this shell script
SCRIPTNAME=`basename $0`
if [ "$#" -lt 1 ] || [ ! -f $R_FILENAME ]; then
  cat >&2 <<EOF
* Usage:
  $SCRIPTNAME <R_script_name[.R]>
* where:
  R_script_name[.R]: The name of R file.
EOF
  exit 1
fi

## Qualification tests name
TESTNAME=`basename $1 .R`
## R Script file name
R_FILENAME=$TESTNAME.R
## default R options
R_ARGUMENT="--slave --no-save"
## R executable location (see SCOM for installation)
R_EXEC=`which R`

## test R path 
if [ ! -x $R_EXEC ]; then
    echos "ERROR:"
    echo "$R_EXEC path not found!"
    exit 1
fi

## execute R with argument
$R_EXEC $R_ARGUMENT < $R_FILENAME
echos "Data analisys and the execution scenario are terminated."
echos "You can now stop the system."
## move file in results directory
TESTCPDIR=$TESTNAME-results
mkdir -p $TESTCPDIR 2>/dev/null
cp -f $TESTNAME\_*.dat $TESTCPDIR 2>/dev/null
mv -f test_summary.result.$TESTNAME $TESTCPDIR/test_summary.result 2>/dev/null
cp -f $R_FILENAME $TESTCPDIR 2>/dev/null
exit 0
