#!/bin/sh
# 
ID_=[18/11/2008]

if [ "$#" != "3" ]
then
  echo "Usage: $0 [process name/number] [# iterations] [output file name]"
  echo $ID_
  exit 1
fi
# number of iterations
NITER="$2"
# Output file name
FNAME="$3"
FNAME_p1="`mktemp -t $3.XXXXX`"
FNAME_p2="`mktemp -t $3.XXXXX`"

# Process PID
PROCESS_ID=`ps aux | grep "$1" | grep -vw grep | grep -vw use_cpu | head -1 | tr -s [:blank:] | sed 's/^[ ]*//' |  cut -d' ' -f2`
echo "PRCESS NAME***: " $1
echo "PROCESS ID***: " $PROCESS_ID

if [ "$PROCESS_ID" == "" ]
then
  echo "ERROR: process $1 not found!"
  exit 1
fi

top -p $PROCESS_ID -b -d 0.01 -n $NITER >$FNAME_p1

cat $FNAME_p1 | grep -w $PROCESS_ID |  tr -s [:blank:] | cut -d' ' -f 5 >$FNAME_p2
if [ "`cat $FNAME_p2`" == "" ]
then
  echo "ERROR: unable to read cpu size for process $1."
  exit 1
fi
if [ -f "$FNAME" ]
then
    echo "Overwriting file $FNAME..."
else
    echo "Creating file $FNAME..."
fi

mv $FNAME_p2 $FNAME

