/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/*
 * @author Raffaele Mele <rmele@progesi.it>
*/

#include "qualif/perftests/testperfcommon/ParseCfg.hpp"
#include "qualif/perftests/testperfcommon/Tokenizer.hpp"

using namespace std;
using namespace utils;

namespace {
const int MAXBUF = 1024;
const int SUCCESS = 0;
const int FAILURE = 1;
}

namespace utils {

int parseCfg(const std::string& fileName, cfgData &cfg)
{
    char buf[ MAXBUF ];

    ifstream configFile( fileName.c_str() );

    if ( !configFile ) {
        cerr << "Error: in reading " << configFile << endl;
        return FAILURE; 
    }

    // number of iteration
    configFile.getline( buf, MAXBUF );
    Tokenizer( buf, cfg.niter);
    // dalay
    configFile.getline( buf, MAXBUF );
    Tokenizer( buf, cfg.delay);
    // Invocation type
    configFile.getline( buf, MAXBUF );
    Tokenizer( buf, cfg.inv_type);
    // Data type
    configFile.getline( buf, MAXBUF );
    Tokenizer( buf, cfg.data_type);
    // Data size
    configFile.getline( buf, MAXBUF );
    Tokenizer( buf, cfg.data_size);
    // Measure type
    configFile.getline( buf, MAXBUF );
    Tokenizer( buf, cfg.measure_type);
    // File prefix
    configFile.getline( buf, MAXBUF );
    Tokenizer( buf, cfg.fileprefix);

    if ( configFile.fail() ) {
        cerr << "Error: cfg data error in " << configFile << endl;
        return FAILURE;
    }

    return SUCCESS;
}

}
