/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef CDMW_PARSECFG_HPP
#define CDMW_PARSECFG_HPP

#include <iostream>
#include <fstream>
#include <vector>

namespace utils
{

// Container for config data
struct cfgData
{                                           // ** Config file example **
    std::vector<int> niter;                 // 2000
    std::vector<int> delay;                 // 0, 10, 100
    std::vector<std::string> inv_type;      // CR, OW
    std::vector<std::string> data_type;     // NONE
    std::vector<long> data_size;            // 0
    std::vector<std::string> measure_type;  // HR_TIME
    std::vector<std::string> fileprefix;    // A-010
};

/**
 * @brief parse performance tests configuration file.
 * @param filename name of the configuration file.
 * @param cfg contain the results of config file parsing.
 */
 //// TODO: insert check of token number for every line of file.
int parseCfg( const std::string& filename, cfgData& cfg);

}

#endif // CDMW_PARSECFG_HPP
