/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.qualification.perftest.testperfcommon;

public class Tokenizer {
    //  default token delimiters
    private static String DEF_DELIM = ",";
    
    public static String[] stringToken(String str, String delimiters) {
        if (delimiters == null) 
            delimiters = DEF_DELIM;
        
        String[] result = str.split(delimiters);
        
        // remove leading and trailing whitespace
        for (int i=0; i<result.length; i++) {
            result[i] = result[i].trim();
        }
        
        return result;
    }
    
    public static int[] intToken(String str, String delimiters) {
        if (delimiters == null) 
            delimiters = DEF_DELIM;
        
        String[] s = str.split(delimiters);
        
        int[] i = new int[s.length];

        // parse integers
        for(int j=0; j<i.length; j++) {
            i[j] = Integer.parseInt(s[j].trim());
        }
            
        return i;
    }
}
