/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <jni.h>
#include "cdmw_qualification_perftest_testperfcommon_HighResolutionClock.h"
#include "HighResClock.hpp"

extern "C" {
    
    JNIEXPORT jlong JNICALL Java_cdmw_qualification_perftest_testperfcommon_HighResolutionClock_getHighResTime (JNIEnv *, jclass)
    {
        unsigned long long rdtsc;
        __asm__ volatile (".byte 0x0f, 0x31" : "=A" (rdtsc));

        // Convert clock number into nano seconds
        unsigned long long timeNS = static_cast<unsigned long long>(rdtsc * ctools::time::HighResClock::sysinfo->CLOCK_PERIOD_NS);
        return timeNS;
    }
    
    JNIEXPORT jlong JNICALL Java_cdmw_qualification_perftest_testperfcommon_HighResolutionClock_getCPUTime (JNIEnv *, jclass)
    {
        static clockid_t clk_id = CLOCK_THREAD_CPUTIME_ID;
        static struct timespec tp;

        clock_gettime(clk_id, &tp);

        // return Thread-specific CPU-time clock in usec.
        return static_cast<long>(tp.tv_nsec/1000);
    }
    
    JNIEXPORT jlong JNICALL Java_cdmw_qualification_perftest_testperfcommon_HighResolutionClock_getTickCount (JNIEnv *, jclass)
    {
        return ctools::time::HighResClock::getClockTickCount();
    }    
    
}
      
