###################################################
# crash time thresholds (from the QTPDR document)
###################################################
TIMED_OUT_DET1 <- 120
TIMED_OUT_DET2 <- 200
###################################################
## percentage thresholds (from the QTPDR document)
###################################################
PERCENT1 <- 95
PERCENT2 <- 99
###################################################

############## function definitions ###############

## return numember x with dec decimal
num_dec <- function(x,dec) x<- round(x*(10^dec))/(10^dec)

###################################################

### read process crash time
prc_time<-scan("Q-153_detect.dat",list("",0,"",0));
### extract seconds from the table
prc_sec<-prc_time[[2]];
### extract usec from the table
prc_usec<-prc_time[[4]];

### read observer notification time
obs_time<-scan("Q-153_observer.dat",list("",0,"",0));
### extract seconds from the table
obs_sec<-obs_time[[2]];
### extract usec from the table
obs_usec<-obs_time[[4]];

### calculate elapsed seconds
elapsed_sec<-obs_sec-prc_sec;
### calculate elapsed microseconds
elapsed_usec<-obs_usec-prc_usec;
## total elapsed microseconds (10-6 sec) (500000usec timeout watchdog)
elapsed_tot=(elapsed_sec*1000000)+(elapsed_usec)-(500000)
## total number of element
len_tot = length(elapsed_tot)
## number of element with elapsed time <= TIMED_OUT_DET1 (in usec)
len_percent1 <- length(elapsed_tot[elapsed_tot <= (TIMED_OUT_DET1*1000)])
## number of element with elapsed time <= TIMED_OUT_DET1 (in usec)
len_percent2 <- length(elapsed_tot[elapsed_tot <= (TIMED_OUT_DET2*1000)])
## percentage of element with elapsed time <= TIMED_OUT_DET1
DET_PERCENT1 <- (len_percent1 / len_tot) * 100
## percentage of element with elapsed time <= TIMED_OUT_DET1
DET_PERCENT2 <- (len_percent2 / len_tot) * 100
mean_elapsed<-mean(elapsed_tot)
## write results
results<-"test_summary.result.Q-153"
write("               Q-153 result",results);
write("-------------------------------------------",results,append=TRUE);
write(ncolumns=7,c("Percentage with notification time <=",
                   TIMED_OUT_DET1,
                   "ms:\n",
                   num_dec(DET_PERCENT1,1),
                   "%  (threshold:",
                   PERCENT1,
                   "%)"),
                   results,append=TRUE);
                   
                   
                   
 write(ncolumns=3,c("The mean of elapsed time is : ",
                   mean_elapsed/1000," ms"),
                   results,append=TRUE);
 
                   
                   
write(ncolumns=7,c("Percentage with notification time <=",
                   TIMED_OUT_DET2,
                   "ms:\n",
                   num_dec(DET_PERCENT2,1),
                   "%  (threshold:",
                   PERCENT2,
                   "%)"),
                   results,append=TRUE);

write("-------------------------------------------",results,append=TRUE);
##################################################
## write test OK/NOK to a file 
##################################################

if ((DET_PERCENT1 >= PERCENT1) && (DET_PERCENT2 >= PERCENT2)) {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: OK  ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
} else {
    write("########################################", results, append=TRUE)
    write("## The qualification scenario is: NOK ##", results, append=TRUE)
    write("########################################", results, append=TRUE)
}
##################################################
## display the file with SO primitive
##################################################
system("cat test_summary.result.Q-153")

