#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

EXEC_STEP=50

echo "Removing Q-153_observer.dat and Q-153_detect.dat"
rm -rf @config.install.dir@/share/Q-153_observer.dat
rm -rf @config.install.dir@/share/Q-153_detect.dat
ssh @hostname3val@ rm -rf @config.install.dir@/share/Q-153_observer.dat 


INIT_TIMEOUT=10
CLEANUP_TIMEOUT=10

datecmd="date +%Y-%m-%d_%H:%M:%S"
istep=0

define_system.sh Q-153-1.xml
sleep $INIT_TIMEOUT

while [ $istep -lt $EXEC_STEP ];
do 
  istep=$(($istep+1))
  echo `$datecmd` "===> running step: $istep / $EXEC_STEP"
  # === Start_system ===
  start_system.sh Q-153-1.xml
  sleep $INIT_TIMEOUT
  # === stop_system ===
  stop_system.sh Q-153-1.xml
  sleep $CLEANUP_TIMEOUT
done    
echo "Done! Running data analisys.."
sleep 2
# copy from the remote qualification install directory
scp @hostname3val@:@config.install.dir@/share/Q-153_observer.dat .
R_analysis.sh Q-153-1 Q-153_observer.dat 10
