#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

PLATMNG_PORT=21869
# extract xml test name from this script name
PREFIX=run_test_
SCRIPTNAME=`basename $0 .sh`
TESTNAME=${SCRIPTNAME##$PREFIX}
# the name of qualification scenario
XMLFILE=$TESTNAME-1.xml
# total number of iteration
EXEC_STEP=50

if [ ! -f "$XMLFILE" ] || [ $EXEC_STEP -lt "0" ]; then
    echo "** ERROR **"
    echo "Invalid data in $0."
    echo " - test scenario: $XMLFILE"
    echo " - exec step    : $EXEC_STEP"
    exit 1
fi

echo "========================================================================="
echo "                       CDMW Qualification Test $TESTNAME"
echo "========================================================================="
echo ""
echo "The Cdmw Daemon must have been started with start_daemon_verbosely.sh"
echo "on each host used by the scenario."
echo "The Platform Supervision must have been started with start_supervision.sh"
echo "** Hit a key when ready. **"
read -s -n 1 FOO
echo "========================================================================="

INIT_TIMEOUT=5
CLEANUP_TIMEOUT=5

datecmd="date +%Y-%m-%d_%H:%M:%S"
istep=0

RSH=ssh
HOST2=@hostname2val@
INST_DIR=@config.install.dir@/share
DELFILE1=Q-152_observer.dat
DELFILE2=Q-152_exit.dat

echo " ---------------removing *.dat files on local machine ------------"
rm -f $DELFILE1
rm -f $DELFILE2
echo " ---------------removing *.dat files on HOST2 ------------"
ssh $HOST2 rm -f $INST_DIR/$DELFILE1
ssh $HOST2 rm -f $INST_DIR/$DELFILE2




define_system.sh $XMLFILE
sleep $INIT_TIMEOUT
start_system.sh $XMLFILE

  sleep $INIT_TIMEOUT
while [ $istep -lt $EXEC_STEP ];
do 
  istep=$(($istep+1))
echo "-------STEP number $istep on $EXEC_STEP---------" 
 # temp comment !!! $echo `$datecmd` "===> running step: $istep / $EXEC_STEP"
  cdmw_platform_admin --system-corbaloc=corbaloc::localhost:21869/CdmwPlatformMngtSupervision --proc-stop SmgPerfApplication SmgProcess_Q-152 @hostname1val@
 sleep $CLEANUP_TIMEOUT
cdmw_platform_admin --system-corbaloc=corbaloc::localhost:21869/CdmwPlatformMngtSupervision --proc-initialise SmgPerfApplication SmgProcess_Q-152 @hostname1val@
 sleep $INIT_TIMEOUT
cdmw_platform_admin --system-corbaloc=corbaloc::localhost:21869/CdmwPlatformMngtSupervision --proc-run SmgPerfApplication SmgProcess_Q-152 @hostname1val@
 sleep $INIT_TIMEOUT
done    
stop_system.sh $XMLFILE
echo "Done! Running data analisys.."
sleep 2
echo "End cycle"
# copy from the remote qualification install directory
scp @hostname2val@:@config.install.dir@/share/Q-152_observer.dat .
R_analysis.sh Q-152-1 Q-152_observer.dat 10
