/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CDMWRECORDINGRECORDER_INTERFACE_IMPL_HPP 
#define INCL_CDMWRECORDINGRECORDER_INTERFACE_IMPL_HPP 

#include <stdio.h>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/ossupport/OS.hpp>
#include <Foundation/osthreads/Condition.hpp>
#include <recordingidl/CdmwRecordingRecorder.skel.hpp>
#include <TraceAndPerf/recordingidl/CdmwRecordingData.stub.hpp>
#include <string>
#include <Foundation/osthreads/Mutex.hpp>

namespace CdmwRecording
{
    class Recorder_impl :public virtual POA_CdmwRecording::Recorder,
                         virtual public PortableServer::RefCountServantBase,
                         public CppUnit::TestFixture
    {

    public:
        
        Recorder_impl (bool filter_activated);
        virtual ~Recorder_impl()
            throw();
        
        virtual void record(const ::CdmwRecording::GroupHeader& header,
                       const GIOP_Buffers& data) throw(CORBA::SystemException);

      static bool M_test_ok;
      static void check_test_result() throw(CORBA::SystemException);

      static Cdmw::TestUtils::ThreadedTestRunner* M_test_thread;
      static bool M_filter_activated;

    protected:
      
    private:

      void check_recorded_data();

      CdmwRecording::RequestReplyPair_var m_last_record;

      Cdmw::OsSupport::Mutex                   m_mutex;

      typedef std::vector<CdmwRecording::RequestReplyPair_var> RecordList;
      RecordList m_record_list;

    }; // End class 

}; // End namespace CdmwRecording

#endif // INCL_CDMWRECORDINGRECORDER_INTERFACE_IMPL_HPP 

