/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TEST_SERVER_HPP
#define INCL_TEST_SERVER_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/osthreads/Mutex.hpp>
#include <Foundation/osthreads/Condition.hpp>
#include <Foundation/ossupport/OS.hpp>
#include "recording_operations/Basic_Q_411.skel.hpp"
#include <Foundation/orbsupport/RefCountLocalObject.hpp>


namespace BasicDemo
{

class Server: virtual public POA_BasicDemo::Display,
              virtual public Cdmw::OrbSupport::RefCountLocalObject
{
public:
    // constructor
    Server();

    // destructor
    ~Server();

    //
    // IDL:thalesgroup.com/BasicDemo/Display/test_string:1.0
    //
    char * BasicDemo::Server::test_string (const char * p1,
                                                 char *& p2,
                                           CORBA::String_out p3)
      throw(CORBA::SystemException);

    //
    // IDL:thalesgroup.com/BasicDemo/Display/test_exception:1.0
    //
    void BasicDemo::Server::test_exception ()
      throw(ExceptionTestRecording);

protected:
private:
};
}; // namespace BasicDemo

#endif // INCL_TEST_SERVER_HPP

