/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <exception>
#include <iostream>
#include <sstream>
#include "recording_operations/Server.hpp"

namespace BasicDemo{

// constructor
Server::Server()
{
}

//destructor
Server::~Server()
{
}

//
// IDL:thalesgroup.com/BasicDemo/Display/test_string:1.0
//
char * BasicDemo::Server::test_string (const char * p1,
                                                 char *& p2,
                                                 CORBA::String_out p3)
    throw(CORBA::SystemException)
{
    std::cout << "---- Server: test_string method called ----" << std::endl;
    char *retstr = CORBA::string_dup ("RETURN");
    p3 = CORBA::string_dup ("OUT");
    // free inout value before reallocate
    std::string in_out_str = CORBA::string_dup (p2);
    CORBA::string_free(p2);
    in_out_str += "OUT";
    p2 = CORBA::string_dup (in_out_str.c_str());
    return retstr;
}

//
// IDL:thalesgroup.com/BasicDemo/Display/test_exception:1.0
//
void BasicDemo::Server::test_exception ()
    throw(ExceptionTestRecording)
{
    std::cout << "---- Server: test_exception method called ----" << std::endl;
    throw ExceptionTestRecording();
}
}; // namespace BasicDemo

