/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.restartwarmth;

import com.thalesgroup.CdmwPlatformMngt.*;
import com.thalesgroup.CdmwPlatformMngtBase.*;
import com.acme.TestRestartWarmth.*;
import cdmw.ossupport.OS;



class TestThread extends Thread 
{
    private com.thalesgroup.CdmwPlatformMngt.System m_sys;
    
    private TestRestartWarmthInterface m_test_ctx;
    private com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContext m_p_ctx;
    
    public TestThread(com.thalesgroup.CdmwPlatformMngt.System sys, TestRestartWarmthInterface test_ctx, com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContext p_ctx ) 
    {
        m_sys = sys;
        m_test_ctx = test_ctx;
        m_p_ctx = p_ctx;
    }

    public void run() 
    {
       try{OS.sleep(10000);}catch(Exception e){};
       
       java.lang.System.out.println("Starting test");
       java.lang.System.out.println( "TEST 0: ENV VARIABLE");
       
       String test_int = java.lang.System.getenv("TEST_INT");
       java.lang.System.out.println( "TEST_INT : " + test_int);
       
       cdmw.common.Assert.check(0==test_int.compareTo("1"));
       
       String test_string = java.lang.System.getenv("TEST_STRING");
       java.lang.System.out.println( "TEST_STRING : " + test_string);
       
       cdmw.common.Assert.check(0==test_string.compareTo("test string"));
      
       java.lang.System.out.println( "TEST 0: OK");
              
       java.lang.System.out.println("xxxxx sequence is CPAHS , where HOT is " +  RestartWarmth.HOT_RESTART.value() + " COLD is " + RestartWarmth.COLD_RESTART.value());
        
       TestRequestedRestartWarmth requested_server = new TestRequestedRestartWarmth(
                                                        RestartWarmth.COLD_RESTART,
                                                        RestartWarmth.COLD_RESTART,
                                                        RestartWarmth.COLD_RESTART,
                                                        RestartWarmth.COLD_RESTART,
                                                        RestartWarmth.COLD_RESTART);
       
       
       
       java.lang.System.out.println("requested_server is after initialisation: " + 
                                     requested_server.comp.value() +
                                     requested_server.proc.value() +
                                     requested_server.appl.value() +
                                     requested_server.host.value() +
                                     requested_server.system.value() );
       
       java.lang.System.out.println( "TEST 1: ALL HOT_RESTART AT INITIAL");
      
       try
       {            
            requested_server = m_test_ctx.test_operation("TEST 1: ALL HOT_RESTART AT INITIAL");
       }
       catch(org.omg.CORBA.SystemException ex)
       {
            java.lang.System.out.println( "***" + ex + " caught SystemException while invoking test_operation in TEST1***");
       }

       java.lang.System.out.println("after test_operation: " + 
                                     requested_server.comp.value() +
                                     requested_server.proc.value() +
                                     requested_server.appl.value() +
                                     requested_server.host.value() +
                                     requested_server.system.value() );

       if ( (RestartWarmth.HOT_RESTART.value() == requested_server.comp.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.proc.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.appl.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.host.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.system.value()) )
                                                   
           cdmw.common.Assert.check(true);
       else  cdmw.common.Assert.check(false);
       
       
       try{OS.sleep(3000);}catch(Exception e){};
       
       java.lang.System.out.println( "TEST 2: PROCESS COLD_RESTART ");
       try
       {    
            String host_name = m_test_ctx.get_host_name();
            com.thalesgroup.CdmwPlatformMngt.Process server_process = m_sys.get_application("CcmTestRestartWarmthApplication1").get_process("TestRestartWarmthProcessServer1", host_name);
            short s_m = 0;
            com.thalesgroup.CdmwPlatformMngtBase.StartupKind startup_kind = new com.thalesgroup.CdmwPlatformMngtBase.StartupKind(com.thalesgroup.CdmwPlatformMngtBase.StateRetrieval.LAST_STATE,
                                                                s_m, "" );
                                                                
            if (server_process == null)  cdmw.common.Assert.check(false);
            else server_process.cold_restart(startup_kind);
            
            java.lang.System.out.println( "TEST 2: waiting the process to restart... ");
            try{OS.sleep(5000);}catch(Exception e){};
            requested_server = m_test_ctx.test_operation("TEST 2: PROCESS COLD_RESTART");
       }
       catch(Exception ex)
       {
            java.lang.System.out.println( "***" + ex + " caught  while invoking test_operation in TEST2***");
       }
           java.lang.System.out.println("after test_operation: " + 
                                     requested_server.comp.value() +
                                     requested_server.proc.value() +
                                     requested_server.appl.value() +
                                     requested_server.host.value() +
                                     requested_server.system.value() );

       if ( (RestartWarmth.COLD_RESTART.value() == requested_server.comp.value()) &&
          (RestartWarmth.COLD_RESTART.value() == requested_server.proc.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.appl.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.host.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.system.value()) )
                                                   
           cdmw.common.Assert.check(true);
        else  cdmw.common.Assert.check(false);
       
        
       java.lang.System.out.println( "TEST 3: PROCESS HOT_RESTART ");
       try
       {    
            String host_name = m_test_ctx.get_host_name();
            com.thalesgroup.CdmwPlatformMngt.Process server_process = m_sys.get_application("CcmTestRestartWarmthApplication1").get_process("TestRestartWarmthProcessServer1", host_name);
            short s_m = 0;
            com.thalesgroup.CdmwPlatformMngtBase.StartupKind startup_kind = new com.thalesgroup.CdmwPlatformMngtBase.StartupKind(com.thalesgroup.CdmwPlatformMngtBase.StateRetrieval.LAST_STATE,
                                                                s_m, "" );
            if (server_process == null)  cdmw.common.Assert.check(false);
            else server_process.hot_restart(startup_kind);
            
            java.lang.System.out.println( "TEST 3: waiting the process to restart... ");
            try{OS.sleep(5000);}catch(Exception e){};
            requested_server = m_test_ctx.test_operation("TEST 3: PROCESS HOT_RESTART");
       }
       catch(Exception ex)
       {
            java.lang.System.out.println( "***" + ex + " caught  while invoking test_operation in TEST3***");
       }
           java.lang.System.out.println("after test_operation: " + 
                                     requested_server.comp.value() +
                                     requested_server.proc.value() +
                                     requested_server.appl.value() +
                                     requested_server.host.value() +
                                     requested_server.system.value() );

       if ( (RestartWarmth.HOT_RESTART.value() == requested_server.comp.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.proc.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.appl.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.host.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.system.value()) )
                                                   
           cdmw.common.Assert.check(true);
        else  cdmw.common.Assert.check(false);
        
        
       
       java.lang.System.out.println( "TEST 4: APPLICATION COLD_RESTART ");
       try
       {    
            com.thalesgroup.CdmwPlatformMngt.Application server_application = 
                        m_sys.get_application("CcmTestRestartWarmthApplication1");
            
            short s_m = 0;
            com.thalesgroup.CdmwPlatformMngtBase.StartupKind startup_kind = new com.thalesgroup.CdmwPlatformMngtBase.StartupKind(com.thalesgroup.CdmwPlatformMngtBase.StateRetrieval.LAST_STATE,
                                                                s_m, "" );
            if (server_application == null)  cdmw.common.Assert.check(false);
            else server_application.cold_restart(startup_kind);
            java.lang.System.out.println( "TEST 4: waiting the application to restart... ");
            try{OS.sleep(10000);}catch(Exception e){};
            requested_server = m_test_ctx.test_operation("TEST 4: APPLICATION COLD_RESTART");
       }
       catch(Exception ex)
       {
            java.lang.System.out.println( "***" + ex + " caught  while invoking test_operation in TEST4***");
       }

       java.lang.System.out.println("after test_operation: " + 
                                     requested_server.comp.value() +
                                     requested_server.proc.value() +
                                     requested_server.appl.value() +
                                     requested_server.host.value() +
                                     requested_server.system.value() );

       if ( (RestartWarmth.COLD_RESTART.value() == requested_server.comp.value()) &&
          (RestartWarmth.COLD_RESTART.value() == requested_server.proc.value()) &&
          (RestartWarmth.COLD_RESTART.value() == requested_server.appl.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.host.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.system.value()) )
                                                   
           cdmw.common.Assert.check(true);
       else  cdmw.common.Assert.check(false);      
       


      java.lang.System.out.println( "TEST 5: APPLICATION HOT_RESTART ");
       try
       {    
            com.thalesgroup.CdmwPlatformMngt.Application server_application = 
                        m_sys.get_application("CcmTestRestartWarmthApplication1");
            
            short s_m = 0;
            com.thalesgroup.CdmwPlatformMngtBase.StartupKind startup_kind = new com.thalesgroup.CdmwPlatformMngtBase.StartupKind(com.thalesgroup.CdmwPlatformMngtBase.StateRetrieval.LAST_STATE,
                                                                s_m, "" );
            if (server_application == null)  cdmw.common.Assert.check(false);
            else server_application.hot_restart(startup_kind);
            java.lang.System.out.println( "TEST 5: waiting the application to restart... ");
            try{OS.sleep(10000);}catch(Exception e){};
            requested_server = m_test_ctx.test_operation("TEST 5: APPLICATION HOT_RESTART");
       }
       catch(Exception ex)
       {
            java.lang.System.out.println( "***" + ex + " caught  while invoking test_operation in TEST5***");
       }

       java.lang.System.out.println("after test_operation: " + 
                                     requested_server.comp.value() +
                                     requested_server.proc.value() +
                                     requested_server.appl.value() +
                                     requested_server.host.value() +
                                     requested_server.system.value() );

       if ( (RestartWarmth.HOT_RESTART.value() == requested_server.comp.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.proc.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.appl.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.host.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.system.value()) )
                                                   
           cdmw.common.Assert.check(true);
       else  cdmw.common.Assert.check(false);
       
       java.lang.System.out.println( "TEST 5: HOST COLD_RESTART ");
       try
       {    
            String host_name = m_test_ctx.get_host_name();
            com.thalesgroup.CdmwPlatformMngt.Host server_host = m_sys.get_host(host_name);

            if (server_host == null)  cdmw.common.Assert.check(false);
            else server_host.cold_restart();
            
            java.lang.System.out.println( "TEST 5: waiting the host to restart...waiting longer ");
            java.lang.System.out.println( "Please make sure that \"source ...-qualif/delivery/bin/set_env.sh\" is in ~/.bashrc or that the daemon controller is started");
            try{OS.sleep(20000);}catch(Exception e){};
            requested_server = m_test_ctx.test_operation("TEST 5: HOST COLD_RESTART");
       }
       catch(Exception ex)
       {
            java.lang.System.out.println( "***" + ex + " caught  while invoking test_operation in TEST5***");
       }
           java.lang.System.out.println("after test_operation: " + 
                                     requested_server.comp.value() +
                                     requested_server.proc.value() +
                                     requested_server.appl.value() +
                                     requested_server.host.value() +
                                     requested_server.system.value() );

       if ( (RestartWarmth.COLD_RESTART.value() == requested_server.comp.value()) &&
          (RestartWarmth.COLD_RESTART.value() == requested_server.proc.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.appl.value()) &&
          (RestartWarmth.COLD_RESTART.value() == requested_server.host.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.system.value()) )
                                                   
           cdmw.common.Assert.check(true);
        else  cdmw.common.Assert.check(false);

                   
       java.lang.System.out.println( "TEST 6: HOST HOT_RESTART ");
       try
       {    
            String host_name = m_test_ctx.get_host_name();
            com.thalesgroup.CdmwPlatformMngt.Host server_host = m_sys.get_host(host_name);

            if (server_host == null)  cdmw.common.Assert.check(false);
            else server_host.hot_restart();
            
            java.lang.System.out.println( "TEST 6: waiting the host to restart, waiting longer... ");
            java.lang.System.out.println( "Please make sure that \"source ...-qualif/delivery/bin/set_env.sh\" is in ~/.bashrc or that the daemon controller is started");

            try{OS.sleep(20000);}catch(Exception e){};
            requested_server = m_test_ctx.test_operation("TEST 6: HOST HOT_RESTART");
       }
       catch(Exception ex)
       {
            java.lang.System.out.println( "***" + ex + " caught  while invoking test_operation in TEST6***");
       }
           java.lang.System.out.println("after test_operation: " + 
                                     requested_server.comp.value() +
                                     requested_server.proc.value() +
                                     requested_server.appl.value() +
                                     requested_server.host.value() +
                                     requested_server.system.value() );

       if ( (RestartWarmth.HOT_RESTART.value() == requested_server.comp.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.proc.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.appl.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.host.value()) &&
          (RestartWarmth.HOT_RESTART.value() == requested_server.system.value()) )
                                                   
           cdmw.common.Assert.check(true);
        else  cdmw.common.Assert.check(false);
        
        
        
        java.lang.System.out.println("##### Test finished : all verification are OK ######");
        
         java.lang.System.out.println("Now exiting...");
        m_p_ctx.exit(0);
    
    }


}


//
// IDL:thalesgroup.com/TestRestartWarmth/CCM_Client:1.0
//
public class CCMClientImpl extends org.omg.CORBA.LocalObject
    implements Session_CCM_Client{
    //extends CCMTestRestartWarmthInterfaceImpl
    //    implements com.acme.TestRestartWarmth.CCM_Client {
    
    private int indice = 0;

    private String name = "";
    
    private TestThread t;
    
    //private com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContext m_ctx;
    //    private com.acme.TestRestartWarmth.CCM_TestRestartWarmthInterface display = new CCMTestRestartWarmthInterfaceImpl();

    public CCMClientImpl() {
        this.m_sessionContext = null;
    }

    // session context
    private CCM_Client_Context m_sessionContext;

    //
    // IDL:thalesgroup.com/TestRestartWarmth/CCM_Client_Executor/name:1.0
    //
    public String name() {
        // TODO: Implementation
        return this.name;
    }

    public void name(String name) {
        this.name = name;
    }


    public com.acme.TestRestartWarmth.CCM_TestRestartWarmthInterface get_test_component_context(){
        return null; 
    }   


    public void set_session_context(org.omg.Components.SessionContext ctx)
    {
        java.lang.System.out.println("   ... CCMClientImpl::set_session_context called!");
        this.m_sessionContext = CCM_Client_ContextHelper.narrow(ctx);
    }
 
    public CCM_Client_Context getContext()
    {
        return this.m_sessionContext;
    }


    public void ccm_activate() {


        org.omg.CORBA.Object obj = null;
            
        java.lang.System.out.println("Resolving ManagedComponentContext");
        com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContext c_ctx = null;
        
        try
            {
                obj = m_sessionContext.resolve_service_reference("ManagedComponentContext");
                c_ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContextHelper.narrow(obj);

            }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }
        com.thalesgroup.CdmwPlatformMngt.System sys = com.thalesgroup.CdmwPlatformMngt.SystemHelper.narrow(c_ctx.the_system());
        
        java.lang.System.out.println("Resolving ManagedProcessContext");
        com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContext p_ctx = null;
        try
            {
                obj = m_sessionContext.resolve_service_reference("ManagedProcessContext");
                p_ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContextHelper.narrow(obj);

            }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }
        
        
        // get connected server
        TestRestartWarmthInterface test_ctx =
            this.m_sessionContext.get_connection_test_server();
 
        
        if (test_ctx == null)
            {
                java.lang.System.out.println("pointer TestRestartWarmth  null !");
                 cdmw.common.Assert.check(false);
            }

        
        java.lang.System.out.println("start the Thread test"); 
        t = new TestThread( sys, test_ctx, p_ctx);
        t.start();
        java.lang.System.out.println("######### ccm_activate ended");
    }

    public void ccm_remove() {
        java.lang.System.out.println("***  ccm_remove() ***");
    }
  
   
    public void ccm_passivate() {
        java.lang.System.out.println("***  ccm_passivate()  ***");
        
        try{ t.join(1000); } catch(Exception e) {};
    }


    public void _notify(Event e) {
        java.lang.System.out.println(e.to_string());   
    }

}

