/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "Foundation/orbsupport/OrbSupport.hpp"
#include "Foundation/ossupport/OS.hpp"
#include "Foundation/common/System.hpp"
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"
#include "idllib/CdmwPlatformMngtApplication.stub.hpp"
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"
#include "idllib/CdmwPlatformMngtProcess.stub.hpp"
#include "idllib/CdmwPlatformMngtComponent.stub.hpp"
#include "idllib/CdmwPlatformMngtHost.stub.hpp"
#include "idllib/CdmwPlatformMngtEntity.stub.hpp"
#include <Foundation/testutils/CORBATestManager.hpp>

namespace Cdmw
{        // Begin namespace Cdmw

namespace PlatformMngt
{ 
// Begin namespace PlatformMngt


/**
 *Purpose:
 *<p> This class is used to perform the restart (hot and cold) 
 *    commands on System by external process.   
 */
class PropertyStatusChange_impl: public virtual POA_CdmwPlatformMngt::SupervisionObserver,
                              public virtual PortableServer::RefCountServantBase, 
                              public CppUnit::TestFixture
{

public:

    //Constructor
    PropertyStatusChange_impl ();

    //Destructor                 
    ~PropertyStatusChange_impl();
    
    void setUp ();

    //the notify function
    void notify( CdmwPlatformMngt::Event* an_event )
    throw( CORBA::SystemException );

    void test_system_restart();

private:
    
    std::string host_name1; 
    std::string host_name2;
    
    std::string app_managed_proc,managed_process, 
    app_unmanaged_proc,unmanaged_process, comp ;
    
    CdmwPlatformMngt::System_var m_system;
    CdmwPlatformMngt::Application_var m_application;
    CdmwPlatformMngt::Process_var m_managed_process;
    CdmwPlatformMngt::Process_var m_unmanaged_process;
    CdmwPlatformMngt::CcmComponent_var m_component;
    CdmwPlatformMngt::Host_var m_host1;
    CdmwPlatformMngt::Entity_var m_entity;
    
    //status string
    CORBA::String_var status_result;
    
    
    // register test suite and test operation
    CPPUNIT_TEST_SUITE( PropertyStatusChange_impl );
    CPPUNIT_TEST( test_system_restart );
    CPPUNIT_TEST_SUITE_END();

};

} // End namespace PlatformMngt
} // End namespace Cdmw


