/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/*
#include <string>
#include <cctype>
#include <algorithm>
#include <sstream>
#include "Foundation/common/Locations.hpp"
#include "Foundation/common/System.hpp"
#include "Foundation/ossupport/OS.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"
#include "Foundation/common/Exception.hpp"
#include "Foundation/common/Assert.hpp"
#include "test_restart_control/TraceClientThread.hpp"*/

#include <iostream>
#include "Foundation/ossupport/OS.hpp"
#include <testgracefulexitstop/GracefulExitStopThread.hpp>


namespace TestExitStop
{


GracefulExitStopThread::GracefulExitStopThread(int req_number, TestGracefulExitStop_ptr test, bool exit)
    throw (CORBA::SystemException)
{

    m_test = TestGracefulExitStop::_duplicate(test);
    
    m_req_number = req_number;
    
    m_exit = exit;
   
}


GracefulExitStopThread::~GracefulExitStopThread() throw()
{
}

 
void GracefulExitStopThread::run () throw()
{

    if (m_exit){
         try
         { 
             m_test->test_exit();        
         }
     catch (...)
         {
        std::cerr<<"Exit request exception"<< std::endl;
        }
    }
    else{ 

    try
    {  
             
         
             bool a = false;
                  a = m_test->test_sleep();
             if (a) {
                 std::cerr<<"Sleep request "<< m_req_number<<" OK"<< std::endl;
             }
             else {
                 std::cerr<<"Sleep request "<< m_req_number<<" DISCARDED"<< std::endl;
             }
         
      
    }
    catch (const CORBA::SystemException& exc)
    {
          std::cerr<<"Sleep request "<< m_req_number<<" DISCARDED"<< std::endl;
    }
    catch (...)
    {
        std::cerr<<"Sleep request "<< m_req_number<<" DISCARDED"<< std::endl;
        std::cout << "File : " << __FILE__ << " Line : " << __LINE__ << " Unexpected exception in thread ..." << std::endl;
    }
    }
}


}; // End of namespace TestCcmContext


