/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.exitStop;

import com.thalesgroup.CdmwPlatformMngt.*;
import com.acme.TestExitStop.*;
import cdmw.ossupport.OS;


class SleepRequestThread extends Thread
{
    //protected int m_exitCode;
    TestGracefulExitStop m_test_ctx;
    int m_reqNumber;

    public SleepRequestThread(int reqNumber, TestGracefulExitStop test_ctx)
    {
        m_test_ctx = test_ctx;
        m_reqNumber = reqNumber;
    }

    public void run()
    {
        boolean ret;
    
        try {
    
           ret = m_test_ctx.test_sleep();
       
        }
        catch (org.omg.CORBA.SystemException se){
           ret = false;
        }
       
        if (ret){
           java.lang.System.out.println("Sleep request "+ m_reqNumber + " OK");
        }
        else {  
           java.lang.System.out.println("Sleep request "+ m_reqNumber + " DISCARDED");
        }
    }
}


class StopRequestThread extends Thread
{

    TestGracefulExitStop m_test_ctx;
    com.thalesgroup.CdmwPlatformMngt.Process m_proc;

    public StopRequestThread(TestGracefulExitStop test_ctx, com.thalesgroup.CdmwPlatformMngt.Process proc)
    {
        m_test_ctx = test_ctx;
        m_proc = proc;
    }

    public void run()
    {
        
       boolean ret;
       
       short sm=0; 
          
        com.thalesgroup.CdmwPlatformMngtBase.StartupKind startup_kind = new com.thalesgroup.CdmwPlatformMngtBase.StartupKind(com.thalesgroup.CdmwPlatformMngtBase.StateRetrieval.LAST_STATE, sm, "" );  
        try {
            
            java.lang.System.out.println("before restart server process");
            
            cdmw.ossupport.OS.sleep(5000);
            m_proc.hot_restart(startup_kind);
          
            java.lang.System.out.println("restart server process");
            
            cdmw.ossupport.OS.sleep(10000);
      
            SleepRequestThread sleepRequestThread3 = new SleepRequestThread(3, m_test_ctx);

            java.lang.System.out.println("test_sleep request 3 before stop ");
            
            sleepRequestThread3.start();
       
            cdmw.ossupport.OS.sleep(3000);
     
            java.lang.System.out.println("stop server process");
 
            m_proc.stop(false);
 
            cdmw.ossupport.OS.sleep(3000);
     
            SleepRequestThread sleepRequestThread4 = new SleepRequestThread(4, m_test_ctx);

            java.lang.System.out.println("test_sleep request 4 during stop ");
          
            sleepRequestThread4.start();
           
        }
        catch( java.lang.InterruptedException iex){
            java.lang.System.out.println("OS.sleep Interrupted Exception");
        }
        catch(com.thalesgroup.CdmwPlatformMngt.IncompatibleStatus isEx){
            java.lang.System.out.println( "*** caught exception: " + isEx + "***");
        }
    }
}


//
// IDL:thalesgroup.com/TestExitStop/CCM_Client:1.0
//
public class CCMClientImpl extends org.omg.CORBA.LocalObject
    implements Session_CCM_Client{
    
    private int indice = 0;

    private String name = "";
    
    private StopRequestThread stopRequestThread;
    
    //    private com.acme.TestExitStop.CCM_TestGracefulExitStop display = new CCMTestGracefulExitStopImpl();

    public CCMClientImpl() {
        this.m_sessionContext = null;
    }

    // session context
    private CCM_Client_Context m_sessionContext;

    //
    // IDL:thalesgroup.com/TestExitStop/CCM_Client_Executor/name:1.0
    //
    public String name() {
        // TODO: Implementation
        return this.name;
    }

    public void name(String name) {
        this.name = name;
    }


    public com.acme.TestExitStop.CCM_TestGracefulExitStop get_test_graceful_exit_stop(){
        return null; 
    }   


    public void set_session_context(org.omg.Components.SessionContext ctx)
    {
        java.lang.System.out.println("   ... CCMClientImpl::set_session_context called!");
        this.m_sessionContext = CCM_Client_ContextHelper.narrow(ctx);
    }
 
    public CCM_Client_Context getContext()
    {
        return this.m_sessionContext;
    }


    public void ccm_activate() {


        org.omg.CORBA.Object obj = null;
        try
            {    
                obj = m_sessionContext.resolve_service_reference(cdmw.platformmngt.PlatformInterface.MANAGED_PROCESS_CONTEXT_NAME);

            }
        catch (Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContext ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContextHelper.narrow(obj);
    
        com.thalesgroup.CdmwPlatformMngt.External.System sys = ctx.the_system();
        com.thalesgroup.CdmwPlatformMngt.External.Process proc = ctx.the_process();
        com.thalesgroup.CdmwPlatformMngt.External.Host host = ctx.the_host();
        com.thalesgroup.CdmwPlatformMngt.External.Application app = ctx.the_application();
        com.thalesgroup.CdmwPlatformMngt.ManagedElement managed_element = ctx.the_managed_element();
   
        com.thalesgroup.CdmwPlatformMngt.System sys2 = com.thalesgroup.CdmwPlatformMngt.SystemHelper.narrow(ctx.the_system());
       
        com.thalesgroup.CdmwPlatformMngt.Application app2 = com.thalesgroup.CdmwPlatformMngt.ApplicationHelper.narrow(ctx.the_application());

        java.lang.System.out.println("Testing Managed Component Context operations");
        try
            {
                obj = m_sessionContext.resolve_service_reference("ManagedComponentContext");

            }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }
 
        com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContext comp_ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContextHelper.narrow(obj);
 
 
        sys = comp_ctx.the_system();
        proc = comp_ctx.the_process();
        host = comp_ctx.the_host();
        app = comp_ctx.the_application();
        managed_element = comp_ctx.the_managed_element();

        cdmw.common.Assert.check(sys.name().equals("S1"));

        cdmw.common.Assert.check(proc.name().equals("TestGracefulExitStopProcessClient1") ); 

        cdmw.common.Assert.check(managed_element.name().equals("ClientInst"));

        cdmw.common.Assert.check(app.name().equals("CcmTestGracefulExitStopApplication"));

        cdmw.common.Assert.check(host.name().equals(OS.getHostname()));

        Client thisComponent = null;
        try {
            // narrow context in SessionContext for get_CCM_objet() access
            org.omg.Components.SessionContext session_ctx =
                org.omg.Components.SessionContextHelper.narrow(m_sessionContext);

            // call SessionContext.get_CCM_objet()
            obj = session_ctx.get_CCM_object();

            thisComponent = ClientHelper.narrow(obj);

            cdmw.common.Assert.check(thisComponent != null);

        } catch (org.omg.CORBA.UserException e) {
            java.lang.System.err.println("UserException during get_CCM_Object() :" + e);
            cdmw.common.Assert.check(false);
        } catch (org.omg.CORBA.SystemException e) {
            java.lang.System.err.println("SystemException during get_CCM_Object() :" + e);
            cdmw.common.Assert.check(false);
        }
 

        // get connected server
        TestGracefulExitStop test_ctx =
            this.m_sessionContext.get_connection_test_server();
 
        String str = "operation_parameter";
        if (test_ctx == null)
            {
                java.lang.System.out.println("pointer TestGracefulExitStop  null !");
                cdmw.common.Assert.check(false);
            }
             
        try
            {
                obj = this.m_sessionContext.resolve_service_reference("ManagedComponentContext");
            }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        java.lang.System.out.println("*** Registering TestExitStop_Client observer *** ");
        sys.register_observer("TestExitStop_Client", thisComponent);
        java.lang.System.out.println("*** Observer Registerd *** ");

        java.lang.System.out.println("*** Registering TestExitStop_Client observer *** ");
        
        java.lang.System.out.println("*** Testing notify_message *** ");
        ctx.notify_message(0, "CLIENT_NOTIFICATION_MESSAGE");
        try
            {
                OS.sleep(1000);
            }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        java.lang.System.out.println("*** Testing notify_user_event *** ");
        org.omg.CORBA.Any any_data = org.omg.CORBA.ORB.init().create_any();
        any_data.insert_string("any_dummy");
        try
            {
                ctx.notify_user_event (any_data);
            }
        catch(org.omg.CORBA.NO_IMPLEMENT ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        try{
            sys.unregister_observer("TestExitStop_Client");
        }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex);
            }   

        try{

            SleepRequestThread sleepRequestThread1 = new SleepRequestThread(1, test_ctx);

            java.lang.System.out.println("test_sleep request 1 before exit ");
            
            sleepRequestThread1.start();
            
            cdmw.ossupport.OS.sleep(3000);
            
            java.lang.System.out.println(" call test_exit ");
           
            test_ctx.test_exit();
            
            cdmw.ossupport.OS.sleep(3000);
            
            java.lang.System.out.println("test_sleep request 2 during exit ");
            
            SleepRequestThread sleepRequestThread2 = new SleepRequestThread(2, test_ctx);
            
            sleepRequestThread2.start();
          
            cdmw.ossupport.OS.sleep(15000);
        
            com.thalesgroup.CdmwPlatformMngt.ElementNamesHolder elems = new com.thalesgroup.CdmwPlatformMngt.ElementNamesHolder();
            com.thalesgroup.CdmwPlatformMngt.ElementNamesIteratorHolder it = new com.thalesgroup.CdmwPlatformMngt.ElementNamesIteratorHolder();
         
            int nbr_of_host = sys2.get_number_of_hosts();

            sys2.get_all_host_names(nbr_of_host, elems, it);
            
            String host_name2 = elems.value[0];
          
            com.thalesgroup.CdmwPlatformMngt.External.Process proc2ext = app2.get_process("TestGracefulExitStopProcessServer1", host_name2);
          
            com.thalesgroup.CdmwPlatformMngt.Process proc2 = com.thalesgroup.CdmwPlatformMngt.ProcessHelper.narrow(proc2ext);
          
            short sm=0; 
          
            com.thalesgroup.CdmwPlatformMngtBase.StartupKind startup_kind = new com.thalesgroup.CdmwPlatformMngtBase.StartupKind(com.thalesgroup.CdmwPlatformMngtBase.StateRetrieval.LAST_STATE, sm, "" );

            stopRequestThread = new StopRequestThread(test_ctx, proc2);
    
            stopRequestThread.start();
            
            java.lang.System.out.println("### All verification are ok ###");
     
        }
        catch(org.omg.CORBA.SystemException ex)
            {
                java.lang.System.out.println( "***" + ex + " caught SystemException because component Server has crashed! ***");
            }
        catch( java.lang.InterruptedException iex){
            java.lang.System.out.println("OS.sleep Interrupted Exception");
        }
        catch(com.thalesgroup.CdmwPlatformMngt.ProcessNotFound pnfEx){
            java.lang.System.out.println( "*** caught exception: " + pnfEx + "***");
        }
        
    }

    public void ccm_remove() {
        java.lang.System.out.println("***  ccm_remove() ***");
    }
  
   
    public void ccm_passivate() {
    
       java.lang.System.out.println("***  ccm_passivate()  ***");
    
        try{
            stopRequestThread.join();
        }
        catch( java.lang.InterruptedException iex){
            java.lang.System.out.println(" stopRequestThread.join() Interrupted Exception");
        }
  
    }

    public void _notify(Event e) {
        java.lang.System.out.println(e.to_string());   
    }

}

