/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_MY_HOST_GRAPH_CHK_CLS_HPP 
#define INCL_MY_HOST_GRAPH_CHK_CLS_HPP 

#include <iostream>
#include <string>
#include <list>

#include "testpreconhostgraphs/ProcessEventInfo.hpp"

namespace Cdmw
  {        // Begin namespace Cdmw

  namespace PlatformMngt
    { // Begin namespace PlatformMngt

    class HostGraphChecker 
    {

      public:

        HostGraphChecker();

        ~HostGraphChecker();

       void submit_event (ProcessEventInfo processEventInfo);

       std::list<std::string> get_streaming_result();

       private:

        bool compareTimeStamps (TimeStampInfo first,
           TimeStampInfo second);

        std::string WAITING_PROCESS_NAME;

        std::string SUCCESSOR_PROCESS_NAME;

        std::string FIRST_WAITED_PROCESS_NAME;

        std::string SECOND_WAITED_PROCESS_NAME;

        std::string MSG_TITLE;

        std::string MSG_SUCCESSORS_TEST;

        std::string MSG_PRECONS_TEST;

        std::string RESULT_OK;

        std::string RESULT_NOT_OK;

        CdmwPlatformMngt::ProcessStatus threshold_status;

        TimeStampInfo time_stamps[4];

        bool successor_test_result;

        bool first_precon_test_result;

        bool second_precon_test_result;
      };

  } // End namespace PlatformMngt
} // End namespace Cdmw

#endif //INCL_MY_HOST_GRAPH_CHK_CLS_HPP 
