/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "Foundation/ossupport/OS.hpp"

#include "testproccompconsistency/MyProcessControl.hpp"
#include "SystemMngt/platforminterface/PlatformInterface.hpp"
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>


namespace Cdmw
{
namespace PlatformMngt
{

/**
*Purpose:
*<p>    [class description]
*
*Features:
*<p> [Thread safety, exception safety, performance]
*    [if no pertinent write none ]
*
*@see  [if necessary] 
*@link [if necessary] 
*
*/
MyProcessControl::MyProcessControl(CORBA::ORB_ptr      orb,
                                   std::ostream &      os, 
                                   bool except)
    : m_orb (CORBA::ORB::_duplicate(orb)),
      m_os (os),
      m_except(except),
      m_counter(2)
{
}

MyProcessControl::~MyProcessControl() 
  throw()
{
    //if (m_client_thread != 0) 
    //this->on_stop();
}
    


void 
MyProcessControl::on_initialise(const CdmwPlatformMngtBase::StartupKind& startup_kind)
    throw(CORBA::SystemException) 
{
    using namespace Cdmw::PlatformMngt;
    // Default behaviour only informs of receipt of the message
    PlatformInterface::Notify_message(CdmwPlatformMngtBase::INF,
                     PlatformInterface::Get_process_name(),
                     "Received 'initialisation' message");
             
   
   if (m_except) {
     CORBA::INTERNAL ex(Cdmw::OrbSupport::INTERNAL, 
                           CORBA::COMPLETED_NO);
     std::cerr<<"Throw Exception in MyProcessControl::on_initialise -------"<<std::endl;
     throw ex;
   }
}

}; // End namespace PlatformMngt
}; // End namespace Cdmw

