/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP
#define INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP

#include <Foundation/orbsupport/OrbSupport.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp>
#include "SystemMngt/idllib/CdmwPlatformMngtComponent.stub.hpp"
#include "SystemMngt/idllib/CdmwPlatformMngtFTGroup.stub.hpp"
#include "SystemMngt/idllib/CdmwPlatformMngtSystem.stub.hpp"
#include "SystemMngt/idllib/CdmwPlatformMngtExternalSystem.stub.hpp"

namespace TestUnknown
{
        class SupervisionObserver_impl: public virtual POA_CdmwPlatformMngt::SupervisionObserver,
                    public virtual PortableServer::RefCountServantBase
        {

            public:
                SupervisionObserver_impl();

                 bool  is_group_test_ok(){return m_group_test;}
                 bool  is_component_test_ok(){return m_component_test;}

                 void  set_group_test_ok(bool nd){m_group_test=nd;}
                 void  set_component_test_ok(bool test_ok){m_component_test=test_ok;}
                
                void notify( CdmwPlatformMngt::Event* an_event )
                throw( CORBA::SystemException );
                

            protected:
                  bool m_group_test;
                  bool m_component_test;

                
            private:
                
                CdmwPlatformMngt::System_var m_sys ;
                CdmwPlatformMngt::CcmComponent_var m_comp ;
                CdmwPlatformMngt::FTGroup_var m_group ;
         };


} // End namespace TestUnknown

#endif //INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP

