#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

usage() {
    echo "$0 -base <base diretory> -xsd <XSD File>"
    echo "Validates all cdp files under <base directory> against <XSD File>"
    exit 1
}

if [ $# -ne 4 ] ; then
    usage
fi

while [ -n "${*}" ]; do
    case ${1} in
        -base)
            xml=$2
            ;;
        -xsd)
            xsd=$2
            ;;
        *)
            usage
            ;;
    esac
 
    shift 2
done


for i in `find ${xml} -name "*.cdp"`; do
  echo "validating $i"
  validate_xml_from_xsd.sh -xml $i -xsd ${xsd}

  if [ $? -ne 0 ]
  then
    echo "Validation of $i failed"
    exit 1
  fi
done  

echo "OK, all cdp files are valid"

