/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


//#ifndef INCL_PLATFORMMNGT_DAEMONLOGMESSAGEID_HPP 
//#define INCL_PLATFORMMNGT_DAEMONLOGMESSAGEID_HPP


namespace Cdmw
{
namespace PlatformMngt
{


enum DaemonLogMessageIds
{

    /**
    * "---------DAEMON CONTROLLER START-------"
    */
    MSG_ID_CONTROLLER_START,

    /**
    * "Waiting platform daemon with port %i"
    */
    MSG_ID_CONTROLLER_WAINTING_DAEMON_WITH_PORT,

    /**
    * "platform daemon with port %i find!!!"
    */
    MSG_ID_CONTROLLER_DAEMON_WITH_PORT_FOUND,

    /*
    * "Register daemon controller in daemon's (port = %i local services with name DaemonController",
    */
    MSG_ID_CONTROLLER_REGISTER_IN_DAEMON,
    
    /**
    * "Start controller for platform daemon with port %i"
    */
    MSG_ID_CONTROLLER_START_FOR_DAEMON, 
    
    /**
    * "Platform daemon with pid %i and port %i dies"
    */
    MSG_ID_CONTROLLER_DAEMON_WITH_PID_PORT_DIES,
    
    /**
    * "Invalid pid process: %i"
    */
    MSG_ID_CONTROLLER_INVALID_PID_PROCESS,
    
    /**
    * "Notify exit action %i for platform daemon with port %i and policy %s"
    */
    MSG_ID_CONTROLLER_NOTIFY_EXIT_ACTION_PORT_POLICY,
    
    /**
    * "Stop request for system with platform daemon port %i, stop host in progress"
    */
    MSG_ID_CONTROLLER_STOP_IN_PROGRESS,
    
    /**
    * "Shutdown request , shutdown in progress"
    */
    MSG_ID_CONTROLLER_SHUTDOWN_IN_PROGRESS,
    
    /**
    * "Restart request, restart in progress"
    */
    MSG_ID_CONTROLLER_RESTART_IN_PROGRESS,
    
    /**
    * "Host isolated, stop all systems"
    */
    MSG_ID_CONTROLLER_STOP_ALL_SYSTEM,
    
    /**
    * "Request to monitor unknown"
    */
    MSG_ID_CONTROLLER_UNKNOW,
    
    /**
    * "Error in register_local_service, BAD PARAM for platform daemon with port %i"
    */
    MSG_ID_CONTROLLER_REGISTER_LOCAL_SERVICE_ERROR,
    
    /**
    * Daemon with port %i dies
    */
    MSG_ID_CONTROLLER_DAEMON_WITH_PORT_DIES,
    
    /**
    * "Reboot request, reboot in progress"
    */
    MSG_ID_CONTROLLER_REBOOT_IN_PROGRESS,
    
    /**
    * "Restart of the system with platform daemon port %i using start file %s"
    */
    MSG_ID_CONTROLLER_RESTART_IN_PROGRESS_OF_THE_SYSTEM,
    
    /**
    * "No action for the dies of the daemon with port %i"
    */
    MSG_ID_CONTROLLER_NO_ACTION,
    
    /**
    * "Killing system with daemon port %i, and clean the platform daemon file %s",
    */
    MSG_ID_KILLING_AND_CLEANING,
    
    /**
    * "Opening %s"
    */
    MSG_ID_OPENING,
    
    /**
    * "Deleting %s"
    */
    MSG_ID_DELETING,
    
    /**
    * "Path not found"
    */
    MSG_ID_PATH_NOT_FOUND,
    
    /**
    * "Killing %s"
    */
    MSG_ID_KILLING_PROCESS,
     
    /**
    * "Chahge status of host, new status = %s"
    */
    MSG_ID_HOST_CHANGE_STATUS,
    
       
    MSG_ID_CONTROLLER_END

    
};


} // End namespace PlatformMngt
} // End namespace Cdmw


//#endif // INCL_PLATFORMMNGT_DAEMONLOGMESSAGEID_HPP


