/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef __PLATFORMADMIN_HPP__
#define __PLATFORMADMIN_HPP__

#define HELP_OPTION            "--help"
#define LOG_FILE_OPTION        "--log-file"
#define CHECK_ONLY_OPTION      "--check-only"
#define SYSTEM_CORBALOC_OPTION "--system-corbaloc"
#define SYSTEM_PORT_OPTION     "--system-port"
#define SHOW_ATTR_PARAM        "show-attr"

#define SYS_SNAPSHOT           "--sys-snapshot"
#define SYS_DEFINE             "--sys-define"
#define SYS_ADD_HOST           "--sys-add-host"
#define SYS_REMOVE_HOST        "--sys-remove-host"
#define SYS_ADD_APPLICATION    "--sys-add-application"
#define SYS_REMOVE_APPLICATION "--sys-remove-application"
#define SYS_ADD_ENTITY         "--sys-add-entity"
#define SYS_REMOVE_ENTITY      "--sys-remove-entity"
#define SYS_ADD_SERVICE        "--sys-add-service"
#define SYS_REMOVE_SERVICE     "--sys-remove-service"
#define SYS_ADD_PROPERTY       "--sys-add-property"
#define SYS_REMOVE_PROPERTY    "--sys-remove-property"
#define SYS_SET_INIT_GRAPH     "--sys-set-init-graph"
#define SYS_SET_STOP_GRAPH     "--sys-set-stop-graph"
#define SYS_START              "--sys-start"
#define SYS_RESUME             "--sys-resume"
#define SYS_ACKNOWLEDGE        "--sys-acknowledge"
#define SYS_STOP               "--sys-stop"
#define SYS_HOT_RESTART        "--sys-hot-restart"
#define SYS_COLD_RESTART       "--sys-cold-restart"
#define SYS_PROPERTY           "--sys-property"


#define APP_SNAPSHOT           "--app-snapshot"
#define APP_ADD_PROCESS        "--app-add-process"
#define APP_REMOVE_PROCESS     "--app-remove-process"
#define APP_ADD_SERVICE        "--app-add-service"
#define APP_REMOVE_SERVICE     "--app-remove-service"
#define APP_ADD_ENTITY         "--app-add-entity"
#define APP_REMOVE_ENTITY      "--app-remove-entity"
#define APP_ADD_PROPERTY       "--app-add-property"
#define APP_REMOVE_PROPERTY    "--app-remove-property"
#define APP_SET_INIT_GRAPH     "--app-set-init-graph"
#define APP_SET_STOP_GRAPH     "--app-set-stop-graph"
#define APP_INITIALISE         "--app-initialise"
#define APP_INITIALISE_AND_WAIT "--app-initialise-and-wait"
#define APP_RESUME             "--app-resume"
#define APP_ACKNOWLEDGE        "--app-acknowledge"
#define APP_RUN                "--app-run"
#define APP_STOP               "--app-stop"
#define APP_HOT_RESTART        "--app-hot-restart"
#define APP_COLD_RESTART       "--app-cold-restart"
//#define APP_FORCE_MANUAL_START "--app-force-manual-start"
#define APP_PROPERTY           "--app-property"
//#define APP_AUTORESTART_INFO   "--app-autorestart-info"


#define PROC_SNAPSHOT          "--proc-snapshot"
#define PROC_ADD_SERVICE       "--proc-add-service"
#define PROC_REMOVE_SERVICE    "--proc-remove-service"
#define PROC_ADD_ENTITY        "--proc-add-entity"
#define PROC_REMOVE_ENTITY     "--proc-remove-entity"
#define PROC_ADD_PROPERTY      "--proc-add-property"
#define PROC_REMOVE_PROPERTY   "--proc-remove-property"
#define PROC_INITIALISE        "--proc-initialise"
#define PROC_NEXT_STEP         "--proc-next-step"
#define PROC_RUN               "--proc-run"
#define PROC_STOP              "--proc-stop"
#define PROC_SET_INFO          "--proc-set-info"
#define PROC_SET_AUTOENDING    "--proc-set-autoending"
#define PROC_RESET_AUTOENDING  "--proc-reset-autoending"
#define PROC_SET_LIFE_CYLE     "--proc-set-life-cycle"
//#define PROC_TRACE             "--proc-trace"
//#define PROC_FORCE_MANUAL_START "--proc-force-manual-start"
#define PROC_HOT_RESTART       "--proc-hot-restart"
#define PROC_COLD_RESTART      "--proc-cold-restart"
#define PROC_PROPERTY          "--proc-property"
#define PROC_EXIT_ACTION       "--proc-exit-action"
//#define PROC_AUTORESTART_INFO  "--proc-autorestart-info"


#define ENTITY_ADD_PROPERTY    "--ent-add-property"
#define ENTITY_REMOVE_PROPERTY "--ent-remove-property"
#define ENTITY_STATUS          "--ent-status"
#define ENTITY_PROPERTY        "--ent-property"


#define HOST_REBOOT            "--host-reboot"
#define HOST_SHUTDOWN          "--host-shutdown"
#define HOST_ADD_PROPERTY      "--host-add-property"
#define HOST_REMOVE_PROPERTY   "--host-remove-property"
#define HOST_HOT_REBOOT        "--host-hot-reboot"
#define HOST_COLD_REBOOT       "--host-cold-reboot"
#define HOST_PROPERTY          "--host-property"
//#define HOST_AUTORESTART_INFO  "--host-autorestart-info"
#define HOST_STOP              "--host-stop"
#define HOST_HOT_RESTART       "--host-hot-restart"
#define HOST_COLD_RESTART      "--host-cold-restart"
#define HOST_SNAPSHOT          "--host-snapshot"

#define COMP_PROPERTY          "--comp-property"
#define COMP_SNAPSHOT          "--comp-snapshot" 

#define FTGROUP_PROPERTY       "--ftgroup-property"
#define FTGROUP_COMPONENTS     "--ftgroup-components"
#define FTGROUP_COMPONENTS_PROPERTY "--ftgroup-components-property"
#define FTGROUP_SNAPSHOT       "--ftgroup-snapshot" 


#define LBGROUP_PROPERTY       "--lbgroup-property"
#define LBGROUP_COMPONENTS     "--lbgroup-components"
#define LBGROUP_COMPONENTS_PROPERTY "--lbgroup-components-property"
#define LBGROUP_SNAPSHOT       "--lbgroup-snapshot"
 
#endif //__PLATFORMADMIN_HPP__

