/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMADMIN_ENTITYTYPEPARSER_HPP
#define INCL_PLATFORMADMIN_ENTITYTYPEPARSER_HPP

#include "platformadminlibrary/ConfigElementParser.hpp"
#include "platformadminlibrary/PropertyParser.hpp"
#include <vector>

namespace Cdmw {         // Begin namespace Cdmw
namespace PlatformAdmin { // Begin namespace PlatformAdmin

typedef std::vector<PropertyParser> PropList;

//class PropertyParser;

class EntityTypeParser : public virtual ConfigElementParser
{
public:
    EntityTypeParser( const DOM_Node& entityParser );
    std::string name() const;
    //PropertyParser get_property(unsigned int propertyIndex) const;
    //unsigned int get_property_count() const;
    //std::string get_status_type_values() const;
    //CdmwPlatformMngt::EntityStatusValues * parse_status_values(std::string & stat_val_str) const;
    std::string get_entity_type_name() const;
    std::string get_status_values_for_type() const;
    PropertyParser get_property(unsigned int propertyIndex) const;
    unsigned int get_property_count() const;
    PropList entity_type_properties;

};

class EntityTypeContainerParser : public virtual ConfigElementParser
{
protected:
    EntityTypeContainerParser( const DOM_Node& entityContainerParser );

public:
    unsigned int get_entity_type_count() const;

    //unsigned int get_entity_count() const;

    EntityTypeParser get_entity_type( unsigned int entityIndex ) const;
    

};

} // End namespace PlatformAdmin
} // End namespace Cdmw

#endif //INCL_PLATFORMADMIN_ENTITYTYPEPARSER_HPP

