/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMADMIN_FTGROUPPARSER_HPP
#define INCL_PLATFORMADMIN_FTGROUPPARSER_HPP

#include "platformadminlibrary/ConfigElementParser.hpp"
#include "platformadminlibrary/PropertyParser.hpp"
#include "platformadminlibrary/EntityParser.hpp"

namespace Cdmw {         // Begin namespace Cdmw
namespace PlatformAdmin { // Begin namespace PlatformAdmin


class FTGroupParser : public virtual ConfigElementParser,
                           public virtual EntityContainerParser
{
public:
    FTGroupParser( const DOM_Node& ftgroupParser );
    PropertyParser get_property(unsigned int propertyIndex) const;
    unsigned int get_property_count() const;
    std::string name() const;
    unsigned long minimum_nbr_replicas() const;
    CdmwPlatformMngt::ReplicationStyle style() const;
 
};


class FTGroupContainerParser : public virtual ConfigElementParser,
                               public virtual EntityContainerParser
{
protected:
    FTGroupContainerParser( const DOM_Node& ftgroupContainerParser );

public:
    unsigned int get_ftgroup_count() const;

    FTGroupParser get_ftgroup( unsigned int ftgroupIndex ) const;
};

} // End namespace PlatformAdmin
} // End namespace Cdmw

#endif //INCL_PLATFORMADMIN_FTGROUPPARSER_HPP

