/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMADMIN_HOSTPARSER_HPP
#define INCL_PLATFORMADMIN_HOSTPARSER_HPP

#include "platformadminlibrary/ConfigElementParser.hpp"
#include "platformadminlibrary/EntityParser.hpp"

namespace Cdmw {         // Begin namespace Cdmw
namespace PlatformAdmin { // Begin namespace PlatformAdmin

class HostMonitoringParser;
class PropertyParser;
class HostParser;

class HostParser : public virtual ConfigElementParser, public virtual EntityContainerParser
{
public:
    HostParser( const DOM_Node& hostParser);

    HostMonitoringParser get_monitoring() const;

    std::string name() const;

    std::string app_exec_path() const;

    PropertyParser get_property() const;    

    PropertyParser HostParser::get_property(unsigned int propertyIndex) const;

    unsigned int HostParser::get_property_count() const;
 
    std::string get_default_restart_warmth() const;

    unsigned int get_max_nbr_of_restart_attempt() const;
    
    CdmwPlatformMngt::AutoRestartControl HostParser::get_auto_restart_control() const;

};

} // End namespace PlatformAdmin
} // End namespace Cdmw

#endif //INCL_PLATFORMADMIN_HOSTPARSER_HPP

