/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef __PLATFORMADMINSNAPSHOT_HPP__
#define __PLATFORMADMINSNAPSHOT_HPP__

#include <string>

#include "Foundation/orbsupport/CORBA.hpp"

#include "SystemMngt/idllib/CdmwPlatformMngtCommon.stub.hpp"
#include "SystemMngt/idllib/CdmwPlatformMngtEntity.stub.hpp"
#include "SystemMngt/idllib/CdmwPlatformMngtSystem.stub.hpp"

//---------------------//
// Function prototypes //
//---------------------//
std::string snapShotToString( CdmwPlatformMngt::SystemSnapshot* snapshot);
std::string snapShotToString( CdmwPlatformMngt::HostSnapshot* snapshot, const char* sIndent);
std::string snapShotToString( CdmwPlatformMngt::ApplicationSnapshot* snapshot, const char* sIndent);
std::string snapShotToString( CdmwPlatformMngt::ProcessSnapshot* snapshot, const char* sIndent);
std::string snapShotToString( CdmwPlatformMngt::EntitySnapshot* snapshot, const char* sIndent);
std::string snapShotToString( CdmwPlatformMngt::PropertySnapshot* snapshot, const char* sIndent);
std::string snapShotToString( CdmwPlatformMngt::ComponentSnapshot* snapshot, const char* sIndent);
std::string snapShotToString(CdmwPlatformMngt::FTGroupSnapshot* snapshot, const char* sIndent );
std::string snapShotToString(CdmwPlatformMngt::LBGroupSnapshot* snapshot, const char* sIndent );
                                  
#endif //__PLATFORMADMINSNAPSHOT_HPP__

