/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "platformadminlibrary/ExitActionParser.hpp"

namespace Cdmw {         // Begin namespace Cdmw
namespace PlatformAdmin { // Begin namespace PlatformAdmin

/**
 * ExitAction class.
 */
ExitActionParser::ExitActionParser(
    const DOM_Node& propertyParser )
: ConfigElementParser( propertyParser )
{
}

CdmwPlatformMngt::ExitActionType ExitActionParser::get_type() const
{
    std::string type_name = get_attribute_value("Type");

    if ( type_name == "RESTART_APPLICATION")
        return CdmwPlatformMngt::RESTART_APPLICATION;
    else if ( type_name == "RESTART_PROCESS")
        return CdmwPlatformMngt::RESTART_PROCESS;
    else if( type_name == "SHUTDOWN_NODE")
        return CdmwPlatformMngt::SHUTDOWN_NODE;
    else if ( type_name == "REBOOT_NODE")
        return CdmwPlatformMngt::REBOOT_NODE;
    else if ( type_name == "STOP_APPLICATION")
        return CdmwPlatformMngt::STOP_APPLICATION;
    else if ( type_name == "ABORT_PROCESS")
        return CdmwPlatformMngt::ABORT_PROCESS; 
    else
        return CdmwPlatformMngt::NO_ACTION;

}      
               
long ExitActionParser::get_exit_code() const                                                                               
{
    return atol( get_attribute_value( "Exit-code" ).c_str() ); 
}


} // End namespace PlatformAdmin
} // End namespace Cdmw

