/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "platformadminlibrary/RunSetParser.hpp"

namespace Cdmw {         // Begin namespace Cdmw
namespace PlatformAdmin { // Begin namespace PlatformAdmin

/**
 * RunSetElementParser class.
 */
RunSetParser::RunSetElementParser::RunSetElementParser(
    const DOM_Node& runSetElementParser )
: ConfigElementParser( runSetElementParser )
{
}

std::string RunSetParser::RunSetElementParser::name() const
{
    return get_attribute_value( "Name" );
}

/**
 * RunSet class.
 */
RunSetParser::RunSetParser(
    const DOM_Node& runSetParser )
: ConfigElementParser( runSetParser )
{
}

std::string RunSetParser::name() const
{
    return get_attribute_value( "Name" );
}

unsigned int RunSetParser::get_run_set_element_count() const
{
    return get_child_count( "Run-set-element" );
}

std::string RunSetParser::get_run_set_element_name(
    unsigned int runSetElementIndex ) const
{
    RunSetElementParser runSetElementParser(
        get_child_element( "Run-set-element", runSetElementIndex ) );

    return runSetElementParser.name();
}

} // End namespace PlatformAdmin
} // End namespace Cdmw

