/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_PLATFORMMNGT_DEPLOYMENTINFO_HPP
#define INCL_PLATFORMMNGT_DEPLOYMENTINFO_HPP

#include <iostream>

namespace Cdmw
{
namespace PlatformMngt
{

enum PROCESS_COMPONENT_EVENT{PROCESS_COMPONENTS_COMPLETION_EVENT, PROCESS_COMPONENTS_INITIALISATION_EVENT, PROCESS_COMPONENTS_SUSPENSION_EVENT};

struct DeploymentInfo
{
    std::string host_name;
    std::string deployment_plan;
    inline bool operator==(const DeploymentInfo& deployment_info)const 
        {
            std::string this_tmp = host_name + deployment_plan;
            std::string tmp = deployment_info.host_name + deployment_info.deployment_plan;
            return (this_tmp == tmp);           
        };
    inline bool operator<(const DeploymentInfo& deployment_info)const 
        {
            std::string this_tmp = host_name + deployment_plan;
            std::string tmp = deployment_info.host_name + deployment_info.deployment_plan;
            return (this_tmp < tmp);            
        };    
    inline bool operator<=(const DeploymentInfo& deployment_info)const 
        {
            std::string this_tmp = host_name + deployment_plan;
            std::string tmp = deployment_info.host_name + deployment_info.deployment_plan;
            return (this_tmp <= tmp);           
        };    
                
    inline bool operator>(const DeploymentInfo& deployment_info)const 
    {
            return (!operator<(deployment_info));           
    };
};

}// closing namespaces
}

#endif /*INCL_PLATFORMMNGT_DEPLOYMENTINFO_HPP_*/
