
/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_FILTERS_MAP_HPP
#define INCL_PLATFORMMNGT_FILTERS_MAP_HPP


#include <map>
#include <iostream>

namespace Cdmw
{
namespace PlatformMngt
{

     //define multi-map for the filtering to apply
     typedef pair<string,string> my_key; 

     struct less_my_key : public binary_function<my_key, my_key, bool> 
     { bool operator()(const my_key& x, const my_key& y) const
     {
    
     if (  (x.first.compare(y.first) ) )
       {       
       return ( lexicographical_compare(x.first.begin(),
                                     x.first.end(),
                                     y.first.begin(),
                                     y.first.end()) ); 
       }       
       else    
       {       
       return ( lexicographical_compare(x.second.begin(),
                                     x.second.end(),
                                     y.second.begin(),
                                     y.second.end()) );
                 
       }       
     }
    };
 
    //internal multi-map for the filters
    typedef map<my_key,unsigned long,less_my_key> filters_map;


} // End namespace PlatformMngt
} // End namespace Cdmw



#endif 

