/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_REDUNDANCYGROUP_STATES_HPP
#define INCL_PLATFORMMNGT_REDUNDANCYGROUP_STATES_HPP

#include "Foundation/common/Exception.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"
#include "SystemMngt/idllib/CdmwPlatformMngtCommon.stub.hpp"
#include "SystemMngt/idllib/CdmwPlatformMngtProcess.stub.hpp"
#include "SystemMngt/platformlibrary/StateMachineTemplate.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

class RedundancyGroup_impl;
class RedundancyGroupState;

typedef StateMachine< RedundancyGroup_impl , RedundancyGroupState > RedundancyGroupStateMachine;


class RedundancyGroupState : public virtual RedundancyGroupStateMachine::AbstractState
{
private:
    RedundancyGroupState(
        const RedundancyGroupState& rhs );

    RedundancyGroupState& operator=(
        const RedundancyGroupState& rhs );

protected:
    RedundancyGroupState() {};

public:
    virtual ~RedundancyGroupState() {};

public:

    virtual CdmwPlatformMngt::RedundancyEltState status() = 0;

};

class RedstateNorg : public virtual RedundancyGroupState
{
private:
    RedstateNorg( const RedstateNorg& rhs );

    RedstateNorg& operator=(
        const RedstateNorg& rhs );

public:
    RedstateNorg();

    CdmwPlatformMngt::RedundancyEltState status();

};


class RedstatePrimary : public virtual RedundancyGroupState
{
private:
    RedstatePrimary(
        const RedstatePrimary& rhs );

    RedstatePrimary& operator=(
        const RedstatePrimary& rhs );

public:
    RedstatePrimary();

    CdmwPlatformMngt::RedundancyEltState status();

};



class RedstatePassive : public virtual RedundancyGroupState
{
private:
    RedstatePassive(
        const RedstatePassive& rhs );

    RedstatePassive& operator=(
        const RedstatePassive& rhs );

public:
    RedstatePassive();

    CdmwPlatformMngt::RedundancyEltState status();

};

/* instance it to try the compilation ... */
   //RedstatePassive *redstate = new RedstatePassive() ;

} // End namespace PlatformMngt
} // End namespace Cdmw

#endif //INCL_PLATFORMMNGT_REDUNDANCYGROUP_STATES_HPP

