/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TESTDEPLOYMENTMANAGER_HPP
#define INCL_PLATFORMMNGT_TESTDEPLOYMENTMANAGER_HPP

#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/common/System.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/idllib/CdmwDnC.stub.hpp>
#include <SystemMngt/platformlibrary/BoundSyncCall.hpp>


namespace Cdmw
{
  namespace PlatformMngt
  {

    /**
     *Purpose:
     *<p>
     *
     *Features:
     *<p> Thread safe
     *
     *
     */
    class TestDeploymentManager:public CppUnit::TestFixture
    {

    public:

      /**
       * Purpose:
       * <p> Constructor
       *
       */
      TestDeploymentManager () throw ();

      /**
       * Purpose:
       * <p> Destructor
       *
       */
      virtual ~TestDeploymentManager () throw ();

      void setUp();

      void tearDown();

      /**
       * Purpose:
       * <p> Call from the testable object
       *
       */
      virtual void test_set_remove_node_deployment_info() ;

      virtual void test_set_remove_node_deployment_infos() ;

      virtual void test_notify();                           

    private:

      /**
       * Purpose:
       * <p> Assignment operator
       *
       */
      TestDeploymentManager & operator= (const TestDeploymentManager & rhs) throw ();
    
      /**
       * Purpose:
       * <p>  Copy constructor
       *
       */
      TestDeploymentManager (const TestDeploymentManager & rhs) throw ();
    
      CPPUNIT_TEST_SUITE (TestDeploymentManager);

      // Test Cases 
      
      CPPUNIT_TEST (test_set_remove_node_deployment_info);
      
      CPPUNIT_TEST (test_set_remove_node_deployment_infos);
     
      CPPUNIT_TEST( test_notify); 
//      CPPUNIT_TEST_EXCEPTION( test_notify, CdmwDnC::StartError); 
            
      CPPUNIT_TEST_SUITE_END ();
    };

  }             /* End namespace PlatformMngt */
}               /* End namespace Cdmw */
#endif              /* INCL_PLATFORMMNGT_TESTDEPLOYMENTMANAGER_HPP */
