/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.platformmngt.test;

import com.thalesgroup.CdmwDnC.NodeManager;


import cdmw.ossupport.OS;
import cdmw.testutils.Testable;

/**
 *
 * @author acedrone
 */
public class NodeApplicationImpl extends com.thalesgroup.CdmwDnC.NodeApplicationPOA{
    
    static private String status;
    private org.omg.CORBA.ORB orb;
    private String deployment_plan;
    private String exceptionAt;

    /** Creates a new instance of NodeApplication */
    public NodeApplicationImpl(org.omg.CORBA.ORB orb, String deployment_plan, String exceptionAt) {
        this.orb = orb;
        this.deployment_plan = deployment_plan;
        status = "";
        this.exceptionAt = exceptionAt; 
    }
    /**
     * The second step in launching an application.
     * This step will establish components connections.
     *
     * @throws StartError if an error occured at start-up
     */
    public void finish_launch() throws com.thalesgroup.CdmwDnC.StartError {
  
         System.out.println("\nbegin of NodeApplication finish_launch() operation: deploying <<"+ deployment_plan + ">>" );
         if (exceptionAt.equals("finish_launch"))
         {
             status = "exception";  
             System.out.println("*** going to throw com.thalesgroup.CdmwDnC.StartError() *** ");
             throw new com.thalesgroup.CdmwDnC.StartError();
         }


         if  (!status.equals("/finish_launch"))
             status += "/finish_launch";

        try{
            OS.sleep(1000);
        } catch(Exception e)
        {}
        System.out.println("end of NodeApplication finish_launch() operation: deploying <<"+ deployment_plan +   ">>\n");
    }
    
    /**
     * Starts the application.
     *
     * @throws StartError if an error occured at start-up
     */
    public void start() throws com.thalesgroup.CdmwDnC.StartError {

        System.out.println("begin of NodeApplication.Start()");   
         if (exceptionAt.equals("start"))
         {
             status = "exception";
             System.out.println("*** going to throw com.thalesgroup.CdmwDnC.StartError() *** ");
             throw new com.thalesgroup.CdmwDnC.StartError();
         }

        if  (status.equals("/finish_launch")) 
            status += "/start";
        System.out.println(deployment_plan);
        System.out.println("end of NodeApplication.Start()");
        throw  new com.thalesgroup.CdmwDnC.StartError();  
    }
    
    public String toString() {
        return status;
    }
    
}
