/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.platformmngt.test;


import com.thalesgroup.CdmwDnC.NodeManager;
import cdmw.testutils.Testable;
import cdmw.ossupport.OS;


public class NodeApplicationManagerImpl extends com.thalesgroup.CdmwDnC.NodeApplicationManagerPOA{
 
    private NodeApplicationImpl nodeApplicationImpl;
  
    // status variable to check if a method has been called
    static private String status;
    
    private org.omg.CORBA.ORB orb;
  
    private String deployment_plan;

    private String exceptionAt;

 
    /** Creates a new instance of NodeApplicationManager */
    public NodeApplicationManagerImpl(org.omg.CORBA.ORB orb, String deployment_plan, String exceptionAt) {
        this.orb             = orb; 
        status               = "";
        this.deployment_plan = deployment_plan;
        this.exceptionAt = exceptionAt;
    }
    
    /**
     * Executes the application, but does not start it yet.
     * This step will create components.
     *
     * @return the running NodeApplication
     *
     * @throws StartError if an error occured at start-up
     */
    public com.thalesgroup.CdmwDnC.NodeApplication start_launch() throws  com.thalesgroup.CdmwDnC.StartError 
    { 
        System.out.println("\nbegin NodeApplicationManager start_launch() operation: deploying <<"+ deployment_plan + ">>" );
        if (exceptionAt.equals("start_launch"))
        {
            status = "exception";
            System.out.println("*** going to throw com.thalesgroup.CdmwDnC.StartError() *** "); 
            throw new com.thalesgroup.CdmwDnC.StartError();
        }
 
        status += "/start_launch";
        try
        {
           OS.sleep(1000);
        } 
        catch(Exception e)
        {
        }
        System.out.println("end NodeApplicationManager start_launch() operation: deploying <<"+ deployment_plan + ">> create NodeApplication\n");

        //NodeApplicationImpl 
        nodeApplicationImpl = new NodeApplicationImpl(orb, deployment_plan, exceptionAt); 
        return nodeApplicationImpl._this(orb);
    }
    
    /**
     * Terminates a running NodeApplication
     *
     * @param application The running NodeApplication to be terminated.
     *
     * @throws StopError if an error occured during stop
     * @throws InvalidReference if the specified NodeApplication
     * is unknown
     */
    public void destroy_application( com.thalesgroup.CdmwDnC.NodeApplication application) throws  com.thalesgroup.CdmwDnC.StopError,  com.thalesgroup.CdmwDnC.InvalidReference 
    { 
        System.out.println("destroy_application (NodeApplication) "+
    deployment_plan);
        status += "/destroy_application_manager";
    }
    

    public NodeApplicationImpl getNodeApplicationImpl()
    {
        return nodeApplicationImpl; 
    }   
 
    public String toString() 
    {
        return status;
    }
    
}
