/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.platformmngt.test;

import cdmw.common.BadOrderException;
import cdmw.common.BadParameterException;

import com.thalesgroup.CdmwDnC.NodeManager;
import com.thalesgroup.CdmwPlatformMngt.ManagedComponent;


public class NodeManagerImpl extends com.thalesgroup.CdmwDnC.NodeManagerPOA {

    private org.omg.CORBA.ORB orb;

    private NodeApplicationManagerImpl nodeApplicationManagerImpl;
    
    private String exceptionAt;  
 
    // status variable to check if a method has been called
    static private String status;
   
    public NodeManagerImpl(org.omg.CORBA.ORB orb, String exceptionAt) {
    
        try 
    {
            this.orb = orb;
            org.omg.CORBA.Object obj = orb.resolve_initial_references("RootPOA");
            org.omg.PortableServer.POA poa = org.omg.PortableServer.POAHelper.narrow(obj);
            poa.the_POAManager().activate();
            ManagedComponentImpl managedComponentImpl = new ManagedComponentImpl(orb);      
            com.thalesgroup.CdmwPlatformMngt.ManagedComponent managedComponent = managedComponentImpl._this(orb);
            status = "";
            this.exceptionAt = exceptionAt;
            String ref_string = orb.object_to_string(managedComponent);
        try 
        {
            java.io.FileWriter fileWriter = new  java.io.FileWriter("ManagedComponent.ior");
            fileWriter.write(ref_string);
            fileWriter.close();
        } catch (java.io.IOException ex) 
        {
             System.err.println("Cannot write ManagedComponent.ior");
             ex.printStackTrace();  
            }
     } 
     catch(Exception e) 
     {
         e.printStackTrace();
     }
        }
        
        
    public com.thalesgroup.CdmwDnC.NodeApplicationManager prepare_plan(java.lang.String local_plan_name) throws com.thalesgroup.CdmwDnC.StartError,com.thalesgroup.CdmwDnC.PlanError 
    {
        System.out.println("\nprepare_plan("+local_plan_name+ ")");       
        if (exceptionAt.equals("prepare_plan"))
        {
            status = "exception"; 
            System.out.println("*** going to throw com.thalesgroup.CdmwDnC.PlanError() *** ");
            throw new com.thalesgroup.CdmwDnC.PlanError();
        } 
        status += "/prepare_plan";
        nodeApplicationManagerImpl  = new NodeApplicationManagerImpl (orb, local_plan_name, exceptionAt);
        return nodeApplicationManagerImpl._this(orb);
    };
        
    public void destroy_manager(com.thalesgroup.CdmwDnC.NodeApplicationManager appManager) throws com.thalesgroup.CdmwDnC.InvalidReference,com.thalesgroup.CdmwDnC.StopError 
    {
        System.out.println("destroy_manager(NodeApplicationManager)");
        status += "/destroy_manager";
    };
    
    public NodeApplicationManagerImpl getNodeApplicationManagerImpl()
    {
        return nodeApplicationManagerImpl;
    }
   
    public String toString() 
    {
    return status;
    }
    

}

