/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TESTSTDATTRIBUTES_PROCESS_HPP 
#define INCL_PLATFORMMNGT_TESTSTDATTRIBUTES_PROCESS_HPP 

#include "Foundation/testutils/TestManager.hpp"
#include "Foundation/common/System.hpp"
#include <Foundation/orbsupport/CORBA.hpp>
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"
#include "idllib/CdmwPlatformMngtApplication.stub.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

/**
*Purpose:
*<p>   
*
*Features:
*<p> Thread safe
*
*
*/
class TestStdAttributes_Process : public CppUnit::TestFixture
{

    public:
        CORBA::ORB_var m_orb;

        /**
        * Purpose:
        * <p> Constructor
        * 
        */ 
        TestStdAttributes_Process() throw();



        /**
        * Purpose:
        * <p> Destructor 
        * 
        */ 
        virtual 
        ~TestStdAttributes_Process() throw();

        void setUp() ;
        
        /**
        * Purpose:
        * <p> Call from the testable object 
        * 
        */ 

        virtual void  name();
        virtual void  get_status( );
        virtual void  get_process_info( );
        virtual void  set_process_info( );
        virtual void  set_exit_autorestart_info();
        virtual void  get_exit_autorestart_info();
        virtual void  restart_attempt();
        //virtual void  get_process_mode_exception();
        virtual void  get_memory_resident_exception();
        virtual void  set_memory_resident_exception();
        virtual void  get_core_dump_size_exception();
        virtual void  get_name_by_snapshot();
        virtual void  get_status_by_snapshot();
        virtual void  get_run_as_root_exception();

        virtual void  force_manual_start();
        virtual void  get_last_exit_code();
        virtual void  set_indicator_relevant_status();
        virtual void  get_indicator_relevant_status();
        virtual void trace_filters();        
        virtual void  get_predefined_attributes();
        virtual void restart_warmth();
        virtual void get_pid();
        virtual void get_previous_pid();


    protected:


    private:
        static CdmwPlatformMngt::System_var mysystem;
        static CdmwPlatformMngt::Process_var proc;
        static CdmwPlatformMngt::Application_var app;
        static bool m_is_one_shot_initialized;
    static CdmwPlatformMngt::ProcessInfo_var proc_info;
             
        static void one_shot_init();

        /**
        * Purpose:
        * <p> Assignment operator
        * 
        */ 
        TestStdAttributes_Process& operator=(const TestStdAttributes_Process& rhs) throw();
        /**
        * Purpose:
        * <p>  Copy constructor
        * 
        */ 
        TestStdAttributes_Process(const TestStdAttributes_Process& rhs) throw();
        
CPPUNIT_TEST_SUITE(TestStdAttributes_Process);
//CPPUNIT_TEST( do_tests );
CPPUNIT_TEST( name );
CPPUNIT_TEST( get_status );
CPPUNIT_TEST( get_process_info );
CPPUNIT_TEST( set_process_info );
CPPUNIT_TEST( set_exit_autorestart_info );
CPPUNIT_TEST( get_exit_autorestart_info );
CPPUNIT_TEST( restart_attempt );
CPPUNIT_TEST( trace_filters );
CPPUNIT_TEST( restart_warmth );
CPPUNIT_TEST( get_predefined_attributes );
//CPPUNIT_TEST_EXCEPTION( get_process_mode_exception, CORBA::NO_IMPLEMENT);
CPPUNIT_TEST_EXCEPTION( get_memory_resident_exception, CORBA::NO_IMPLEMENT);
CPPUNIT_TEST_EXCEPTION( set_memory_resident_exception, CORBA::NO_IMPLEMENT);
CPPUNIT_TEST_EXCEPTION( get_core_dump_size_exception, CORBA::NO_IMPLEMENT);
CPPUNIT_TEST( get_name_by_snapshot);
CPPUNIT_TEST( get_status_by_snapshot);
CPPUNIT_TEST_EXCEPTION( get_run_as_root_exception, CORBA::NO_IMPLEMENT);

CPPUNIT_TEST( force_manual_start );
CPPUNIT_TEST( get_last_exit_code );
CPPUNIT_TEST( get_pid );
CPPUNIT_TEST( get_previous_pid );
//CPPUNIT_TEST_EXCEPTION( set_process_arguments, CORBA::NO_IMPLEMENT);
//CPPUNIT_TEST_EXCEPTION( get_process_arguments, CORBA::NO_IMPLEMENT);
CPPUNIT_TEST( set_indicator_relevant_status);
CPPUNIT_TEST( get_indicator_relevant_status);

CPPUNIT_TEST_SUITE_END();

};

} /* End namespace PlatformMngt */
} /* End namespace Cdmw */
#endif 

