/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "Foundation/orbsupport/ExceptionMinorCodes.hpp"

#include "SystemMngt/platformelementlibrary/RWEntityContainer_impl.hpp"


/**
* Root namespace for CDMW runtime.
*/
namespace Cdmw
{
/**
* Namespace for CDMW PlatformMngt
*/
namespace PlatformMngt
{

    //
    // Constructor
    //
    RWEntityContainer_impl::RWEntityContainer_impl(
                                       PortableServer::POA_ptr poa,
                                       PlatformMngt::EntityContainer* pActualContainer,
                                       CdmwPlatformMngt::RWElementRepository_ptr element_repository)
            throw()
            : EntityContainer_impl(poa, pActualContainer,element_repository)
    {
    } 



    //
    // Destructor
    // 
    RWEntityContainer_impl::~RWEntityContainer_impl()
    {
    } 


    //
    // Add entity in container
    //
    CdmwPlatformMngt::Entity_ptr RWEntityContainer_impl::add_entity (
                const CdmwPlatformMngt::EntityDef & entity_def)
             throw(CdmwPlatformMngt::EntityAlreadyExists,CosPropertyService::MultipleExceptions,
                   CORBA::SystemException)
    {
        CdmwPlatformMngt::Entity_var entityObject =
                      getActualContainer()->addEntity(entity_def);
        
        // return Entity object reference           
        return entityObject._retn();
    } 


        
    //
    // Remove entity from container
    //
    void RWEntityContainer_impl::remove_entity(const char* entity_name)
             throw(CdmwPlatformMngt::EntityNotFound,
                   CORBA::SystemException)
    {
        getActualContainer()->removeEntity(entity_name);
    } 
                      

} // End namespace PlatformMngt
} // End namespace Cdmw



