/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

//@author Antonello Cedrone <a.cedrone@vitrociset.it>

#ifndef INCL_PLATFORMMNGT_TESTCHILDOBJECTS_HPP
#define INCL_PLATFORMMNGT_TESTCHILDOBJECTS_HPP

#include "Foundation/testutils/TestManager.hpp"
#include "Foundation/common/System.hpp"
#include <Foundation/orbsupport/CORBA.hpp>

namespace Cdmw
{

namespace PlatformMngt
{

    
  class TestChildObjects : public CppUnit::TestFixture
  {
  public:
    CORBA::ORB_var m_orb;

    /**

     * Purpose:
     * <p> Constructor
     *
     */

    TestChildObjects() throw();

    
    /**
     * Purpose:
     * <p> Destructor
     *
     */
    
    virtual ~TestChildObjects() throw();


    
    /**
     * Purpose:
     * <p> Call from the testable object 
     *
     */
    

    virtual 
    void 
    do_tests() ;

/*
    static std::string a_row("-------------------");
    static std::string a_col("|");
      
    inline void Graph_parent(std::string p) {std::cerr<<std::endl<<p<<"\n";}
    inline void Graph_child(std::string info, std::string f) {std::cerr<<a_col<<(a_row+info+" "+f+"\n");}
    inline void Graph_end() {std::cerr<<"\n"<<"\n";}
*/      

    protected:


    private:

        /**
        * Purpose:
        * <p> Assignment operator
        * 
        */ 
        TestChildObjects& operator=(const TestChildObjects& rhs) throw();
        /**
        * Purpose:
        * <p>  Copy constructor
        * 
        */ 
        TestChildObjects(const TestChildObjects& rhs) throw();
        

CPPUNIT_TEST_SUITE(TestChildObjects);
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();
};


    
} //end of PlatformMngt namespace

} //end of Cdmw namespace

#endif
