/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#include "testconfigurationchange/OneShotInitFactory.hpp"


namespace Cdmw
{
  namespace PlatformMngt
  {

    void OneShotInitFactory::register_one_shot_kind (OneShotInitIf *
                             one_shot_init_kind)
    {
      m_one_shot_init_kind = one_shot_init_kind;
    }

    OneShotInitIf *OneShotInitFactory::create_one_shot_init_kind ()
    {
      return m_one_shot_init_kind;
    }


    OneShotInitFactory* OneShotInitFactory::get_instance ()
    {
      static OneShotInitFactory one_shot_init_factory;
      return &one_shot_init_factory;
    }

    OneShotInitFactory::~OneShotInitFactory()
    {
        delete m_one_shot_init_kind;
    }

    CdmwPlatformMngt::System_var  OneShotInitFactory::get_system()
    {
         return m_one_shot_init_kind->get_system();
    } 

    CdmwPlatformMngt::SupervisionObserver_var  OneShotInitFactory::get_observer() 
    {
         return m_one_shot_init_kind->get_observer();
    }

    Cdmw::PlatformMngt::SupervisionObserver_impl*  OneShotInitFactory::get_observer_impl() 
    {
         return m_one_shot_init_kind->get_observer_impl();
    }



  }
}
