/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TESTENTITYSTATUS_HPP
#define INCL_PLATFORMMNGT_TESTENTITYSTATUS_HPP

#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/common/System.hpp"
#include <Foundation/orbsupport/CORBA.hpp>
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"
#include "idllib/CdmwPlatformMngtApplication.stub.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

/**
*Purpose:
*<p>   
*
*Features:
*<p> Thread safe
*
*
*/
class TestEntityStatus : public CppUnit::TestFixture
{

    public:
        CORBA::ORB_var m_orb;

        /**
        * Purpose:
        * <p> Constructor
        * 
        */ 
        TestEntityStatus() throw();



        /**
        * Purpose:
        * <p> Destructor 
        * 
        */ 
        virtual 
        ~TestEntityStatus() throw();


        
        /**
        * Purpose:
        * <p> Call from the testable object 
        * 
        */ 
    void setUp() ;

        virtual void get_name() ;
        virtual void get_name2() ;
        virtual void set_status_out_range() ;
        virtual void set_status_out_range2() ;
        virtual void set_status() ;
        virtual void set_status2() ;
        virtual void get_status() ;
        virtual void get_status2() ;
    virtual void get_default_status() ;
    virtual void check_propertyOfEntity3() ;
    virtual void check_propertyOfEntity4() ;
    virtual void check_propertyOfEntity5() ;



    private:
        static CdmwPlatformMngt::System_var mysystem;
    static CdmwPlatformMngt::Application_var myapp;
    static CdmwPlatformMngt::Entity_var myentity;
    static CdmwPlatformMngt::Entity_var myentity2;
    static CdmwPlatformMngt::Entity_var myentity3;
    static CdmwPlatformMngt::Entity_var myentity4;
    static CdmwPlatformMngt::Entity_var myentity5;
        static bool m_is_one_shot_initialized;
         
        static void one_shot_init();

        /**
        * Purpose:
        * <p> Assignment operator
        * 
        */ 
        TestEntityStatus& operator=(const TestEntityStatus& rhs) throw();
        /**
        * Purpose:
        * <p>  Copy constructor
        * 
        */ 
        TestEntityStatus(const TestEntityStatus& rhs) throw();
        

    CPPUNIT_TEST_SUITE(TestEntityStatus);
    CPPUNIT_TEST( get_name);
    CPPUNIT_TEST( get_name2);
    CPPUNIT_TEST_EXCEPTION( set_status_out_range, CdmwPlatformMngt::EntityStatusNotAllowed);
    CPPUNIT_TEST_EXCEPTION( set_status_out_range2, CdmwPlatformMngt::EntityStatusNotAllowed);
    CPPUNIT_TEST( set_status);
    CPPUNIT_TEST( set_status2);
    CPPUNIT_TEST( get_status);
    CPPUNIT_TEST( get_status2);
    CPPUNIT_TEST( get_default_status);
    CPPUNIT_TEST( check_propertyOfEntity3);
    CPPUNIT_TEST( check_propertyOfEntity4);
    CPPUNIT_TEST( check_propertyOfEntity5);

    CPPUNIT_TEST_SUITE_END();
};

} /* End namespace PlatformMngt*/
} /* End namespace Cdmw*/
#endif 

