/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TESTPROPERTYCHANGE_HPP
#define INCL_PLATFORMMNGT_TESTPROPERTYCHANGE_HPP

#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/common/System.hpp"
#include <Foundation/orbsupport/CORBA.hpp>
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"
#include "idllib/CdmwPlatformMngtApplication.stub.hpp"
#include <SystemMngt/idllib/CdmwPlatformMngtSupervisionObserver.stub.hpp>
#include "SupervisionObserver_impl.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

/**
*Purpose:
*<p>
*
*Features:
*<p> Thread safe
*
*
*/
class TestEntityStatusChange : public CppUnit::TestFixture
{

    public:

        /**
        * Purpose:
        * <p> Constructor
        *
        */
        TestEntityStatusChange() throw();

        /**
        * Purpose:
        * <p> Destructor
        *
        */
        virtual
        ~TestEntityStatusChange() throw();


        void setUp() ;

        static CORBA::ORB_var                               m_orb;
        static CdmwPlatformMngt::System_var                 m_system;
        static CdmwPlatformMngt::Entity_var                 m_sys_entity;
        static CdmwPlatformMngt::Entity_var                 m_app_entity;
        static CdmwPlatformMngt::Entity_var                 m_host_entity;
        static CdmwPlatformMngt::Entity_var                 m_proc_entity;
        static CdmwPlatformMngt::Entity_var                 m_component_entity;
        static CdmwPlatformMngt::Entity_var                 m_ftgroup_entity;
        static CdmwPlatformMngt::Entity_var                 m_lbgroup_entity;
        static bool                                         m_is_one_shot_initialized;
        static CORBA::ULong                                 size1;
        static CdmwPlatformMngt::Process_var                m_proc;
        static CdmwPlatformMngt::Application_var            m_app;
        static CdmwPlatformMngt::Host_var                   m_host;
        static CdmwPlatformMngt::FTGroup_var                m_ftgroup;
        static CdmwPlatformMngt::LBGroup_var                m_lbgroup;
        static CdmwPlatformMngt::CcmComponent_var           m_component;
        static CdmwPlatformMngt::SupervisionObserver_var    m_observer;
        static SupervisionObserver_impl*                    m_observer_impl;


        void one_shot_init() ;
        /**
        * Purpose:
        * <p> Call from the testable object
        *
        */

        virtual void test_set_system_entity_status_change();
        virtual void test_set_host_entity_status_change();
        virtual void test_set_application_entity_status_change();
        virtual void test_set_process_entity_status_change();
        virtual void test_set_component_entity_status_change();
        virtual void test_set_ftgroup_entity_status_change();
        virtual void test_set_lbgroup_entity_status_change();
        virtual void test_notify();
        
    protected:


    private:

        /**
        * Purpose:
        * <p> Assignment operator
        *
        */
        TestEntityStatusChange& operator=(const TestEntityStatusChange& rhs) throw();
        /**
        * Purpose:
        * <p>  Copy constructor
        *
        */
        TestEntityStatusChange(const TestEntityStatusChange& rhs) throw();


        CPPUNIT_TEST_SUITE(TestEntityStatusChange);
        CPPUNIT_TEST(test_set_system_entity_status_change);
        CPPUNIT_TEST(test_notify);
        CPPUNIT_TEST(test_set_host_entity_status_change);
        CPPUNIT_TEST(test_notify);
        CPPUNIT_TEST(test_set_application_entity_status_change);
        CPPUNIT_TEST(test_notify);
        CPPUNIT_TEST(test_set_process_entity_status_change);
        CPPUNIT_TEST(test_notify);
        CPPUNIT_TEST(test_set_component_entity_status_change);
        CPPUNIT_TEST(test_notify);
        CPPUNIT_TEST(test_set_ftgroup_entity_status_change);
        CPPUNIT_TEST(test_notify);
        CPPUNIT_TEST(test_set_lbgroup_entity_status_change);
        CPPUNIT_TEST(test_notify);
        CPPUNIT_TEST_SUITE_END();
};

} /* End namespace PlatformMngt*/
} /* End namespace Cdmw*/
#endif /* INCL_PLATFORMMNGT_TESTPROPERTYCHANGE_HPP*/

