/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TRACE_ORBTHREAD_HPP 
#define INCL_TRACE_ORBTHREAD_HPP 

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"
#include "Foundation/orbsupport/StrategyList.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"
#include "Foundation/orbsupport/OrbSpecificProperties.hpp"
#include "Foundation/ossupport/SystemProperties.hpp"
#include "Foundation/common/String.hpp"

#include "Foundation/osthreads/ThreadHandle.hpp"

//#if CDMW_ORB_VER < 14
//#include <orbsvcs/FaultTolerance/FT_Service_Activate.h>
//#else
//#include <orbsvcs/FaultTolerance/FT_ClientService_Activate.h>
//#endif


namespace Cdmw 
{
namespace PlatformMngt
{


class OrbThread : public OsSupport::Thread {

    public:
        
        OrbThread(){
             
            
            OrbSupport::StrategyList strategyList;
            strategyList.add_OrbThreaded();
            strategyList.add_PoaThreadPool(10);
#ifdef CDMW_USE_FAULTTOLERANCE
            strategyList.add_multicast();
#endif

            int argc(0);
            //int argc(2);
            std::string str_opt("-ORBDebugLevel 10");

            //char** argv__ = Cdmw::Common::String::to_char_array (
            //    Cdmw::Common::String::to_strings(str_opt));

        //TAO_FT_ClientService_Activate* service_activate = new TAO_FT_ClientService_Activate();
        //service_activate->init(argc, NULL);
            
        //As the default strategy is RW, and the test uses AMI. We have to force the MT strategy.
           std::string ORBClientConnectionHandlerPName(Cdmw::OrbSupport::CDMW_ORB_PROPERTY_NAME_PREFIX);
           ORBClientConnectionHandlerPName += "." + std::string(Cdmw::OrbSupport::TAO_ORB_CLIENT_CONNECTION_HANDLER_PROPERTY_NAME);
           OsSupport::SystemProperties::Set_Property(ORBClientConnectionHandlerPName, "MT");
          
            m_orb = OrbSupport::OrbSupport::ORB_init(argc,NULL, strategyList );
            //m_orb = OrbSupport::OrbSupport::ORB_init(argc, argv__, strategyList );        
        // TO be removed walk around!!!!!
        //Cdmw::OrbSupport::OrbSupport::set_endpoint_selector_factory("FT_Endpoint_Selector_Factory");

            
            // And activate the root POA
            CORBA::Object_var obj = m_orb->resolve_initial_references("RootPOA");
            m_poa = PortableServer::POA::_narrow(obj.in());
            PortableServer::POAManager_var poaMgr = m_poa->the_POAManager();
            poaMgr->activate();

        }

        ~OrbThread() throw(){};


        void
        shutdown() {
            m_orb->shutdown(false);
        OrbSupport::OrbSupport::ORB_cleanup(m_orb.in());
        m_orb->destroy();
        }


        CORBA::ORB_ptr orb()
        {
            return CORBA::ORB::_duplicate(m_orb.in());
        }

        
        PortableServer::POA_ptr poa()
        {
            return PortableServer::POA::_duplicate(m_poa.in());
        }

    protected:

        void
        run() throw() {

            m_orb->run();
            
        }

    private:

        CORBA::ORB_var  m_orb;

        PortableServer::POA_var m_poa;

};

} // End namespace PlatformMngt

} // End namespace Cdmw

#endif // INCL_TRACE_ORBTHREAD_HPP 

