/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_LBGROUP_ACCESSOR_IMPL_HPP
#define INCL_PLATFORMMNGT_LBGROUP_ACCESSOR_IMPL_HPP


#include <Foundation/common/Exception.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>

#include <SystemMngt/platformftaccessorlibrary/ManagedElementAccessor_impl.hpp>

#include <SystemMngt/idllib/CdmwFTSystMngtLBGroup.skel.hpp>
#include <SystemMngt/idllib/CdmwFTSystMngtLBGroup.stub.hpp>

#include <SystemMngt/idllib/CdmwPlatformMngtElementRepository.stub.hpp>
#include <SystemMngt/platformftaccessorlibrary/RWEntityContainerAccessor_impl.hpp>
#include <SystemMngt/platformftaccessorlibrary/RedundancyGroupAccessor_impl.hpp>


namespace Cdmw
{
  namespace PlatformMngt
  {

    class LBGroupAccessor_impl:public virtual POA_CdmwFTSystMngt::
      LBGroupAccessor, public RedundancyGroupAccessor_impl
    {

    public:

      LBGroupAccessor_impl (CdmwPlatformMngt::
                            ElementRepository_ptr element_repository) throw ();

      ~LBGroupAccessor_impl ();

      CdmwPlatformMngt::LBGroup_ptr 
           get_lbgroup ( const char* target_element_path) 
                   throw(CdmwPlatformMngt::ManagedElementNotFound);

      CdmwPlatformMngt::LBGroupSnapshot *
        get_snapshot (const char *target_element_path) throw (CORBA::
                                                              SystemException,
                                                              CdmwPlatformMngt::
                                                              ManagedElementNotFound);


      CdmwPlatformMngt::
        BalancingStyle get_style (const char *target_element_path)
        throw (CORBA::SystemException,
               CdmwPlatformMngt::ManagedElementNotFound);


      void set_style (const char *target_element_path,
                      CdmwPlatformMngt::BalancingStyle) throw (CORBA::
                                                               SystemException,
                                                               CdmwPlatformMngt::
                                                               ManagedElementNotFound);
      
      virtual CdmwPlatformMngt::ElementType get_element_type (const char *target_element_path) throw (CORBA::
                                                                     SystemException);

    };

/* try to instance it, only to check compilation ... */
    /*   CdmwPlatformMngt::ElementRepository_ptr ele1_repository;
    LBGroupAccessor_impl *lb_group_accessor =
      new LBGroupAccessor_impl (ele1_repository); */

  }                             // End namespace PlatformMngt
}                               // End namespace Cdmw

#endif                          //INCL_PLATFORMMNGT_LBGROUP_ACCESSOR_IMPL_HPP
