/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_PROXY_REDUNDANCYGROUP_IMPL_HPP
#define INCL_PLATFORMMNGT_PROXY_REDUNDANCYGROUP_IMPL_HPP

#include <Foundation/common/Exception.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>

#include <SystemMngt/idllib/CdmwPlatformMngtRedundancyGroup.skel.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtRedundancyGroup.stub.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtApplicationAgent.stub.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtCommon.stub.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtEntity.stub.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtEvent.stub.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtHost.stub.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtService.stub.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtDaemon.stub.hpp>

#include "platformftproxy/ManagedElement_impl.hpp"

#include "platformftproxy/ProxyUtil.hpp"
#include "platformftproxy/AccessorLookupService.hpp"
#include "platformftproxy/ProxyCollection.hpp"

#include <string>
#include <set>
#include <map>

namespace Cdmw
{
  namespace PlatformMngt
  {
    namespace Proxy
    {

      // class System_impl;

/**
 *Purpose:
 *<p>
 */
      class RedundancyGroup_impl:public virtual
        POA_CdmwPlatformMngt::RedundancyGroup,
        virtual public PortableServer::RefCountServantBase,
        virtual public ManagedElement_impl
      {
      

      private:

          Cdmw::PlatformMngt::Proxy::ProxyCollection *m_proxy_collection;

      private:

    /**
     *Purpose:
     *<p> Copy constructor is not allowed.
     */
        RedundancyGroup_impl (RedundancyGroup_impl & rhs);

    /**
     * Purpose:
     * <p> Assignment operator is not allowed.
     */
        RedundancyGroup_impl & operator= (const RedundancyGroup_impl & rhs);


      public:
        virtual ~RedundancyGroup_impl () throw ();

        RedundancyGroup_impl (CORBA::ORB_ptr orb,
                              ProxyCollection * proxy_collection,
                              AccessorLookupService * lookup_service)
          throw (Cdmw::BadParameterException, Cdmw::OutOfMemoryException);


        CdmwPlatformMngt::Entity *
           add_entity (const CdmwPlatformMngt::
                                       EntityDef & ent_def) 
                                        throw (CORBA::SystemException);


        void start_up () throw (CORBA::SystemException);

        void shut_down () throw (CORBA::SystemException);

        void insert (CdmwPlatformMngt::ManagedElement *) throw (CORBA::
                                                                SystemException);

        void _cxx_delete (CdmwPlatformMngt::ManagedElement *) throw (CORBA::
                                                                     SystemException);
        void get_all_components (CORBA::ULong,
                                 CdmwPlatformMngt::CcmComponents_out,
                                 CdmwPlatformMngt::
                                 ComponentsIterator_out) throw (CORBA::
                                                                SystemException);

        CdmwPlatformMngt::CcmComponent * get_component (const char *,
                                                          const char *)
          throw (CORBA::SystemException,CdmwPlatformMngt::ComponentNotFound);

        CORBA::ULong get_number_of_components () throw (CORBA::
                                                          SystemException);


        CORBA::ULong get_number_of_entities () throw (CORBA::SystemException);

        void get_all_entity_names (CORBA::ULong,
                                   CdmwPlatformMngt::ElementNames_out,
                                   CdmwPlatformMngt::
                                   ElementNamesIterator_out) throw (CORBA::
                                                                    SystemException);

        CdmwPlatformMngt::Entity *
          get_entity (const char *) throw ( CdmwPlatformMngt::EntityNotFound, CORBA::SystemException);

        CORBA::Boolean get_entities (const CdmwPlatformMngt::ElementNames &,
                                       CdmwPlatformMngt::
                                       Entities_out) throw (CORBA::
                                                            SystemException);

       void get_all_entities (CORBA::ULong how_many,
                               CdmwPlatformMngt::Entities_out ent_out,
                               CdmwPlatformMngt::
                               EntitiesIterator_out ent_iter_out) throw (CORBA::
                                                                         SystemException);

        //CdmwPlatformMngt::Entity *
          //add_entity (const CdmwPlatformMngt::EntityDef &) throw (CORBA::
           //                                                       SystemException);


        CORBA::Long get_minimum_size () throw (CORBA::SystemException);


        CdmwPlatformMngt::TechnicalStatus get_status (CORBA::
                                                        String_out)
          throw (CORBA::SystemException); 

        void set_minimum_size (CORBA::Long) throw (CORBA::SystemException);

        CdmwFTSystMngt::ManagedElementAccessor_ptr
          accessor_managed_element () throw (CORBA::TRANSIENT);

        Cdmw::Logging::Logger * Get_Logger ();


        virtual CdmwFTSystMngt::
          ManagedElementAccessor_ptr accessor_managed_group () 
           throw (CORBA::SystemException) = 0;

        virtual CdmwFTSystMngt::
          RedundancyGroupAccessor_ptr accessor_redu_group () 
           throw (CORBA::SystemException) = 0;

        void remove_entity(const char *) throw (CdmwPlatformMngt::EntityNotFound, CORBA::SystemException);


        char *group_domain_id () throw (CORBA::SystemException);
        //instance it only to try the compilation ...

        //RedundancyGroup_impl *redugroup = new RedundancyGroup_impl ();
     

      };

    }                           // End namespace Proxy
  }                             // End namespace PlatformMngt
}                               // End namespace Cdmw

#endif                          //INCL_PLATFORMMNGT_REDUNDANCYGROUP_IMPL_HPP
