/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#include "testbasic/SIM_HostAccessor_impl.hpp"
#include "testbasic/TestModus.hpp"
#include "testbasic/TestSamples.hpp"
#include <SystemMngt/platformlibrary/ElementPathsIterator_impl.hpp>
#include <Foundation/common/Assert.hpp> 

namespace Cdmw
{
namespace PlatformMngt
{
namespace Proxy
{

SIM_HostAccessor_impl::SIM_HostAccessor_impl(
        SIM_HostAccessor_impl& rhs)
{
     CDMW_NEVER_HERE(); // FIXME tbd
}


SIM_HostAccessor_impl& SIM_HostAccessor_impl::operator=(
            const SIM_HostAccessor_impl& rhs) 
{
    CDMW_NEVER_HERE(); // FIXME tbd
    return *this;
}
        
SIM_HostAccessor_impl::SIM_HostAccessor_impl()
    throw()
{
}

SIM_HostAccessor_impl::~SIM_HostAccessor_impl() 
{
}
    
    

CdmwPlatformMngt::HostStatus 
SIM_HostAccessor_impl::get_status
(const char* target_element_path)
             throw (CdmwPlatformMngt::ManagedElementNotFound,
                    CORBA::SystemException)
{
    raiseExceptionIfExceptionModus();


//     enum HostStatus
//     {
//         /**
//         * The host is responding
//         */
//         HOST_RESPONDING,

//         /**
//         * The host is not responding
//         */
//         HOST_UNREACHABLE
//     };

    return CdmwPlatformMngt::HOST_RESPONDING;
}

CdmwPlatformMngt::AutoRestartInfo SIM_HostAccessor_impl::get_autorestart_info(const char* target_element_path)
    throw(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

void SIM_HostAccessor_impl::set_autorestart_info(const char* target_element_path, 
                                                 const CdmwPlatformMngt::AutoRestartInfo& auto_restart_info)
    throw(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}


    CORBA::Long SIM_HostAccessor_impl::restart_attempt(const char* target_element_path) throw (CdmwPlatformMngt::ManagedElementNotFound, CORBA::SystemException )
    {
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
    }



    /**
     *Purpose:
     *<p> facade to get an attribute
     *
     */

void SIM_HostAccessor_impl::get_attribute( const char * target_element_path, 
                                           const char * attr_name, 
                                           CORBA::Any_out ret_attr, 
                                           CdmwPlatformMngt::Owner flag  )  
    throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound, CdmwPlatformMngt::ManagedElementNotFound)
{
throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

    /**
     *Purpose:
     *<p> facade to set an attribute
     *
     */

void SIM_HostAccessor_impl::set_attribute( const char * target_element_path, 
                                           const char * attr_name, 
                                           const CORBA::Any & attr, 
                                           CdmwPlatformMngt::Owner flag)  
    throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound, CdmwPlatformMngt::ReadOnlyAttribute, CdmwPlatformMngt::ManagedElementNotFound)
{
throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}


/*
char* 
SIM_HostAccessor_impl::get_platform_application_exe
(const char* target_element_path)
    throw (CdmwPlatformMngt::ManagedElementNotFound,
       CORBA::SystemException) 
{
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementName(target_element_path));

    return TestSamples::getPlatformApplicationExe();
}  
*/  
    
CdmwPlatformMngt::ElementPaths* 
SIM_HostAccessor_impl::get_processes
(const char* target_element_path,
 CORBA::ULong how_many,
 CdmwPlatformMngt::ElementPathsIterator_out processes_iterator)
    throw (CdmwPlatformMngt::ManagedElementNotFound,
       CORBA::SystemException)
{
    raiseExceptionIfExceptionModus(); 
   
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
  
    raiseExceptionIfExceptionModus();

    CdmwPlatformMngt::ElementPaths_var elems = 
    TestSamples::getElementPaths();

    CdmwPlatformMngt::ElementPaths_var head =
    new CdmwPlatformMngt::ElementPaths();
    CdmwPlatformMngt::ElementPaths_var tail =
    new CdmwPlatformMngt::ElementPaths();
    
    split(elems, how_many, head, tail);

    // create the path iterator
    CdmwPlatformMngt::ElementPathsIterator_var elementsRemainingIt =
    ElementPathsIterator_impl::create (seq2list(tail));

    processes_iterator = elementsRemainingIt;

    return head._retn();
}

char * SIM_HostAccessor_impl::get_process( const char * target_element_path, const char * process_name, const char * application_name) throw (CdmwPlatformMngt::ManagedElementNotFound, CORBA::SystemException)
    {
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
    }

   
void 
SIM_HostAccessor_impl::shutdown (const char* target_element_path, const char* issuer)
    throw (CdmwPlatformMngt::ManagedElementNotFound,
       CORBA::SystemException) 
{
    raiseExceptionIfExceptionModus();
   
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
}


void 
SIM_HostAccessor_impl::cold_reboot (const char* target_element_path, const char* issuer)
    throw (CdmwPlatformMngt::ManagedElementNotFound,
       CORBA::SystemException) 
{
    raiseExceptionIfExceptionModus();
   
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
}


void 
SIM_HostAccessor_impl::hot_reboot (const char* target_element_path, const char* issuer)
    throw (CdmwPlatformMngt::ManagedElementNotFound,
       CORBA::SystemException)
{
    raiseExceptionIfExceptionModus();
   
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
}
   
::CdmwPlatformMngt::ElementType SIM_HostAccessor_impl::get_element_type(const char * target_element_path)
            throw (CORBA::SystemException)
{
    return CdmwPlatformMngt::HOST_TYPE;
}


CdmwPlatformMngt::ElementPaths* SIM_HostAccessor_impl::get_children (const char * target_element_path)
            throw (CORBA::SystemException)
{
    return 0;
}

CORBA::Long SIM_HostAccessor_impl::get_restart_attempt(const char* target_element_path)
                    throw (CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT(OrbSupport::NO_IMPLEMENT,CORBA::COMPLETED_NO);
}   
                                      
void SIM_HostAccessor_impl::stop_host(const char* target_element_path, const char* issuer)
            throw (CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT(OrbSupport::NO_IMPLEMENT,CORBA::COMPLETED_NO);
}
            
void SIM_HostAccessor_impl::cold_restart(const char* target_element_path, const char* issuer)
                throw (CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT(OrbSupport::NO_IMPLEMENT,CORBA::COMPLETED_NO);
}
                
void SIM_HostAccessor_impl::hot_restart(const char* target_element_path, const char* issuer)                                              
    throw (CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT(OrbSupport::NO_IMPLEMENT,CORBA::COMPLETED_NO);
}

CdmwPlatformMngt::HostSnapshot* SIM_HostAccessor_impl::get_snapshot(const char* target_element_path)                                              
    throw (CdmwPlatformMngt::ManagedElementNotFound,
       CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT(OrbSupport::NO_IMPLEMENT,CORBA::COMPLETED_NO);
}

} // End namespace Proxy
} // End namespace PlatformMngt
} // End namespace Cdmw
