/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testbasic/SIM_ProcessAccessor_impl.hpp"
#include "testbasic/TestSamples.hpp"

#include "testbasic/TestModus.hpp"
#include <Foundation/common/Assert.hpp> 
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtPredefinedProperties.stub.hpp>

namespace Cdmw
{
namespace PlatformMngt
{
namespace Proxy
{


SIM_ProcessAccessor_impl::SIM_ProcessAccessor_impl(const SIM_ProcessAccessor_impl& rhs) 
{
    CDMW_NEVER_HERE();
}

 
SIM_ProcessAccessor_impl& 
SIM_ProcessAccessor_impl::operator=(const SIM_ProcessAccessor_impl& rhs) 
{
    CDMW_NEVER_HERE();
    return *this;
}


SIM_ProcessAccessor_impl::SIM_ProcessAccessor_impl()
    throw() 
{
}

SIM_ProcessAccessor_impl::~SIM_ProcessAccessor_impl()
{
}



/**
*Purpose:
*<p> facade to get an attribute
*
*/

void SIM_ProcessAccessor_impl::get_attribute( const char * target_element_path, 
                                                   const char * attr_name, 
                                                   CORBA::Any_out ret_attr, 
                                                   CdmwPlatformMngt::Owner flag  )  
        throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound, CdmwPlatformMngt::ManagedElementNotFound)
{
        raiseExceptionIfExceptionModus();
    CORBA::Any_var any = new CORBA::Any();
        if(std::string(attr_name) == std::string(CdmwPlatformMngt::AUTORESTART_INFO))
        {
          CdmwPlatformMngt::AutoRestartInfo auto_restart_info;
          auto_restart_info.max_nbr_of_restart_attempt = (CORBA::ULong) 0;
          auto_restart_info.auto_restart_control = CdmwPlatformMngt::USE_COUNTER;
          *any <<= auto_restart_info;
        }
        else if(std::string(attr_name) == std::string(CdmwPlatformMngt::REQUESTED_RESTART_WARMTH))
             {
                 *any <<= CdmwPlatformMngt::COLD_RESTART;
             } 
        else if(std::string(attr_name) == std::string(CdmwPlatformMngt::TRACE_FILTERS))
             {
                 *any <<= CORBA::string_dup("C1,D1,6");
             } 
    ret_attr = any._retn();     
                                                                                                                                                             
        raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
}

/**
*Purpose:
*<p> facade to set an attribute
*
*/

void SIM_ProcessAccessor_impl::set_attribute( const char * target_element_path, 
                                                   const char * attr_name, 
                                                   const CORBA::Any & attr, 
                                                   CdmwPlatformMngt::Owner flag)  
         throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound, CdmwPlatformMngt::ReadOnlyAttribute, CdmwPlatformMngt::ManagedElementNotFound)
{
}


/*
CdmwPlatformMngt::ProcessMode SIM_ProcessAccessor_impl::get_process_mode(const char* path)throw(CORBA::SystemException)
{
throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}
*/

CORBA::Boolean SIM_ProcessAccessor_impl::get_memory_resident(const char* path)throw(CORBA::SystemException)
{
throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

CORBA::Long SIM_ProcessAccessor_impl::get_core_dump_size(const char* path)throw(CORBA::SystemException)
{
throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}


void SIM_ProcessAccessor_impl::set_memory_resident(const char* path,bool val)throw(CORBA::SystemException)
{
throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

CdmwPlatformMngt::ProcessType 
SIM_ProcessAccessor_impl::get_type (const char* target_element_path)
    throw(CdmwPlatformMngt::ManagedElementNotFound,
      CORBA::SystemException) 
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getProcessType();
}



CORBA::Object_ptr 
SIM_ProcessAccessor_impl::get_embedded_service(const char* target_element_path)
    throw(CdmwPlatformMngt::ManagedElementNotFound,
      CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getEmbeddedService();
}
              

CdmwPlatformMngt::ProcessPID 
SIM_ProcessAccessor_impl::get_pid(const char* target_element_path)
    throw(CdmwPlatformMngt::ManagedElementNotFound,
      CORBA::SystemException) 
{  
   raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getProcessPID();
}
    

CORBA::Boolean 
SIM_ProcessAccessor_impl::get_created_dynamically
(const char* target_element_path)
    throw(CdmwPlatformMngt::ManagedElementNotFound,
      CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getCreatedDynamically();
}
     
CORBA::Long 
SIM_ProcessAccessor_impl::get_restart_attempt(const char* target_element_path)
              throw(CdmwPlatformMngt::ManagedElementNotFound,
                    CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getRestartAttempt();
}     
    
    
CdmwPlatformMngtBase::TimeStamp 
SIM_ProcessAccessor_impl::get_start_time(const char* target_element_path)
    throw(CdmwPlatformMngt::ManagedElementNotFound,
      CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getTimeStamp();
}

    
CdmwPlatformMngtBase::TimeStamp 
SIM_ProcessAccessor_impl::get_stop_time(const char* target_element_path)
              throw(CdmwPlatformMngt::ManagedElementNotFound,
                    CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getTimeStamp();
}
        
    
CdmwPlatformMngt::ProcessStatus
SIM_ProcessAccessor_impl::get_status(const char* target_element_path,
       CORBA::String_out status_info)
    throw(CdmwPlatformMngt::ManagedElementNotFound,
      CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getProcessStatus();
}


char* 
SIM_ProcessAccessor_impl::get_host(const char* target_element_path)
    throw(CdmwPlatformMngt::ManagedElementNotFound,
      CORBA::SystemException)
{
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getElementPath();
}
              
 

CORBA::Boolean 
SIM_ProcessAccessor_impl::is_auto_ending(const char* target_element_path)
              throw(CdmwPlatformMngt::ManagedElementNotFound,
                    CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getAutoEnding();
}

              
              
void 
SIM_ProcessAccessor_impl::set_auto_ending(const char* target_element_path,
                      CORBA::Boolean auto_ending)
              throw(CdmwPlatformMngt::ManagedElementNotFound,
                    CdmwPlatformMngt::IncompatibleStatus,
                    CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path) ||
               TestSamples::getAutoEnding() != auto_ending);
}




CdmwPlatformMngt::ProcessInfo* 
SIM_ProcessAccessor_impl::get_process_info(const char* target_element_path)
              throw(CdmwPlatformMngt::ManagedElementNotFound,
                    CORBA::SystemException)
{  
     raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getProcessInfo();  
}

void 
SIM_ProcessAccessor_impl::set_process_info(const char* target_element_path,
                          const CdmwPlatformMngt::ProcessInfo& process_info )
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CdmwPlatformMngt::IncompatibleStatus,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    CdmwPlatformMngt::ProcessInfo_var check = 
    TestSamples::getProcessInfo();

    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path) );
}


CdmwPlatformMngt::LifeCycleDef* 
SIM_ProcessAccessor_impl::get_life_cycle(const char* target_element_path)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CdmwPlatformMngt::IncompatibleType,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getLifeCycleDef();  
}

void 
SIM_ProcessAccessor_impl::set_life_cycle(const char* target_element_path,
                        const CdmwPlatformMngt::LifeCycleDef& life_cycle)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CdmwPlatformMngt::DuplicateStep,
                   CdmwPlatformMngt::IncompatibleType,
                   CdmwPlatformMngt::IncompatibleStatus,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    CdmwPlatformMngt::LifeCycleDef_var check = 
    TestSamples::getLifeCycleDef();

    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
}
    

CdmwPlatformMngt::CompleteMonitoringInfo 
SIM_ProcessAccessor_impl::get_monitoring_info(
                         const char* target_element_path)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CdmwPlatformMngt::IncompatibleType,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getCompleteMonitoringInfo(); 
}


void 
SIM_ProcessAccessor_impl::set_monitoring_info(
                         const char* target_element_path,
                         const CdmwPlatformMngt::CompleteMonitoringInfo& monitoring_info)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CdmwPlatformMngt::IncompatibleType,
                   CdmwPlatformMngt::IncompatibleStatus,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    CdmwPlatformMngt::CompleteMonitoringInfo_var check = 
    TestSamples::getCompleteMonitoringInfo();

    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
}

                   
CdmwPlatformMngt::ExitAutoRestartInfo* 
SIM_ProcessAccessor_impl::get_exit_autorestart_info(
                         const char* target_element_path)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getExitAutoRestartInfo(); 
}



 void 
SIM_ProcessAccessor_impl::set_exit_autorestart_info(
                         const char* target_element_path,
                         const CdmwPlatformMngt::ExitAutoRestartInfo& exit_autorestart_info)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CdmwPlatformMngt::IncompatibleStatus,
                   CORBA::SystemException)
{  
     raiseExceptionIfExceptionModus();
    
    CdmwPlatformMngt::ExitAutoRestartInfo_var check = 
    TestSamples::getExitAutoRestartInfo();

    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
}


CdmwPlatformMngt::ProcessSnapshot* 
SIM_ProcessAccessor_impl::get_snapshot(const char* target_element_path)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getProcessSnapshot(); 
}
             
CdmwPlatformMngt::RequestStatus 
SIM_ProcessAccessor_impl::initialise(
                          const char* target_element_path,
                          const CdmwPlatformMngtBase::StartupKind& startup_kind)
             throw (CdmwPlatformMngt::ManagedElementNotFound,
                    CdmwPlatformMngt::IncompatibleStatus,
                    CORBA::SystemException)
{  
     raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getRequestStatus(); 
}


CdmwPlatformMngt::RequestStatus 
SIM_ProcessAccessor_impl::next_step(const char* target_element_path)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CdmwPlatformMngt::InvalidStep,
                   CdmwPlatformMngt::IncompatibleType,
                   CdmwPlatformMngt::IncompatibleStatus,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getRequestStatus(); 
}



CdmwPlatformMngt::RequestStatus 
SIM_ProcessAccessor_impl::run(const char* target_element_path)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CdmwPlatformMngt::NotReadyToRun,
                   CdmwPlatformMngt::IncompatibleType,
                   CdmwPlatformMngt::IncompatibleStatus,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getRequestStatus(); 
}


CdmwPlatformMngt::RequestStatus 
SIM_ProcessAccessor_impl::stop(const char* target_element_path,
                                         CORBA::Boolean emergency)
             throw(CdmwPlatformMngt::ManagedElementNotFound,
                   CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getRequestStatus(); 
}

             
             
CdmwPlatformMngt::RequestStatus 
SIM_ProcessAccessor_impl::cold_restart(
                          const char* target_element_path,
                          const CdmwPlatformMngtBase::StartupKind& startup_kind, const char* issuer)
             throw (CdmwPlatformMngt::ManagedElementNotFound,
                    CdmwPlatformMngt::IncompatibleStatus,
                    CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getRequestStatus(); 
}

             

CdmwPlatformMngt::RequestStatus 
SIM_ProcessAccessor_impl::hot_restart(
                          const char* target_element_path,
                          const CdmwPlatformMngtBase::StartupKind& startup_kind, const char* issuer)
             throw (CdmwPlatformMngt::ManagedElementNotFound,
                    CdmwPlatformMngt::IncompatibleStatus,
                    CORBA::SystemException)
{  
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getRequestStatus(); 
}

::CdmwPlatformMngt::ElementType SIM_ProcessAccessor_impl::get_element_type(const char * target_element_path)
            throw (CORBA::SystemException)
{
    return CdmwPlatformMngt::PROCESS_TYPE;
}


CdmwPlatformMngt::ElementPaths* SIM_ProcessAccessor_impl::get_children (const char * target_element_path)
            throw (CORBA::SystemException)
{
    return 0;
}


CdmwPlatformMngt::ProcessExitInfo SIM_ProcessAccessor_impl::get_last_exit_code( const char* target_element_path) throw( CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}


void SIM_ProcessAccessor_impl::set_indicator_relevant_status( const char* target_element_path, const bool indicator_relevant_status) throw( CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

bool SIM_ProcessAccessor_impl::get_indicator_relevant_status( const char* target_element_path) throw( CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}


void SIM_ProcessAccessor_impl::set_component_start_graph( const char* target_element_path, const CdmwPlatformMngt::GraphElements& component_graph) throw( CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

CdmwPlatformMngt::GraphElements * SIM_ProcessAccessor_impl::get_component_start_graph( const char* target_element_path) throw( CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

void SIM_ProcessAccessor_impl::set_component_stop_graph( const char* target_element_path, const CdmwPlatformMngt::GraphElements& component_graph) throw( CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

CdmwPlatformMngt::GraphElements * SIM_ProcessAccessor_impl::get_component_stop_graph( const char* target_element_path) throw( CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}

CdmwPlatformMngt::LongRequestStatus SIM_ProcessAccessor_impl::stop_and_wait (const char* target_element_path,
                                                                         CORBA::Boolean emergency)
             throw(CdmwPlatformMngt::ManagedElementNotFound, CORBA::SystemException)
  {
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
  }


void SIM_ProcessAccessor_impl::set_init_graph (const char* target_element_path, const CdmwPlatformMngt::GraphElements& graph_element)
             throw(CORBA::SystemException)
  {
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
  }

void SIM_ProcessAccessor_impl::set_stop_graph (const char* target_element_path, const CdmwPlatformMngt::GraphElements& graph_element)
             throw(CORBA::SystemException)
  {
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
  }

CdmwPlatformMngt::CcmComponent*     SIM_ProcessAccessor_impl::add_component (const char* target_element_path,
                                                                             CdmwPlatformMngt::ComponentDef* comp_def)
       throw (CORBA::SystemException, CdmwPlatformMngt::ComponentAlreadyExists, CdmwPlatformMngt::ComponentServerNotFound,
              CdmwPlatformMngt::DuplicateEntity, CosPropertyService::MultipleExceptions,
              CdmwPlatformMngt::DuplicateService, CdmwPlatformMngt::DuplicateStep,
              CdmwPlatformMngt::IncompatibleStatus)
  {
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
  }

void  SIM_ProcessAccessor_impl::remove_component (const char* target_element_path,
                                                  const char* component_name, const char* host_name)
      throw(CORBA::SystemException, CdmwPlatformMngt::ComponentNotFound, CdmwPlatformMngt::ComponentStillActive, CdmwPlatformMngt::IncompatibleStatus)
  {
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
  }


CdmwPlatformMngt::ProcessPID SIM_ProcessAccessor_impl::get_previous_pid(const char* target_element_path) 
    throw(CORBA::SystemException,CdmwPlatformMngt::ManagedElementNotFound)
{
    raiseExceptionIfExceptionModus();
    
    raiseSystemExceptionIf(! TestSamples::hasElementPath(target_element_path));
    // FIXME verify the porperty list
    
    return TestSamples::getProcessPID();
}    

void SIM_ProcessAccessor_impl::get_all_components(const char* target_element_path, CORBA::ULong how_many, CdmwPlatformMngt::ElementPaths_out element_paths, CdmwPlatformMngt::ComponentsIterator_out components_iterator) 
    throw(CORBA::SystemException,CdmwPlatformMngt::NotComponentServer,                        CdmwPlatformMngt::ManagedElementNotFound)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}   

char* SIM_ProcessAccessor_impl::get_component(const char* target_element_path, const char* component_name) 
throw(CORBA::SystemException,CdmwPlatformMngt::ComponentNotFound, CdmwPlatformMngt::NotComponentServer,
                CdmwPlatformMngt::ManagedElementNotFound)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}                

CORBA::ULong SIM_ProcessAccessor_impl::get_number_of_components(const char* target_element_path)
    throw(CORBA::SystemException,CdmwPlatformMngt::NotComponentServer,         CdmwPlatformMngt::ManagedElementNotFound)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
} 

CdmwPlatformMngt::RequestStatus SIM_ProcessAccessor_impl::stop_process(const char*, CORBA::Boolean, const char* issuer)  throw
(CORBA::SystemException)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
} 

CdmwPlatformMngt::CcmComponent* SIM_ProcessAccessor_impl::add_component(const char* target_element_path, const CdmwPlatformMngt::ComponentDef& component_def)
    throw(CORBA::SystemException,CdmwPlatformMngt::ComponentAlreadyExists, CdmwPlatformMngt::ComponentServerNotFound,
        CdmwPlatformMngt::DuplicateEntity, CosPropertyService::MultipleExceptions,
        CdmwPlatformMngt::DuplicateService, CdmwPlatformMngt::DuplicateStep,
        CdmwPlatformMngt::IncompatibleStatus)
{
    throw CORBA::NO_IMPLEMENT (OrbSupport::NO_IMPLEMENT, CORBA::COMPLETED_NO);
}        
  
  
} // End namespace Proxy
} // End namespace PlatformMngt
} // End namespace Cdmw

