/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_COMPONENT_CONTEXTEXTIMPL_HPP 
#define INCL_PLATFORMMNGT_COMPONENT_CONTEXTEXTIMPL_HPP  

#include "SystemMngt/idllib/CdmwPlatformMngtComponentContextExt.skel.hpp"

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"
#include "platforminterface/ComponentContext_impl.hpp"
#include "platforminterface/ProcessContext_impl.hpp"


namespace Cdmw
{
namespace PlatformMngt
{


/**
* Purpose:
* <p>
* The default implementation of a ManagedElementContexts::ComponentContextExt.
*/
class ComponentContextExt_impl :  
      virtual public CdmwPlatformMngt::ManagedElementContexts::ComponentContextExt,
      virtual public Cdmw::OrbSupport::RefCountLocalObject,
      virtual public ComponentContext_impl
{

public:

    /**
     * Purpose:
     * <p> Constructor.
     */ 
    ComponentContextExt_impl(const char* component_name, 
            CdmwPlatformMngt::ManagedElementContexts::ProcessContext_ptr process_ctx);


    /**
     * Purpose:
     * <p> Destructor.
     */ 
    virtual ~ComponentContextExt_impl() throw ();

    /**
     * Purpose:
     * <p>
     * implements the
     * IDL:thalesgroup.com/CdmwPlatformMngt/ManagedElementContexts/ComponentContexExt/notify_property_change:1.0
     * attribute
     */
    void notify_property_change (
        CdmwPlatformMngt::PropertyChange * property_change_event)
    throw (CORBA::SystemException);
 
};


} // End namespace PlatformMngt
} // End namespace Cdmw

#endif // INCL_PLATFORMMNGT_COMPONENT_CONTEXTEXTIMPL_HPP 

