/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "platforminterface/ComponentContextExt_impl.hpp"
//#include "platforminterface/PlatformInterface.hpp"


namespace Cdmw
{
namespace PlatformMngt
{

//
// Constructor
//
ComponentContextExt_impl::ComponentContextExt_impl(const char* component_name, CdmwPlatformMngt::ManagedElementContexts::ProcessContext_ptr process_ctx)
:ComponentContext_impl (component_name, CdmwPlatformMngt::ManagedElementContexts::ProcessContext::_duplicate(process_ctx))
{
}


//
// Destructor
//
ComponentContextExt_impl::~ComponentContextExt_impl()
    throw()
{
}

void ComponentContextExt_impl::notify_property_change (
        CdmwPlatformMngt::PropertyChange * property_change_event)
    throw (CORBA::SystemException)
{ 
    ProcessContext_impl * process_ctx_impl =  dynamic_cast <ProcessContext_impl*>(m_process_ctx.in());
    
    try
    {
        process_ctx_impl->notify_property_change(property_change_event);
   }
    catch (const CORBA::SystemException &e)
    {
        std::cerr<< "ComponentContextExt_impl: Exception is " << e <<std::endl;
    }

}


} // End namespace PlatformMngt
} // End namespace Cdmw


