/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_MANAGED_CONTEXT_UTIL_HPP
#define INCL_MANAGED_CONTEXT_UTIL_HPP

#include <iostream>
#include "SystemMngt/idllib/CdmwPlatformMngtManagedElementContexts.stub.hpp"
#include "Foundation/orbsupport/CORBA.hpp"
#include "testmanagedprocess/SupervisionObserver_impl.hpp"

namespace Cdmw
{

namespace PlatformMngt
{


class ManagedContextUtil
{

    public:

    ManagedContextUtil(){};

    ManagedContextUtil(CORBA::ORB_ptr orb);

    virtual ~ManagedContextUtil() throw();

    void perform_operation(); 

    private:

    CORBA::ORB_var m_orb;   

    Cdmw::PlatformMngt::SupervisionObserver_impl* m_supervision_observer_impl;
    CdmwPlatformMngt::SupervisionObserver_var m_supervision_observer_var;
    CdmwPlatformMngt::ManagedElementContexts::ProcessContext_var ctx; 
};


} //end PlatformMngt

} //end Cdmw

#endif // INCL_MANAGED_CONTEXT_UTIL_HPP

