/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <iostream>
#include "testmanagedprocess/SupervisionObserver_impl.hpp"

namespace Cdmw
{        // Begin namespace Cdmw

    namespace PlatformMngt
    { // Begin namespace PlatformMngt

        SupervisionObserver_impl::SupervisionObserver_impl()
        {
            m_ok = false;
        }
                                    

        void SupervisionObserver_impl::set_ok()
        {
            m_ok = true;
        }

        bool SupervisionObserver_impl::is_ok()
        {
            return m_ok;
        }
    
        void SupervisionObserver_impl::notify( CdmwPlatformMngt::Event* an_event ) throw( CORBA::SystemException )
        {
           if ((dynamic_cast<CdmwPlatformMngt::ProcessMessage*>(an_event))&&(!dynamic_cast<CdmwPlatformMngt::ProcessStatusChange*>(an_event) )) 
           {
               m_ok = true;
               std::string event_to_string(an_event->to_string());
               unsigned int found = event_to_string.find("MessageFromProcessContext");
                 if (found < event_to_string.length())
               {
                  std::cerr << event_to_string<< std::endl;  
                  set_ok();
               }
              assert(is_ok());
           }
        }
    } // End namespace PlatformMngt
} // End namespace Cdmw

