/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.platformmngt.test;

import cdmw.common.BadOrderException;
import cdmw.common.BadParameterException;
import com.thalesgroup.CdmwPlatformMngt.*;
import cdmw.ossupport.OS;
import cdmw.common.Assert;



public class SupervisionObserverImpl extends com.thalesgroup.CdmwPlatformMngt.SupervisionObserverPOA implements Runnable
{

    private org.omg.CORBA.ORB orb;
    // true when ProcessMessageEvent has arrived
    private boolean m_ok;
    public void run() 
    {
        while(true)
        {
        //      java.lang.System.out.println("loop");
        }
    }

    public SupervisionObserverImpl(org.omg.CORBA.ORB orb) {
        try 
    {
         this.orb = orb;
         m_ok = false;
    } 
    catch(Exception e) 
    {
        e.printStackTrace();
    }
    }
    
    public void set_ok()
    {
        m_ok = true;
    }
      
    public boolean is_ok()
    {
        return m_ok;
    }
    
    public void _notify(com.thalesgroup.CdmwPlatformMngt.Event event)
    {
        //check only the first ProcessMessage event
        if ((event instanceof com.thalesgroup.CdmwPlatformMngt.ProcessMessage)&&(!( event instanceof com.thalesgroup.CdmwPlatformMngt.ProcessStatusChange)))
        {
           String event_stringfied = event.to_string();
           int index = event_stringfied.indexOf("MessageFromProcessContext");
           if (index != -1)
           {
               java.lang.System.out.println(event.to_string());
               m_ok=true;
           }
          Assert.check(is_ok());
        }
    } 
}

