/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.platformmngt.test;

import cdmw.testutils.Testable;
import cdmw.common.BadOrderException;
import cdmw.common.BadParameterException;
import cdmw.platformmngt.*;
import com.thalesgroup.CdmwPlatformMngt.*;
import com.thalesgroup.CdmwPlatformMngt.ProcessCallbackPackage.*;
import com.thalesgroup.CdmwPlatformMngt.ProcessCallbackPackage.ProcessStartingData.*;
//import cdmw.platformmngt.ProcessDelegateImpl;
 
class SimProcessCallbackImpl extends com.thalesgroup.CdmwPlatformMngt.ProcessCallbackPOA{


private ProcessStartingData m_startingData;
private ProcessDelegate     m_process;
private String              m_errorIssuer;


public SimProcessCallbackImpl(
      ProcessStartingData startingData)
{
    m_startingData = new  ProcessStartingData();
    m_startingData = startingData;
}

public ProcessDelegate getProcess()
{
    return m_process;
}


public String getErrorIssuer()
{
    return m_errorIssuer;
}


//
// IDL:thalesgroup.com/CdmwPlatformMngt/ProcessCallback/set_ready:1.0
//
public ProcessStartingData set_ready(ProcessDelegate the_process) throws org.omg.CORBA.SystemException
{
    // updates the application agent reference
    m_process = the_process;

    // signals the acknowledgement
   /*  if (!signal())
    {
        // The acknowledgement has been performed too late
        throw CORBA::NO_PERMISSION(OrbSupport::NO_PERMISSION, CORBA::COMPLETED_NO);
    }

    */ 
    ProcessStartingData result = m_startingData;

    return result;
}


//
// IDL:thalesgroup.com/CdmwPlatformMngt/ProcessCallback/get_starting_info:1.0
//
public ProcessStartingData get_starting_info (ProcessDelegate the_process) throws org.omg.CORBA.SystemException
{
    // updates the application agent reference
/*     m_process = CdmwPlatformMngt::ProcessDelegate::_duplicate(the_process);

    CdmwPlatformMngt::ProcessCallback::ProcessStartingData_var result(m_startingData);

    return result._retn(); */
     return m_startingData;
}

//
// IDL:thalesgroup.com/CdmwPlatformMngt/ProcessCallback/set_creation_done:1.0
//     
public void set_creation_done () throws org.omg.CORBA.SystemException
{
    // signals the acknowledgement
/*     if (!signal())
    {
        // The acknowledgement has been performed too late
        throw CORBA::NO_PERMISSION(OrbSupport::NO_PERMISSION, CORBA::COMPLETED_NO);
    } */
}



//
// IDL:thalesgroup.com/CdmwPlatformMngt/ProcessCallback/notify_error:1.0
//
public void notify_error(String issuer, String error_info)
    throws org.omg.CORBA.SystemException
{
   
        java.lang.System.out.println("ProcessMessageBroker.notify_process_error("+ issuer + "," + error_info + ")");
}

}
