/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.platformmngt.test;

import com.thalesgroup.CdmwPlatformMngt.ProcessMessageBrokerPOA;
import com.thalesgroup.CdmwPlatformMngt.*;
import org.omg.CORBA.*;


class SimProcessMessageBrokerImpl extends  com.thalesgroup.CdmwPlatformMngt.ProcessMessageBrokerPOA
{
    //implements ProcessMessageBrokerOperations


    /**
     * Purpose:
     * <p> Constructor
     * 
     */
    public SimProcessMessageBrokerImpl() throws org.omg.CORBA.SystemException
    {
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/notify_user_event:1.0
    //
    public
    void
    notify_user_event(String issuer, org.omg.CORBA.Any data) throws org.omg.CORBA.SystemException
    {
        java.lang.System.out.println("ProcessMessageBroker.notify_user_event" + issuer  + " data");
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/notify_message:1.0
    //
    public void   notify_message(com.thalesgroup.CdmwPlatformMngtBase.EventHeader header,
                                 String issuer,
                                 String message) throws org.omg.CORBA.SystemException
    {
        java.lang.System.out.println("ProcessMessageBroker.notify_message( {" + header.level + "},"+ issuer + "," + message + ")");
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/notify_error:1.0
    //
    public void    notify_error(com.thalesgroup.CdmwPlatformMngtBase.TimeStamp time_stamp,
                                String issuer,
                                String error_info)   throws org.omg.CORBA.SystemException
    {
        java.lang.System.out.println("ProcessMessageBroker.notify_error (" + issuer + "," +  error_info + ")");
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/notify_process_error:1.0
    //
    public void notify_process_error (String failed_process_name,
                                      com.thalesgroup.CdmwPlatformMngtBase.TimeStamp  time_stamp,
                                      String issuer,
                                      String error_info)
    throws com.thalesgroup.CdmwPlatformMngt.ProcessNotFound,
           org.omg.CORBA.SystemException
    {
        java.lang.System.out.println("ProcessMessageBroker.notify_process_error(" + failed_process_name + "," + issuer + "," +error_info + ")");
    }


    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/get_service:1.0
    //
    public
    org.omg.CORBA.Object
    get_service (String service_name)
    throws com.thalesgroup.CdmwPlatformMngtService.ServiceNotFound,
           com.thalesgroup.CdmwPlatformMngtService.ServiceUnavailable,
           org.omg.CORBA.SystemException
    {
        java.lang.System.out.println("ProcessMessageBroker.get_service(" + service_name  + ")");

        String                                                  service_name_str = service_name;
        com.thalesgroup.CdmwPlatformMngt.External.System        system = null;
        com.thalesgroup.CdmwPlatformMngt.External.Application   application = null;
        com.thalesgroup.CdmwPlatformMngt.External.Process       process = null;
        com.thalesgroup.CdmwPlatformMngt.External.Host          host = null;

        if (service_name.equals("singleton"))
            return system;

        if (service_name_str.lastIndexOf("PROC1.proc") < service_name_str.length())
            return process;

        if (service_name_str.lastIndexOf("APPL1.appl") < service_name_str.length())
            return application;

        if (service_name_str.lastIndexOf(".host") < service_name_str.length())
            return host;

        org.omg.CORBA.Object obj = null;

        return obj;
    }


    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/get_managed_element:1.0
    //
    public      com.thalesgroup.CdmwPlatformMngt.ManagedElement   get_managed_element (String element_path)
    throws com.thalesgroup.CdmwPlatformMngt.ElementPathInvalid,
           com.thalesgroup.CdmwPlatformMngt.ManagedElementNotFound,
           org.omg.CORBA.SystemException
    {
        java.lang.System.out.println("ProcessMessageBroker.get_managed_element (" + element_path + ")");

        com.thalesgroup.CdmwPlatformMngt.ManagedElement element = null;

        return element;
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/get_system_entity_status:1.0
    //
    public String get_system_entity_status (
                        String entity_name,
                        org.omg.CORBA.StringHolder entity_info)
    throws com.thalesgroup.CdmwPlatformMngt.EntityNotFound,
           org.omg.CORBA.SystemException
    {
        java.lang.System.out.println("ProcessMessageBroker.get_system_entity_status( " + entity_name + ")");

        String entity_status = new String("");
        entity_info.value = new String("");

        return entity_status;
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/get_host_entity_status:1.0
    //
    public String get_host_entity_status (
                      String host_name,
                      String entity_name,
                      org.omg.CORBA.StringHolder entity_info)
    throws com.thalesgroup.CdmwPlatformMngt.HostNotFound,
           com.thalesgroup.CdmwPlatformMngt.EntityNotFound,
           org.omg.CORBA.SystemException
    {
        if (host_name == null)
        {
        java.lang.System.out.println("ProcessMessageBroker.get_host_entity_status (" + entity_name + ")");
        }
        else
        {
        java.lang.System.out.println("ProcessMessageBroker.get_host_entity_status(" +  host_name + "," + entity_name + ")");
        }

        String entity_status = new String("");
        entity_info.value = new String("");

        return entity_status;
    }



    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/get_application_entity_status:1.0
    //
    public String get_application_entity_status (
                         String application_name,
                         String entity_name,
                         org.omg.CORBA.StringHolder entity_info)
    throws com.thalesgroup.CdmwPlatformMngt.ApplicationNotFound,
           com.thalesgroup.CdmwPlatformMngt.EntityNotFound,
           org.omg.CORBA.SystemException
    {
        if (application_name == null)
        {
        java.lang.System.out.println("ProcessMessageBroker.get_application_entity_status (" + entity_name + ")");
        }
        else
        {
        java.lang.System.out.println("ProcessMessageBroker.get_application_entity_status (" + application_name + "," +  entity_name + ")");
        }

        String entity_status = new String("");
        entity_info.value = (new String(""));

        return entity_status;
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/get_process_entity_status:1.0
    //
    public String get_process_entity_status (
                         String application_name,
                         String process_name,
                         String host_name,
                         String entity_name,
                         org.omg.CORBA.StringHolder entity_info)
    throws com.thalesgroup.CdmwPlatformMngt.EntityNotFound,
           org.omg.CORBA.SystemException
    {
        if (application_name == null)
        {
        java.lang.System.out.println("ProcessMessageBroker.get_process_entity_status(" + entity_name + ")");
        }
        else
        {
        java.lang.System.out.println("ProcessMessageBroker.get_process_entity_status " +  application_name +
                         "," + process_name + "," + host_name + "," + entity_name + ")");
        }

        String entity_status = new String("");
        entity_info.value = (new String(""));

        return entity_status;
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/set_system_entity_status:1.0
    //
    public void set_system_entity_status (
                      String entity_name,
                      String entity_status,
                      String entity_info)
    throws com.thalesgroup.CdmwPlatformMngt.EntityNotFound,
           org.omg.CORBA.SystemException
    {
        java.lang.System.out.println("ProcessMessageBroker.set_system_entity_status(" + entity_name  +
                                     "," +  entity_status + "," + entity_info +  ")");
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/set_host_entity_status:1.0
    //
    public void set_host_entity_status (
                    String host_name,
                    String entity_name,
                    String entity_status,
                    String entity_info)
    throws com.thalesgroup.CdmwPlatformMngt.HostNotFound,
           com.thalesgroup.CdmwPlatformMngt.EntityNotFound,
           org.omg.CORBA.SystemException
    {
        if (host_name == null)
        {
        java.lang.System.out.println("ProcessMessageBroker.set_host_entity_status"+
                         "("  + entity_name  + "," + entity_status + "," + entity_info + ")");
        }
        else
        {
        java.lang.System.out.println("ProcessMessageBroker.set_host_entity_status" +
                         "("  + host_name + "," + entity_name + "," + entity_status + "," + entity_info + ")");
        }
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/set_application_entity_status:1.0
    //
    public void set_application_entity_status (
                           String application_name,
                           String entity_name,
                           String entity_status,
                           String entity_info)
    throws com.thalesgroup.CdmwPlatformMngt.ApplicationNotFound,
           com.thalesgroup.CdmwPlatformMngt.EntityNotFound,
           org.omg.CORBA.SystemException
    {
        if (application_name == null)
        {
        java.lang.System.out.println("ProcessMessageBroker.set_application_entity_status" +
                         "(" + entity_name + "," + entity_status + "," + entity_info + ")");
        }
        else
        {
        java.lang.System.out.println("ProcessMessageBroker.set_application_entity_status"+
                         "(" + application_name + "," + entity_name + "," + entity_status + "," + entity_info + ")");
        }
    }

    //
    // IDL:thalesgroup.com/com.thalesgroup.CdmwPlatformMngt/ProcessMessageBroker/set_process_entity_status:1.0
    //
    public void set_process_entity_status (
                       String application_name,
                       String process_name,
                       String host_name,
                       String entity_name,
                       String entity_status,
                       String entity_info)
    throws com.thalesgroup.CdmwPlatformMngt.ProcessNotFound,
           com.thalesgroup.CdmwPlatformMngt.EntityNotFound,
           org.omg.CORBA.SystemException
    {
        if (application_name == null)
        {
        java.lang.System.out.println("ProcessMessageBroker.set_process_entity_status" +
                         "(" + entity_name + "," + entity_status + "," + entity_info + ")" );
        }
        else
        {
        java.lang.System.out.println("ProcessMessageBroker.set_process_entity_status" +
                         "(" + application_name + "," + process_name + "," + host_name + "," +
                         entity_name + "," + entity_status + "," + entity_info + ")");
        }
    }
    
    public void notify_property_change (PropertyChange property_change_event)
    {
    
    java.lang.System.out.println(" SimBrokerStub : notify_property_change() CALLED!!!");
    
    } 



}
