#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================


ret_ok=0;
ret_nok=-1;
signal=15;
CMDLINE=$*

print_usage()
{
    echo "This script kills process which has its pid saved into the specified file, and delete this file."
    echo "Usage:"
    echo "   $0 <pid_file>"
    echo " "
}

if [ "$*" = "" ]; then
    print_usage
    exit $ret_nok;
fi

for OPT in $CMDLINE;
do
    OPT_=$(echo "$OPT" | tr [a-z] [A-Z])

    case $OPT_ in

        --HELP)
            print_usage
            exit $ret_ok; 
        ;;

        --SIGNAL=*)
            signal=`echo $OPT | cut -d= -f2`
            if [ -z $signal ]; then
                echo "error: $OPT require an argument ($OPT=[...])"
                exit $ret_nok; 
            fi
        ;;  
esac
done


pid_file=$1
shift

#sleep 5

if [ -f $pid_file ]; then

    pid=`cat $pid_file 2> /dev/null`
    
    if [ "x$pid" != "x" ]; then
        kill -$signal $pid
        echo "kill -$signal $pid $pid_file"
    fi
    
    rm -f $pid_file
    
  
fi

exit $ret_ok


