/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_PLATFORMMNGT_SUPERVISION_MANAGEDELEMENT_PROP_OBSKEY_HPP
#define INCL_PLATFORMMNGT_SUPERVISION_MANAGEDELEMENT_PROP_OBSKEY_HPP


#include <iostream>
#include <vector>


class PropObsKey
{

public:
  PropObsKey ();
  
  ~PropObsKey ();

  bool operator== (const PropObsKey & prop_obs_key) const;
  bool operator< (const PropObsKey & prop_obs_key) const;
  bool operator> (const PropObsKey & prop_obs_key) const;

  inline std::string get_element_path ()
  {
    return element_path;
  };
  inline std::string get_property ()
  {
    return property;
  };
  inline void set_element_path (const std::string & element_path)
  {
    this->element_path = element_path;
  };
  inline void set_property (const std::string & property)
  {
    this->property = property;
  };

private:
  //PropObsKey operator=(const PropObsKey& prop_obs_key) const;
  //PropObsKey(const PropObsKey& prop_obs_key);

private:
  std::string property;
  std::string element_path;
};
#endif
