/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_PLATFORMMNGT_SUPERVISION_MANAGEDELEMENT_PROP_TYPES_HPP
#define INCL_PLATFORMMNGT_SUPERVISION_MANAGEDELEMENT_PROP_TYPES_HPP

#include <map>

#include <SystemMngt/idllib/CdmwPlatformMngtSupervisionObserver.stub.hpp>
#include <SystemMngt/platformlibrary/PropObsKey.hpp>

// Observer structure containing Observer ptr and the observer name


namespace Cdmw
{
  namespace PlatformMngt
  {

    struct ObserverInfo
    {
      std::string observer_name;
      CdmwPlatformMngt::SupervisionObserver_ptr observer_ptr;
    };

// Map for observer registered for all
    typedef std::multimap < std::string, ObserverInfo > MapObsForAll;

// Map for observer registered for property names
    typedef std::multimap < PropObsKey, ObserverInfo > MapObsForProp;
  }


    /*
     * The event deallocator
     */ 
    template < class TElement > class QueueElementDeallocator
    {

    public:
        /**
         * Purpose:
         * <p>
         * Deallocates the element TElement passed by user.
         */
        static void deallocate (TElement * event) throw ()
        {
            CORBA::remove_ref (event);
        }

    };

 
}
#endif
