/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_PLATFORMMNGT_SUPERVISION_MANAGEDELEMENT_PROP_UTILS_HPP
#define INCL_PLATFORMMNGT_SUPERVISION_MANAGEDELEMENT_PROP_UTILS_HPP

#include <iostream>
#include <vector>
#include "PropTypes.hpp"
#include <Foundation/ossupport/OS.hpp>


namespace Cdmw
{
  namespace PlatformMngt
  {
    class PropUtils
    {

    public:
      PropUtils ();
      ~PropUtils ();
      
      PropUtils& operator-= (const PropUtils & rhs);
      
      void set_propertyset (const CosPropertyService::
                PropertyNames & property_names);
     
      void set_propertyset (const std::vector<std::string>&  property_names);
       
      inline std::vector < std::string >* get_propertyset (const CosPropertyService::
              PropertyNames & property_names);

      std::vector < std::string >* get_propertyset ();
    
      static void update_keys (MapObsForProp & map_obs_for_prop,
                   const std::string & element_path,
                   const std::vector < std::string > *prop_names,
                   const ObserverInfo & obs_info) throw (CdmwPlatformMngt::ElementAlreadyExists);

      static std::vector <std::string>* get_property_names_in_map (MapObsForProp & map_obs_for_prop,
                                       const std::string & element_path);

      static void print_map_for_all(MapObsForAll & map_obs_for_all);
      
      static void print_map_for_prop(MapObsForProp & map_obs_for_prop);
      // TO DO const MapObsForProp&    
      static bool check_obs_name_in_map_for_prop (MapObsForProp& map_for_prop ,const std::string& observer_name,const PropObsKey& key);
      
      static bool check_obs_name_in_map_for_all(MapObsForAll& map_for_all,const std::string& observer_name, const std::string& element_path);

    private:
        PropUtils operator= (const PropUtils & prop_util);
        PropUtils (const PropUtils & prop_util);

    private:
        std::vector < std::string > m_setproperty;
        

    };

  }
}
#endif
