#ifndef FAKEAPPLICATION_IMPL_HPP_
#define FAKEAPPLICATION_IMPL_HPP_

#include <iostream>
#include "testperiodicnotifier/FakeProcess.hpp"
#include "testperiodicnotifier/FakeEntity.hpp"
#include "testperiodicnotifier/FakeLBGroup.hpp"
#include "testperiodicnotifier/FakeFTGroup.hpp"

#include <SystemMngt/idllib/CdmwPlatformMngtApplication.stub.hpp>

namespace Cdmw
{
namespace PlatformMngt
{


// This class replaces Application_impl for test purposes

class FakeApplication: public CdmwPlatformMngt::Application
{
public:
    
    FakeApplication();
    virtual ~FakeApplication()throw();;

    CdmwPlatformMngt::Process_ptr get_process(const char* process_name,
            const char* host_name)
    throw( CdmwPlatformMngt::ProcessNotFound,
            CORBA::SystemException );

    CdmwPlatformMngt::FTGroup_ptr get_ft_group(const char*)
    throw (CORBA::SystemException, CdmwPlatformMngt::GroupNotFound);


    CdmwPlatformMngt::LBGroup_ptr get_lb_group(const char*)
    throw (CORBA::SystemException, CdmwPlatformMngt::GroupNotFound);


    void get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
    throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound);

    CdmwPlatformMngt::Entity_ptr get_entity (const char* entity_name)
    throw( CdmwPlatformMngt::EntityNotFound,
            CORBA::SystemException );
                   


private:
        CORBA::UShort m_attr_value; 
    
        FakeProcess * m_proc;
        FakeEntity * m_entity;
        FakeLBGroup * m_lb_group;
        FakeFTGroup * m_ft_group;
            
};

};
};



#endif /*FAKEApplication_impl_HPP_*/
