#ifndef FAKEHOST_IMPL_HPP_
#define FAKEHOST_IMPL_HPP_

#include <iostream>
#include "testperiodicnotifier/FakeEntity.hpp"
#include "testperiodicnotifier/FakeProcess.hpp"

#include <SystemMngt/idllib/CdmwPlatformMngtHost.stub.hpp>

namespace Cdmw
{
namespace PlatformMngt
{


// This class replaces Host_impl for test purposes

class FakeHost: public CdmwPlatformMngt::Host
{
public:
    
    FakeHost();
    virtual ~FakeHost()throw();    
    void get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
        throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound);
        
    CdmwPlatformMngt::Entity_ptr get_entity (const char* entity_name)
        throw( CdmwPlatformMngt::EntityNotFound,
               CORBA::SystemException );
                   

private:
        FakeEntity *m_entity;
        CORBA::UShort m_attr_value;
            
};

};
};



#endif /*FAKEHost_impl_HPP_*/
