#ifndef FAKEPROCESS_IMPL_HPP_
#define FAKEPROCESS_IMPL_HPP_

#include <iostream>
#include "testperiodicnotifier/FakeEntity.hpp"
#include "testperiodicnotifier/FakeComponent.hpp"

#include <SystemMngt/idllib/CdmwPlatformMngtProcess.stub.hpp>


namespace Cdmw
{
namespace PlatformMngt
{


// This class replaces Process_impl for test purposes

class FakeProcess : public CdmwPlatformMngt::Process
{
public:

    FakeProcess();
    virtual ~FakeProcess()throw();
    virtual CdmwPlatformMngt::CcmComponent_ptr get_component(const char* component_name)
    throw(CdmwPlatformMngt::ComponentNotFound,
        CdmwPlatformMngt::NotComponentServer,
        CORBA::SystemException);

    void get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
    throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound);

    CdmwPlatformMngt::Entity_ptr get_entity (const char* entity_name)
    throw( CdmwPlatformMngt::EntityNotFound,
            CORBA::SystemException );

private:

        CORBA::UShort m_attr_value; 
        FakeEntity * m_entity;
        FakeComponent * m_comp;
            
};

};
};



#endif /*FAKEProcess_impl_HPP_*/
