#ifndef FAKESYSTEM_IMPL_HPP_
#define FAKESYSTEM_IMPL_HPP_

#include <iostream>
#include "testperiodicnotifier/FakeApplication.hpp"
#include "testperiodicnotifier/FakeHost.hpp"
#include "testperiodicnotifier/FakeEntity.hpp"

#include <SystemMngt/idllib/CdmwPlatformMngtSystem.stub.hpp>




namespace Cdmw
{
namespace PlatformMngt
{


// This class replaces System_impl for test purpose
class FakeSystem : public CdmwPlatformMngt::System
{
public:
    
    FakeSystem();
    virtual ~FakeSystem()throw();
    
    CdmwPlatformMngt::Application_ptr get_application (const char* application_name)
    throw (CdmwPlatformMngt::ApplicationNotFound,CORBA::SystemException);
    
    void get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
    throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound);
    
    CdmwPlatformMngt::Entity_ptr get_entity (const char* entity_name)
    throw( CdmwPlatformMngt::EntityNotFound,CORBA::SystemException );
               
    CdmwPlatformMngt::Host_ptr get_host(const char* host_name)
    throw (CdmwPlatformMngt::HostNotFound,CORBA::SystemException);   


private:
    
    //CORBA::UShort m_attr_value; 
    FakeApplication * m_appl;
    FakeEntity * m_entity;
    FakeHost * m_host;

};

};
};



#endif /*FAKESYSTEM_IMPL_HPP_*/
