#include "testperiodicnotifier/FakeComponent.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

FakeComponent::FakeComponent()
{   
    m_entity = new FakeEntity();
    
    m_attr_value = 1;    
}

FakeComponent::~FakeComponent()throw()
{   
    delete m_entity;
    
    m_entity = 0;    
}



void FakeComponent::get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound)
{ 
    TEST_INFO("FakeComponent::get_attribute"<<std::endl);
    if (!strcmp(attr_name, "ComponentAttribute"))
    {
        TEST_INFO("FakeComponent::get_attribute - ComponentAttribute"<<std::endl);
        CORBA::Any_var tempany = new CORBA::Any;
        tempany.inout () <<= m_attr_value;
        ret_attr = tempany._retn ();
    }
    else if (!strcmp(attr_name, "AttributeNotFound"))
    {
        TEST_INFO("FakeComponent::get_attribute - AttributeNotFound"<<std::endl);
        throw CdmwPlatformMngt::AttributeNotFound();
    }
    else if (!strcmp(attr_name, "AttributeException"))
    {
        TEST_INFO("FakeComponent::get_attribute - AttributeException"<<std::endl);
        CDMW_THROW2 (Cdmw::Exception, Cdmw::Exception::UNKNOWN,
                     "FakeComponent::get_attribute - AttributeException");

    }
}

CdmwPlatformMngt::Entity_ptr FakeComponent::get_entity (const char* entity_name)
throw( CdmwPlatformMngt::EntityNotFound,CORBA::SystemException )
{
    TEST_INFO("FakeComponent::get_entity"<<std::endl);
    if (!strcmp(entity_name, "ENTNotFound"))
    {
        TEST_INFO("FakeComponent::get_entity - EntityNotFound"<<std::endl);
        throw CdmwPlatformMngt::EntityNotFound();
    }
    return m_entity;
} 

            
}
}









