#include "testperiodicnotifier/FakeFTGroup.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

FakeFTGroup::FakeFTGroup()
{   
    m_entity = new FakeEntity();
    
    m_attr_value = 4 ;
    
}

FakeFTGroup::~FakeFTGroup()throw()
{   
    delete m_entity;
    m_entity = 0 ;
    
}


void FakeFTGroup::get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound)
{ 
    TEST_INFO("FakeFTGroup::get_attribute"<<std::endl);
    if (!strcmp(attr_name, "FTAttribute"))
    {
        TEST_INFO("FakeFTGroup::get_attribute - FTAttribute"<<std::endl);
        CORBA::Any_var tempany = new CORBA::Any;
        tempany.inout () <<= m_attr_value;
        ret_attr = tempany._retn ();
    }
    else if (!strcmp(attr_name, "AttributeNotFound"))
    {
        TEST_INFO("FakeFTGroup::get_attribute - AttributeNotFound"<<std::endl);
        throw CdmwPlatformMngt::AttributeNotFound();
    }
    else if (!strcmp(attr_name, "AttributeException"))
    {
        TEST_INFO("FakeFTGroup::get_attribute - AttributeException"<<std::endl);
        CDMW_THROW2 (Cdmw::Exception, Cdmw::Exception::UNKNOWN,
                     "FakeFTGroup::get_attribute - AttributeException");

    }
}

CdmwPlatformMngt::Entity_ptr FakeFTGroup::get_entity (const char* entity_name)
throw( CdmwPlatformMngt::EntityNotFound,CORBA::SystemException )
{
    TEST_INFO("FakeFTGroup::get_entity"<<std::endl);
    if (!strcmp(entity_name, "ENTNotFound"))
    {
        TEST_INFO("FakeFTGroup::get_entity - ENTNotFound"<<std::endl);
        throw CdmwPlatformMngt::EntityNotFound();
    }
    return m_entity;
} 

            
}
}









