#include "testperiodicnotifier/FakeLBGroup.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

FakeLBGroup::FakeLBGroup()
{   
    m_entity = new FakeEntity();   
    m_attr_value = 5; 
}

FakeLBGroup::~FakeLBGroup()throw()
{   
    delete m_entity;   
    m_entity=0; 
}


void FakeLBGroup::get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound)
{ 
    TEST_INFO("FakeLBGroup::get_attribute"<<std::endl);
    if (!strcmp(attr_name, "LBAttribute"))
    {
        TEST_INFO("FakeLBGroup::get_attribute - LBAttribute"<<std::endl);
        CORBA::Any_var tempany = new CORBA::Any;
        tempany.inout () <<= m_attr_value;
        ret_attr = tempany._retn ();
    }
    else if (!strcmp(attr_name, "AttributeNotFound"))
    {
        TEST_INFO("FakeLBGroup::get_attribute - AttributeNotFound"<<std::endl);
        throw CdmwPlatformMngt::AttributeNotFound();
    }
    else if (!strcmp(attr_name, "AttributeException"))
    {
        TEST_INFO("FakeLBGroup::get_attribute - AttributeNotFound"<<std::endl);
        CDMW_THROW2 (Cdmw::Exception, Cdmw::Exception::UNKNOWN,
                     "FakeLBGroup::get_attribute - AttributeException");

    }
}

CdmwPlatformMngt::Entity_ptr FakeLBGroup::get_entity (const char* entity_name)
throw( CdmwPlatformMngt::EntityNotFound,CORBA::SystemException )
{
    TEST_INFO("FakeLBGroup::get_entity"<<std::endl);
    if (!strcmp(entity_name, "ENTNotFound"))
    {
        TEST_INFO("FakeLBGroup::get_entity - ENTNotFound"<<std::endl);
        throw CdmwPlatformMngt::EntityNotFound();
    }
    return m_entity;
} 

            
}
}









