#include "testperiodicnotifier/FakeProcess.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

FakeProcess::FakeProcess()
{   
    m_entity = new FakeEntity();  
    m_comp = new FakeComponent();
    m_attr_value = 5;  
}

FakeProcess::~FakeProcess()throw()
{   
    delete m_entity;
    m_entity = 0;  
    delete m_comp;
    m_comp = 0; 
}

void FakeProcess::get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound)
{ 
    TEST_INFO("FakeProcess::get_attribute"<<std::endl);
    if (!strcmp(attr_name, "ProcessAttribute"))
    {
        TEST_INFO("FakeProcess::get_attribute - ProcessAttribute"<<std::endl);
        CORBA::Any_var tempany = new CORBA::Any;
        tempany.inout () <<= m_attr_value;
        ret_attr = tempany._retn ();
    }
    else if (!strcmp(attr_name, "AttributeNotFound"))
    {
        TEST_INFO("FakeProcess::get_attribute - AttributeNotFound"<<std::endl);
        throw CdmwPlatformMngt::AttributeNotFound();
    }
    else if (!strcmp(attr_name, "AttributeException"))
    {
        TEST_INFO("FakeProcess::get_attribute - AttributeException"<<std::endl);
        CDMW_THROW2 (Cdmw::Exception, Cdmw::Exception::UNKNOWN,
                     "FakeProcess::get_attribute - AttributeException");

    }
}

CdmwPlatformMngt::Entity_ptr FakeProcess::get_entity (const char* entity_name)
throw( CdmwPlatformMngt::EntityNotFound,CORBA::SystemException )
{
    TEST_INFO("FakeProcess::get_entity"<<std::endl);
    if (!strcmp(entity_name, "ENTNotFound"))
    {
        TEST_INFO("FakeProcess::get_entity - EntityNotFound"<<std::endl);
        throw CdmwPlatformMngt::EntityNotFound();
    }
    return m_entity;
} 
  

CdmwPlatformMngt::CcmComponent_ptr FakeProcess::get_component(const char* comp_name)
throw (CdmwPlatformMngt::ComponentNotFound,CdmwPlatformMngt::NotComponentServer,CORBA::SystemException)
{
    TEST_INFO("FakeProcess::get_component"<<std::endl);
    if (!strcmp(comp_name, "COMPNotFound"))
    {
        TEST_INFO("FakeProcess::get_entity - ComponentNotFound"<<std::endl);
        throw CdmwPlatformMngt::ComponentNotFound();
    }
    return m_comp;
}

            
}
}









