/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_PLATFORMMNGT_CONSISTENT_SYNCHRO_SOLVER_HPP
#define INCL_PLATFORMMNGT_CONSISTENT_SYNCHRO_SOLVER_HPP

//#include "SystemMngt/idllib/CdmwPlatformMngtCommon.stub.hpp"
//#include "SystemMngt/platformapplicationlibrary/ConsistencyStatusSolver.hpp"
//#include "platformsystemlibrary/System_impl.hpp"
#include "Foundation/osthreads/ThreadHandle.hpp"
#include "Foundation/osthreads/Mutex.hpp"
#include "Foundation/osthreads/MutexGuard.hpp"
namespace Cdmw
{
namespace PlatformMngt
{

//using namespace std;
class System_impl;

class ConsistentSynchroSolver:  public Cdmw::OsSupport::Thread 
{

     public:

         /**
         * Constructor 
         */
         ConsistentSynchroSolver(Cdmw::PlatformMngt::System_impl* system);

         /**
         * Denstructor
         */
         ~ConsistentSynchroSolver() throw();

         /**
         *Purpose:
         *<p> 
         */
         void run() throw();
         
    private:
    
    Cdmw::PlatformMngt::System_impl* m_system;
    
    OsSupport::Mutex m_mutex;

};

} // End namespace PlatformMngt
} // End namespace Cdmw

#endif //INCL_PLATFORMMNGT_CONSISTENT_SYNCHRO_SOLVER

