/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef FAKEHOST_IMPL_HPP_
#define FAKEHOST_IMPL_HPP_

#include <iostream>
#include "Foundation/orbsupport/OrbSupport.hpp"
#include "SystemMngt/idllib/CdmwPlatformMngtCommon.stub.hpp"

namespace Cdmw
{
namespace PlatformMngt
{


// This class replaces Host_impl for test purposes

class Host_impl 
{
public:
    
    Host_impl();
    
    void hot_reboot(); 
    void start_processes(); 
    void stop_processes(); 
    void notify_status_change();
    void set_restart_attempt(long current_restart_attempt);
    void set_stop_in_progress(CORBA::Boolean stop_in_progress){};

    bool hot_reboot_called(); 
    bool start_processes_called(); 
    bool stop_processes_called(); 
    bool notify_status_change_called();
    bool set_restart_attempt_called();

    void set_attribute_internal (const char* attr_name, const CORBA::Any& attr, CdmwPlatformMngt::Owner flag)  
    throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound, Cdmw::BadOrderException, 
            CdmwPlatformMngt::ReadOnlyAttribute){}
    
    char * get_status_info(){char* temp=""; return temp; }

private:
    bool m_hot_reboot_called;
    bool m_start_processes_called;
    bool m_stop_processes_called;
    bool m_notify_status_change_called;
    bool m_set_restart_attempt_called;
            
};

};
};



#endif /*FAKEHOST_IMPL_HPP_*/
