/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TESTNAVIGABILITY_HPP 
#define INCL_PLATFORMMNGT_TESTNAVIGABILITY_HPP 

#include "Foundation/testutils/CORBATestManager.hpp"
#include "platformsystemlibrary/HostStates.hpp"
#include "testhoststatemachine/FakeHost_impl.hpp"

#include <iostream>

class TestHostStateMachine : public CppUnit::TestFixture
{

public:
    CORBA::ORB_var m_orb;

    TestHostStateMachine() throw();
    virtual ~TestHostStateMachine() throw();

    virtual void test_state_transitions() throw();
    virtual void test_error_conditions() throw();
    virtual void test_state_actions() throw();
    virtual void test_status_changes_notifications() throw();
    virtual void test_enum_return_values() throw();

private:

    TestHostStateMachine& operator=(const TestHostStateMachine& rhs) throw();
    TestHostStateMachine(const TestHostStateMachine& rhs) throw();

    CPPUNIT_TEST_SUITE(TestHostStateMachine);
    CPPUNIT_TEST(test_state_transitions);
    CPPUNIT_TEST(test_state_actions);
    CPPUNIT_TEST(test_error_conditions);
    CPPUNIT_TEST(test_status_changes_notifications);
    CPPUNIT_TEST(test_enum_return_values);
    CPPUNIT_TEST_SUITE_END();
};

#endif /* INCL_PLATFORMMNGT_PILOT_SYSTEM_HPP*/

