/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TESTNAVIGABILITY_HPP 
#define INCL_PLATFORMMNGT_TESTNAVIGABILITY_HPP 

#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/common/System.hpp"
#include <Foundation/orbsupport/CORBA.hpp>
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"
#include "idllib/CdmwPlatformMngtApplication.stub.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

/**
*Purpose:
*<p>   
*
*Features:
*<p> Thread safe
*
*
*/
class TestNavigability : public CppUnit::TestFixture
{

    public:
        CORBA::ORB_var m_orb;

        /**
        * Purpose:
        * <p> Constructor
        * 
        */ 
        TestNavigability() throw();



        /**
        * Purpose:
        * <p> Destructor 
        * 
        */ 
        virtual 
        ~TestNavigability() throw();


        void setUp() ;

        static CdmwPlatformMngt::System_var mysystem;
        static CdmwPlatformMngt::Host_var myhost;
        static bool m_is_one_shot_initialized;
    static CORBA::ULong size1;
    static CdmwPlatformMngt::Processes_var my_processes_from_host;
    static CdmwPlatformMngt::Processes_var my_host_processes_from_app   ;
    static CdmwPlatformMngt::Application_var application;
    static CdmwPlatformMngt::Host_var actual_host;
        
    void one_shot_init() ;
        /**
        * Purpose:
        * <p> Call from the testable object 
        * 
        */ 

        virtual void get_num_apps_from_System_to_Applications();
        virtual void get_parent_from_Host_to_System();
        virtual void get_processes_from_Host_to_Process_size_sequence();
        virtual void get_processes_from_Host_to_Process_sequence();
        virtual void get_num_processes_from_Application_to_Process();
        virtual void get_parent_from_Application_to_System();
        virtual void get_processes_from_Host_to_Process_iterator();
        virtual void get_parent_from_Process_to_Application_HelloProcess1();
        virtual void get_parent_from_Process_to_Application_HelloProcess2();
        virtual void get_parent_from_Process_to_Application_HelloProcess3();
        virtual void get_process_from_Host_to_Process();


    protected:


    private:

        /**
        * Purpose:
        * <p> Assignment operator
        * 
        */ 
        TestNavigability& operator=(const TestNavigability& rhs) throw();
        /**
        * Purpose:
        * <p>  Copy constructor
        * 
        */ 
        TestNavigability(const TestNavigability& rhs) throw();
        

CPPUNIT_TEST_SUITE(TestNavigability);
CPPUNIT_TEST(get_num_apps_from_System_to_Applications);
CPPUNIT_TEST(get_parent_from_Host_to_System);
CPPUNIT_TEST(get_processes_from_Host_to_Process_size_sequence);
CPPUNIT_TEST(get_processes_from_Host_to_Process_sequence);
CPPUNIT_TEST(get_num_processes_from_Application_to_Process);
CPPUNIT_TEST(get_parent_from_Application_to_System);
CPPUNIT_TEST(get_processes_from_Host_to_Process_iterator);
CPPUNIT_TEST(get_parent_from_Process_to_Application_HelloProcess1);
CPPUNIT_TEST(get_parent_from_Process_to_Application_HelloProcess2);
CPPUNIT_TEST(get_parent_from_Process_to_Application_HelloProcess3);
CPPUNIT_TEST(get_process_from_Host_to_Process);
CPPUNIT_TEST_SUITE_END();
};

} /* End namespace PlatformMngt*/
} /* End namespace Cdmw*/
#endif /* INCL_PLATFORMMNGT_PILOT_SYSTEM_HPP*/

