/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TESTSTDATTRIBUTES_HOST_HPP 
#define INCL_PLATFORMMNGT_TESTSTDATTRIBUTES_HOST_HPP 

#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/common/System.hpp"
#include <Foundation/orbsupport/CORBA.hpp>
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"
#include "idllib/CdmwPlatformMngtApplication.stub.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

/**
*Purpose:
*<p>   
*
*Features:
*<p> Thread safe
*
*
*/
class TestStdAttributes_Host : public CppUnit::TestFixture
{

    public:
        CORBA::ORB_var m_orb;

        /**
        * Purpose:
        * <p> Constructor
        * 
        */ 
        TestStdAttributes_Host() throw();



        /**
        * Purpose:
        * <p> Destructor 
        * 
        */ 
        virtual 
        ~TestStdAttributes_Host() throw();


        
        /**
        * Purpose:
        * <p> Call from the testable object 
        * 
        */ 
    void setUp() ;

        virtual void get_name() ;
        virtual void status() ;
        virtual void host_status_info() ;
        virtual void get_monitoring_parameters() ;
        virtual void set_monitoring_parameters() ;
        virtual void get_readonly_attributes() ;
        virtual void restart_warmth() ;
        virtual void autorestart_info() ;



    protected:


    private:
        static CdmwPlatformMngt::Host_var myhost;
    static CdmwPlatformMngt::System_var mysystem;
        static bool m_is_one_shot_initialized;
         
    static char *hostname;
    static CdmwPlatformMngt::CompleteMonitoringInfo glob_monitor_info;
        static void one_shot_init();

        /**
        * Purpose:
        * <p> Assignment operator
        * 
        */ 
        TestStdAttributes_Host& operator=(const TestStdAttributes_Host& rhs) throw();
        /**
        * Purpose:
        * <p>  Copy constructor
        * 
        */ 
        TestStdAttributes_Host(const TestStdAttributes_Host& rhs) throw();
        

CPPUNIT_TEST_SUITE(TestStdAttributes_Host);
CPPUNIT_TEST( get_name);
CPPUNIT_TEST(status);
CPPUNIT_TEST(host_status_info);
CPPUNIT_TEST(set_monitoring_parameters);
CPPUNIT_TEST(get_monitoring_parameters);
CPPUNIT_TEST(get_readonly_attributes);
CPPUNIT_TEST(restart_warmth);
CPPUNIT_TEST(autorestart_info);
CPPUNIT_TEST_SUITE_END();
};

} /* End namespace PlatformMngt*/
} /* End namespace Cdmw*/
#endif 

