/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.platformmngt;

import com.thalesgroup.CdmwPlatformMngt.*;
import com.thalesgroup.CdmwPlatformMngtBase.*;

  
public class ApplicationStatusChangeImpl
    extends ApplicationStatusChange {

    /**
     * Default constructor
     */
    public ApplicationStatusChangeImpl() {
    }

   public String getHeader()
    {
        short level =  this.header.level;
        String stringfiedLevel = "";
        if ( level == INF.value )
            stringfiedLevel = INF_STR.value;
        else if ( level == WRN.value )
            stringfiedLevel = WRN_STR.value;
        else if ( level == ERR.value )
            stringfiedLevel = ERR_STR.value;
        else if ( level == FTL.value )
            stringfiedLevel = FTL_STR.value;
       
        String dateFormat = this.header.time_stamp.year + "/" + 
    this.header.time_stamp.month + "/" +
    this.header.time_stamp.day +
    " " + this.header.time_stamp.hour + ":"+
    this.header.time_stamp.minute + ":"+
    this.header.time_stamp.second + ":"+
    this.header.time_stamp.millisecond + ":"+
    this.header.time_stamp.microsecond + " "+
        stringfiedLevel + " "+  
    get_issuer()+ " "; 
    return dateFormat; 
    }
    
    public String to_string(){
       return
           ( getHeader()+" S:'" + this.system_name + "' " +
         "A:'" + this.application_name + "' " +
         application_status.toString());
    }

    public String get_issuer(){
        return PFMMNG.value;
    }
           
}

