/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.platformmngt;

import com.thalesgroup.CdmwPlatformMngt.*;
import com.thalesgroup.CdmwPlatformMngtBase.*;
import  cdmw.logging.*;
import static cdmw.logging.Logger.*;
/**
 * This class provides helper functions to be used by the CDMW generated 
 * CdmwInterface.java file.
 * 
 */
public class InitUtils {

    /**
     * Register the value type factories in the ORB
     * 
     * @param orb A reference to the ORB pseudo-object
     */
    public static void registerValuetypeFactories(org.omg.CORBA.ORB orb) {

    CDMW_DEBUG(Logger.Get_Logger(PFMMNG.value), "...registering value factories...", new Throwable());
    
      ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
            ProcessMessageHelper.id(), 
        new ProcessMessageFactoryImpl());
     
     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             ApplicationModeChangeHelper.id(), 
         new ApplicationModeChangeFactoryImpl());
         
     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             ApplicationStatusChangeHelper.id(), 
         new ApplicationStatusChangeFactoryImpl());
         
     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             ConfigurationChangeHelper.id(), 
         new ConfigurationChangeFactoryImpl());
     
     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             EntityStatusChangeHelper.id(), 
         new EntityStatusChangeFactoryImpl());
         
     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             HostStatusChangeHelper.id(), 
         new HostStatusChangeFactoryImpl());

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             ProcessStatusChangeHelper.id(), 
         new ProcessStatusChangeFactoryImpl());

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             PropertyChangeHelper.id(), 
         new PropertyChangeFactoryImpl());

     /*((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             CdmwCommandHelper.id(), 
         new CdmwCommandFactoryImpl());*/

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             AcknowledgeHelper.id(), 
         new AcknowledgeFactoryImpl());

      ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             RebootHelper.id(), 
         new RebootFactoryImpl());

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             RestartHelper.id(), 
         new RestartFactoryImpl());

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             ShutdownHelper.id(), 
         new ShutdownFactoryImpl());

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             StopHelper.id(), 
         new StopFactoryImpl());

    ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             RestartHelper.id(), 
         new RestartFactoryImpl());

 
     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             SystemModeChangeHelper.id(), 
         new SystemModeChangeFactoryImpl());

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             SystemStatusChangeHelper.id(), 
         new SystemStatusChangeFactoryImpl());

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             UserEventHelper.id(), 
         new UserEventFactoryImpl());
     
     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             ComponentStatusChangeHelper.id(), 
         new ComponentStatusChangeFactoryImpl());

     ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
             RedundancyGroupStatusChangeHelper.id(), 
         new RedundancyGroupStatusChangeFactoryImpl());
     
    }

}

