/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.platformmngt;

import com.thalesgroup.CdmwPlatformMngt.*;



/**
 * Implementation of a default valuetype factory for FacetDescrption valuetypes.
 *
 */
public class StopFactoryImpl
    implements org.omg.CORBA.portable.ValueFactory {

    /**
     * Is called by the ORB runtime while in the process of
     * unmarshaling a value type. It returns a new StopImpl object
     * with appropriate values.
     */
    public java.io.Serializable read_value(
        org.omg.CORBA_2_3.portable.InputStream is) {
        java.io.Serializable c = new StopImpl();
        return is.read_value(c);
    }
    
    public StopImpl create(
            com.thalesgroup.CdmwPlatformMngtBase.EventHeader event_header,
            java.lang.String event_system_name, java.lang.String issuer_element_path, 
            java.lang.String issuer_element_name, 
            java.lang.String event_issuer, boolean event_emergency)
    {
        return new StopImpl( event_header, event_system_name, issuer_element_path, issuer_element_name, event_issuer, event_emergency);
    }

}

