/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "SystemMngt/plugin/Plugin.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

CdmwPlatformMngt::System_ptr Plugin::get_system()
{
   return CdmwPlatformMngt::System::_duplicate(m_system.in());
}
std::string Plugin::get_name() const
{
   return m_name;
}
std::string Plugin::get_args() const
{
   return m_args;
}
std::string Plugin::get_system_port() const
{
   return m_system_port;
}

void Plugin::set_system(CdmwPlatformMngt::System_ptr system)
{
    m_system = CdmwPlatformMngt::System::_duplicate(system);
}
void Plugin::set_name(const std::string & name)
{
   m_name = name;
}
void Plugin::set_args(const std::string & args)
{
   m_args = args;
}
void Plugin::set_system_port(const std::string & system_port)
{
   m_system_port = system_port;
}

} // End namespace PlatformMngt
} // End namespace Cdmw



