/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CDMW_PLATFORMMNGT_CURRENT_IMPL_HPP 
#define INCL_CDMW_PLATFORMMNGT_CURRENT_IMPL_HPP 

// Cdmw Files

#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <idllib/CdmwPlatformMngtCurrent.skel.hpp>

//
// IDL:thalesgroup.com/Cdmw:1.0
//
namespace Cdmw
{
    
namespace PlatformMngt
{

//
// IDL:thalesgroup.com/Cdmw/Current:1.0 
//
class Current_impl : virtual public CdmwPlatformMngt::Current, 
                     virtual public Cdmw::OrbSupport::RefCountLocalObject

{

public:

    Current_impl(PortableInterceptor::Current_ptr   pi_current,
                 const PortableInterceptor::SlotId  issuer);
    ~Current_impl();

    //
    // IDL:thalesgroup.com/CdmwFT/Current/get_issuer:1.0
    //
    virtual char* get_issuer() 
          throw(CORBA::SystemException);
        
    virtual void set_issuer (const char* issuer)
          throw(CORBA::SystemException);

private:
    // hide default constructor, copy constructor and operator =
    Current_impl();
    Current_impl(const Current_impl&);
    void operator=(const Current_impl&);

    // Current object that is used specifically by portable Interceptors 
    // to transfer thread context information to a request context.
    PortableInterceptor::Current_var  m_pi_current;

    PortableInterceptor::SlotId  m_issuer_slot_id;

};


} // End of namespace PlatformMngt

} // End of namespace Cdmw

#endif // INCL_CDMW_PLATFORMMNGT_CURRENT_IMPL_HPP

