/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_CDMW_PLATFORMMNGT_TIMEOUTINSERTER_HPP
#define INCL_CDMW_PLATFORMMNGT_TIMEOUTINSERTER_HPP

// private include files

// include files
#include <string>

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/common/Exception.hpp>

#include <Foundation/osthreads/ReaderWriterLock.hpp>
#include <Foundation/osthreads/Mutex.hpp>
#include <Foundation/osthreads/Condition.hpp>


/**
* Namespace for Supervision
*/
namespace Cdmw {
namespace PlatformMngt 
{


/**
*Purpose:
*<p>   
*
*Features:
*<p> 
*
*
*/

class TimeoutInserter 
{

    public:

        /**
        * Purpose:
        * <p> Destructor
        * 
        */ 
        virtual
        ~TimeoutInserter();

        static Cdmw::PlatformMngt::TimeoutInserter* Instance();

        CORBA::Object_ptr capsule_timeout (CORBA::ORB_ptr orb, 
                             CORBA::Object_ptr obj,
                         unsigned long callTimeout_millisec);

        CORBA::Object_ptr capsule_timeout (CORBA::Object_ptr obj,
                         unsigned long callTimeout_millisec);

        void attachOrb(CORBA::ORB_ptr attachingOrb);

        bool is_orb_attached ();

    protected:

    private:

        //
        // ctor
        //
        TimeoutInserter ();
        
        //
        // Copy ctor
        //
        TimeoutInserter (const TimeoutInserter& rhs)
                throw();

        //
        // Assignement operator
        //
        TimeoutInserter& operator=(const TimeoutInserter& rhs)
                 throw();

        CORBA::ORB_var m_orb;

        bool m_is_orb_attached;

        Cdmw::OsSupport::ReaderWriterLock m_orb_attached_lock;

}; // End class TimeoutInserter 

} // End namespace PlatformMngt 
}  // End namespace Cdmw

#endif // INCL_CDMW_PLATFORMMNGT_TIMEOUTINSERTER_HPP
