/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

// private include files
#include "tools/IssuerManager.hpp"

// include files
#include "Foundation/common/Exception.hpp"
#include "Foundation/common/Assert.hpp"
#include "Foundation/osthreads/MutexGuard.hpp"

#include <memory>


namespace Cdmw {
namespace PlatformMngt 
{

/**
*Implementation notes: 
*<p>
*Portability issues:  none 
*<p>
*/

//
// Ctor
//    
IssuerManager::IssuerManager ()
    :m_current_issuer("")
{
    is_locked = false;
}



//
// Dtor
//
IssuerManager::~IssuerManager()
    throw()
{
}


//
// Change the timeout value
//
Cdmw::PlatformMngt::IssuerManager* IssuerManager::Instance()
{
    static Cdmw::PlatformMngt::IssuerManager Issuer_manager;
    return &Issuer_manager;
}

//
// Set the issuer 
//
void IssuerManager::set_issuer (const std::string& issuer)
throw ()
{
    // first lock the mutex
/*
    m_mutex.lock(); 
    is_locked = true;
    m_current_issuer = issuer;
*/    
}

//
// Get the issuer 
//
std::string IssuerManager::get_issuer ()
  throw()
{
 
    std::string issuer_to_retr = "";
/*
    if (is_locked)
    {
        issuer_to_retr = m_current_issuer;
        m_mutex.unlock(); 
        is_locked = false;
    }
*/
    return issuer_to_retr;
}


} // End namespace PlatformMngt 
}  // End namespace Cdmw
