/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_PLATFORMMNGT_TESTSMGTOOLS_HPP 
#define INCL_PLATFORMMNGT_TESTSMGTOOLS_HPP 

#include "Foundation/testutils/CORBATestManager.hpp"
#include "tools/ManagedElementKey.hpp"

class Task : public Cdmw::OsSupport::Thread
{

    private:
        
    //    
    int m_num_thread;
    
    public:

        Task (int numero);
        /**
        * Purpose:
        * <p> Destructor.
        */ 
        virtual ~Task() throw();
        /**
         *Purpose:
         *<p>
         */
        virtual void run() throw();
        
        bool is_finished ();


}; // End Task
/*
 *This class is needed to test SystemIssuerManager functions (issuer set and get).
 */
class SystemIssuerManagerTask : public Cdmw::OsSupport::Thread
{
    public:
    
        SystemIssuerManagerTask ();
        /**
        * Purpose:
        * <p> Destructor.
        */ 
        virtual ~SystemIssuerManagerTask() throw();
        /**
         *Purpose:
         *<p>
         */
        virtual void run() throw();
        
        bool is_finished ();
};

class TestSuite_ManagedElementKey_cpp_d2128995 : public CppUnit::TestFixture
{
    public:
        CPPUNIT_TEST_SUITE(TestSuite_ManagedElementKey_cpp_d2128995);
        CPPUNIT_TEST(test_Check_process_rel_key_1);
        //CPPUNIT_TEST(test_Check_process_rel_key_10);
        CPPUNIT_TEST(test_Check_process_rel_key_2);
        CPPUNIT_TEST(test_Check_process_rel_key_3);
        CPPUNIT_TEST(test_Check_process_rel_key_4);
        /*CPPUNIT_TEST(test_Check_process_rel_key_5);
        CPPUNIT_TEST(test_Check_process_rel_key_6);
        CPPUNIT_TEST(test_Check_process_rel_key_7);
        CPPUNIT_TEST(test_Check_process_rel_key_8);
        CPPUNIT_TEST(test_Check_process_rel_key_9);*/
        CPPUNIT_TEST(test_Get_application_entity_path_1);
        /*CPPUNIT_TEST(test_Get_application_entity_path_10);
        CPPUNIT_TEST(test_Get_application_entity_path_2);
        CPPUNIT_TEST(test_Get_application_entity_path_3);
        CPPUNIT_TEST(test_Get_application_entity_path_4);
        CPPUNIT_TEST(test_Get_application_entity_path_5);
        CPPUNIT_TEST(test_Get_application_entity_path_6);
        CPPUNIT_TEST(test_Get_application_entity_path_7);
        CPPUNIT_TEST(test_Get_application_entity_path_8);
        CPPUNIT_TEST(test_Get_application_entity_path_9);*/
        CPPUNIT_TEST(test_Get_application_path_1);
        /*CPPUNIT_TEST(test_Get_application_path_10);
        CPPUNIT_TEST(test_Get_application_path_2);
        CPPUNIT_TEST(test_Get_application_path_3);
        CPPUNIT_TEST(test_Get_application_path_4);
        CPPUNIT_TEST(test_Get_application_path_5);
        CPPUNIT_TEST(test_Get_application_path_6);
        CPPUNIT_TEST(test_Get_application_path_7);
        CPPUNIT_TEST(test_Get_application_path_8);
        CPPUNIT_TEST(test_Get_application_path_9);*/
        CPPUNIT_TEST(test_Get_component_entity_path_1);
        /*CPPUNIT_TEST(test_Get_component_entity_path_10);
        CPPUNIT_TEST(test_Get_component_entity_path_2);
        CPPUNIT_TEST(test_Get_component_entity_path_3);
        CPPUNIT_TEST(test_Get_component_entity_path_4);
        CPPUNIT_TEST(test_Get_component_entity_path_5);
        CPPUNIT_TEST(test_Get_component_entity_path_6);
        CPPUNIT_TEST(test_Get_component_entity_path_7);
        CPPUNIT_TEST(test_Get_component_entity_path_8);
        CPPUNIT_TEST(test_Get_component_entity_path_9);*/
        CPPUNIT_TEST(test_Get_component_path_1);
        //CPPUNIT_TEST(test_Get_component_path_10);
        CPPUNIT_TEST(test_Get_component_path_12);
        /*CPPUNIT_TEST(test_Get_component_path_13);
        CPPUNIT_TEST(test_Get_component_path_14);
        CPPUNIT_TEST(test_Get_component_path_15);
        CPPUNIT_TEST(test_Get_component_path_16);
        CPPUNIT_TEST(test_Get_component_path_17);
        CPPUNIT_TEST(test_Get_component_path_18);
        CPPUNIT_TEST(test_Get_component_path_19);
        CPPUNIT_TEST(test_Get_component_path_2);
        CPPUNIT_TEST(test_Get_component_path_20);
        CPPUNIT_TEST(test_Get_component_path_21);
        CPPUNIT_TEST(test_Get_component_path_3);
        CPPUNIT_TEST(test_Get_component_path_4);
        CPPUNIT_TEST(test_Get_component_path_5);
        CPPUNIT_TEST(test_Get_component_path_6);
        CPPUNIT_TEST(test_Get_component_path_7);
        CPPUNIT_TEST(test_Get_component_path_8);
        CPPUNIT_TEST(test_Get_component_path_9);*/
        CPPUNIT_TEST(test_Get_component_rel_key_1);
        /*CPPUNIT_TEST(test_Get_component_rel_key_10);
        CPPUNIT_TEST(test_Get_component_rel_key_2);
        CPPUNIT_TEST(test_Get_component_rel_key_3);
        CPPUNIT_TEST(test_Get_component_rel_key_4);
        CPPUNIT_TEST(test_Get_component_rel_key_5);
        CPPUNIT_TEST(test_Get_component_rel_key_6);
        CPPUNIT_TEST(test_Get_component_rel_key_7);
        CPPUNIT_TEST(test_Get_component_rel_key_8);
        CPPUNIT_TEST(test_Get_component_rel_key_9);*/
        CPPUNIT_TEST(test_Get_element_names_1);
        //CPPUNIT_TEST(test_Get_element_names_10);
        CPPUNIT_TEST(test_Get_element_names_2);
        CPPUNIT_TEST(test_Get_element_names_3);
        /*CPPUNIT_TEST(test_Get_element_names_4);
        CPPUNIT_TEST(test_Get_element_names_5);
        CPPUNIT_TEST(test_Get_element_names_6);
        CPPUNIT_TEST(test_Get_element_names_7);
        CPPUNIT_TEST(test_Get_element_names_8);
        CPPUNIT_TEST(test_Get_element_names_9);*/
        CPPUNIT_TEST(test_Get_element_type_1);
        CPPUNIT_TEST(test_Get_element_type_10);
        CPPUNIT_TEST(test_Get_element_type_2);
        CPPUNIT_TEST(test_Get_element_type_3);
        CPPUNIT_TEST(test_Get_element_type_4);
        CPPUNIT_TEST(test_Get_element_type_5);
        CPPUNIT_TEST(test_Get_element_type_6);
        CPPUNIT_TEST(test_Get_element_type_7);
        CPPUNIT_TEST(test_Get_element_type_8);
        CPPUNIT_TEST(test_Get_element_type_9);
        CPPUNIT_TEST(test_Get_element_type_11);
        CPPUNIT_TEST(test_Get_entity_path_1);
        /*CPPUNIT_TEST(test_Get_entity_path_2);
        CPPUNIT_TEST(test_Get_entity_path_3);
        CPPUNIT_TEST(test_Get_entity_path_4);
        CPPUNIT_TEST(test_Get_entity_path_5);
        CPPUNIT_TEST(test_Get_entity_path_6);
        CPPUNIT_TEST(test_Get_entity_path_7);
        CPPUNIT_TEST(test_Get_entity_path_8);*/
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_1);
        /*CPPUNIT_TEST(test_Get_ftgroup_entity_path_10);
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_2);
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_3);
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_4);
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_5);
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_6);
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_7);
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_8);
        CPPUNIT_TEST(test_Get_ftgroup_entity_path_9);*/
        CPPUNIT_TEST(test_Get_ftgroup_path_1);
        /*CPPUNIT_TEST(test_Get_ftgroup_path_10);
        CPPUNIT_TEST(test_Get_ftgroup_path_2);
        CPPUNIT_TEST(test_Get_ftgroup_path_3);
        CPPUNIT_TEST(test_Get_ftgroup_path_4);
        CPPUNIT_TEST(test_Get_ftgroup_path_5);
        CPPUNIT_TEST(test_Get_ftgroup_path_6);
        CPPUNIT_TEST(test_Get_ftgroup_path_7);
        CPPUNIT_TEST(test_Get_ftgroup_path_8);
        CPPUNIT_TEST(test_Get_ftgroup_path_9);*/
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_1);
        /*CPPUNIT_TEST(test_Get_ftgroup_rel_key_10);
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_2);
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_3);
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_4);
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_5);
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_6);
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_7);
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_8);
        CPPUNIT_TEST(test_Get_ftgroup_rel_key_9);*/
        CPPUNIT_TEST(test_Get_host_entity_path_1);
        /*CPPUNIT_TEST(test_Get_host_entity_path_10);
        CPPUNIT_TEST(test_Get_host_entity_path_2);
        CPPUNIT_TEST(test_Get_host_entity_path_3);
        CPPUNIT_TEST(test_Get_host_entity_path_4);
        CPPUNIT_TEST(test_Get_host_entity_path_5);
        CPPUNIT_TEST(test_Get_host_entity_path_6);
        CPPUNIT_TEST(test_Get_host_entity_path_7);
        CPPUNIT_TEST(test_Get_host_entity_path_8);
        CPPUNIT_TEST(test_Get_host_entity_path_9);*/
        CPPUNIT_TEST(test_Get_host_path_1);
        /*CPPUNIT_TEST(test_Get_host_path_10);
        CPPUNIT_TEST(test_Get_host_path_2);
        CPPUNIT_TEST(test_Get_host_path_3);
        CPPUNIT_TEST(test_Get_host_path_4);
        CPPUNIT_TEST(test_Get_host_path_5);
        CPPUNIT_TEST(test_Get_host_path_6);
        CPPUNIT_TEST(test_Get_host_path_7);
        CPPUNIT_TEST(test_Get_host_path_8);
        CPPUNIT_TEST(test_Get_host_path_9);*/
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_1);
        /*CPPUNIT_TEST(test_Get_lbgroup_entity_path_10);
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_2);
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_3);
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_4);
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_5);
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_6);
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_7);
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_8);
        CPPUNIT_TEST(test_Get_lbgroup_entity_path_9);*/
        CPPUNIT_TEST(test_Get_lbgroup_path_1);
        /*CPPUNIT_TEST(test_Get_lbgroup_path_10);
        CPPUNIT_TEST(test_Get_lbgroup_path_2);
        CPPUNIT_TEST(test_Get_lbgroup_path_3);
        CPPUNIT_TEST(test_Get_lbgroup_path_4);
        CPPUNIT_TEST(test_Get_lbgroup_path_5);
        CPPUNIT_TEST(test_Get_lbgroup_path_6);
        CPPUNIT_TEST(test_Get_lbgroup_path_7);
        CPPUNIT_TEST(test_Get_lbgroup_path_8);
        CPPUNIT_TEST(test_Get_lbgroup_path_9);*/
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_1);
        /*CPPUNIT_TEST(test_Get_lbgroup_rel_key_10);
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_2);
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_3);
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_4);
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_5);
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_6);
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_7);
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_8);
        CPPUNIT_TEST(test_Get_lbgroup_rel_key_9);*/
        CPPUNIT_TEST(test_Get_parent_path_1);
        /*CPPUNIT_TEST(test_Get_parent_path_10);
        CPPUNIT_TEST(test_Get_parent_path_2);
        CPPUNIT_TEST(test_Get_parent_path_3);
        CPPUNIT_TEST(test_Get_parent_path_4);
        CPPUNIT_TEST(test_Get_parent_path_5);
        CPPUNIT_TEST(test_Get_parent_path_6);
        CPPUNIT_TEST(test_Get_parent_path_7);
        CPPUNIT_TEST(test_Get_parent_path_8);
        CPPUNIT_TEST(test_Get_parent_path_9);*/
        CPPUNIT_TEST(test_Get_process_element_names_1);
        /*CPPUNIT_TEST(test_Get_process_element_names_10);
        CPPUNIT_TEST(test_Get_process_element_names_2);
        CPPUNIT_TEST(test_Get_process_element_names_3);
        CPPUNIT_TEST(test_Get_process_element_names_4);
        CPPUNIT_TEST(test_Get_process_element_names_5);
        CPPUNIT_TEST(test_Get_process_element_names_6);
        CPPUNIT_TEST(test_Get_process_element_names_7);
        CPPUNIT_TEST(test_Get_process_element_names_8);
        CPPUNIT_TEST(test_Get_process_element_names_9);*/
        CPPUNIT_TEST(test_Get_process_entity_path_1);
        /*CPPUNIT_TEST(test_Get_process_entity_path_10);
        CPPUNIT_TEST(test_Get_process_entity_path_2);
        CPPUNIT_TEST(test_Get_process_entity_path_3);
        CPPUNIT_TEST(test_Get_process_entity_path_4);
        CPPUNIT_TEST(test_Get_process_entity_path_5);
        CPPUNIT_TEST(test_Get_process_entity_path_6);
        CPPUNIT_TEST(test_Get_process_entity_path_7);
        CPPUNIT_TEST(test_Get_process_entity_path_8);
        CPPUNIT_TEST(test_Get_process_entity_path_9);*/
        CPPUNIT_TEST(test_Get_process_parent_path_1);
        /*CPPUNIT_TEST(test_Get_process_parent_path_10);
        CPPUNIT_TEST(test_Get_process_parent_path_2);
        CPPUNIT_TEST(test_Get_process_parent_path_3);
        CPPUNIT_TEST(test_Get_process_parent_path_4);
        CPPUNIT_TEST(test_Get_process_parent_path_5);
        CPPUNIT_TEST(test_Get_process_parent_path_6);
        CPPUNIT_TEST(test_Get_process_parent_path_7);
        CPPUNIT_TEST(test_Get_process_parent_path_8);
        CPPUNIT_TEST(test_Get_process_parent_path_9);*/
        CPPUNIT_TEST(test_Get_process_path_1);
        //CPPUNIT_TEST(test_Get_process_path_10);
        CPPUNIT_TEST(test_Get_process_path_12);
        /*CPPUNIT_TEST(test_Get_process_path_13);
        CPPUNIT_TEST(test_Get_process_path_14);
        CPPUNIT_TEST(test_Get_process_path_15);
        CPPUNIT_TEST(test_Get_process_path_16);
        CPPUNIT_TEST(test_Get_process_path_17);
        CPPUNIT_TEST(test_Get_process_path_18);
        CPPUNIT_TEST(test_Get_process_path_19);
        CPPUNIT_TEST(test_Get_process_path_2);
        CPPUNIT_TEST(test_Get_process_path_20);
        CPPUNIT_TEST(test_Get_process_path_21);
        CPPUNIT_TEST(test_Get_process_path_3);
        CPPUNIT_TEST(test_Get_process_path_4);
        CPPUNIT_TEST(test_Get_process_path_5);
        CPPUNIT_TEST(test_Get_process_path_6);
        CPPUNIT_TEST(test_Get_process_path_7);
        CPPUNIT_TEST(test_Get_process_path_8);
        CPPUNIT_TEST(test_Get_process_path_9);*/
        CPPUNIT_TEST(test_Get_process_rel_key_1);
        /*CPPUNIT_TEST(test_Get_process_rel_key_10);
        CPPUNIT_TEST(test_Get_process_rel_key_2);
        CPPUNIT_TEST(test_Get_process_rel_key_3);
        CPPUNIT_TEST(test_Get_process_rel_key_4);
        CPPUNIT_TEST(test_Get_process_rel_key_5);
        CPPUNIT_TEST(test_Get_process_rel_key_6);
        CPPUNIT_TEST(test_Get_process_rel_key_7);
        CPPUNIT_TEST(test_Get_process_rel_key_8);
        CPPUNIT_TEST(test_Get_process_rel_key_9);*/
        CPPUNIT_TEST(test_Get_system_entity_path_1);
        /*CPPUNIT_TEST(test_Get_system_entity_path_10);
        CPPUNIT_TEST(test_Get_system_entity_path_2);
        CPPUNIT_TEST(test_Get_system_entity_path_3);
        CPPUNIT_TEST(test_Get_system_entity_path_4);
        CPPUNIT_TEST(test_Get_system_entity_path_5);
        CPPUNIT_TEST(test_Get_system_entity_path_6);
        CPPUNIT_TEST(test_Get_system_entity_path_7);
        CPPUNIT_TEST(test_Get_system_entity_path_8);
        CPPUNIT_TEST(test_Get_system_entity_path_9);*/
        CPPUNIT_TEST(test_Get_system_path_1);
        /*CPPUNIT_TEST(test_Get_system_path_2);
        CPPUNIT_TEST(test_Get_system_path_3);
        CPPUNIT_TEST(test_Get_system_path_4);*/
        CPPUNIT_TEST(test_issuer_manager);
    CPPUNIT_TEST(test_path_element1);
    CPPUNIT_TEST(test_path_element2);
    CPPUNIT_TEST(test_path_element3);
    CPPUNIT_TEST(test_path_element4);
    CPPUNIT_TEST(test_path_element5);
        CPPUNIT_TEST_SUITE_END();
public:      
        Task* task1;
        Task* task2 ;
        Task* task3 ;
        Task* task4 ;
        SystemIssuerManagerTask* sys_task;
        
        void setUp();
        void tearDown();

        void test_Check_process_rel_key_1();
        void test_Check_process_rel_key_10();
        void test_Check_process_rel_key_2();
        void test_Check_process_rel_key_3();
        void test_Check_process_rel_key_4();
        void test_Check_process_rel_key_5();
        void test_Check_process_rel_key_6();
        void test_Check_process_rel_key_7();
        void test_Check_process_rel_key_8();
        void test_Check_process_rel_key_9();
        void test_Get_application_entity_path_1();
        void test_Get_application_entity_path_10();
        void test_Get_application_entity_path_2();
        void test_Get_application_entity_path_3();
        void test_Get_application_entity_path_4();
        void test_Get_application_entity_path_5();
        void test_Get_application_entity_path_6();
        void test_Get_application_entity_path_7();
        void test_Get_application_entity_path_8();
        void test_Get_application_entity_path_9();
        void test_Get_application_path_1();
        void test_Get_application_path_10();
        void test_Get_application_path_2();
        void test_Get_application_path_3();
        void test_Get_application_path_4();
        void test_Get_application_path_5();
        void test_Get_application_path_6();
        void test_Get_application_path_7();
        void test_Get_application_path_8();
        void test_Get_application_path_9();
        void test_Get_component_entity_path_1();
        void test_Get_component_entity_path_10();
        void test_Get_component_entity_path_2();
        void test_Get_component_entity_path_3();
        void test_Get_component_entity_path_4();
        void test_Get_component_entity_path_5();
        void test_Get_component_entity_path_6();
        void test_Get_component_entity_path_7();
        void test_Get_component_entity_path_8();
        void test_Get_component_entity_path_9();
        void test_Get_component_path_1();
        void test_Get_component_path_10();
        void test_Get_component_path_12();
        void test_Get_component_path_13();
        void test_Get_component_path_14();
        void test_Get_component_path_15();
        void test_Get_component_path_16();
        void test_Get_component_path_17();
        void test_Get_component_path_18();
        void test_Get_component_path_19();
        void test_Get_component_path_2();
        void test_Get_component_path_20();
        void test_Get_component_path_21();
        void test_Get_component_path_3();
        void test_Get_component_path_4();
        void test_Get_component_path_5();
        void test_Get_component_path_6();
        void test_Get_component_path_7();
        void test_Get_component_path_8();
        void test_Get_component_path_9();
        void test_Get_component_rel_key_1();
        void test_Get_component_rel_key_10();
        void test_Get_component_rel_key_2();
        void test_Get_component_rel_key_3();
        void test_Get_component_rel_key_4();
        void test_Get_component_rel_key_5();
        void test_Get_component_rel_key_6();
        void test_Get_component_rel_key_7();
        void test_Get_component_rel_key_8();
        void test_Get_component_rel_key_9();
        void test_Get_element_names_1();
        void test_Get_element_names_10();
        void test_Get_element_names_2();
        void test_Get_element_names_3();
        void test_Get_element_names_4();
        void test_Get_element_names_5();
        void test_Get_element_names_6();
        void test_Get_element_names_7();
        void test_Get_element_names_8();
        void test_Get_element_names_9();
        void test_Get_element_type_1();
        void test_Get_element_type_10();
        void test_Get_element_type_2();
        void test_Get_element_type_3();
        void test_Get_element_type_4();
        void test_Get_element_type_5();
        void test_Get_element_type_6();
        void test_Get_element_type_7();
        void test_Get_element_type_8();
        void test_Get_element_type_9();
        void test_Get_element_type_11();
        void test_Get_entity_path_1();
        void test_Get_entity_path_2();
        void test_Get_entity_path_3();
        void test_Get_entity_path_4();
        void test_Get_entity_path_5();
        void test_Get_entity_path_6();
        void test_Get_entity_path_7();
        void test_Get_entity_path_8();
        void test_Get_ftgroup_entity_path_1();
        void test_Get_ftgroup_entity_path_10();
        void test_Get_ftgroup_entity_path_2();
        void test_Get_ftgroup_entity_path_3();
        void test_Get_ftgroup_entity_path_4();
        void test_Get_ftgroup_entity_path_5();
        void test_Get_ftgroup_entity_path_6();
        void test_Get_ftgroup_entity_path_7();
        void test_Get_ftgroup_entity_path_8();
        void test_Get_ftgroup_entity_path_9();
        void test_Get_ftgroup_path_1();
        void test_Get_ftgroup_path_10();
        void test_Get_ftgroup_path_2();
        void test_Get_ftgroup_path_3();
        void test_Get_ftgroup_path_4();
        void test_Get_ftgroup_path_5();
        void test_Get_ftgroup_path_6();
        void test_Get_ftgroup_path_7();
        void test_Get_ftgroup_path_8();
        void test_Get_ftgroup_path_9();
        void test_Get_ftgroup_rel_key_1();
        void test_Get_ftgroup_rel_key_10();
        void test_Get_ftgroup_rel_key_2();
        void test_Get_ftgroup_rel_key_3();
        void test_Get_ftgroup_rel_key_4();
        void test_Get_ftgroup_rel_key_5();
        void test_Get_ftgroup_rel_key_6();
        void test_Get_ftgroup_rel_key_7();
        void test_Get_ftgroup_rel_key_8();
        void test_Get_ftgroup_rel_key_9();
        void test_Get_host_entity_path_1();
        void test_Get_host_entity_path_10();
        void test_Get_host_entity_path_2();
        void test_Get_host_entity_path_3();
        void test_Get_host_entity_path_4();
        void test_Get_host_entity_path_5();
        void test_Get_host_entity_path_6();
        void test_Get_host_entity_path_7();
        void test_Get_host_entity_path_8();
        void test_Get_host_entity_path_9();
        void test_Get_host_path_1();
        void test_Get_host_path_10();
        void test_Get_host_path_2();
        void test_Get_host_path_3();
        void test_Get_host_path_4();
        void test_Get_host_path_5();
        void test_Get_host_path_6();
        void test_Get_host_path_7();
        void test_Get_host_path_8();
        void test_Get_host_path_9();
        void test_Get_lbgroup_entity_path_1();
        void test_Get_lbgroup_entity_path_10();
        void test_Get_lbgroup_entity_path_2();
        void test_Get_lbgroup_entity_path_3();
        void test_Get_lbgroup_entity_path_4();
        void test_Get_lbgroup_entity_path_5();
        void test_Get_lbgroup_entity_path_6();
        void test_Get_lbgroup_entity_path_7();
        void test_Get_lbgroup_entity_path_8();
        void test_Get_lbgroup_entity_path_9();
        void test_Get_lbgroup_path_1();
        void test_Get_lbgroup_path_10();
        void test_Get_lbgroup_path_2();
        void test_Get_lbgroup_path_3();
        void test_Get_lbgroup_path_4();
        void test_Get_lbgroup_path_5();
        void test_Get_lbgroup_path_6();
        void test_Get_lbgroup_path_7();
        void test_Get_lbgroup_path_8();
        void test_Get_lbgroup_path_9();
        void test_Get_lbgroup_rel_key_1();
        void test_Get_lbgroup_rel_key_10();
        void test_Get_lbgroup_rel_key_2();
        void test_Get_lbgroup_rel_key_3();
        void test_Get_lbgroup_rel_key_4();
        void test_Get_lbgroup_rel_key_5();
        void test_Get_lbgroup_rel_key_6();
        void test_Get_lbgroup_rel_key_7();
        void test_Get_lbgroup_rel_key_8();
        void test_Get_lbgroup_rel_key_9();
        void test_Get_parent_path_1();
        void test_Get_parent_path_10();
        void test_Get_parent_path_2();
        void test_Get_parent_path_3();
        void test_Get_parent_path_4();
        void test_Get_parent_path_5();
        void test_Get_parent_path_6();
        void test_Get_parent_path_7();
        void test_Get_parent_path_8();
        void test_Get_parent_path_9();
        void test_Get_process_element_names_1();
        void test_Get_process_element_names_10();
        void test_Get_process_element_names_2();
        void test_Get_process_element_names_3();
        void test_Get_process_element_names_4();
        void test_Get_process_element_names_5();
        void test_Get_process_element_names_6();
        void test_Get_process_element_names_7();
        void test_Get_process_element_names_8();
        void test_Get_process_element_names_9();
        void test_Get_process_entity_path_1();
        void test_Get_process_entity_path_10();
        void test_Get_process_entity_path_2();
        void test_Get_process_entity_path_3();
        void test_Get_process_entity_path_4();
        void test_Get_process_entity_path_5();
        void test_Get_process_entity_path_6();
        void test_Get_process_entity_path_7();
        void test_Get_process_entity_path_8();
        void test_Get_process_entity_path_9();
        void test_Get_process_parent_path_1();
        void test_Get_process_parent_path_10();
        void test_Get_process_parent_path_2();
        void test_Get_process_parent_path_3();
        void test_Get_process_parent_path_4();
        void test_Get_process_parent_path_5();
        void test_Get_process_parent_path_6();
        void test_Get_process_parent_path_7();
        void test_Get_process_parent_path_8();
        void test_Get_process_parent_path_9();
        void test_Get_process_path_1();
        void test_Get_process_path_10();
        void test_Get_process_path_12();
        void test_Get_process_path_13();
        void test_Get_process_path_14();
        void test_Get_process_path_15();
        void test_Get_process_path_16();
        void test_Get_process_path_17();
        void test_Get_process_path_18();
        void test_Get_process_path_19();
        void test_Get_process_path_2();
        void test_Get_process_path_20();
        void test_Get_process_path_21();
        void test_Get_process_path_3();
        void test_Get_process_path_4();
        void test_Get_process_path_5();
        void test_Get_process_path_6();
        void test_Get_process_path_7();
        void test_Get_process_path_8();
        void test_Get_process_path_9();
        void test_Get_process_rel_key_1();
        void test_Get_process_rel_key_10();
        void test_Get_process_rel_key_2();
        void test_Get_process_rel_key_3();
        void test_Get_process_rel_key_4();
        void test_Get_process_rel_key_5();
        void test_Get_process_rel_key_6();
        void test_Get_process_rel_key_7();
        void test_Get_process_rel_key_8();
        void test_Get_process_rel_key_9();
        void test_Get_system_entity_path_1();
        void test_Get_system_entity_path_10();
        void test_Get_system_entity_path_2();
        void test_Get_system_entity_path_3();
        void test_Get_system_entity_path_4();
        void test_Get_system_entity_path_5();
        void test_Get_system_entity_path_6();
        void test_Get_system_entity_path_7();
        void test_Get_system_entity_path_8();
        void test_Get_system_entity_path_9();
        void test_Get_system_path_1();
        void test_Get_system_path_2();
        void test_Get_system_path_3();
        void test_Get_system_path_4();
        void test_issuer_manager();
        void test_path_element1();
        void test_path_element2();
        void test_path_element3();
        void test_path_element4();
        void test_path_element5();
#endif /* INCL_PLATFORMMNGT_TESTSMGTOOLS_HPP*/

};
