/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP
#define INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP


#include <iostream>
#include <fstream>
#include <limits>
#include <string>
#include <stdlib.h>

#include <SystemMngt/idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp>

#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/common/System.hpp"
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/ossupport/OS.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>
#include <Foundation/orbsupport/StrategyList.hpp>
#include "Foundation/osthreads/Mutex.hpp"
#include "Foundation/osthreads/MutexGuard.hpp"
#include <Foundation/common/Options.hpp>
#include <Foundation/common/Exception.hpp>
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"
#include "idllib/CdmwPlatformMngtApplication.stub.hpp"


namespace Cdmw
{        // Begin namespace Cdmw

    namespace PlatformMngt
    { // Begin namespace PlatformMngt

        
        class SupervisionObserver_impl: public virtual POA_CdmwPlatformMngt::SupervisionObserver,
                    public virtual PortableServer::RefCountServantBase
        {

            public:
                
                SupervisionObserver_impl();
                
                void notify( CdmwPlatformMngt::Event* an_event )
                throw( CORBA::SystemException );
                
                void set_event(CdmwPlatformMngt::ElementPath_var, 
                               const char* name);
                
                bool result();
                
            private:
                typedef struct PropertyEvent
                {
                    CdmwPlatformMngt::ElementPath_var path ;
                    CosPropertyService::PropertyName name;
                };
                PropertyEvent expectedPropertyEvent; 
                Cdmw::OsSupport::Mutex m_mutex;
                bool ok ;
         };

    } // End namespace PlatformMngt
} // End namespace Cdmw

#endif //INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP


