/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <iostream>
#include "testUDAandPDAComponentsGroupsnotification/SupervisionObserver_impl.hpp"

namespace Cdmw
{        // Begin namespace Cdmw

    namespace PlatformMngt
    { // Begin namespace PlatformMngt

    SupervisionObserver_impl::SupervisionObserver_impl()
    {
        ok = false;
    }
    
        void SupervisionObserver_impl::notify( CdmwPlatformMngt::Event* an_event )
        throw( CORBA::SystemException )
        {
            CDMW_MUTEX_GUARD (m_mutex);
            
            CORBA::String_var message = an_event->to_string();
            std::cout <<"#####" <<message.in() << std::endl;
            
            CdmwPlatformMngt::PropertyChange* prop_chg = dynamic_cast<CdmwPlatformMngt::PropertyChange*> (an_event);
            if (prop_chg!=0)   
            {
                CORBA::ULong index = 0;
                if ((( (std::string)prop_chg->element_path()) == 
                       ((std::string) expectedPropertyEvent.path)))
                {
                    if((
                        ((std::string)(prop_chg->property_infos()[index]).property_name) == 
                        ((std::string) expectedPropertyEvent.name) )) 
                    {
                        ok = true;
                    }
                }
            }
        }
        
        void SupervisionObserver_impl::set_event(CdmwPlatformMngt::ElementPath_var ep, 
                       const char* name)
        {
            expectedPropertyEvent.path = ep;
            expectedPropertyEvent.name = CORBA::string_dup (name );
            ok=false;
        }
        
        bool SupervisionObserver_impl::result()
        {
            return ok;
        }
        
    } // End namespace PlatformMngt
} // End namespace 


