/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TestComponentsAndGroupsAttributes_HPP 
#define INCL_PLATFORMMNGT_TestComponentsAndGroupsAttributes_HPP 

#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/common/System.hpp"
#include <Foundation/orbsupport/CORBA.hpp>
#include <platformsystemlibrary/System_impl.hpp>
#include <platformapplicationlibrary/Application_impl.hpp>

namespace Cdmw
{
namespace PlatformMngt
{

/**
*Purpose:
*<p>   
*
*Features:
*<p> Thread safe
*
*
*/
class TestComponentsAndGroupsAttributes : public CppUnit::TestFixture
{

    public:
        CORBA::ORB_var m_orb;

        /**
        * Purpose:
        * <p> Constructor
        * 
        */ 
        TestComponentsAndGroupsAttributes() ;



        /**
        * Purpose:
        * <p> Destructor 
        * 
        */ 
        virtual 
        ~TestComponentsAndGroupsAttributes() ;

        void setUp() ;

        
        /**
        * Purpose:
        * <p> Call from the testable object 
        * 
        */ 
        virtual void get_component_properties() ;
        virtual void set_and_get_component_properties() ;

        virtual void get_ftgroup_properties() ;
        virtual void set_and_get_ftgroup_properties() ;

        virtual void get_lbgroup_properties() ;
        virtual void set_and_get_lbgroup_properties() ;


    protected:


    private:

        /**
        * Purpose:
        * <p> Assignment operator
        * 
        */ 
        TestComponentsAndGroupsAttributes& operator=(const TestComponentsAndGroupsAttributes& rhs) throw();
        /**
        * Purpose:
        * <p>  Copy constructor
        * 
        */ 
        TestComponentsAndGroupsAttributes(const TestComponentsAndGroupsAttributes& rhs) throw();

        static CdmwPlatformMngt::System_var mysystem;
        static CdmwPlatformMngt::Process_var myprocess;
        static CdmwPlatformMngt::Application_var app;
        static CdmwPlatformMngt::CcmComponent_var comp;
        static bool m_is_one_shot_initialized;
                 
        static void one_shot_init();

CPPUNIT_TEST_SUITE(TestComponentsAndGroupsAttributes);
CPPUNIT_TEST( get_component_properties );
CPPUNIT_TEST( set_and_get_component_properties );

CPPUNIT_TEST( get_ftgroup_properties );
CPPUNIT_TEST( set_and_get_ftgroup_properties );

CPPUNIT_TEST( get_lbgroup_properties );
CPPUNIT_TEST( set_and_get_lbgroup_properties );


CPPUNIT_TEST_SUITE_END();
        


};

} /* End namespace PlatformMngt */
} /* End namespace Cdmw */
#endif 

