/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <iostream>
#include "test_periodic_notification/Observer_impl.hpp"
#include <tao/AnyTypeCode/TypeCode.h>
#include <Foundation/orbsupport/CosPropertyService.stub.hpp>
#include <idllib/CdmwPlatformMngtPredefinedProperties.stub.hpp>


using namespace std;

namespace Cdmw
{// Begin namespace Cdmw
    
namespace PlatformMngt
{// Begin namespace PlatformMngt
    
namespace Periodic
{ // Begin namespace Periodic 


Observer_impl::Observer_impl()
{
    m_stop_condition_flag = false;
    
    m_count = 0;
}

void
Observer_impl::execute( const CosPropertyService::Properties & properties )
throw( CORBA::SystemException )
{

    CORBA::ULong len = properties.length ();
    for (unsigned int i=0; i<len; ++i) 
    {
        std::cout << "property name ["<<i<<"] = "<< properties[i].property_name<< std::endl;
        if (properties [i].property_value.type()->equal(CdmwPlatformMngt::_tc_RestartWarmth))
        {
            std::cout << "|  type  :  RestartWarmth" << std::endl;
            CdmwPlatformMngt::RestartWarmth value;
            properties [i].property_value >>= value;
            std::cout << "|  value :  "<< ( (CdmwPlatformMngt::HOT_RESTART == value)?"Hot":"Cold" ) <<std::endl;   
        }
    }
    m_count++;
}

bool Observer_impl::is_execute_called()
{
    return m_stop_condition_flag;
}

int Observer_impl::get_count()
{
    return m_count;
}

void Observer_impl::reset_count()
{
    m_count=0;
}

}//End namespace PlatformMngt
} // End namespace PlatformMngt
} // End namespace Cdmw
