/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_PLATFORMMNGT_TEST_TIMER_OBSERVER_HPP
#define INCL_PLATFORMMNGT_TEST_TIMER_OBSERVER_HPP

#include <iostream>
#include "test_periodic_notification/TestTimerObserver.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"


namespace Cdmw
{// Begin namespace Cdmw
    
namespace PlatformMngt
{// Begin namespace PlatformMngt
    
TestTimerObserver::TestTimerObserver()
{
    m_timeout=false;
}

TestTimerObserver::~TestTimerObserver()
{
    
}
void TestTimerObserver::wake_up() throw ()
{
    m_timeout=true;
    
    TEST_INFO("The timer is expired..");
}

bool TestTimerObserver::is_timer_expired()
{
    return m_timeout;
}

void TestTimerObserver::reset_timer()
{
    m_timeout=false;
}

}/* End namespace PlatformMngt */
}/* End namespace Cdmw */

#endif /* INCL_PLATFORMMNGT_TEST_TIMER_OBSERVER_HPP */
