/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_PERIODIC_OBSERVER_HPP
#define INCL_PLATFORMMNGT_PERIODIC_OBSERVER_HPP

#include "test_periodic_notification_reception/TestObj.hpp"
/*#include <Foundation/orbsupport/OrbSupport.hpp>
#include <tools/TimeoutObserver.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtApplication.stub.hpp>
#include <SystemMngt/idllib/CdmwPlatformMngtProcess.stub.hpp>
#include "idllib/CdmwPlatformMngtSystem.stub.hpp"*/
#include "idllib/CdmwPlatformMngtPeriodicObserver.skel.hpp"
#include <SystemMngt/tools/ManagedElementKey.hpp>

namespace Cdmw
{        // Begin namespace Cdmw

namespace PlatformMngt
{// Begin namespace PlatformMngt

namespace Periodic
{ // Begin namespace Periodic

//class TestObj;

class TestObserver_impl: public virtual POA_CdmwPlatformMngt::Periodic::Observer,
                     public virtual PortableServer::RefCountServantBase
                    
{   

public:
    
    TestObserver_impl(CdmwPlatformMngt::System_ptr sys, 
                     char* appl_name,
                     char* proc_name,
                     CORBA::ULong num_userdef); 

    virtual ~TestObserver_impl() throw();

    void execute( const CosPropertyService::Properties & properties )
    throw( CORBA::SystemException );
    
    bool is_assert_false();

    CORBA::ULong get_count();
    
    void reset_count();
    
private:
    
    bool m_assert_false;

    CORBA::ULong m_count;
    
    TestObj * m_test_object;

};

}
} // End namespace PlatformMngt
} // End namespace Cdmw

#endif //INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP

