/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_PLATFORMMNGT_TESTTIMEROBSERVER_HPP
#define INCL_PLATFORMMNGT_TESTTIMEROBSERVER_HPP

//#include <Foundation/orbsupport/OrbSupport.hpp>
#include <tools/TimeoutObserver.hpp>
//#include "SystemMngt/idllib/CdmwPlatformMngtDaemon.stub.hpp"
//#include "idllib/CdmwPlatformMngtPeriodicObserver.skel.hpp"

namespace Cdmw
{// Begin namespace Cdmw

namespace PlatformMngt
{// Begin namespace PlatformMngt

/* Purpose:
* <p>
* Implementation of a single shot timer timeout observer.
*/
class TestTimerObserver : public Cdmw::PlatformMngt::TimeoutObserver
{
    
public:

    //costructor
    TestTimerObserver(bool sup_kill);
    
    //destructor
    virtual ~TestTimerObserver();
    
    // callback method to call when the timeout will be expired.
    void wake_up() throw ();
    
    bool is_timer_expired();
    
    void reset_timer();
    
private:
    
    bool m_timeout;
    
    bool m_sup_kill;
    
};


}
}
#endif /*TESTTIMEROBSERVER_HPP_*/
