/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#include "test_periodic_notification_reception/TestGroupObserver_impl.hpp"
//#include <Foundation/orbsupport/CosPropertyService.stub.hpp>
#include "Foundation/testutils/CORBATestManager.hpp"



namespace Cdmw
{// Begin namespace Cdmw

namespace PlatformMngt
{// Begin namespace PlatformMngt


namespace Periodic
{ // Begin namespace Periodic


TestGroupObserver_impl::TestGroupObserver_impl(CdmwPlatformMngt::System_ptr sys,
                                               char* app,
                                               char* proc,
                                               CORBA::ULong num_userdef)
{
    m_test_object = new TestObj(sys, app, proc, num_userdef);
    m_assert_false = false;
    m_count = 0;
}
    
void
TestGroupObserver_impl::execute( const CosPropertyService::Properties & properties )
throw( CORBA::SystemException )
{

    if (m_test_object->is_assert_false())
    {
        TEST_INFO(" Observer_impl :: callback execute ASSERT FALSE ");
        m_assert_false = false;
        CPPUNIT_ASSERT (false);
    }
    
    CosPropertyService::Properties_var prop = new CosPropertyService::Properties(properties);
    
    //call the tester to check recieved properties
    m_test_object->execute(prop.in());
    
    m_count++;
}
    
bool TestGroupObserver_impl::is_assert_false()
{
    return m_assert_false;
}

CORBA::ULong TestGroupObserver_impl::get_count()
{
    return m_count;
}

void TestGroupObserver_impl::reset_count()
{
    m_count=0;
}

}//End namespace PlatformMngt
} // End namespace PlatformMngt
} // End namespace Cdmw

