/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <unistd.h>
#include <cstdlib>
#include <string>
#include <sstream>
#include <iostream>
#include <Foundation/common/System.hpp>
#include <Foundation/ossupport/OS.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>
#include <fstream>

// argv[] contains the variables names to be checked in the process enviroment.
// Their values will be saved in a file called Process_env.dat

int main(int argc, char* argv[])
{
    std::cout << "\n-------------------------" << std::endl
    << " PROCESS_ENV  IS RUNNING      " << std::endl
    << "-------------------------" << std::endl;
    
    std::ofstream of("Process_env.dat",std::ios::out|std::ios::app);
    
    if( argc > 1)
    {
        std::cout<<std::endl;
        for(int i=1;i<argc;i++) //n=0 represents that process path
            std::cout<< argv[i] << " ";
        std::cout<< " saved in Process_env.dat \n";  
        if (of)
        {
            for (int n=1; n < argc; n++)  
            {
                of <<getenv(argv[n])<< std::endl;
                sleep(1);
            }
        }
        else
        {
            std::cerr << "*** ERROR IN WRITING FILE PROCESS_ENV.DAT ***" << std::endl;
            return 1;
        }      
    }
    else 
        std::cout << "There are not any variables to be saved \n"; 
    of.close();
    return 0;
}
