/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP
#define INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP

#include "Foundation/orbsupport/OrbSupport.hpp"
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"
#include "Foundation/osthreads/MutexGuard.hpp"


namespace Cdmw
  {        // Begin namespace Cdmw

  namespace PlatformMngt
    { // Begin namespace PlatformMngt

    class ProcObserver_impl: public virtual POA_CdmwPlatformMngt::SupervisionObserver,
          public virtual PortableServer::RefCountServantBase
      {

      public:
        
        ProcObserver_impl(): process_status(CdmwPlatformMngt::PROCESS_INITIAL), application_status(CdmwPlatformMngt::APPLICATION_INITIAL), system_status( CdmwPlatformMngt::SYSTEM_INITIAL){}
//, number(0) {}

        void notify( CdmwPlatformMngt::Event* an_event )
        throw( CORBA::SystemException );
      
        /**
         * these functions control the status of process/application/system
         */

        bool has_status(int status);

        bool has_system_status(CdmwPlatformMngt::SystemStatus status);

        bool has_application_status(int status);

      private:

                
        CdmwPlatformMngt::ProcessStatus process_status;        
        CdmwPlatformMngt::ApplicationStatus application_status;
        //int  system_status;
        OsSupport::Mutex m_mutex;

        CdmwPlatformMngt::SystemStatus system_status;
        //int number;
      };

  } // End namespace PlatformMngt
} // End namespace Cdmw

#endif //INCL_PLATFORMMNGT_SUPERVISION_OBSERVER_HPP

