/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TEST_MIOP_HPP
#define INCL_TEST_MIOP_HPP

#include <string>

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>


namespace CdmwFT {
namespace Test {

class TestIncompatibleStatus : public CppUnit::TestFixture
{
public:
    // constructor
    TestIncompatibleStatus();
    
    // destructor
    virtual ~TestIncompatibleStatus();
    
    void setUp ();

protected:
    // test_single_controller_isolation
    virtual void test_incompatible_status();

private:
    TestIncompatibleStatus(const TestIncompatibleStatus&);
    void operator=(const TestIncompatibleStatus&);

    CORBA::ORB_var                      m_orb;
    std::string          platform_daemon_port;
    

CPPUNIT_TEST_SUITE( TestIncompatibleStatus );
CPPUNIT_TEST( test_incompatible_status );
CPPUNIT_TEST_SUITE_END();
    
}; // end class 

}; // namespace Test

}; // namespace CdmwFT

#endif // INCL_TEST_MIOP_HPP

