#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================
#===============================================================================

LOGFILE=supervision_log.txt
rm -rf $LOGFILE

echo "Cleaning up processes..."
killall -9 cdmw_platform_daemon
killall -9 cdmw_ft_manager
killall -9 cdmw_platform_supervision

echo "Starting platform daemon..."
if [ -e /tmp/CdmwDaemon_21869 ] 
then
    cdmw_platform_kill_all_pids.sh /tmp/CdmwDaemon_21869
fi
start_daemon_verbosely.sh 2>&1 1>/dev/null &

sleep 5

echo "Starting FT manager..."
cdmw_ft_manager --CdmwXMLFile=CdmwFaultToleranceManager_conf.xml --groupConf=CdmwFTSystemMngtGroupCreator_conf.xml 2>&1 1>/dev/null &

sleep 5

echo "Starting platform supervision..."
start_supervision_to_log_file.sh --CdmwPluginConf=PluginValidConf_03.xml 2>&1 1>/dev/null &

sleep 5

echo; echo;
echo "Testing results..."
RESULT=`grep "Error loading plugin \"not_existing.so\"" $LOGFILE`
echo RESULT: $RESULT
if [ -z "$RESULT" ] 
then
   echo "Test is NOT OK"
else
   echo "Test is OK"
fi
echo; echo;

echo "Cleaning up processes..."
killall -9 cdmw_platform_daemon
killall -9 cdmw_ft_manager
killall -9 cdmw_platform_supervision



