/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "testplugin/PluginObj.hpp"

#include <cstdlib> 
#include <ctime> 
#include <iostream>

namespace Cdmw
{
namespace PlatformMngt
{

// Used to create a unique id when loading multiple instances of this library
int id_progressive = 0;

PluginObj::PluginObj()
    : m_id(id_progressive++)
{
    std::cerr << "PluginObj() called " << m_id << std::endl;
}

void PluginObj::set_up()
{
    std::cerr << "PluginObj::set_up() called for ID: " << m_id << std::endl;
    m_plugin = new PluginValid_impl();
    m_system = get_system();
    m_plugin->set_id( m_id );
    m_plugin->set_system( m_system );
    std::cerr << "PluginObj::set_up() m_plugin reference: " << m_plugin << std::endl;
}

void PluginObj::run( )
{
    std::cerr << "PluginObj::run() called for ID: " << m_id << std::endl;
}

void PluginObj::tear_down()
{
    std::cerr << "PluginObj::tear_down() called" << m_id << std::endl;
}

}
}






