#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

# @brief script to start the valid. test V-SMG-041


#define of the scenario ...
echo "Define scenario ..."
define_system.sh V-SMG-041-1-1.xml &
echo "Wait 5 seconds to be sure that scenario is defined ..."
sleep 5

#start executable TestFTAutomatic_actions ...

echo ""
echo "Start TestFTAutomatic_actions to log attribute values to file V-SMG-041_LOG1.txt"
TestFTAutomatic_actions > V-SMG-041_LOG1.txt

#start system ...
echo ""
echo "Start system ..."
start_system.sh &
echo "Wait 20 seconds before this script kills the primary supervision ..."
sleep 20

#kill primary supervision ...
pidsup=`/sbin/pidof cdmw_platform_supervision`
echo "pidsup=$pidsup"
kill -9 $pidsup

echo "Wait 2 seconds to be sure that primary supervision is killed ..."

echo ""
echo "Start TestFTAutomatic_actions to log attribute values to file V-SMG-041_LOG2.txt"
TestFTAutomatic_actions > V-SMG-041_LOG2.txt


echo ""
echo "Wait until the restart messages, in the observer window, are terminated,"
echo "and then push enter to exit ."

read dummy2

exit

