#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

# @brief script to start the qualif. test Q-246-5
echo "Start test" 
SYS_SNAP1="Q-246-5_4SYS_SNAP1"
SYS_SNAP2="Q-246-5_4SYS_SNAP2"
SYS_SNAP3="Q-246-5_4SYS_SNAP3"
TMP_SYS_SNAP1="TMP_Q-246-5_4SYS_SNAP1"
TMP_SYS_SNAP2="TMP_Q-246-5_4SYS_SNAP2"
TMP_SYS_SNAP3="TMP_Q-246-5_4SYS_SNAP3"

echo "Primary supervision snapshot" 
system_snapshot.sh show-attr > $TMP_SYS_SNAP1
#kill primary supervision
echo
echo "kill primary supervision" 
kill -9 `cat /tmp/CdmwDaemon_21869/SMG_SUPERVISION_PROCESS.pid`
echo "First backup supervision" 
sleep 10
system_snapshot.sh show-attr > $TMP_SYS_SNAP2
#kill first backup supervision
echo
echo "kill first backup supervision" 
ssh @hostname2val@  "cat /tmp/CdmwDaemon_21869/SMG_SUPERVISION_PROCESS.pid | xargs kill -9"
sleep 10
system_snapshot.sh show-attr > $TMP_SYS_SNAP3
echo "Second backup supervision" 

cat $TMP_SYS_SNAP1 | grep -v CDMW.PFMADM > $SYS_SNAP1
cat $TMP_SYS_SNAP2 | grep -v CDMW.PFMADM > $SYS_SNAP2
cat $TMP_SYS_SNAP3 | grep -v CDMW.PFMADM > $SYS_SNAP3

echo "Supervision snapshot created "  
echo $SYS_SNAP1  
echo $SYS_SNAP2
echo $SYS_SNAP3

echo "****************************************************"
echo "Check the difference between supervision's snapshots" 
echo "****************************************************"



