/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef CARDAMOM_CLOCK_TAOTIMER_HPP
#define CARDAMOM_CLOCK_TAOTIMER_HPP

#include <ace/TP_Reactor.h>
#include <ace/Timer_List.h>
#include <ace/Timer_Wheel.h>
#include <ace/Recursive_Thread_Mutex.h>
#include <ace/Guard_T.h>
#include <ace/Task.h>
#include <tao/ORB_Core.h>
#include <Foundation/osthreads/Mutex.hpp>
#include <Foundation/osthreads/MutexGuard.hpp>
#include <Foundation/osthreads/RecursiveMutex.hpp>

typedef ACE_Event_Handler CDMW_Event_Handler;
typedef ACE_Time_Value CDMW_Time_Value;
typedef ACE_Timer_Queue CDMW_Timer_Queue;
typedef ACE_Timer_List CDMW_Timer_List;
typedef ACE_Task_Base CDMW_Task_Base;
typedef ACE_Reactor CDMW_Reactor;
typedef ACE_TP_Reactor CDMW_TP_Reactor;
typedef ACE_Timer_Wheel CDMW_Timer_Wheel;

// to substitute with Cardamom specific
typedef ACE_Recursive_Thread_Mutex CDMW_Recursive_Thread_Mutex;

#ifdef CDMW_Guard
#  undef CDMW_Guard
#endif
#define CDMW_Guard ACE_Guard

#endif //CARDAMOM_CLOCK_TAOTIMER_HPP
