/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.clock;

/**
 * <p>Title: CdmwCosClock</p>
 * <p>Description:  </p>
 * <p>Copyright: Copyright (c) 2006</p>
 * @author Francesca Annunziata
 * @author Raffaele Mele
 * @version 
 */

import org.omg.PortableServer.*;
import org.omg.CORBA.ORB;
import cdmw.orbsupport.ORBSupport;
import org.omg.CosClockService.UtcTimeService;
import org.omg.CosClockService.UtcTimeServicePOATie;
import org.omg.CosClockService.ClockCatalogPackage.ClockEntry;
import org.omg.PortableServer.POA ;
import org.omg.CosClockService.ControlledClock;
import org.omg.CosClockService.ControlledClockPOATie;
import org.omg.CosClockService.UTCValueFactory;


import Cdmw.clock.ControlledClockEx;
import Cdmw.clock.ControlledClockExHelper;
import Cdmw.clock.ControlledClockExPOATie;

public class CdmwCosClock 
{

    /** 
     * Start EVoT services and allocate resources.
     * @param theOrb A reference to the ORB.
     * @param args The args from main.
     * @return true if all is ok, false is some problem.
     */
    public static boolean init(ORB orb, String[] args)
    {
        boolean result = cdmw.clock.JNIClock.init(orb, args);
        if (!result) 
            System.out.println("Error : unable to initialize Clock Service");

        ((org.omg.CORBA_2_3.ORB)orb).register_value_factory("IDL:omg.org/CosClockService/UTC:1.0",
                    new UTCValueFactoryImpl());
        ((org.omg.CORBA_2_3.ORB)orb).register_value_factory("IDL:omg.org/CosClockService/TimeSpan:1.0",
               new TimeSpanValueFactoryImpl());


        return result;
        
    }
    
    /**
     * Perform correctly the cleanup of EVoT services.
     */
     public static void close()
    {
        cdmw.clock.JNIClock.close();
    }

    org.omg.PortableServer.POA get_POA()
    {
        return null;
    }

}
