/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.clock;

import java.util.Iterator;
import java.util.Vector;
import org.omg.CosClockService.ClockCatalogOperations;
import org.omg.CosClockService.ClockCatalogPOA;
import org.omg.CosClockService.ClockCatalogPackage.ClockEntry;
import org.omg.CosClockService.ClockCatalogPackage.UnknownEntry;

public class ClockCatalogImpl extends ClockCatalogPOA
    implements ClockCatalogOperations
{

    public ClockCatalogImpl(org.omg.CORBA.ORB orb)
    {   
        this.orb = orb;
        catalog = new Vector();
    }

    public ClockEntry[] available_entries()
    {
        Iterator iterator = catalog.iterator();
        Vector vector = new Vector();
        ClockEntryImpl entry;
        for(; iterator.hasNext(); vector.add(entry.getClockEntry()))
            entry = (ClockEntryImpl)iterator.next();

        ClockEntry aclockentry[] = new ClockEntry[vector.size()];
        aclockentry = (ClockEntry[])vector.toArray(new ClockEntry[0]);
        return aclockentry;
    }



    public ClockEntry get_entry(String s)
        throws UnknownEntry
    {
        for(Iterator iterator = catalog.iterator(); iterator.hasNext();)
        {
            ClockEntryImpl entry = (ClockEntryImpl)iterator.next();
            if(entry.getEntryName().equals(s))
                return entry.getClockEntry();
        }

      
        throw new UnknownEntry();
    }

    public void delete_entry(String s)
        throws UnknownEntry
    {
        for(int i = 0; i < catalog.size(); i++)
        {
            ClockEntryImpl entry = (ClockEntryImpl)catalog.get(i);
            if(entry.getEntryName().equals(s))
            {
                catalog.removeElementAt(i);
                return;
            }
        }

        throw new UnknownEntry();
    }

    public void register(ClockEntry clockentry)
    {
        try
        {
            get_entry(clockentry.name);
            try
            {
                delete_entry(clockentry.name);
                ClockEntryImpl entry  = new ClockEntryImpl(orb,clockentry);
                catalog.add(entry);
            }
            catch(UnknownEntry unknownentry)
            {
                System.out.println("Can not delete existing entry");
                return;
            }
        }
        catch(UnknownEntry unknownentry1)
        {
            ClockEntryImpl entry2  = new ClockEntryImpl(orb,clockentry);
            catalog.add(entry2);
        }
    }
    Vector catalog;    
    static org.omg.CORBA.ORB orb;
    
}
