/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.clock;

import java.io.Serializable;
import org.omg.CosClockService.Clock;
import org.omg.CosClockService.ClockCatalogPackage.ClockEntry;
import org.omg.CosClockService.ClockHelper;

public class ClockEntryImpl
    implements Serializable
{

    public ClockEntryImpl(org.omg.CORBA.ORB clock_orb, Clock clock, String s)
    {
        this.orb = clock_orb; 
        entry = orb.object_to_string(clock);
        entryName = s;
    }

    public ClockEntryImpl(org.omg.CORBA.ORB clock_orb,ClockEntry clockentry)
    {
        this.orb = clock_orb; 
        entry = orb.object_to_string(clockentry.subject);
        entryName = clockentry.name;
    }

    public Clock getClock()
    {
        return ClockHelper.narrow(orb.string_to_object(entry));
    }

    public String getEntryName()
    {
        return entryName;
    }

    public ClockEntry getClockEntry()
    {
        return new ClockEntry(ClockHelper.narrow(orb.string_to_object(entry)), entryName);
    }

    public void setORB (org.omg.CORBA.ORB clock_orb) 
    {
        this.orb = clock_orb;      
    }
    private String entry;
    private String entryName;
    static org.omg.CORBA.ORB orb;
}
