/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.clock;

/*
 * Clock Macro definition
 */
public class Macro {
    // todo comment
    
    public static final long Mask48 = 0x0000FFFFFFFFFFFFL;

    public static final long Mask32 = 0x00000000FFFFFFFFL;
    public static final long Mask16 = 0x000000000000FFFFL;
    // Max value storable in a long
    public static final long MAX_UTC_TIME = Long.MAX_VALUE;
      // microseconds in a day
    public static final long USEC_IN_A_DAY  = 86400000000L;
    // microseconds in a hour
    public static final long USEC_IN_A_HOUR = 3600000000L;

    // microseconds in a minute
    public static final long USEC_IN_A_MIN  = 60000000L;

    // microseconds in a second
    public static final long USEC_IN_A_SEC  = 1000000L;

    // microseconds in a millisecond
    public static final long USEC_IN_A_MSEC = 1000L;

    // TimeT (10e-7 sec) in a second
    public static final long TIMET_IN_A_SEC = 10000000L;

    // TimeT (10e-7 sec) in a usec
    public static final long TIMET_IN_A_USEC = 10L;
}
