/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.clock;

import java.io.Serializable;
import org.omg.CosClockService.TimeSpan;
import org.omg.CosClockService.TimeSpanValueFactory;
import org.omg.TimeBase.IntervalT;
import org.omg.CORBA_2_3.portable.InputStream;

public class TimeSpanValueFactoryImpl
    implements TimeSpanValueFactory
{

    public TimeSpanValueFactoryImpl()
    {
    }

    public TimeSpan init(IntervalT intervalt)
    {
        TimeSpanImpl timespan = new TimeSpanImpl();
        timespan.lower_bound = intervalt.lower_bound;
        timespan.upper_bound = intervalt.upper_bound;
        return timespan;
    }

    public TimeSpan compose(long lower_bound, long upper_bound)
    {
        TimeSpanImpl timespan = new TimeSpanImpl();
        timespan.lower_bound = lower_bound;
        timespan.upper_bound = upper_bound;
        return timespan;
    }

    public Serializable read_value(InputStream inputstream)
   {
        return inputstream.read_value(new TimeSpanImpl());
   } 
}

