/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.clock;

import org.omg.CosClockService.*;
import org.omg.TimeBase.UtcT;

public class UTCImpl extends UTC 
{
    public UTCImpl()
    {}
///////////////////////////////////////////////////////////////////////////////

    public long inaccuracy()
    {
        return ((((long)inacchi) << 32) | inacclo);
    }
///////////////////////////////////////////////////////////////////////////////

    public UtcT utc_time()
    {
        return new UtcT(time, inacclo, inacchi, tdf);
    }
///////////////////////////////////////////////////////////////////////////////

    public TimeComparison compare_time(ComparisonType comparisontype, UTC utc)
    {
        // ComparisonType is IntervalC
        if(comparisontype == ComparisonType.IntervalC)
        {
            if(inaccuracy() == 0L && utc.inaccuracy() == 0L && time == utc.time)
                return TimeComparison.TCEqualTo;
                
            if(interval().spans(utc, new TimeSpanHolder()) != OverlapType.OTNoOverlap)
                return TimeComparison.TCIndeterminate;
            if(time < utc.time)
                return TimeComparison.TCLessThan;
            else
                return TimeComparison.TCGreaterThan;
        }
        // ComparisonType is MidC
        if(time < utc.time)
            return TimeComparison.TCLessThan;
        if(time > utc.time)
            return TimeComparison.TCGreaterThan;
        else
            return TimeComparison.TCEqualTo;
    }
///////////////////////////////////////////////////////////////////////////////

    public TimeSpan interval()
    {
        TimeSpanImpl timespan = new TimeSpanImpl();
        timespan.lower_bound = time - inaccuracy();
        timespan.upper_bound = time + inaccuracy();
        return timespan;
    }
 
}

