/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.clock;

/**
 * @struct cdmwTime
 * @brief This class provides Java version of c++ struct cdmw_tm
 */
 public class cdmwTime 
{
   /**
    * tm_sec  : The number of seconds after the minute, normally in the range 0
    *            to 59 but can be up to 61 to allow for leap seconds.
    */
   public int tm_sec;

   /**
    * tm_min  : The number of minutes after the hour, in the range 0 to 59.
    */
   public int tm_min;

   /**
    * tm_hour : The number of hours past midnight, in the range 0 to 23.
    */
   public int tm_hour;

   /**
    * tm_mday : The day of the month, in the range 1 to 31.
    */
   public int tm_mday;

   /**
    * tm_mon  : The number of months since January, in the range 0 to 11.
    */
   public int tm_mon;

   /**
    * tm_year : The year since the year 1900.
    */
   public int tm_year;

   /**
    * tm_wday : The number of days since Sunday, in the range 0 to 6.
    */
   public int tm_wday;

   /**
    * tm_yday : The number of days since January 1-st, in the range 0 to 365.
    */
   public int tm_yday;

   /**
    * tm_isdst: A flag that indicates whether daylight saving time is in effect
    *            at the time described. The value is positive if daylight saving
    *            time is in effect, zero if it is not, and negative if
    *            the information is not available.
    */
   public int tm_isdst;

   /**
    * tm_msec  : The number of milliseconds
    */
   public int tm_msec;

   /**
    * tm_usec : The number of microseconds
    */
   public int tm_usec;
}

