/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.clock.test;

import org.omg.CORBA.Any;

public class ClockObserverImpl extends Cdmw.clock.ClockObserverPOA{
    
    //private cdmw.clock.ControlledClockEvent event_;
    
    int event_;
    
    
    public ClockObserverImpl()
    {
        event_ = Cdmw.clock.NONE.value;
    }    
    
    public void handle_pause(Any arg0) throws org.omg.CORBA.SystemException{
        event_ |= Cdmw.clock.PAUSE.value;        
    }
    
    public void handle_resume(Any arg0) throws org.omg.CORBA.SystemException{
        event_ |= Cdmw.clock.RESUME.value;
    }
    
    public void handle_set(Any arg0) throws org.omg.CORBA.SystemException{
        event_ |= Cdmw.clock.SET_TIME.value;        
    }
    
    public void handle_set_rate(Any arg0) throws org.omg.CORBA.SystemException{
        event_ |= Cdmw.clock.SET_RATE.value;        
    }
    
    public void handle_terminate(Any arg0) throws org.omg.CORBA.SystemException{
        event_ |= Cdmw.clock.TERMINATE.value;    
    }
    
    public int getProcessedEvents()
    {
        return event_;
    }
}
