/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.clock.test;
import cdmw.clock.*;
import cdmw.testutils.Testable;
import org.omg.CORBA.ORB;
import org.omg.CosClockService.TimeUnavailable;
import org.omg.CosClockService.ControlledClock;
import org.omg.CosClockService.ClockCatalog;
import org.omg.CosClockService.ClockCatalogHelper;
import org.omg.CosClockService.ControlledClockHelper;
import org.omg.CosClockService.ClockCatalogPackage.ClockEntry;




public class CreateMultipleVirtualClockTest extends Testable
{

    private final int       NUMOFTESTS = 1;
    private ORB orb;
    private static String[] args;

    private ClockCatalog catalog;


    public CreateMultipleVirtualClockTest (ORB orb,ClockCatalog catalog,String[] args) 
    {
      this.name = "CreateMultipleVirtualClockTest";
      this.out = System.out;
      this.orb = orb;
      this.args = args;
      this.catalog = catalog;
    }

    public ControlledClock createVirtualClock()
    {
       try 
       {
           ClockEntry entry = catalog.get_entry("ControlledClock");
           return ControlledClockHelper.narrow(entry.subject);
       }
       catch (org.omg.CosClockService.ClockCatalogPackage.UnknownEntry e)
       {
           return null;
       }


    }
    public boolean MultipleVirtualClocksTest()
    {

       ControlledClock vclock1 = createVirtualClock();
       ControlledClock vclock2 = createVirtualClock();
       ControlledClock vclock3 = createVirtualClock();

       System.out.println(" get current time form virtual clock vclock1 = " + getTimeFromVirtualClock(vclock1) );
       System.out.println(" get current time form virtual clock vclock2 = " + getTimeFromVirtualClock(vclock2) );
       System.out.println(" get current time form virtual clock vclock3 = " + getTimeFromVirtualClock(vclock3) );
       
       return Macro.TEST_OK; 
    }
    public long getTimeFromVirtualClock(ControlledClock virtualClock)
    {
       try
       {
           return virtualClock.current_time();
       }
       catch (TimeUnavailable e)
       {
           return -1;
       } 
    }  

    public void doTests() 
    {
        setNbOfRequestedTestOK(NUMOFTESTS);
        check(MultipleVirtualClocksTest());        
    }
}

