/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef CONTROLLERENFORCEINTERVALPOLICYTEST_HPP
#define CONTROLLERENFORCEINTERVALPOLICYTEST_HPP

/**
 * @author Francesca Annunziata <fannunziata@selex-si.com>
 * @author Fabrizio Morciano <fmorciano@selex-si.com>
 * @author Marco Macellari <mmacellari@progesi.it>
 */

#include <cppunit/extensions/HelperMacros.h>
#include "Time/idllib/CdmwTime.stub.hpp"
#include <functional>

class ControllerEnforceIntervalPolicyTest 
    : public CppUnit::TestFixture
{
    CPPUNIT_TEST_SUITE( ControllerEnforceIntervalPolicyTest );
      CPPUNIT_TEST( check_policy );
      CPPUNIT_TEST( PCR_0450_on_set_rate );     
      CPPUNIT_TEST( PCR_0450_on_set );
      CPPUNIT_TEST( PCR_0450_on_pause_resume );
      // CPPUNIT_TEST( PCR_0450_on_mixed_controls );
      CPPUNIT_TEST( on_set_time_and_rate_while_in_pause );
      CPPUNIT_TEST( more_controllers_with_different_policies_at_the_same_time );
      CPPUNIT_TEST( PCR_0450_on_terminate );
    CPPUNIT_TEST_SUITE_END();

protected:

    std::string                                        m_alias_name;
    CosClockService::ControlledClock_var               m_controlledClock;
    CosClockService::PeriodicExecution::Controller_var m_controller;
    Cdmw::clock::policy::ControllerUpdateAdmin_var     m_admin;
    CORBA::Object_var                                  m_obj;
 
public:

    ControllerEnforceIntervalPolicyTest();

    void setUp();
    void tearDown() ;

    void check_policy();
    void PCR_0450_on_set_rate();
    void PCR_0450_on_set();
    void PCR_0450_on_pause_resume();
    // void PCR_0450_on_mixed_controls();
    void on_set_time_and_rate_while_in_pause();
    void more_controllers_with_different_policies_at_the_same_time();
    void PCR_0450_on_terminate();
};

#endif // CONTROLLERENFORCEINTERVALPOLICYTEST_HPP

