#!/bin/bash

# handle input parameters
SCRIPT=`basename $0`
if [[ $# -ne 1 ]] ; then
    echo "usage: $SCRIPT <test program name>"
    echo "where: <test program name> is the program name of the test to be run"
    echo "notes: required local environment variables are:"
    echo "       - TESTS_REPORTS_SCRIPTS_ROOT pointing to the local absolute path for test reports logs."
    echo "       - TESTS_REPORTS_LOGS_ROOT    pointing to the local absolute path for test reports logs."
    echo "       - CDMW_HOME                  pointing to the local cardamom installation root."
    echo "       - TMG_PORT                   (from tests_reports-global_macros.bash) containing the communication port."
    exit 1
fi

# include global macros script
source $TESTS_REPORTS_SCRIPTS_ROOT/tests_reports-global_macros.bash

# run the test and handle log files
EXIT_CODE=0
$CDMW_HOME/bin/$1 --server --CdmwFederatedCtrlClock=on --CdmwLocalisationService=$TMG_PORT 2>&1 | tee $TESTS_REPORTS_LOGS_ROOT/simple-test.$1.server-process.out
exit $EXIT_CODE

