#!/bin/bash

# handle input parameters
SCRIPT=`basename $0`
if [[ $# -ne 1 ]] ; then
    echo "usage: $SCRIPT <test program name>"
    echo "where: <test program name> is the program name of the test to be run"
    echo "notes: required local environment variables are:"
    echo "       - TESTS_REPORTS_SCRIPTS_ROOT pointing to the local absolute path for test reports logs."
    echo "       - TESTS_REPORTS_LOGS_ROOT    pointing to the local absolute path for test reports logs."
    echo "       - CDMW_HOME                  pointing to the local cardamom installation root."
    exit 1
fi

# include global macros script
source $TESTS_REPORTS_SCRIPTS_ROOT/tests_reports-global_macros.bash

# run the test and handle
EXIT_CODE=0
$CDMW_HOME/bin/$1 2>&1 | tee $TESTS_REPORTS_LOGS_ROOT/simple-test.$1.single-process.out
if [[ $? -ne 0 ]] ; then EXIT_CODE=1 ; fi
exit $EXIT_CODE

