/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___CCM_FT_TEST_CCM_SERVER_WITH_FACET_IMPL_HPP__
#define ___CCM_FT_TEST_CCM_SERVER_WITH_FACET_IMPL_HPP__

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#include <ccm_ft_with_timer/User_ccm_ft_with_timer.skel.hpp>
#include <CCMContainer/ccmcif/SessionContextExt_impl.hpp>
#include  <Time/idllib/CosClockService.stub.hpp>



namespace CcmFtWithTimerTest
{
//
// IDL:thalesgroup.com/CcmFtWithTimerTest/ServerModule/CCM_ServerWithFacet:1.0
//
class CCM_ServerWithFacet_impl : 
    virtual public ::UserCcmFtWithTimerTest::User_CCM_ServerWithFacet,
    virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    
    CCM_ServerWithFacet_impl(const CCM_ServerWithFacet_impl&);
    void operator=(const CCM_ServerWithFacet_impl&);

    CORBA::String_var m_expectedClientHostname;

    ::CcmFtWithTimerTest::ServerModule::CCM_ServerWithFacet_Context_var m_session_context;

   // extended context with CDMW services
   CdmwComponents::SessionContextExt_var _sessionContextExt;
   // clock catalog
   CosClockService::ClockCatalog_var _clockCatalog;
    // this component reference
   CcmFtWithTimerTest::ServerModule::ServerWithFacet_var _serveur_ref;

   CosClockService::PeriodicExecution::Controller_ptr controller;


public:

    CCM_ServerWithFacet_impl();
    ~CCM_ServerWithFacet_impl();

    
    //
    // attribute expectedClientHostname
    //
    virtual char * expectedClientHostname ()
        throw (CORBA::SystemException);
    virtual void expectedClientHostname (const char * a)
        throw (CORBA::SystemException);
      
    //
    // facet serverHostInfo
    //
    virtual ::CcmFtWithTimerTest::FacetModule::CCM_HostInfo_ptr get_serverHostInfo ()
        throw (CORBA::SystemException);
    
    virtual char* get_hostname()
        throw (CORBA::SystemException);
    

    //
    // Session component specific operations
    //
    void set_session_context(Components::SessionContext_ptr ctx)
        throw(CORBA::SystemException);
    void ccm_activate()
        throw(CORBA::SystemException);
    void ccm_passivate()
        throw(CORBA::SystemException);
    void ccm_remove()
        throw(CORBA::SystemException);


    ::CcmFtWithTimerTest::ServerModule::CCM_ServerWithFacet_Context* get_context()
    {
        return ::CcmFtWithTimerTest::ServerModule::CCM_ServerWithFacet_Context::_duplicate(m_session_context.in());
    }

    // implement Periodic interface
    CORBA::Boolean do_work(const CORBA::Any& args)
      throw (CORBA::SystemException);

      
};


}; // End of namespace CcmFtWithTimerTest

#endif // ___CCM_FT_TEST_CCM_SERVER_WITH_FACET_IMPL_HPP__

