/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_TESTCLASS_HPP
#define INCL_TESTCLASS_HPP

#include "Foundation/common/String.hpp"
#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/testutils/TestManager.hpp"
#include <cppunit/extensions/HelperMacros.h>

#include <iostream>


class TestClass : public CppUnit::TestFixture
{
    CPPUNIT_TEST_SUITE(TestClass);
      CPPUNIT_TEST(testpacktime);
      CPPUNIT_TEST(testunpacktime);
      CPPUNIT_TEST(testpackerror);
    CPPUNIT_TEST_SUITE_END();

    public:
      TestClass();

    CosClockService::ControlledClock_var   m_controlledClock;
    CORBA::Object_var m_obj;
    void testpacktime();
    void tearDown() ;
    void setUp() ;
    void string2cdmw_tm (std::string date,const char* format, cdmw_tm& tmdate);
    void testunpacktime();
    void testpackerror ();

};
#endif

