/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef CDMW_RECORDING_DEBUGPLUGIN_HPP
#define CDMW_RECORDING_DEBUGPLUGIN_HPP

#include "TraceAndPerf/recordinglibrary/Recording_Default_Parameters.hpp"
#include "TraceAndPerf/recordinglibrary/Plugin.hpp"

namespace Cdmw
{
   namespace Recording
   {
      /**
       *Purpose: Store request/reply pairs in a file
       *<p> .
       *
       */
      class DebugPlugin : public virtual Plugin
      {
         public:
            DebugPlugin ()
                  throw() ;

            virtual ~DebugPlugin ()
                  throw() ;

            /**
             *Purpose: return the plugin type, different plugin classes
             * must return different values
             *<p> .
             *
             */
            virtual PluginType type()
                  throw() { return DEBUG_PLUGIN_TYPE ; }

            /**
             *Purpose: Set the debug destination file
             *<p>      .
             *
             */
            virtual bool Destination (const char * destination)
                  throw() ;

            /**
             *Purpose: Get the debug destination file
             *<p>      caller shall call CORBA::string_free().
             *
             */
            virtual char * Destination ()
                  throw() ;

            /**
             *Purpose: Store the request-reply pair given as argument
             *<p> .
             *
             */
            virtual void recordOperation (Message * request, Message * reply)
                  throw() ;

            /**
             *Purpose: initialize the plugin
             *<p> .
             *
             */
             virtual void initialize (CORBA::ORB_ptr orb)
                throw() ;

            /**
             *Purpose: flush the contents of the plugin
             *<p> .
             *
             */
            virtual void finalize ()
                  throw() ;


         private :
            int m_fd ;
            int m_file_size ;
            char * m_file_name ;

      } ;
   }
}

#endif
