/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef CDMW_RECORDING_NETWORKSNIFFER_HPP
#define CDMW_RECORDING_NETWORKSNIFFER_HPP

#include <Foundation/osthreads/Thread.hpp>
#include <TraceAndPerf/recordinglibrary/PacketStore.hpp>

namespace Cdmw
{
   namespace Recording
   {
      /**
       *Purpose:
       *<p> .
       *
       */
      class NetworkSniffer
      {
         public :

            /**
             *Purpose:
             *<p> This class collects the packets from the local TCP ports
             * indicated.
             *
             */
            enum Status { OK, FAILED, INVALID } ;

            NetworkSniffer (PacketStore & store)
                  throw();

            virtual ~NetworkSniffer ()
                  throw() ;

            /**
             *Purpose: Sets the new list of ports to be recorded
             *<p> .
             *
             */
            virtual void TCPPorts (unsigned short * ports)
                  throw() ; // ports must be null terminated

            /**
             *Purpose:
             *<p> .
             *
             */
            virtual unsigned short * TCPPorts ()
                  throw() ; // null terminated

            /**
             *Purpose:
             *<p> .
             *
             */
            virtual unsigned long TCPPorts_Num ()
                  throw() ; // null terminated

           /**
             *Purpose:
             *<p> .
             *
             */
            virtual Status start ()
                  throw() ;

            /**
             *Purpose:
             *<p> .
             *
             */
            virtual Status stop ()
                  throw() ;

            /**
             *Purpose:
             *<p> .
             *
             */
            virtual Status terminate ()
                  throw() ;

            /**
             *Purpose:
             *<p> .
             *
             */
            virtual Status addPort (unsigned short port)
                  throw() ;

            /**
             *Purpose:
             *<p> .
             *
             */
            virtual Status removePort (unsigned short port)
                  throw() ;

            /**
             *Purpose:
             *<p> .
             *
             */
            virtual Status run ()
                  throw() ;

            // Forward declaration of worker thread implementation
            class Worker ;

         private :
            /**
             * Body 
             */

            OsSupport::Mutex m_mutex ;

            unsigned short * m_TCPPorts ;
            unsigned short * m_TCPPorts_Use ; // added to fix PCR-1523
            int m_TCPPorts_Length ;
            int m_TCPPorts_Num ;

            bool m_started ;
            bool m_stopped ;
            bool m_terminated ;

            Worker * m_worker ;

            PacketStore & m_store ;
      } ;

   }

}

#endif
