/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include "testbuffersender/MyBufferSender.hpp"

namespace Cdmw
{
namespace Recording
{
    
/**
*Implementation notes: [if no pertinent write none ]
*<p>
*Portability issues: [if no pertinent write none ]
*<p>
*/

MyBufferSender::MyBufferSender() throw()
: BufferSender()
{
}

MyBufferSender::~MyBufferSender()
    throw()
{
}

void MyBufferSender::sendBuffer(Buffer * buffer)
    throw()
{
    std::cout << "SEND" << std::endl;
    
    FILE * pFile;
    pFile = fopen("buffers.txt","a+");
    
    fprintf(pFile, "%u\n", buffer->date.tv_sec);
    fprintf(pFile, "%u\n", buffer->date.tv_usec);
    
    fprintf(pFile, "%u\n", buffer->header.base_time);
    fprintf(pFile, "%s\n", ((std::string)buffer->header.hostname).c_str());
    fprintf(pFile, "%d\n", buffer->header.num_pairs);

    fprintf(pFile, "%u\n", buffer->size);
    
    for (unsigned int i = 0; i < buffer->size; i++)
    {
        fprintf(pFile, "%u\n", buffer->data[i]);
    }
    fprintf(pFile, "\n\n");
    
    fclose(pFile);
}


}; // End namespace Recording
}; // End namespace Cdmw

