/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_RECORDING_TEST_DEBUG_PLUGIN_HPP 
#define INCL_RECORDING_TEST_DEBUG_PLUGIN_HPP 

#include "Foundation/testutils/CORBATestManager.hpp"
#include "TraceAndPerf/recordinglibrary/DebugPlugin.hpp"

namespace Cdmw
{
namespace Recording
{

class TestDebugPlugin : public CppUnit::TestFixture
{
    public:

        TestDebugPlugin();

        virtual  ~TestDebugPlugin()  throw();

        void setUp();

        void tearDown();         
       
        void test_initialize_1();
        void test_finalize_2();
        void test_finalize_3();
        void test_destination_4();
        void test_destination_5();
        void test_destination_6();
        void test_type_7();
        void test_record_8();
        void test_record_9();
        void test_record_10();
        void test_record_11();
        void test_record_12();
        void test_record_13();
                                       
    private:

           Message * load_message(std::string filename);
  
           bool check_output_empty(std::string file);
           bool check_output_not_empty(std::string file);
           bool check_output_changed(std::string file); 
           void save(std::string file);
    
    CORBA::ORB_ptr orb ;
    Message * request;
    Message * reply;
    std::string copy;
    
    std::string destination5 ;
    std::string destination8 ;
    std::string destination11 ;
    std::string destination13 ;
        
    CPPUNIT_TEST_SUITE( TestDebugPlugin );
    
        CPPUNIT_TEST(test_initialize_1);
        CPPUNIT_TEST(test_finalize_2);
        CPPUNIT_TEST(test_finalize_3);
        CPPUNIT_TEST(test_destination_4);
        CPPUNIT_TEST(test_destination_5);
        CPPUNIT_TEST(test_destination_6);
        CPPUNIT_TEST(test_type_7);
        CPPUNIT_TEST(test_record_8);
        CPPUNIT_TEST(test_record_9);
        CPPUNIT_TEST(test_record_10); 
        CPPUNIT_TEST(test_record_11);
        CPPUNIT_TEST(test_record_12);
        CPPUNIT_TEST(test_record_13);
        
    CPPUNIT_TEST_SUITE_END();

}; // End class TestDebugPlugin

}; // End namespace Recording
}; // End namespace Cdmw

#endif // INCL_RECORDING_TEST_DEBUG_PLUGIN_HPP

