/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef CDMW_RECORDING_MY_OBJECTMAP_HPP
#define CDMW_RECORDING_MY_OBJECTMAP_HPP

#include <string.h>

#include "Foundation/orbsupport/CORBA.hpp"
#include "TraceAndPerf/recordinglibrary/NetworkSniffer.hpp"
#include "TraceAndPerf/recordinglibrary/PacketStore.hpp"
#include "TraceAndPerf/recordinglibrary/InterfaceFilter.hpp"
#include "TraceAndPerf/recordinglibrary/ObjectMap.hpp"

namespace Cdmw
{
   namespace Recording
   {

      class MyObjectMap : public ObjectMap
      {
         public :
            MyObjectMap (InterfaceFilter & filter, NetworkSniffer & sniffer)
                  throw();

            virtual ~MyObjectMap ()
                  throw() ;

            bool checkKey(Message * msg)
                  throw() ;

            int get_checkKey_count();
         private :
         
         int count_checkKey;
      } ;
   }
}

#endif //CDMW_RECORDING_MY_OBJECTMAP_HPP
