/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "testmessageidentifier/MyRequestPairing.hpp"

namespace Cdmw
{
namespace Recording
{
    
/**
*Implementation notes: [if no pertinent write none ]
*<p>
*Portability issues: [if no pertinent write none ]
*<p>
*/

MyRequestPairing::MyRequestPairing(Cdmw::Recording::PacketStore & store)
: RequestPairing(store)
, count_storeRequest(0)
, count_checkReply(0)
{
}

MyRequestPairing::~MyRequestPairing()
    throw()
{
}

void MyRequestPairing::storeRequest(Cdmw::Recording::Message * message)
    throw()
{
    count_storeRequest++;
}

void MyRequestPairing::checkReply(Cdmw::Recording::Message * message)
    throw()
{
    count_checkReply++;
}

int MyRequestPairing::get_storeRequest_count()
{
    return count_storeRequest;
}

int MyRequestPairing::get_checkReply_count()
{
    return count_checkReply;
}

}; // End namespace Recording
}; // End namespace Cdmw

