/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef INCL_RECORDING_OPER_MAP_HPP 
#define INCL_RECORDING_OPER_MAP_HPP 

#include "Foundation/testutils/TestManager.hpp"
#include <string>
#include <set>

namespace Cdmw
{
namespace Recording
{

/**
*Purpose:
*<p>   Test of Operation Map
*/
class TestOperationMap : public CppUnit::TestFixture
{
    public:

        TestOperationMap();

        virtual  ~TestOperationMap()  throw();

        virtual void   do_tests();

        // test cases from 
        // recordinglibrary/PTdev-doc/TCC-TestCase-Recording-OperationMap-02.doc
        virtual void test_create();
        virtual void test_add();
        virtual void test_remove();
        virtual void test_check(); 

        virtual void test_exclusion(); 

        static void save (std::string const & str1, std::size_t i);

        static std::multiset<std::string> oper_set ;

    protected:
    private:

CPPUNIT_TEST_SUITE( TestOperationMap );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();


}; // End class TestOperationMap 

}; // End namespace Recording
}; // End namespace Cdmw

#endif // INCL_RECORDING_OPER_MAP_HPP

