/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef INCL_RECORDING_TEST_RECORDING_PLUGIN_HPP 
#define INCL_RECORDING_TEST_RECORDING_PLUGIN_HPP 

#include "Foundation/testutils/CORBATestManager.hpp"
#include "TraceAndPerf/recordinglibrary/RecordingPlugin.hpp"

namespace Cdmw
{
namespace Recording
{

class TestRecordingPlugin : public CppUnit::TestFixture
{
    public:

        TestRecordingPlugin();

        virtual  ~TestRecordingPlugin()  throw();

        void setUp();
  
        void tearDown(); 
       
    protected:       
    private:
    
        CORBA::ORB_var orb;
        std::string url ;
   
        void test_initialize_finalize_1();
        void test_initialize_finalize_2();
        void test_initialize_finalize_3();
        void test_initialize_finalize_4();
        
        void test_type_5();  
        
        void test_destination_6();       
        void test_destination_7();       
        void test_destination_8();
        
        void test_record_9();       
        void test_record_10();       
        void test_record_11();       
        void test_record_12();       
        void test_record_13();
                
        void test_destination(); 
        void test_parameterization(); 
        
        void start_rec_server_emulator(); 
   
        Message * load_message(std::string filename);
         
        bool check_server_data(int buffers_count);
    
    CPPUNIT_TEST_SUITE( TestRecordingPlugin );
        //CPPUNIT_TEST( test_initialize_finalize_1 );
        CPPUNIT_TEST( test_initialize_finalize_2 ); 
        //CPPUNIT_TEST( test_initialize_finalize_3 );
        CPPUNIT_TEST( test_initialize_finalize_4 );
        CPPUNIT_TEST( test_type_5 );          
        CPPUNIT_TEST( test_destination_6 );       
        CPPUNIT_TEST( test_destination_7 );       
        CPPUNIT_TEST( test_destination_8 ); 
        CPPUNIT_TEST( test_record_9 );       
        CPPUNIT_TEST( test_record_10 );    
        CPPUNIT_TEST( test_record_11 );   
        CPPUNIT_TEST( test_record_12 );    
        CPPUNIT_TEST( test_record_13 ); 
        CPPUNIT_TEST( test_destination );
        CPPUNIT_TEST (test_parameterization);
    CPPUNIT_TEST_SUITE_END();


}; // End class TestRecordingPlugin 

}; // End namespace Recording
}; // End namespace Cdmw

#endif // INCL_RECORDING_TEST_RECORDING_PLUGIN_HPP

