/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
 
#ifndef INCL_RECORDING_MY_REQUEST_PAIRING_HPP 
#define INCL_RECORDING_MY_REQUEST_PAIRING_HPP 

#include "recordinglibrary/RequestPairing.hpp"
#include <fstream>


namespace Cdmw
{
namespace Recording
{

class MyRequestPairing : public RequestPairing
{
    public:
    
           MyRequestPairing (PacketStore & store) 
                  throw() : RequestPairing(store) 
                  {
                    om = new std::ofstream("messages.txt"); 
                  } ;
           ~MyRequestPairing()  throw() ;
                           
 
            void storeRequest (Message * request)
                  throw() ;

 
            void checkReply (Message * reply)
                  throw() ;
                  
            void write(Message * msg, int request_flag);      

             
            private:
            
            std::ofstream * om ;
       
}; // End class MyRequestPairing


}; // End of Recording namespace 
}; // End of Cdmw namespace 

#endif // INCL_RECORDING_MY_REQUEST_PAIRING_HPP 

