/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef INCL_RECORDING_TEST_REQUEST_PAIRING_HPP 
#define INCL_RECORDING_TEST_REQUEST_PAIRING_HPP 

#include "recordinglibrary/RequestPairing.hpp"
#include "testrequestpairing/MyPlugin.hpp"

#include "Foundation/testutils/TestManager.hpp"
#include <string>
#include <set>

namespace Cdmw
{
namespace Recording
{

/**
*Purpose:
*<p>   Test of Request Pairing
*/
class TestRequestPairing : public CppUnit::TestFixture
{
    public:

        TestRequestPairing();

        virtual  ~TestRequestPairing()  throw();

        virtual void   do_tests();
       
        void test_1(RequestPairing * pairing, MyPlugin * plug, PluginType type);   
                    
        void test_2(RequestPairing * pairing, MyPlugin * plug); 
                    
        void test_3(RequestPairing * pairing, MyPlugin * plug);
                       
        void test_4(RequestPairing * pairing, MyPlugin * plug);        
                           
        void test_5(RequestPairing * pairing, MyPlugin * plug1, MyPlugin * plug2, PluginType type2);
                     
        void test_6(RequestPairing * pairing, MyPlugin * plug1, MyPlugin * plug2);  
                    
        void test_7(RequestPairing * pairing, MyPlugin * plug1, MyPlugin * plug2);  

        void test_8(RequestPairing * pairing, MyPlugin * plug1, MyPlugin * plug2);  
                    
        void test_9(RequestPairing * pairing);               

        void test_10(RequestPairing * pairing); 
        
        void test_11(RequestPairing * pairing, MyPlugin * plug, PluginType type);
                             
        void test_12(RequestPairing * pairing, MyPlugin * plug, PluginType type);
        
        void test_13(); 
        void test_14();
        void test_15();
        void test_16();
        void test_17();
        
    protected:
    private:
    
        void check_request_id(Message * m1, Message * m2);
        void check_oneway(Message * m);
        
        void print(std::string label, Message * msg);
        void print(int testnr, MyPlugin * plug);
              
        Message * load_message(std::string filename);  

CPPUNIT_TEST_SUITE( TestRequestPairing );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();


}; // End class TestRequestPairing 

}; // End namespace Recording
}; // End namespace Cdmw

#endif // INCL_RECORDING_TEST_REQUEST_PAIRING_HPP

