/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
 
#include "testrequestpairing/MyPlugin.hpp"
#include <iostream>
#include <stdio.h>

namespace Cdmw
{
namespace Recording
{
     

MyPlugin::~MyPlugin() throw()
{
}
      
PluginType MyPlugin::type() throw()
{
    return m_type ;    
}

bool MyPlugin::Destination (const char * destination) throw()
{
    return true;
}
                  
char * MyPlugin::Destination() throw() 
{
    return 0;
}

void MyPlugin::recordOperation (Message * request, Message * reply) throw()
{
    if(request != 0) { count_request++; }
    
    if(reply != 0)   { count_reply++; }
}

void MyPlugin::initialize(CORBA::ORB_ptr orb) throw()
{
    count_request = 0;
    count_reply = 0;
}

void MyPlugin::finalize() throw()
{ 
    count_request = 0;
    count_reply = 0;    
}

 
}; // End of Recording namespace 
}; // End of Cdmw namespace 

