/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef _IDL_CDMWRECORDINGCONTAINERMANAGER_IMPL_H_
#define _IDL_CDMWRECORDINGCONTAINERMANAGER_IMPL_H_

#include "TraceAndPerf/recordinglibrary/ObjectMap.hpp"
#include "Foundation/idllib/CdmwRecordingContainerManager.skel.hpp"

// ----------------------------------------------------------------------
// Service declarations f o r - MODULE IDL:thalesgroup.com/CdmwRecording:1.0
namespace CdmwRecording {

  // -------------------------------------------------------------------
  // Servant Impl class for interface CdmwRecording::ContainerManager
  class ContainerManager_impl 
    : public virtual POA_CdmwRecording::ContainerManager
    , public virtual PortableServer::RefCountServantBase
  {
    public:
    ContainerManager_impl (CORBA::ORB_ptr orb,
                           PortableServer::POA_ptr parent,
                           Cdmw::Recording::ObjectMap & object_map
                          ) 
        throw(CORBA::SystemException);

      // -----------------------------
      // Methods of this interface 
      // -----------------------------
      // SYNCHRONOUS CALLS
      virtual void record_objects
        (const char *  server_id,
         const Object_List& to_record) throw(CORBA::SystemException);
      virtual void discard_objects
        (const Object_List& to_discard) throw(CORBA::SystemException);
      // ----------------------------------
      // Attributes generated as members
      // ----------------------------------
      // none
private:
    /**
    * ORB reference
    */ 
    CORBA::ORB_var m_orb;

    /**
    * POA reference
    */ 
    PortableServer::POA_var m_poa;

    // ObjectMap
    Cdmw::Recording::ObjectMap & m_object_map;

    // CDO-070330-PRS-1-567 : #106
    Cdmw::OsSupport::Mutex m_mutex ;
  } ; // end class CdmwRecording::ContainerManager_impl
}
// E n d Service declarations f o r - MODULE IDL:thalesgroup.
// com/CdmwRecording:1.0
// ----------------------------------------------------------------------
#endif

