/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_RECORDINGGENERICRECORDERIMPL_HPP 
#define INCL_RECORDINGGENERICRECORDERIMPL_HPP 

#include <Foundation/logging/Logger.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountServantBase.hpp>

#include <TraceAndPerf/recordingidl/CdmwRecordingGenericRecorder.skel.hpp>

namespace CdmwRecording
{

class GenericRecorder_impl : public virtual POA_CdmwRecording::GenericRecorder,
                             virtual public Cdmw::OrbSupport::RefCountServantBase
{
public:

    GenericRecorder_impl::GenericRecorder_impl(
            PortableServer::POA_ptr poa,
            CORBA::ORB_ptr orb,
            Cdmw::Logging::Logger* logger)
        throw(CORBA::SystemException);

    GenericRecorder_impl::~GenericRecorder_impl()
        throw();
        
    virtual void record_data (
            const ::CdmwRecording::NamedValueSeq & context,
            const ::CdmwRecording::NamedValueSeq & data
      )
      throw(::CORBA::SystemException);
   
    virtual PortableServer::POA_ptr _default_POA();
    
private:
   
   PortableServer::POA_var m_poa;
   CORBA::ORB_var  m_orb ;
   Cdmw::Logging::Logger* m_logger ;
};

}

#endif // INCL_RECORDINGGENERICRECORDERIMPL_HPP
