/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.recording.gui;

import javax.swing.JLabel;

import com.thalesgroup.CdmwRecording.DaemonControl;

/**
 * This is a ChooserPanel that deals with a specific type of object, interfaces. Or, 
 * more accurately, strings.
 * 
 * @see ChooserPanel
 * 
 * @author Paul Graham
 */
public class InterfaceChooserPanel extends ChooserPanel
{
   /**
    * Generated SerialVersionUID.
    */
   private static final long serialVersionUID = 3017197076240166556L;

   /**
    * Constructor. 
    */
   public InterfaceChooserPanel ()
   {
      availableLabel = new JLabel ("Available Interfaces");
      
      selectedLabel = new JLabel ("Selected Interfaces");

      objectType = new String ("Interface");
   }
   
   /**
    * This method is called from the ChooserPanel class in live mode
    * when the Add or Add All buttons are pressed.
    */
   public void liveAdd (Object[] objects)
   {
      DaemonControl daemon = ControlBrowser.controlBrowser.getDaemon ();
      
      String[] selectedInterfaces = new String[objects.length];
      for (int i = 0; i < selectedInterfaces.length; i++)
      {
         selectedInterfaces[i] = (String) objects[i];
      }

      daemon.add_interfaces (selectedInterfaces);
   }
   
   /**
    * This method is called from the ChooserPanel class in live mode
    * when the Remove or Remove All buttons are pressed.
    */
   public void liveRemove (Object[] objects)
   {
      DaemonControl daemon = ControlBrowser.controlBrowser.getDaemon ();
      
      String[] selectedInterfaces = new String[objects.length];
      for (int i = 0; i < selectedInterfaces.length; i++)
      {
         selectedInterfaces[i] = (String) objects[i];
      }

      daemon.remove_interfaces (selectedInterfaces);
   }
}
