/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_BIG_IMPL_HPP 
#define INCL_BIG_IMPL_HPP
 
#include <iostream>
#include "testdecoder/Big.skel.hpp"
#include "tao/Exception.h"

class ChildOfAbstr_impl : public virtual POA_ChildOfAbstr
{
public:
   
    void ping() throw(CORBA::SystemException) {} ; 
};

/**
* Purpose:
* <p>
* Implementation of Big IDL interface
*/
class Big_impl : public virtual POA_Big
{
public:
 
    void xx_any (const CORBA::Any & a) throw(CORBA::SystemException){ } ; 
    
    void xx_typecode (CORBA::TypeCode_ptr t) throw(CORBA::SystemException){} ; 
    
    /* principal */
    
    void xx_object (CORBA::Object_ptr  s) throw(CORBA::SystemException){} ; 
         
    void xx_string  (const char * s)         throw(CORBA::SystemException){} ;    
    void xx_wstring (const CORBA::WChar * s) throw(CORBA::SystemException){} ; 
     
    void xx_enum    (color c)    throw(CORBA::SystemException) {}; 
    void xx_alias   (shortM sh)  throw(CORBA::SystemException) {}; 
    
    void xx_struct  (const TimeOfDay & t) throw(CORBA::SystemException) {};
    
    /* value */
    /* value box */
        
    void xx_exception() throw(Big::NotFound,CORBA::SystemException) {} ;
    
    void xx_union    (const AgeOpt & a)    throw(CORBA::SystemException){};
    void xx_array    (const stones arr)    throw(CORBA::SystemException){};
    void xx_sequence (const numbers & seq) throw(CORBA::SystemException){};
    
    void xx_abstract(abstr_ptr a)  throw(CORBA::SystemException){}; 
    
    /* null */
    
    void xx_short      (CORBA::Short a)    throw(CORBA::SystemException){};
    void xx_long       (CORBA::Long  a)    throw(CORBA::SystemException){};
    void xx_longlong   (CORBA::LongLong a) throw(CORBA::SystemException){};
    void xx_ushort     (CORBA::UShort a)   throw(CORBA::SystemException){};
    void xx_ulong      (CORBA::ULong  a)   throw(CORBA::SystemException){};
    void xx_ulonglong  (CORBA::ULongLong a)  throw(CORBA::SystemException){};
    void xx_float      (CORBA::Float  a)     throw(CORBA::SystemException){};
    void xx_double     (CORBA::Double a)     throw(CORBA::SystemException){};
    void xx_longdouble (CORBA::LongDouble a) throw(CORBA::SystemException){};   
     
    void xx_boolean  (bool a) throw(CORBA::SystemException){} ;
    void xx_char     (char a) throw(CORBA::SystemException){} ;
    
    void xx_wchar  (CORBA::WChar a) throw(CORBA::SystemException){};
    void xx_octet  (CORBA::Octet a) throw(CORBA::SystemException)
    {
        throw CORBA::BAD_PARAM (0, CORBA::COMPLETED_NO);
    };
};

#endif // INCL_BIG_IMPL_HPP
