/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef INCL_RECORDING_TEST_DISPLAY_HPP 
#define INCL_RECORDING_TEST_DISPLAY_HPP 

#include "recordingtools/InterfaceMap.hpp"
#include "recordingtools/Display.hpp"
#include "recordingtools/Decoder.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"
#include <string>

namespace Cdmw
{
namespace Recording
{

/**
*Purpose:
*<p>   Test of Request Pairing
*/
class TestDisplay : public CppUnit::TestFixture
{
    public:

        TestDisplay();

        virtual  ~TestDisplay()  throw();
               
        void test_setoutput_1();
        void test_setoutput_2();
        void test_display_file_3();
        void test_display_file_4();
        void test_display_file_5();
        void test_display_file_6();
        void test_display_file_7();
        void test_display_file_8();
        void test_setflags_9();
         
        void setUp();
        void tearDown();
    
    private:
    
       void write_new_data_to(std::string filename);
             
       bool check_output_empty(std::string file);
       bool check_output_not_empty(std::string file);
       bool check_output_changed(std::string file);
       bool check_only_headers(std::string file); 
       void save(std::string file);
       
       std::string url; 
       std::string copy;           
             

CPPUNIT_TEST_SUITE( TestDisplay );
   CPPUNIT_TEST( test_setoutput_1 );
   CPPUNIT_TEST( test_setoutput_2 );
   CPPUNIT_TEST( test_display_file_3 );
   CPPUNIT_TEST( test_display_file_4 );
   CPPUNIT_TEST( test_display_file_5 );
   CPPUNIT_TEST( test_display_file_6 );
   CPPUNIT_TEST( test_display_file_7 );
   CPPUNIT_TEST( test_setflags_9 );
CPPUNIT_TEST_SUITE_END();


}; // End class TestDisplay 

}; // End namespace Recording
}; // End namespace Cdmw

#endif // INCL_RECORDING_TEST_DISPLAY_HPP

