/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef INCL_RECORDING_TEST_INTERFACEMAP_HPP 
#define INCL_RECORDING_TEST_INTERFACEMAP_HPP 

#include "recordingtools/InterfaceMap.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"
#include <string>

namespace Cdmw
{
namespace Recording
{

/**
*Purpose:
*<p>   Test of Request Pairing
*/
class TestInterfaceMap : public CppUnit::TestFixture
{
    public:

        TestInterfaceMap();

        virtual  ~TestInterfaceMap()  throw();
        
        void test_creation_1();
        void test_creation_2();
        void test_creation_3();
             
        void test_getOperation_4();
        void test_getOperation_5();
        void test_getOperation_6();
        void test_getOperation_7();
        void test_getOperation_8();
        void test_getOperation_9();
        void test_getOperation_10();
        
        void setUp();
        void tearDown();
         
    private:
    
        std::string url;     
        std::string interface;  
        std::string operation;
             

CPPUNIT_TEST_SUITE( TestInterfaceMap );
   CPPUNIT_TEST( test_creation_1 );
   CPPUNIT_TEST( test_creation_2 );
   CPPUNIT_TEST( test_creation_3 );
   CPPUNIT_TEST( test_getOperation_4 );
   CPPUNIT_TEST( test_getOperation_5 );
   CPPUNIT_TEST( test_getOperation_6 );
   CPPUNIT_TEST( test_getOperation_8 );
   CPPUNIT_TEST( test_getOperation_9 );
   CPPUNIT_TEST( test_getOperation_10 );
CPPUNIT_TEST_SUITE_END();


}; // End class TestInterfaceMap 

}; // End namespace Recording
}; // End namespace Cdmw

#endif // INCL_RECORDING_TEST_INTERFACEMAP_HPP

