/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "testinterfacemap/TestInterfaceMap.hpp"
#include "testinterfacemap/Transmission_impl.hpp"
#include "Foundation/orbsupport/CORBASystemExceptionWrapper.hpp"
#include <Foundation/ossupport/OS.hpp>

int main(int argc, char** argv )
{   
    using namespace Cdmw::OsSupport;

    try
    {
        
#if (CDMW_ORB_VDR == tao )
    std::cout << "start interface repository " << std::endl;
    std::string ifrservice = "IFR_Service";
    std::string ifrclient = "tao_ifr";
    
    OS::sleep (2000);
    OS::ProcessId idIFR = OS::create_process(
                   ifrservice,
                   "-ORBEndpoint iiop://:6070" );
    OS::sleep (2000);
    (void) OS::create_process(
                   ifrclient,
                   "-ORBInitRef InterfaceRepository=corbaloc::localhost:6070/InterfaceRepository Transmission.idl" );

    OS::sleep (2000);
#endif
   
        Cdmw::TestUtils::TestManager::instance()->init(argc,argv);
         
        Cdmw::TestUtils::TestManager::instance()->run_tests();
        Cdmw::TestUtils::TestManager::instance()->summary();

#if (CDMW_ORB_VDR == tao )
    OS::sleep (2000);
    try 
    {
        // And we kill the Name Server
        OS::kill_process(idIFR);
    }
    catch(const std::exception & ex) 
    {
        std::cerr << "Cannot kill Name Server process.:" << std::endl;
    }
#endif
    } 
    catch (const Cdmw::OrbSupport::CORBASystemExceptionWrapper & ex)
    {
        std::cerr << "+++ 1 +++ " << ex.what() << std::endl;
    }
    catch (const Cdmw::Exception & ex)
    {
        std::cerr << "+++ 2 +++ " << ex.what() << std::endl;
    } 
    catch(const CORBA::Exception& ex)  
    {        
        std::cerr << "+++ 3 +++ " << ex << std::endl;
    }
    catch(...)  
    {        
        std::cerr << "unexpected exception" << std::endl;
    }
}


