/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "tracecollector/TracePrinter.hpp"

namespace Cdmw
{
   namespace Trace
   {
      const char* TracePrinter::END_OF_TRACE_FILE  = "--------------- END OF TRACE FILE ----------------";
      const char* TracePrinter::TRACE_HEADER1      = "**************************************************";
      const char* TracePrinter::TRACE_HEADER2      = "                   LOG FILE ";
      const char* TracePrinter::TRACE_HEADER3      = " (Cont)";
      const char* TracePrinter::TRACE_ERR_MESG1    = "--------------------------------------------------";
      const char* TracePrinter::TRACE_ERR_MESG2    = "---------- Error Message from Trace --------------";

      //
      // timestamp_to_string() utility function
      //
      std::string TracePrinter::timestamp_to_string(OsSupport::OS::Timeval tv, const char* format) const
      {
         // format date
         char time_buf[128];
         OsSupport::OS::get_fmt_time (time_buf, sizeof(time_buf), 
                                      tv.seconds,
                                      const_cast<char*>(format), m_time_mode);
         return std::string(time_buf);
      }
   }
}

