/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "testhelptracecollector/TestHelpTraceCollector.hpp"

#include <stdlib.h>

#include <string>
#include <exception>
#include <iostream>
#include <sstream>




CPPUNIT_TEST_SUITE_REGISTRATION (TestHelpTraceCollector);

// ----------------------------------------------------------------------
// TestHelpTraceCollector class.
// ----------------------------------------------------------------------
TestHelpTraceCollector::TestHelpTraceCollector ()
  throw()
{  
}

TestHelpTraceCollector::~TestHelpTraceCollector()
  throw()
{
}

void TestHelpTraceCollector::do_tests()
{
    long result = 0;
    
    TEST_INFO ("get result from help command of TraceCollector");
    
    result = ::atoi(Cdmw::TestUtils::TestManager::instance()->get_property ("result1").c_str());

    // if return code is 0 all is ok
    if (result == 0)
    {
        CPPUNIT_ASSERT(true);
    }
    else
    {
        CPPUNIT_ASSERT(false);
    }
    
    TEST_INFO ("get result from help command of global TraceCollector");
    
    result = ::atoi(Cdmw::TestUtils::TestManager::instance()->get_property ("result2").c_str());

    // if return code is 0 all is ok
    if (result == 0)
    {
        CPPUNIT_ASSERT(true);
    }
    else
    {
        CPPUNIT_ASSERT(false);
    }
}
