/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.trace;

import cdmw.logging.*;
import com.thalesgroup.CdmwLogging.LogHeader;
import com.thalesgroup.CdmwLogging.LogContext;

public class LogManagerTraceDelegate implements LogManagerDelegate
{
    private FlushAreaMngr flushAreaMngr;

    /**
     * Create a LogManagerTraceDelegate
     *
     *@param FlushAreaMngr mngr
     */    
    public LogManagerTraceDelegate(FlushAreaMngr mngr)
    {
        this.flushAreaMngr = mngr;
    }
    
    /**
     * add a log to the logger 
     *@param LogHeader header
     *@param String message
     */    
    public boolean addLog(LogContext context, LogHeader header, String message)
    {
        FlushAreaMngr.getInstance().addMessage(header, message);
        return true;
    }
}
