/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
 
#include "test18/MyPlugin.hpp"
#include <iostream>
#include <fstream>
#include <string>
#include <stdio.h>

namespace Cdmw
{
namespace Recording
{
     
MyPlugin::~MyPlugin() throw()
{ 
}   
PluginType MyPlugin::type() throw()
{

  return m_type ;    
}
bool MyPlugin::Destination (const char * destination) throw()
{  
    return true;
}                  
char * MyPlugin::Destination() throw() 
{   
    return NULL;
}

const char * the_operation;
const char * MyPlugin::getReceivedOperation ()
{
  return the_operation;
}


void MyPlugin::recordOperation (Message * request, Message * reply) throw()
{
    std::cout <<std::endl<< "=== test18.MyPlugin : recordOperation"<<std::endl ;
    if(request != NULL) 
    { 
        count_request++;
        the_operation = (const char *) (request -> data + request -> operation_Offset) ;
        std::cout << "=== test18.MyPlugin : operation name = " << the_operation;
    }
    else std::cout<< "=== test18.MyPlugin : request = NULL ,"; 
    
    if(reply != NULL)   
    { 
       std::cout<< ", twoway received" << std::endl ;
       count_reply++; 
       
       std::cout<< "=== test18.MyPlugin : reply (size= " << reply->GiopSize() << ")"<< std::endl ; // 12?        
    }
    else 
    {
       std::cout<< ", reply = NULL, " ;    
       // If oneway, sends directly to the plugins
         if ((request->data [16] & 1) == 0)
         {
            std::cout<< " oneway received" << std::endl ;
         }
         else
         {
            std::cout<< " orphaned received" << std::endl ;
           count_empty_reply++;
         }
    }
}

void MyPlugin::initialize(CORBA::ORB_ptr orb) throw()
{ 
}
void MyPlugin::finalize() throw()
{ 
}

}; // End of Recording namespace 
}; // End of Cdmw namespace 

