/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <errno.h>
#include <stdio.h>
//#include <semaphore.h>
#include <unistd.h>
#include <sys/sem.h>
#include <sys/ipc.h>
#include <sys/stat.h>   //S_IRUSR|S_IWUSR
#include <fcntl.h>      //O_CREAT

#include "test18/Transmission_impl.hpp"

#define IPC_ALL 0666

  key_t File_To_Key (const char * path)
   {
     int fd = ::open (path, O_RDWR | O_CREAT) ;
     ::close (fd) ;
     return ::ftok (path, 1) ;
   }

int m_id; 
bool create_semaphore ()
   {
     int index = 0;
     // create semaphore
     // printf ("!!! CORBA server : create semaphore\n");
     m_id = ::semget (File_To_Key("/tmp/test18_semaphore"), 1, IPC_CREAT | IPC_ALL);
     if (m_id < 0)
     {
        if (errno != 0)
        {
          perror ("*** test18_server: Error on semget.\n");
          return false;
        }
     }
     // set count to 0
     int res = ::semctl (m_id, index, SETVAL, 0) ;
     if (res < 0)
     {
        if (errno != 0)
        {
          perror ("*** test18_server: Error on semctl.\n");
          return false;
        }
     }
     return true;
   }

bool Transmission_impl::send(const char * data) throw(CORBA::SystemException)
{
   printf ("=== test18_server: send request received\n");
   // unlock semaphore
   // printf ("!!! CORBA server : unlock semaphore\n");
   int index = 0;
   struct sembuf Op = { index, 1, 0 } ;
   int res = ::semop (m_id, &Op, 1) ;
   if (res < 0)
   {
      if (errno != 0)
      {
        perror ("*** test18_server: Error on semop.\n");
        return false;
      }
   }
   printf ("=== test18_server: sleeping 120s ...\n");
   sleep(120); // server should be killed by test without sending reply
   printf ("*** test18_server: .......... awaken he he he\n");
   return true;
}

void Transmission_impl::oneway_method () throw(CORBA::SystemException)
{
   printf ("=== test18_server: oneway_method request received\n");
}

