/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <iomanip>
#include "test18/Transmission.stub.hpp"

using namespace std;

void send_messages(int size, int count, Transmission_var tm )
{
  //tm->oneway_method ();
  // tm->oneway_method ();
  //  tm->oneway_method ();

    // Send data
    for (int i = 1; i <= count; i++)
    {
        char data[size];
        for (int j = 0; j <= size-1; j++)
        {
            data[j] = 0xCF;
        }
        data[size] = '\0';

        tm->send(data);
        //tm->oneway_method ();
        //tm->oneway_method ();
        //tm->oneway_method ();
    }           
}  
int main(int argc, char * argv[])
{     
    if (argc < 1)
    {
        cout << "=== test18_client: too few arguments" << endl;
        cout << "=== test18_client: usage: <hostname> - name of the host where the server is running" << endl; 
        throw 0;
    }
  
    try 
    {
        // Initialize orb                                
        CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);
        
        std::string server_host = std::string(argv[1]);             
        std::string corbaloc = std::string ("corbaloc::") 
                             + server_host + std::string(":6789/Transmission" );     
        std::cout << "=== test18_client: corbaloc = " << corbaloc << std::endl;
        CORBA::Object_var obj = orb->string_to_object(corbaloc.c_str());
        
        if (CORBA::is_nil(obj)) 
        {
            cout << "*** test18_client: Nil reference" << endl;
            throw 0;
        }
    
        // Narrow
        Transmission_var tm = Transmission::_narrow(obj);
        if (CORBA::is_nil(tm)) 
        {
            cout << "*** test18_client: Argument is not a Transmission reference" << endl;
            throw 0;
        }
        std::cout << "=== test18_client: Sending messages (expecting CORBA exception : COMM_FAILURE)..." << std::endl;
        try
    {    
          send_messages(1,1,tm);
    }            
        catch (const CORBA::Exception & ex) 
        {
          cout << endl << "*** test18_client: as in the present scenario the server is killed, the exception : " << ex<< " is expected " << std::endl;
           return 1;
        }
    }
    catch (const CORBA::Exception & ex) 
    {
      cout << endl << "*** test18_client: as in the present scenario the server is killed, the exception : " << ex<< " is expected " << std::endl;
        return 1;
    }
    catch (...) 
    {
        cout << "*** test18_client: exception: " << endl;
        return 1;
    }
    
    return 0;
}

