/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package tests.OrbBench;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.PrintWriter;

import com.thalesgroup.CdmwRecording.ContainerManager;
import com.thalesgroup.CdmwRecording.ContainerManagerHelper;
import com.thalesgroup.CdmwRecording.DaemonControl;
import com.thalesgroup.CdmwRecording.DaemonControlHelper;

public class Server
{
   public static final String    NAME    = "orbbench.test";

   public static void main( String[] args )
   {
      org.omg.CORBA_2_3.ORB orb = (org.omg.CORBA_2_3.ORB) org.omg.CORBA.ORB.init(args, null);
      try
      {
         org.omg.PortableServer.POA poa =
            org.omg.PortableServer.POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

         poa.the_POAManager().activate();

         String currentPort = "59875";
         String corbaloc = new String ("corbaloc::localhost" + ":" + currentPort + "/RecordingDaemonController" );
         String corbaloc_contMgr = new String ("corbaloc::localhost" + ":" + currentPort + "/RecordingDaemonContainerMgr" );

         org.omg.CORBA.Object o_daemon = orb.string_to_object (corbaloc);
         org.omg.CORBA.Object o_contMgr = orb.string_to_object (corbaloc_contMgr);

         DaemonControl daemon  = DaemonControlHelper.narrow (o_daemon);
         ContainerManager contMgr = ContainerManagerHelper.narrow (o_contMgr);
 
         org.omg.CORBA.Object Obj_List[] = new org.omg.CORBA.Object [1];
         Obj_List[0] = poa.servant_to_reference (new PerfsImpl(orb, daemon));

         if( args.length == 1 )
         {

            if( args[0].equals("JacORB"))
            {
               File _file = new File("/tmp/test29.ior");
               FileWriter _fileWriter = new FileWriter(_file);
               _fileWriter.write(orb.object_to_string(Obj_List[0]));
               _fileWriter.close();
            }
            System.out.println("args.length = 1");
            // write the object reference to args[0]

            PrintWriter ps = new PrintWriter(new FileOutputStream(new File( args[0] )));
            ps.println( orb.object_to_string( Obj_List[0] ) );
            ps.close();
         }

         /* Add test coverage */
         contMgr.record_objects ("perfs", Obj_List);
         contMgr.discard_objects(Obj_List);
         contMgr.record_objects ("perfs", Obj_List);

         System.out.println("Running perfs service, ready to receive requests ...");
         orb.run();
         System.out.println("orb stopped");

      }
      catch ( Exception e )
      {
         e.printStackTrace();
      }


   }
}
