#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

BINDIR=@CDMW_PLATFORM_SCRIPTS_PATH@
. $BINDIR/set_env.sh 
cd $BINDIR/../share

mkdir -p V-TRC-026-results
rm -f /tmp/test26.log*

echo "starting gui in separate xterm"
xterm -e $BINDIR/cdmw_run_daemon_gui.sh &
sleep 5

echo root password to start recording daemon
su -m -s $BINDIR/start_test26_host1.sh
echo "On the GUI select @hostname1val@ and port 59875, then press lookup, then press enter to continue"
read c

echo "starting server in separate xterm"
xterm -e $BINDIR/test26_server --CdmwProcessPort=6789  &
sleep 3

ssh @hostname2val@  $BINDIR/start_test26_host2.sh @hostname1val@ 0

echo check debug file /tmp/test26.log : 
ls -l /tmp/test26.log 
s1=`wc -c /tmp/test26.log| cut -f1 -d ' '`
echo file size is s1=$s1


echo "On the GUI Deactivate Message recording  : press Stop button, then press enter to continue"
read c
ssh @hostname2val@  $BINDIR/start_test26_host2.sh @hostname1val@ 0


echo check debug file /tmp/test26.log : 
ls -l /tmp/test26.log 
s2=`wc -c /tmp/test26.log| cut -f1 -d ' '`
echo file size is s2=$s2

if test $s2 -gt $s1
then
   echo "ERROR: log file size has changed "
else
   echo "OK: log file size unchanged "
fi

echo "Check Result above. Then, on the GUI activate Message recording  : press Play button, then press enter to continue"
read c
ssh @hostname2val@  $BINDIR/start_test26_host2.sh @hostname1val@ 0


echo check debug file /tmp/test26.log : 
ls -l /tmp/test26.log 
s3=`wc -c /tmp/test26.log| cut -f1 -d ' '`
echo file size is s3=$s3

if test $s3 -eq $s2
then
   echo "ERROR: log file size unchanged "
else
   echo "OK: log file size increased "
fi


echo "Check Result above. Then, on the GUI terminate recording  : press Terminate button, then press enter to continue"
read c
ssh @hostname2val@  $BINDIR/start_test26_host2.sh @hostname1val@ 1

echo check debug file /tmp/test26.log : 
ls -l /tmp/test26.log 
s4=`wc -c /tmp/test26.log| cut -f1 -d ' '`
echo file size is s4=$s4

if test $s4 -gt $s3
then
   echo "ERROR: log file size has changed "
else
   echo "OK: log file size unchanged "
fi

echo "Check Result above. Then, terminate the gui, then press enter to continue"
read c

rm -f server.pid
rm -f server_data
killall cdmw_recordingdaemon test26_server

