#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

BINDIR=@CDMW_PLATFORM_SCRIPTS_PATH@
. $BINDIR/set_env.sh 
cd $BINDIR/../share

file=/tmp/test26.log
if ! test -f $file
then
   echo "$file does not exist; run test26 validation first !!!"
   exit
fi
echo starting test28

echo kill running services
killall -q IFR_Service
echo starting interface repository
IFR_Service -ORBEndpoint iiop://:6070 &
sleep 2
echo "loading idl (Transmission_26.idl) to interface repository"
tao_ifr -ORBInitRef InterfaceRepository=corbaloc::localhost:6070/InterfaceRepository -v Transmission_26.idl
sleep 1



echo starting decoding
cdmw_debug_decoder --nocli --ifr_url=corbaloc::localhost:6070/InterfaceRepository < /tmp/test26.log

killall IFR_Service
rm -f if_repo.ior
echo test finished
