/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TRANSMISSIONIMPL_HPP 
#define INCL_TRANSMISSIONIMPL_HPP 

#include "recordingtools/CdmwRecordingDaemonControl_impl.hpp"
#include "test26/Transmission_26.skel.hpp"

    
/**
* Purpose:
* <p>
* Implementation of transmission IDL interface
*/

class Transmission_impl : public virtual POA_Transmission
{
public:

    /**
    * Purpose:
    * <p> Sending oneway messages
    */ 
    virtual void sendto(const char * data) throw(CORBA::SystemException);
    /**
     * Purpose:
     * <p> Sending twoway messages
    */ 
    virtual bool send(const char * data) throw(CORBA::SystemException);

    virtual void terminate() throw(CORBA::SystemException); 
    
    CdmwRecording::DaemonControl_var daemon;   
};

#endif // INCL_TRANSMISSIONIMPL_HPP
