#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

BINDIR=@CDMW_PLATFORM_SCRIPTS_PATH@
. $BINDIR/set_env.sh 
cd $BINDIR/../share

file=/tmp/test24.log
# test if file has been created and is not empty
if test -f $file
then
   echo $file could not be deleted. Please do "clean_valid_test24.sh"
   exit
fi

for loop in 1 2
do
echo =====================================
echo starting test phase $loop
echo =====================================
su -m -s $BINDIR/start_test24_host1.sh
sleep 5
ssh @hostname2val@ $BINDIR/start_test24_host2.sh

echo =====================================
echo " Existing log files for this test : (PASS $loop)"
ls -l /tmp/test24.log*
echo =====================================
done
echo =====================================
echo "test cleanup ..."
echo =====================================
$BINDIR/clean_valid_test24.sh