/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <stdio.h>
#include "testbuffersender/Transmission_impl.hpp"

#include <semaphore.h>
#include <sys/stat.h>   //S_IRUSR|S_IWUSR
#include <fcntl.h>  //O_CREAT 
    
static int n1 = 0;  
static int n2 = 0;  

Transmission_impl::Transmission_impl (std::string test_name)
  : m_test_name(test_name)
{
}

void Transmission_impl::sendto(const char * data) throw(CORBA::SystemException)
{
    // tell the test application that a message have been received
    if (m_test_name == "V-TRC-021")
    {
       sem_t * ssema = sem_open("/testbs_send_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
       sem_post(ssema);
    } 
    if (n1 == 0)
       printf ("=== testbs_server : receiving requests ...");
    else
      printf (".");
          
    FILE * pFile;
    pFile = fopen ("server_data","a+");
    n1++;
    fprintf (pFile, "%s\n", data);
    fclose (pFile);    
}

bool Transmission_impl::send(const char * data) throw(CORBA::SystemException)
{   
    if (m_test_name == "V-TRC-021")
    {
       // tell the test application that a message have been received
       sem_t * ssema = sem_open("/testbs_send_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
       sem_post(ssema);
    } 
    
    if (n2 == 0)
       printf ("=== testbs_server : receiving requests\n");
    else
      printf (".");

    FILE * pFile;
    pFile = fopen ("server_data","a+");
    n2++;
    fprintf (pFile, "%s\n", data);
    fclose (pFile);    
    return true;
}
bool Transmission_impl::finish_iteration() throw(CORBA::SystemException)
{
  printf ("=== testbs_server : finish_iteration request received\n");
  // tell the test that all messages were send
  n1 = 0;
  n2 = 0;
  if (m_test_name == "V-TRC-021")
  {
     printf ("=== testbs_server finish_iteration: received requets : oneway : %d / two_way : %d\n", n1 , n2);
     printf ("=== testbs_server : waiting for test to be finished ...(sleeping 3s) \n");
     sem_t * fsema = sem_open("/testbs_fin_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
     sem_post(fsema); 
  }
  // exit (0);
  return true;
}
bool Transmission_impl::ready() throw(CORBA::SystemException)
{
  printf ("\n=== testbs_server : ready request received\n");
  // wait till test is ready for next iteration
  n1 = 0;
  n2 = 0;
  if (m_test_name == "V-TRC-021")
  {
     printf ("=== testbs_server ready : received requets : oneway : %d / two_way : %d\n", n1 , n2);
     printf ("=== testbs_server ready : ... waiting for test driver (rsema)... \n");
     sem_t * rsema = sem_open("/testbs_ready_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
     sem_wait(rsema); 
  }
  return true;
}
