/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <stdio.h>
#include "testbuffersender22/Recorder_impl.hpp"

namespace POA_CdmwRecording
{
  
void Recorder_impl::record(
        const ::CdmwRecording::GroupHeader & header,
        const ::CdmwRecording::GIOP_Buffers & data) 
        throw(CORBA::SystemException)
{

     printf ("=== Recording Server : Message received, length = %d\n", data.length());      
          
    if (data.length() == 0)
    {
      printf ("=== Recording Server : exiting \n");            
      exit(0);
    }
          
    FILE * pFile;

    //std::cerr<<" +r ";

    printf ("=== Recording Server : writing to file  \n");      
    pFile = fopen ("recordingserver_data","a+");

    fprintf (pFile, "buffer:\n");
    fprintf (pFile, "hostname:\n");
    fprintf (pFile, "%s\n", ((std::string)header.hostname).c_str());
    fprintf (pFile, "num_pairs:\n");
    fprintf (pFile, "%d\n", header.num_pairs);
    
    fclose (pFile);    
}

}
