/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <stdio.h>

#include <semaphore.h>
#include <sys/stat.h>   //S_IRUSR|S_IWUSR
#include <fcntl.h>  //O_CREAT 
    

#include "testbuffersender22/Transmission_impl.hpp"

static int n1 = 0;  
static int n2 = 0;  
 
void Transmission_impl::sendto(const char * data) throw(CORBA::SystemException)
{
  n1++;
  printf ("=== testbs22_server : %d received oneway requests\n", n1);
  printf ("=== testbs22_server : waking test\n");
  //if (n1 >= 10)
  {
    // tell the test application that a message have been received
    try
      {
    sem_t * ssema = sem_open("/testbs22_send_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
    sem_post(ssema);
      }
    catch (...)
      {
    std::cout << "*** testbs22_server : run recording server as Root" << std::endl;
      }
  }

  FILE * pFile;
  pFile = fopen ("server_data","a+");
  //fprintf (pFile, "%s\n", data);
  fprintf (pFile, "+");
  fclose (pFile);    
}

bool Transmission_impl::send(const char * data) throw(CORBA::SystemException)
{
  n2++;
  printf ("=== testbs22_server : %d received twoway requests\n", n2);
  printf ("=== testbs22_server : waking test\n");
  //if (n2 >= 10)
  {
    // tell the test application that a message have been received
    try
      {
    sem_t * ssema = sem_open("/testbs22_send_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
    sem_post(ssema);
      }
    catch (...)
      {
    std::cout << "*** testbs22_server : run recording server as Root" << std::endl;
    return false;
      }
  }    
  FILE * pFile;
  pFile = fopen ("server_data","a+");
  //fprintf (pFile, "%s\n", data);
  fprintf (pFile, "-");
  fclose (pFile);    
  return true;
}
bool Transmission_impl::ready() throw(CORBA::SystemException)
{
  // wait for test is ready
    try
      {
    sem_t * rsema = sem_open("/testbs22_ready_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
    sem_wait(rsema);     
      }
    catch (...)
      {
    std::cout << "*** testbs22_server : run recording server as Root" << std::endl;
    return false;
      }
  return true;
}
bool Transmission_impl::finish_iteration() throw(CORBA::SystemException)
{
  // tell the test that some messages have been sent
    try
      {
    sem_t * fsema = sem_open("/testbs22_fin_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
    sem_post(fsema); 
      }
    catch (...)
      {
    std::cout << "*** testbs22_server : run recording server as Root" << std::endl;
    return false;
      }
  return true;
}


