/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <stdio.h>
#include "testcoalescencemanager/Transmission_impl.hpp"

#include <semaphore.h>
#include <sys/stat.h>   //S_IRUSR|S_IWUSR
#include <fcntl.h>  //O_CREAT 
    
  
void Transmission_impl::sendto(const char * data) throw(CORBA::SystemException)
{
    // tell the test application that a message have been received
    sem_t * ssema = sem_open("/testcm_send_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
    sem_post(ssema); 
    
    FILE * pFile;
    pFile = fopen ("server_data","a+");
    fprintf (pFile, "%s\n", data);
    fclose (pFile);    
}

bool Transmission_impl::send(const char * data) throw(CORBA::SystemException)
{   
    // tell the test application that a message have been received
    sem_t * ssema = sem_open("/testcm_send_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
    sem_post(ssema);
    
    FILE * pFile;
    pFile = fopen ("server_data","a+");
    fprintf (pFile, "%s\n", data);
    fclose (pFile);    
    return true;
}
bool Transmission_impl::finish_iteration() throw(CORBA::SystemException)
{
    // tell the test that all messages were send
    sem_t * fsema = sem_open("/testcm_fin_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
    sem_post(fsema); 
    return true;
}
bool Transmission_impl::ready() throw(CORBA::SystemException)
{
    // wait till test is ready for next iteration
    sem_t * rsema = sem_open("/testcm_ready_semaphore",O_CREAT,S_IRUSR|S_IWUSR, 0); 
    sem_wait(rsema); 
    return true;
}
void Transmission_impl::terminate() throw(CORBA::SystemException)
{
   // daemon->terminate();
   exit (0);
}
