/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_RECORDING_TEST_INTERFACE_FILTER_HPP 
#define INCL_RECORDING_TEST_INTERFACE_FILTER_HPP 

#include "Foundation/testutils/TestManager.hpp"
#include "TraceAndPerf/recordinglibrary/InterfaceFilter.hpp"
    
/**
*Purpose:
*<p>    Test InterfaceFilter class
*
*/
class TestInterfaceFilter : public CppUnit::TestFixture
{

    public:

        /**
        * Purpose:
        * <p> [Constructor description if necessary]
        * 
        */ 
        TestInterfaceFilter();



        /**
        * Purpose:
        * <p> [ Destructor description if necessary]
        * 
        */ 
        virtual 
        ~TestInterfaceFilter()
                throw();




        /**
        * Purpose:
        * <p>
        * 
        */
        virtual
        void
        do_tests();

    private:
        static std::ofstream * om;
        
        static void print_flag (string const & key_str, Cdmw::Recording::InterfaceFilter::Flag_t const & flag);
        
        static void print (string const & str1, string const & str2, size_t i);
        
        void create_folder();

        void create_file(std::string filename, const char * data);
        
        void print_result(bool result);
        
        std::string output_folder;

    CPPUNIT_TEST_SUITE( TestInterfaceFilter );
        CPPUNIT_TEST( do_tests );
    CPPUNIT_TEST_SUITE_END();


}; // End class TestInterfaceFilter 


#endif // INCL_RECORDING_TEST_INTERFACE_FILTER_HPP

