/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TRACELIBRARY_INTERFACE_INTERRUPTED_CLIENT_TESTER_HPP 
#define INCL_TRACELIBRARY_INTERFACE_INTERRUPTED_CLIENT_TESTER_HPP

#include <Foundation/testutils/CORBATestManager.hpp>
#include <string>

/**
 *Purpose:
 *<p>    Test V-TRC-030
 *       Check the capacity to trace in a synchronous way in order to never
 *       loose traces before crashing.
 */
class InterruptedClientTester : public CppUnit::TestFixture
{

public:

    InterruptedClientTester();

    virtual ~InterruptedClientTester()
        throw();

    // Testable operations
    void do_tests();

protected:
    void test_synchronous_traces();
    void test_asynchronous_traces();

private:
    std::string m_host;

    CPPUNIT_TEST_SUITE( InterruptedClientTester );
    CPPUNIT_TEST( do_tests );
    CPPUNIT_TEST_SUITE_END();

}; // End class InterruptedClientTester 


#endif // INCL_TRACELIBRARY_INTERFACE_INTERRUPTED_CLIENT_TESTER_HPP
