/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "testmessageidentifier/MyRequestPairing.hpp"
#include <unistd.h> 
#include <sys/types.h>
#include <sys/stat.h>
#include <fstream>
#include <iostream>

namespace Cdmw
{
namespace Recording
{
    
/**
*Implementation notes: [if no pertinent write none ]
*<p>
*Portability issues: [if no pertinent write none ]
*<p>
*/

MyRequestPairing::MyRequestPairing(Cdmw::Recording::PacketStore & store)
: RequestPairing(store)
{
    //set_output();
}

MyRequestPairing::~MyRequestPairing()
    throw()
{
}

void MyRequestPairing::storeRequest(Cdmw::Recording::Message * message)
    throw()
{
    FILE * pFile;
    pFile = fopen (output_file.c_str(),"a+");
    fprintf (pFile, "Request: %d\n", message->request_id);
    fclose (pFile);    
}

void MyRequestPairing::checkReply(Cdmw::Recording::Message * message)
    throw()
{
    FILE * pFile;
    pFile = fopen (output_file.c_str(),"a+");
    fprintf (pFile, "Reply: for request %d\n", message->request_id);
    fclose (pFile);    
}

void MyRequestPairing::write_header(const char * header)
{
    FILE * pFile;
    pFile = fopen (output_file.c_str(),"a+");
    fprintf (pFile, "%s\n", header);
    fclose (pFile);    
}

void MyRequestPairing::set_output(std::string test_nr)
{
    output_folder = "V-TRC-013-"+ test_nr +"-results";
    create_output_folder();

    char host_name[100] = "";
    gethostname(host_name, sizeof(host_name));
    output_file = output_folder + "/execution-" + host_name + ".output";
    remove((const char *) output_file.c_str());
}

void MyRequestPairing::create_output_folder()
{
    if (mkdir(output_folder.c_str(), 999) != 0)
    {
        std::cerr << "Error creating output directory" << std::endl;
    }
}

const char * MyRequestPairing::get_output()
{
    return output_file.c_str();
}

}; // End namespace Recording
}; // End namespace Cdmw

