#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

BINDIR=@CDMW_PLATFORM_SCRIPTS_PATH@
. $BINDIR/set_env.sh 
cd $BINDIR/../share
xhost +

rm -rf V-TRC-012-results
mkdir V-TRC-012-results
chmod 777 V-TRC-012-results

echo open xterm @hostname2val@ ..
xterm -T host2 -e ssh @hostname2val@ $BINDIR/start_testns_host2.sh &
sleep 2

echo open xterm @hostname3val@ ..
xterm -T host3 -e ssh @hostname3val@ $BINDIR/start_testns_host3.sh &
sleep 2

export CDMW_LDPATH=$LD_LIBRARY_PATH
export CDMW_PATH=$PATH

cp $BINDIR/testns_server1 $BINDIR/testns_server2
 
echo "starting server1 (port 6786) "
$BINDIR/testns_server1 1 --CdmwProcessPort=6786  &
sleep 1s
mv server.pid server1.pid

echo "starting server2 (port 6787) "
$BINDIR/testns_server2 2 --CdmwProcessPort=6787  &
sleep 1s
mv server.pid server2.pid

echo starting test as root..
su -m -s $BINDIR/start_testns_host1.sh

