/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef INCL_RECORDING_TEST_NETWORK_SNIFFER_HPP 
#define INCL_RECORDING_TEST_NETWORK_SNIFFER_HPP 

#include <iostream>
#include <fstream>

#include "Foundation/testutils/TestManager.hpp"
#include "TraceAndPerf/recordinglibrary/PacketStore.hpp"
#include "TraceAndPerf/recordinglibrary/NetworkSniffer.hpp"
    
/**
*Purpose:
*<p>    Test NetworkSniffer class
*/
class TestNetworkSniffer : public CppUnit::TestFixture
{
    public:

        TestNetworkSniffer();

        virtual ~TestNetworkSniffer() throw();

        virtual void  do_tests();
        
        void test_remove_port();
         
        void terminate_sniffer();                    
                            
        void get_messages(std::string outputfile, int iteration);
        
        bool check_sniffer_data(std::string filename, int iteration);
   
   private:     
        std::ofstream * ostrm;  
        Cdmw::Recording::PacketStore store ;
        Cdmw::Recording::NetworkSniffer * sniffer;
        
        std::string etalon1;
        std::string etalon2;
        std::string etalon3;
        std::string etalon4;
                    
    CPPUNIT_TEST_SUITE( TestNetworkSniffer );
        CPPUNIT_TEST( do_tests );
    CPPUNIT_TEST_SUITE_END();

}; // End class TestNetworkSniffer 


#endif // INCL_RECORDING_TEST_NETWORK_SNIFFER_HPP

