/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <unistd.h>
#include <string>

#include "testnetworksniffer/Transmission_impl.hpp"

bool Transmission_impl::send(const char * data, CORBA::Long sleeping_time) throw(CORBA::SystemException)
{
    FILE * pFile;
    std::string filename;
    sleep(sleeping_time);

    switch (sleeping_time)
    {
        case 1: filename = "server_data_1"; break;
        case 2: filename = "server_data_2"; break;
        case 3: filename = "server_data_3"; break;
        case 4: filename = "server_data_4"; break;
        default: filename = "server_data";
    }
  
    pFile = fopen (filename.c_str(),"a+");
    fprintf (pFile, "%s\n", data);
    fclose (pFile);    
    return true;
}

bool Transmission_impl::finish_iteration() throw(CORBA::SystemException)
{ 
   std::cout<<"=== testns_server : finish iteration request received"<<std::endl;  
   return true;
}
