/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_RECORDING_TEST_NETWORK_SNIFFER_HPP 
#define INCL_RECORDING_TEST_NETWORK_SNIFFER_HPP 


#include <semaphore.h>
#include <sys/stat.h>   //S_IRUSR|S_IWUSR
#include <fcntl.h>      //O_CREAT

#include "TraceAndPerf/recordinglibrary/PacketStore.hpp"
#include "TraceAndPerf/recordinglibrary/NetworkSniffer.hpp"

#include "Foundation/testutils/CORBATestManager.hpp"

/**
*Purpose:
*<p>    unit test of NetworkSniffer     
*/
class TestNetworkSniffer : public CppUnit::TestFixture
{

    public:

       TestNetworkSniffer();

       virtual   ~TestNetworkSniffer()  throw();
       
       void test_1();
       void test_2();
       void test_3();
       void test_4();
       void test_5();
       void test_6();
       void test_7();
       void test_8();
       void test_9();
       void test_10();
       void test_11();
       void test_12();
       void test_13();
       void test_14();
       void test_15();
       void test_16();
       
       void init_sniffer(int port_nr);
       void terminate_sniffer();
       std::ofstream * snf_output(int test_number);
       
       void take_messages(std::ofstream * om, int nr);
       void take_messages(std::ofstream * om, int test_nr, int count_msg);
       
       void get_iteration_result(long iteration);
       
       // Count the messages received by network sniffer  
       int count_snf_messages(long iteration); 

       // Check content of messages received by sniffer     
       bool check_snf_messages(long iteration);
       void do_tests();
       
       private:
       
         Cdmw::Recording::PacketStore store;  
         
         Cdmw::Recording::NetworkSniffer * sniffer;
         
         sem_t * snf_semaphore ;
         
         int port_number;
                  
    CPPUNIT_TEST_SUITE( TestNetworkSniffer );
        CPPUNIT_TEST(do_tests);
    CPPUNIT_TEST_SUITE_END();


}; // End class TestNetworkSniffer 


#endif // INCL_RECORDING_TEST_NETWORK_SNIFFER_HPP

