/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
#include "testsniffer2/Transmission_impl.hpp"

void Transmission_impl::wait_semaphore() 
{
   sem_wait(sniffer_semaphore);
}

bool Transmission_impl::send(const char * data) throw(CORBA::SystemException)
{
    FILE * pFile;
    pFile = fopen ("server_data","a+");
    fprintf (pFile, "%s\n", data);
    fclose (pFile);    
   
    return true;
}

bool Transmission_impl::finish_iteration(CORBA::Long iteration)  throw(CORBA::SystemException)
{  
    std::cout<<"finish iteration "<<iteration<<".." ;
   
    return true;
}

bool Transmission_impl::snf_ready(CORBA::Long iteration, const char * port) throw(CORBA::SystemException)
{
  if(0 == iteration)
  {
    //create semaphore for sniffer 
    sniffer_semaphore = sem_open("/snf_semaphore",
                            O_CREAT,S_IRUSR|S_IWUSR, 0);
    
  }    
  std::cerr<<"waiting for sniffer ("<<iteration<<")..";

  //waiting sniffer ready
  wait_semaphore();

  std::cerr<<"ok ("<<iteration<<")"<<std::endl;
    
  return true;
}


void Transmission_impl::finish() throw(CORBA::SystemException)
{
    std::cout<<"finish .." ;
  
    
    // Remove temp files
    remove("server_data");
    remove("sniffer_data_1");
    remove("sniffer_data_2");
    remove("sniffer_data_3");
    remove("sniffer_data_4");
    remove("sniffer_data_5");
    remove("sniffer_data_6");
    remove("sniffer_data_7");
    remove("sniffer_data_8");
    remove("sniffer_data_9");
    remove("sniffer_data_10");
    remove("sniffer_data_11");
    remove("sniffer_data_12"); 
    
    std::cout<<".ok"<<std::endl;
}
