/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.ccm.cif.test;


import cdmw.common.Assert;

/**
 * Class created to simulated the Dance behaviour for the PCR-1877
 */

//
// IDL:acme.com/Test/SimDance:1.0
//
public class SimDance // extends org.omg.PortableServer.ServantLocatorPOA
        extends org.omg.CORBA.LocalObject 
        implements org.omg.PortableServer.ServantLocator
{
    private org.omg.PortableServer.POA poa = null;

    public SimDance(org.omg.PortableServer.POA poa) {
        this.poa = poa;
    }

    public org.omg.PortableServer.POA _default_POA() {
        return poa;
    }

    public org.omg.PortableServer.Servant preinvoke(
            byte[] oid,
            org.omg.PortableServer.POA poa,
            String operation,
            org.omg.PortableServer.ServantLocatorPackage.CookieHolder theCookie)
            throws org.omg.PortableServer.ForwardRequest 
        {
            System.out.println("SimDance: preinvoke");
            
            if (oid != null) { // A bypass to compile successfully
                throw new org.omg.CORBA.TRANSIENT();
            } else {
                System.err.println("!!! We should never pass by here");
                System.exit(1);
            }

            return null;
        }

        public void postinvoke(
            byte[] oid,
            org.omg.PortableServer.POA poa,
            String operation,
            Object theCookie,
            org.omg.PortableServer.Servant theServant) 
        {
            System.out.println("SimDance: postinvoke");
        }
}


