/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.ccm.cif.test;


import cdmw.common.Assert;
import static org.junit.Assert.fail;
import cdmw.testutils.TestManager;
import cdmw.ossupport.OS;

/**
 * Class created to simulate the behaviour of the FtUltimateFallback and
 * Dance for the PCR-1877
 */

//
// IDL:acme.com/Test/SimFtUltimateFallbackAndDance:1.0
//
public class SimFtUltimateFallbackAndDance
        extends org.omg.CORBA.LocalObject 
        implements org.omg.PortableServer.ServantLocator
    // extends org.omg.PortableServer.ServantLocator
{
    private org.omg.CORBA.Object dance = null;
    private org.omg.PortableServer.POA poa = null;

    public SimFtUltimateFallbackAndDance(org.omg.PortableServer.POA poa,
                                 org.omg.CORBA.Object dance) {
        this.dance = dance;
    }

    public org.omg.PortableServer.POA _default_POA() {
        System.out.println("SimFtUltimateFallbackAndDance: _default_POA");
        return poa;
    }

    public org.omg.PortableServer.Servant preinvoke(
            byte[] oid,
            org.omg.PortableServer.POA poa,
            String operation,
            org.omg.PortableServer.ServantLocatorPackage.CookieHolder theCookie)
            throws org.omg.PortableServer.ForwardRequest 
        {
            int timescale = TestManager.getTimescale();

            if(System.getProperty("Num.Test").equals("1016") ||
               System.getProperty("Num.Test").equals("1017") ||
               System.getProperty("Num.Test").equals("1018")){
                try{
                    // Sleep useful for U-CMC-0017 and U-CMC-0018
                    // Indeed TAO doesn't have the same behaviour as
                    // JacORB, the CORBA.TRANSIENT exception
                    // is caught by the client. Therefore to test
                    // the new code with a timeout on connect(),
                    // from CCMObjectImpl, a sleep is performed.
                    OS.sleep(timescale * 10000);
                } catch(java.lang.InterruptedException ie){
                    fail("Unexpected expection: " + ie);
                }
            }

            String __oid = new String(oid, 0, oid.length);
            System.out.println("SimFtUltimateFallbackAndDance: preinvoke - operation="+ operation
                               + "; oid=" + __oid);
            
            if (__oid.compareTo("SimUltimateFallback") == 0) {
                
                try{
                    OS.sleep(timescale * 1000);
                } catch(java.lang.InterruptedException ie){
                    fail("Unexpected expection: " + ie);
                }
                System.out.println("SimFtUltimateFallbackAndDance: ForwardRequest raised");
                throw new org.omg.PortableServer.ForwardRequest(dance);

            }else if(__oid.compareTo("SimDance") == 0){

                try{
                    OS.sleep(timescale * 1000);
                } catch(java.lang.InterruptedException ie){
                    fail("Unexpected expection: " + ie);
                }
                System.out.println("SimFtUltimateFallbackAndDance: CORBA.TRANSIENT raised");
                throw new org.omg.CORBA.TRANSIENT(0, org.omg.CORBA.CompletionStatus.COMPLETED_NO);

            } else {

                fail("Unexpected oid: " + __oid);

            }

            return null;
        }

        public void postinvoke(
            byte[] oid,
            org.omg.PortableServer.POA poa,
            String operation,
            Object theCookie,
            org.omg.PortableServer.Servant theServant) 
        {
            System.out.println("SimFtUltimateFallbackAndDance: postinvoke");
        }
}


