/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ft.watchdog;

import cdmw.ft.FTLogger;
import static cdmw.logging.FunctionLogger.*;

public class RequestTimeoutLocalPullMonitorableImpl extends org.omg.CORBA.LocalObject
    implements com.thalesgroup.CdmwFT.LocalPullMonitorable
{
    
    /**
     * Purpose:
     * <p> to call to check if object is still living that is a request
     * doesn't spend more time than the timeout specified.
     * 
     *@exception CORBA.SystemException
     *
     */ 
     public boolean is_alive() 
     {
         CDMW_LOG_FUNCTION(FTLogger.GetLogger(), "");
         boolean isTimeout 
             = RequestTimeoutLogger.getInstance().checkTimeoutsExpiration();
         return !isTimeout;
     }
}
