/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.lifecycle;


/**
 * The ObjectRegistration acts as a singleton factory for the creation
 * of Lifecycle Objects
 */

public abstract class ObjectRegistrationBase
    extends org.omg.CORBA.LocalObject
    implements com.thalesgroup.CdmwLifeCycle.ObjectRegistration {

    //
    // IDL:thalesgroup.com/CdmwLifeCycle/ObjectRegistration/register_object:1.0
    //
    public void register_object(org.omg.CORBA.Object objectRef,
                                java.lang.String objectName)
        throws org.omg.CosNaming.NamingContextPackage.InvalidName,
               org.omg.CosNaming.NamingContextPackage.AlreadyBound
    {
        bind(objectRef, objectName);
    }

    //
    // IDL:thalesgroup.com/CdmwLifeCycle/ObjectRegistration/unregister_object:1.0
    //
    public void unregister_object(java.lang.String objectName)
        throws org.omg.CosNaming.NamingContextPackage.NotFound,
               org.omg.CosNaming.NamingContextPackage.InvalidName
    {
        unbind(objectName);
    }

    protected ObjectRegistrationBase()
    {
    }

    protected abstract boolean bind(org.omg.CORBA.Object homeRef,
                                    java.lang.String objectName)
        throws org.omg.CosNaming.NamingContextPackage.InvalidName,
               org.omg.CosNaming.NamingContextPackage.AlreadyBound;

    protected abstract boolean unbind(java.lang.String objectName)
        throws org.omg.CosNaming.NamingContextPackage.InvalidName,
               org.omg.CosNaming.NamingContextPackage.NotFound;

}

