/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI.
 * Copyright (C) SELEX SISTEMI INTEGRATI 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.lb.lbinit;

import org.omg.CORBA.LocalObject;
import org.omg.CORBA.ORB;
import org.omg.PortableInterceptor.*;
import org.omg.PortableInterceptor.ORBInitInfoPackage.*;
import org.omg.PortableServer.POAHelper;

public class ORBInitializerImpl extends LocalObject implements org.omg.PortableInterceptor.ORBInitializer
{
    private static final long serialVersionUID = 1L;

    public ORBInitializerImpl()
    {   
        // do nothing
    }   

    public void pre_init(ORBInitInfo info)
    {
        // do nothing
    }

    public void post_init(ORBInitInfo info) throws org.omg.CORBA.NO_IMPLEMENT
    {    
        //ORB
        ORB orb = cdmw.orbsupport.ORBSupport.getORB(info);  
         
         try
         {
             cdmw.orbsupport.Codec.init(orb);
             ServerRequestInterceptor serverInterceptor
                 = new ServerRequestInterceptor(orb, "LBServerInterceptor");
             try
             {
                 //System.out.println("Registering Interceptors");
                 info.add_server_request_interceptor(serverInterceptor);
             }
             catch (DuplicateName dn)
             {
                 System.out.println("DuplicateName " + dn.getMessage());
             }
         }
         catch(Exception e)
         {
             e.printStackTrace();
         }
    }
}
