/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.perftest.CDMWMarshallingCCM;

import cdmw.ccm.cif.SessionContext;

public class ServerExecutorImpl extends org.omg.CORBA.LocalObject
    implements User_Server {
    private CCMTestPing testCall;
    private CCMServerContext sessionContext;

    //
    // IDL:thalesgroup.com/Marshalling/CCM_Server:1.0
    //
    public ServerExecutorImpl() {
        this.testCall = new TestPingFacetExecutorImpl();
    }

    //
    // IDL:thalesgroup.com/Marshalling/CCM_Server/get_server_facet:1.0
    //
    public CCMTestPing getServerFacet() {
        // std::cout << "===> get_server_facet called!" << std::endl;
     
        return this.testCall;
    }

    // From Session Component

    //
    // set_session_context function : it fixes the session context of the component
    // (call by the container)
    //
    public void setSessionContext(org.omg.Components.SessionContext ctx) {
        System.out.println("===> set_session_context called!");
    
        this.sessionContext = CCMServerContextHelper.narrow(ctx); 
    }

    //
    // ccm_activate function : it actives the component (call by the container)
    //
    public void ccm_activate() {
        System.out.println("===> ccm_activate called!");
        ServerProcessControl.ccm_activated();
    }

    //
    // ccm_passivate function : it makes stop the component (call by the container)
    //

    public void ccm_passivate() {
        System.out.println("===> ccm_passivate called!");
    } 

    //
    // ccm_remove function : it destroys the component (call by the container)
    //
    public void ccm_remove() {
        System.out.println("===> ccm_remove called!");
    }
}
