/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccmandlb;

import org.omg.Components.SessionContext;
import com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.*;
import com.acme.CcmAndLB.*;
import cdmw.logging.Logger;
import static cdmw.logging.Logger.*;
import java.util.Date;
import org.omg.CORBA.Any;



public class ClientExecutorImpl extends org.omg.CORBA.LocalObject
    implements com.acme.CcmAndLB.User_Client
{
    private Logger logger;
    private CCM_Client_Context sessionContext;
    private String hostName;
    // component name
    private String componentName;

    public ClientExecutorImpl()
    {
        this.sessionContext = null;
        this.logger = Logger.Get_Logger("CCM_Client","QUALIF_CCM_AND_LB");
        this.hostName = cdmw.ossupport.OS.getHostname();
/*******************
        org.omg.CORBA.Object obj = null;
        try {
            obj = 
                this.sessionContext.resolve_service_reference("ManagedComponentContext");
        } catch (org.omg.Components.CCMException e) {
            System.err.println("ManagedComponentContext not found !!");
        }
        ComponentContext supContext =
            ComponentContextHelper.narrow(obj);
        // get component, process, application names
        this.componentName = supContext.managed_element_name();
/********************/
    }

    public void set_session_context(SessionContext ctx)
        throws org.omg.CORBA.SystemException
    {
        CDMW_INFO(this.logger, "ClientExecutor_impl::set_session_context() ",
                         new Throwable());
        this.sessionContext = CCM_Client_ContextHelper.narrow(ctx);
    }


    public void ccm_activate()
        throws org.omg.CORBA.SystemException
    {
        CDMW_INFO(this.logger, "ClientExecutor_impl::ccm_activate() ",
                         new Throwable());

        try {
            cdmw.ossupport.OS.sleep(10000);
            CDMW_INFO(this.logger, "... The Component CLIENT try to connect to LB SERVER ....",
                             new Throwable());
            HelloWorld display = 
                this.sessionContext.get_connection_client_receptacle();

            for (int numberOfReq=0; numberOfReq < 10; numberOfReq++)
            { 
               CDMW_INFO(this.logger, "Client Component call Server Component...",
                             new Throwable());

               String HostName = cdmw.ossupport.OS.getHostname();
               System.out.println(this.hostName + ": ***************Client Component call Server Component ***********");
              
               cdmw.ossupport.OS.sleep(5000);
               display.sayHello();

            }


        }
        catch (Exception e) {
            CDMW_ERROR(this.logger, "unexpected exception raised." + e,
                              new Throwable());   
        }
    }

    /**
     * Stop the component (called by the container).
     *
     */
    public void ccm_passivate()
        throws org.omg.CORBA.SystemException
    {
        CDMW_INFO(this.logger, "ClientExecutor_impl::ccm_passivate() called.",
                         new Throwable());
    }

    /**
     * Destroy the component (called by the container).
     *
     */
    public void ccm_remove()
        throws org.omg.CORBA.SystemException
    {
        CDMW_INFO(this.logger, "ClientExecutor_impl::ccm_remove() called.",
                         new Throwable());
    }
    public void handle_terminate(Any params)
        throws org.omg.CORBA.SystemException {

    }
public void handle_set_rate(Any params)
        throws org.omg.CORBA.SystemException {
}

public void handle_pause(Any params)
        throws org.omg.CORBA.SystemException {

}

public void handle_resume(Any params)
        throws org.omg.CORBA.SystemException {

}
 public void handle_set(Any params)
        throws org.omg.CORBA.SystemException {
}


    public void cdmw_initialise_component(com.thalesgroup.CdmwPlatformMngtBase.StartupKind startupKind)
                throws com.thalesgroup.CdmwPlatformMngt.ManagedComponentPackage.BadOrder {
        cdmw_initialise_component();
    }
 
 public void cdmw_initialise_component() {
 }


}
