/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccmandlb;

import org.omg.CORBA.*;
import org.omg.CORBA.ContainerPackage.Description;
import org.omg.CORBA.InterfaceDefPackage.FullInterfaceDescription;

import com.acme.CcmAndLB.*;
import com.acme.CcmAndLB.HelloWorld.*;

import cdmw.logging.Logger;
import static cdmw.logging.Logger.*;

public class HelloWorldFacetExecutorImpl extends LocalObject 
    implements CCM_HelloWorld
{
    private Logger logger;
    private ServerExecutorImpl server;
    private String hostName;
    private String processName;

    /**
     * Create a HelloWorldFacetExecutor.
     *
     */
    public HelloWorldFacetExecutorImpl(ServerExecutorImpl server)
    {
        this.logger = Logger.Get_Logger("CCM_HelloWorld","QUALIF_CCM_AND_LB");
        this.server = server;
        this.hostName = cdmw.ossupport.OS.getHostname();
        this.processName = "ServerLB"; 
        
    }
        
    /**
     * HelloWorld a hello message.
     */
    public void sayHello()
    {

        System.err.println("***** Component Server " + this.server.getProcessName() 
                          + " on host " +  this.hostName + " replies saying  HELLO!!! *****<<");
    }

}
