/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ccmfteventstest;

import cdmw.common.Assert;
import cdmw.ccmfteventstest.EventInfos;

//
// IDL:acme.com/CcmFtEventsTest/CCM_HostInfo:1.0
//
public class CCMHostInfoImpl extends org.omg.CORBA.LocalObject
    implements com.acme.CcmFtEventsTest.CCM_HostInfo {

    public CCMHostInfoImpl() {}
    private final int client1 = 0;
    private final int client2 = 1;
    //
    // IDL:thalesgroup.com/CcmFtEventsTest/CCM_HostInfo/display_info:1.0
    //
    public void display_info( String hostname, int numOfEvent )
    {

     int eventIndex = numOfEvent - 1;
     int client_index = 0;
     // fill in progressively the server structure
     if ( EventInfos.events [ client_index ] [ eventIndex ] == true ) {
     client_index++;
     }

     EventInfos.events [ client_index ] [ eventIndex ] = true;
     EventInfos.hostname [ client_index ] [ eventIndex ] = hostname;



     if ( numOfEvent == EventInfos.MAX_NB_EVENTS 
      && EventInfos.events [ client1 ] [ eventIndex ] == true
      && EventInfos.events [ client2 ] [ eventIndex ] == true ) {

         CCMServerWithLocalManagerImpl.mutex.unlock();

     }

    } // display_info()
} // class CCMHostInfoImpl

