/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */

package cdmw.testftrecorder;

import com.acme.TestCcmFtRecorder.*;

//
// IDL:acme.com/TestCcmFtRecorder/CCM_Server:1.0
//
public class CCMServerImpl extends org.omg.CORBA.LocalObject
    implements Session_CCM_Server 
{
    
    // session context
    private CCM_Server_Context m_sessionContext;
     
    
    public CCMServerImpl() 
    {
        this.m_sessionContext = null;
    }

    
    public void set_session_context(org.omg.Components.SessionContext ctx) 
    {
        System.out.println("*** CCMServerImpl::set_session_context() called!");
        this.m_sessionContext = CCM_Server_ContextHelper.narrow(ctx);
            
    }
    
    public CCM_Server_Context getContext()
    {
        return this.m_sessionContext;
    }
    
    
    public void ccm_activate() 
    {
        System.out.println("*** CCMServerImpl::ccm_activate() called!");
    }
    
    public void ccm_passivate() 
    {
        System.out.println("*** CCMServerImpl::ccm_passivate() called!");
    }
    
    public void ccm_remove() 
    {
        System.out.println("*** CCMServerImpl::ccm_remove() called!");
    }
    
    public CCM_Test get_test_facet()
    {
        // component itself implements the test_facet
        return this;
    }
    
    private static final String PARAM_A_S_VALUE = "value for 'a' param";
    private static final String PARAM_A_S_SUCIDE_VALUE = "MyRecorder: kill yourself !!";
    private static final int    PARAM_A_I_VALUE = 1;
    private static final String PARAM_B1_S_VALUE = "value for 'b' param (in)";
    private static final int    PARAM_B1_I_VALUE = 1;
    private static final String PARAM_B2_S_VALUE = "value for 'b' param (out)";
    private static final int    PARAM_B2_I_VALUE = 1;
    private static final String PARAM_C_S_VALUE = "value for 'c' param";
    private static final int    PARAM_C_I_VALUE = 1;
    private static final String PARAM_RET_S_VALUE = "value for return";
    private static final int    PARAM_RET_I_VALUE = 1;
        
    public TestStruct test_operation(TestStruct a, 
                                     TestStructHolder b, 
                                     TestStructHolder c)
    {
        System.out.println("*** CCMServerImpl::test_operation() called!");
        b.value.s = PARAM_B2_S_VALUE;
        b.value.i = PARAM_B2_I_VALUE;
        c.value = new TestStruct();
        c.value.s = PARAM_C_S_VALUE;
        c.value.i = PARAM_C_I_VALUE;

        TestStruct ret = new TestStruct();
        ret.s = PARAM_RET_S_VALUE;
        ret.i = PARAM_RET_I_VALUE;
        
        return ret;
    }
        
    
}

