/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ccmlocaleventmanager;

import cdmw.ccmlocaleventmanager.EventInfos;
import cdmw.common.Assert;
import cdmw.ccmlocaleventmanager.EventTestImpl;

//
// IDL:thalesgroup.com/CcmLocalEventManagerTest/CCM_Client:1.0
//
public class CCMClientEventsImpl extends org.omg.CORBA.LocalObject
    implements com.thalesgroup.UserCcmLocalEventManagerTest.User_CCM_ClientEvents {

    private com.acme.CcmLocalEventManagerTest.CCM_ClientEvents_Context context = null;

    public CCMClientEventsImpl() {}
    public void set_session_context(org.omg.Components.SessionContext ctx) {
        System.out.println("ClientEvents: set_session_context called!");
        this.context = 
            com.acme.CcmLocalEventManagerTest.CCM_ClientEvents_ContextHelper.narrow(ctx);
    }
    
    /**
     * Actives the component (call by the container)
     */
    public void ccm_activate() {
    System.out.println("   ... CCMClientEventsImpl.ccm_activate called!");
    }
    
    /**
     * Makes stop the component (call by the container)
     */
    public void ccm_passivate() {
    System.out.println("   ... CCMClientEventsImpl.ccm_passivate called!"); 
    }
    
    /**
     * Destroys the component (call by the container)
     */
    public void ccm_remove() {
        System.out.println("Client: ccm_remove called!");
    }

    public com.acme.CcmLocalEventManagerTest.CCM_ClientEvents_Context get_context() {
        return this.context;
    }
    
    public void push_eventServ1Consumes (com.acme.CcmLocalEventManagerTest.EventTest event)
     {

    System.out.println( "ClientJava: EventTest #" + event.numOfEvent
                + " received" );
    
    com.acme.CcmLocalEventManagerTest.HostInfo server_facet;

    try {
        server_facet = context.get_connection_server1HostInfo();
       
        if ( server_facet == null )
        {
            Assert.check(false);
        }
       
        //get the connection to the server 
        server_facet.display_info( cdmw.ossupport.OS.getHostname(), 
                    event.numOfEvent );

    } catch (org.omg.CORBA.SystemException e) {
        System.err.println("Unexpected CORBA::SystemException: " + e );
        Assert.check(false);
    }

    }

   public void push_eventServ2Consumes (com.acme.CcmLocalEventManagerTest.SecondEventTest event)
     {

    System.out.println( "ClientJava: SecondEventTest #" + event.numOfEvent
                + " received" );
    
    com.acme.CcmLocalEventManagerTest.HostInfo server_facet;

    try {
        server_facet = context.get_connection_server2HostInfo();
       
        if ( server_facet == null )
        {
            Assert.check(false);
        }
       
        //get the connection to the server 
        server_facet.display_info( cdmw.ossupport.OS.getHostname(), 
                    event.numOfEvent );

    } catch (org.omg.CORBA.SystemException e) {
        System.err.println("Unexpected CORBA::SystemException: " + e );
        Assert.check(false);
    }
    }

}

