/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ccmlocaleventmanager;

import cdmw.common.Assert;
import cdmw.ccmlocaleventmanager.EventInfos;

//
// IDL:acme.com/CcmLocalEventManagerTest/CCM_HostInfo:1.0
//
public class CCMHostInfoImpl extends org.omg.CORBA.LocalObject
    implements com.acme.CcmLocalEventManagerTest.CCM_HostInfo {

    private final int client1 = 0;
    private final int client2 = 1;

    // Total number of message received by the facet
    int nb_msg_received = 0;

    public CCMHostInfoImpl() {
        nb_msg_received = 0;
    }

    //
    // IDL:thalesgroup.com/CcmLocalEventManagerTest/CCM_HostInfo/display_info:1.0
    //
    synchronized public void display_info( String hostname, int numOfEvent )
    {

        int eventIndex = numOfEvent - 1;
        int client_index = 0;
        // fill in progressively the server structure
        if ( EventInfos.events [ client_index ] [ eventIndex ] == true ) {
            client_index++;
        }
        
        EventInfos.events [ client_index ] [ eventIndex ] = true;
        EventInfos.hostname [ client_index ] [ eventIndex ] = hostname;
        
        nb_msg_received++;
        
        if ( nb_msg_received == EventInfos.MAX_NB_EVENTS * 2 ) {

            System.out.println("The check of the server can start...");
            
            // No need of a mutex because this setting is considerated as atomic 
            // for a boolean data. In addition, the method is synchronized and
            // it is the only one to have a writing access.
            CCMServerWithLocalManagerImpl.eventsReceived = true;

        }

    } // display_info()
} // class CCMHostInfoImpl

