/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccmreconnect;

import com.acme.ReconnectDemo.*;

public class ServerExecutorImpl extends org.omg.CORBA.LocalObject
implements com.thalesgroup.UserReconnectDemo.User_CCM_Server
{
    private CCM_Server_Context sessionContext;
    private CCM_EventChecking facet;
    
    /**
     *Create a  ServerExecutorImpl.
     *
     */

    public ServerExecutorImpl()
    {
        this.facet = new EventCheckingExecutorImpl();
    }

    /**
     * Set the session context of the component (called by the container).
     *
     * @param SessionContext a session context
     *
     * @exception CORBA SystemException
     */
    public void set_session_context(org.omg.Components.SessionContext ctx)
        throws org.omg.CORBA.SystemException
    {
        this.sessionContext = CCM_Server_ContextHelper.narrow(ctx);
    }
    
    
    /**
     * Activate the component (called by the container).
     *
     * @exception CORBA SystemException
     */
    public void ccm_activate()
       throws org.omg.CORBA.SystemException
    {
    }
    
    
    /**
     * Stop the component (called by the container).
     *
     * @exception CORBA SystemException
     */
    public void ccm_passivate()
       throws org.omg.CORBA.SystemException
    {
    }
    
    
    /**
     * Destroy the component (called by the container).
     *
     * @exception CORBA SystemException
     */
    public void ccm_remove()
       throws org.omg.CORBA.SystemException
    {
    }

    //
    // IDL:thalesgroup.com/ReconnectDemo/CCM_Server/get_for_clients:1.0
    //
    public CCM_EventChecking get_for_clients()
    {
        return this.facet;
    }

    //
    // IDL:thalesgroup.com/ReconnectDemo/CCM_Server/push_event_sink:1.0
    //
    public void push_event_sink(TestEvent event)
    {
        // set flag that event has been received 
        ((EventCheckingExecutorImpl)this.facet).wasEventReceived = true;
     
        // send the same event back to Client
        this.sessionContext.push_event_publish(event);
    }

    //
    // IDL:thalesgroup.com/ReconnectDemo/Supported/test_supported:1.0
    //
    public void test_supported()
    {
        // nothing to do
    }
}
