
/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package qualif.timeoutrequest.testtimeoutrequest;

import cdmw.orbsupport.ORBSupport;
import cdmw.orbsupport.ExceptionMinorCodes;


public class HelloServantLocator
    extends org.omg.CORBA.LocalObject 
    implements org.omg.PortableServer.ServantLocator {

    private HelloInterfaceImpl m_hello_servant;

    private ComputInterfaceImpl m_comput_servant;

    private String m_process_name;
    
    private cdmw.commonsvcs.naming.NamingInterface m_naming_interface;

    public HelloServantLocator(HelloInterfaceImpl hello_servant, 
                        ComputInterfaceImpl comput_servant, 
                        String process_name, 
                cdmw.commonsvcs.naming.NamingInterface naming_interface) {
        m_hello_servant = hello_servant;
    m_comput_servant = comput_servant;
    m_process_name = process_name;
    m_naming_interface = naming_interface;
    }

    public org.omg.PortableServer.Servant preinvoke(
        byte[] oid,
        org.omg.PortableServer.POA poa,
        String operation,
        org.omg.PortableServer.ServantLocatorPackage.CookieHolder theCookie)
        throws org.omg.PortableServer.ForwardRequest {
        System.out.println(" test_server : HelloServantLocator::preinvoke of '" + operation + "'" );
        String oid_string = new String(oid);

        if( oid_string.equals("Hello"))
        {
            return m_hello_servant;
        }

        if( oid_string.equals("Comput") )
        {

        if(( ! operation.equals( "get_result_forward")) || ( ! m_process_name.equals("P21")) ) 
        {
           return m_comput_servant;  // normal case
        }

        org.omg.CORBA.Object obj;

        try
        {
                obj = m_naming_interface.resolve ("dom3/P41ComputInterface");
        }
        catch (org.omg.CosNaming.NamingContextPackage.NotFound e)
        {
                e.printStackTrace();
                throw new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        }    
        catch (org.omg.CosNaming.NamingContextPackage.CannotProceed e)
        {
                e.printStackTrace();
                throw new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        } 
        catch (org.omg.CosNaming.NamingContextPackage.InvalidName e)
        {
                e.printStackTrace();
                throw new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        }               
        
            System.out.println(" test_server : HelloServantLocator::preinvoke forwarding" );

        throw new org.omg.PortableServer.ForwardRequest(obj);
        }
        System.out.println("throw CORBA::OBJECT_NOT_EXIST");        
            throw new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public void postinvoke(
        byte[] oid,
        org.omg.PortableServer.POA poa,
        String operation,
        Object theCookie,
        org.omg.PortableServer.Servant theServant) 
    {
        //nothing to do
    }
    
    

}



