/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2009. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.containervirtualsize;

import cdmw.logging.*;
import static cdmw.logging.FunctionLogger.*;
import com.acme.ContainerVirtualSize.*;

//
// IDL:acme.com/ContainerVirtualSize/CCM_ServerLBClientFTClientLBHome:1.0
//

/**
 * Component Home implementation of a ServerLBClientFT
 */
public class CCMServerLBClientFTHomeImpl extends org.omg.CORBA.LocalObject
    implements CCM_ServerLBClientFTHome
{
    private Logger logger;

    /**
     * Purpose:
     * <p> Constructor.
     */
    public CCMServerLBClientFTHomeImpl() 
    {
        this.logger = Logger.Get_Logger("CCMServerLBClientFTHomeImpl",
                                        "QUALIF_CCM_CONTAINER_VIRTUAL_SIZE");
        CDMW_LOG_FUNCTION(this.logger, 
                          "CCMServerLBClientFTHomeImpl Constructor");
    }

    //
    // IDL:acme.com.ContainerVirtualSize.CCM_ServerLBClientFTHomeImplicit.create:1.0
    //
    /**
     * Purpose:
     * <p> Ask component home to create a new component
     *
     * @exception org.omg.Components.CCMException 
     */
    public org.omg.Components.EnterpriseComponent create() 
        throws org.omg.Components.CCMException 
    {
        System.out.println("CCMServerLBClientFTHomeImpl.create");

        return new CCMServerLBClientFTImpl();
    }

    /**
     * Purpose:
     * <p> create a new server home
     */
    public static org.omg.Components.HomeExecutorBase createCCMServerLBClientFTHome() 
    {
       System.out.println("CCMServerLBClientFTHomeImpl.createCCMServerLBClientFTHome");

        return new CCMServerLBClientFTHomeImpl();
    }

} /* End of class */
