/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ccm_context;

import com.thalesgroup.CdmwPlatformMngt.*;
import com.acme.TestCcmContext.*;
import cdmw.ossupport.OS;


//
// IDL:thalesgroup.com/TestCcmContext/CCM_Server:1.0
//
public class CCMServerImpl extends org.omg.CORBA.LocalObject
    implements Session_CCM_Server {
    //extends CCMTestComponentContextImpl
    //    implements com.acme.TestCcmContext.CCM_Server {
    

    private String name = "";
    

    com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContext m_ctx;

    public CCMServerImpl() {
        this.m_sessionContext = null;
        m_ctx = null;
    }

    // session context
    private CCM_Server_Context m_sessionContext;

    //
    // IDL:thalesgroup.com/TestCcmContext/CCM_Server_Executor/name:1.0
    //
    public String name() {
        // TODO: Implementation
        return this.name;
    }

    public void name(String name) {
        this.name = name;
    }


    public com.acme.TestCcmContext.CCM_TestComponentContext get_test_component_context(){
        return this; 
    }   


    public void set_session_context(org.omg.Components.SessionContext ctx)
    {
        java.lang.System.out.println("   ... CCMServerImpl::set_session_context called!");
        this.m_sessionContext = CCM_Server_ContextHelper.narrow(ctx);
    }
 
    public CCM_Server_Context getContext()
    {
        return this.m_sessionContext;
    }

    public void cdmw_initialise_component(com.thalesgroup.CdmwPlatformMngtBase.StartupKind startUpKind)
    {
         java.lang.System.out.println(" *** cdmw_initialise_component  ***");
        org.omg.CORBA.Object obj = null;
        try
            {    
                obj = m_sessionContext.resolve_service_reference(cdmw.platformmngt.PlatformInterface.MANAGED_PROCESS_CONTEXT_NAME);
            }
        catch (Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        m_ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContextHelper.narrow(obj);

        java.lang.System.out.println(" *** testing get_snapshot()  ***");

        com.thalesgroup.CdmwPlatformMngt.External.System sys = m_ctx.the_system();
   
        sys.get_snapshot();

        java.lang.System.out.println(" *** testing get_snapshot()  is OK  ***");


    }


    public void ccm_activate() {
        java.lang.System.out.println("***  ccm_activate()  ***");
        
        java.lang.System.out.println("Testing Managed Process operations");

        com.thalesgroup.CdmwPlatformMngt.External.System sys = m_ctx.the_system();
        com.thalesgroup.CdmwPlatformMngt.External.Process proc = m_ctx.the_process();
        com.thalesgroup.CdmwPlatformMngt.External.Host host = m_ctx.the_host();
        com.thalesgroup.CdmwPlatformMngt.External.Application app = m_ctx.the_application();
        com.thalesgroup.CdmwPlatformMngt.ManagedElement managed_element = m_ctx.the_managed_element();

        cdmw.common.Assert.check(sys.name().equals("S1"));

        cdmw.common.Assert.check(proc.name().equals("TestComponentContextProcessServer1") );

        cdmw.common.Assert.check(managed_element.name().equals("TestComponentContextProcessServer1"));

        cdmw.common.Assert.check(app.name().equals("CcmTestComponentContextApplication"));

        cdmw.common.Assert.check(host.name().equals(OS.getHostname()));

        java.lang.System.out.println("### All verification are ok ###");
 
        /*
          org.omg.CORBA.Object obj = null; 
          try
          {
          obj = m_sessionContext.resolve_service_reference("ManagedComponentContext");
          }
          catch(Exception ex)
          {
          java.lang.System.out.println(ex.toString());
          }

          com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContext comp_ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContextHelper.narrow(obj);

          com.thalesgroup.CdmwPlatformMngt.External.System sys = comp_ctx.the_system();
          com.thalesgroup.CdmwPlatformMngt.External.Process proc = comp_ctx.the_process();
          com.thalesgroup.CdmwPlatformMngt.External.Host host = comp_ctx.the_host();
          com.thalesgroup.CdmwPlatformMngt.External.Application app = comp_ctx.the_application();
          com.thalesgroup.CdmwPlatformMngt.ManagedElement managed_element = comp_ctx.the_managed_element();

          sys = comp_ctx.the_system();
          proc = comp_ctx.the_process();
          host = comp_ctx.the_host();
          app = comp_ctx.the_application();
          managed_element = comp_ctx.the_managed_element();
          java.lang.System.out.println("-- system name:" + sys.name() + "-- process name:" +proc.name() +
          "-- application name:" + app.name() + "-- host name:"+ host.name() +
          "-- managed element name:" + managed_element.name());
        */

    }

    public void ccm_remove() {
        java.lang.System.out.println("***  ccm_remove() ***");
    }
  
   
    public void ccm_passivate() {
        java.lang.System.out.println("***  ccm_passivate()  ***");
    }



    public com.thalesgroup.CdmwPlatformMngt.External.RedundancyGroup get_server_group()
    {
        throw new org.omg.CORBA.NO_IMPLEMENT (cdmw.orbsupport.ExceptionMinorCodes.NO_IMPLEMENT, 
                                              org.omg.CORBA.CompletionStatus.COMPLETED_NO); 
    } 


    public void test_operation(java.lang.String param)
    {
        java.lang.System.out.println("*** test_operation " + param + " ***");
        m_ctx.exit(10);
    }

}

