/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.restartwarmth;

import com.thalesgroup.CdmwPlatformMngt.*;
import com.acme.TestRestartWarmth.*;
import cdmw.ossupport.OS;


//
// IDL:thalesgroup.com/TestRestartWarmth/CCM_Server:1.0
//
public class CCMServerImpl extends org.omg.CORBA.LocalObject
    implements Session_CCM_Server {
    //extends CCMTestRestartWarmthInterfaceImpl
    //    implements com.acme.TestRestartWarmth.CCM_Server {
    

    private String name = "";
    
    private TestRequestedRestartWarmth m_restart_warmth;
    //private TestRequestedRestartWarmthHolder m_restart_warmth_h;
    

    com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContext m_ctx;

    public CCMServerImpl() {
    
    java.lang.System.out.println("   ... CCMServerImpl::c'tor");
        
        this.m_sessionContext = null;
        m_ctx = null;
        m_restart_warmth = new TestRequestedRestartWarmth( RestartWarmth.COLD_RESTART,
                            RestartWarmth.COLD_RESTART,
                            RestartWarmth.COLD_RESTART,
                            RestartWarmth.COLD_RESTART,
                            RestartWarmth.COLD_RESTART );
        
        //m_restart_warmth_h = new TestRequestedRestartWarmthHolder(m_restart_warmth);
        /*
        m_restart_warmth_h.value.comp = RestartWarmth.HOT_RESTART;
        m_restart_warmth_h.value.proc = RestartWarmth.HOT_RESTART;
        m_restart_warmth_h.value.appl = RestartWarmth.HOT_RESTART;
        m_restart_warmth_h.value.host = RestartWarmth.HOT_RESTART;
        m_restart_warmth_h.value.system =  RestartWarmth.HOT_RESTART;*/
        
               java.lang.System.out.println("requested_server is : " + 
                                     m_restart_warmth.comp.value() +
                                     m_restart_warmth.proc.value() +
                                     m_restart_warmth.appl.value() +
                                     m_restart_warmth.host.value() +
                                     m_restart_warmth.system.value() );
        
        java.lang.System.out.println("   ... CCMServerImpl::c'tor ended");
    }

    // session context
    private CCM_Server_Context m_sessionContext;

    //
    // IDL:thalesgroup.com/TestRestartWarmth/CCM_Server_Executor/name:1.0
    //
    public String name() {
        // TODO: Implementation
        return this.name;
    }

    public void name(String name) {
        this.name = name;
    }


    public com.acme.TestRestartWarmth.CCM_TestRestartWarmthInterface get_test_restart_warmth(){
        return this; 
    }   


    public void set_session_context(org.omg.Components.SessionContext ctx)
    {
        java.lang.System.out.println("   ... CCMServerImpl::set_session_context called!");
        this.m_sessionContext = CCM_Server_ContextHelper.narrow(ctx);
    }
 
    public CCM_Server_Context getContext()
    {
        return this.m_sessionContext;
    }

    public void cdmw_initialise_component(com.thalesgroup.CdmwPlatformMngtBase.StartupKind startUpKind)
    {
         java.lang.System.out.println(" *** cdmw_initialise_component  ***");
        org.omg.CORBA.Object obj = null;
        try
            {    
                obj = m_sessionContext.resolve_service_reference("ManagedComponentContext");
            }
        catch (Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        
        m_ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContextHelper.narrow(obj);

        com.thalesgroup.CdmwPlatformMngt.External.System sys = m_ctx.the_system();
        com.thalesgroup.CdmwPlatformMngt.External.Process proc = m_ctx.the_process();
        com.thalesgroup.CdmwPlatformMngt.External.Host host = m_ctx.the_host();
        com.thalesgroup.CdmwPlatformMngt.External.Application app = m_ctx.the_application();
        com.thalesgroup.CdmwPlatformMngt.External.CcmComponent comp = com.thalesgroup.CdmwPlatformMngt.External.CcmComponentHelper.narrow(m_ctx.the_managed_element());
        
        
        if ( proc == null ) java.lang.System.out.println(" proc is null" );
        if ( sys == null ) java.lang.System.out.println(" sys is null" );
        if ( host == null ) java.lang.System.out.println(" host is null" );
        if ( app == null ) java.lang.System.out.println(" app is null" );
        if ( comp == null ) java.lang.System.out.println(" comp is null" );
        
        
        org.omg.CORBA.Any myAny_comp = org.omg.CORBA.ORB.init().create_any();
        org.omg.CORBA.Any myAny_proc = org.omg.CORBA.ORB.init().create_any();
        org.omg.CORBA.Any myAny_host = org.omg.CORBA.ORB.init().create_any();
        org.omg.CORBA.Any myAny_appl = org.omg.CORBA.ORB.init().create_any();
        org.omg.CORBA.Any myAny_system = org.omg.CORBA.ORB.init().create_any();
        org.omg.CORBA.AnyHolder myAnyHolder_proc = new org.omg.CORBA.AnyHolder(myAny_proc);
        org.omg.CORBA.AnyHolder myAnyHolder_comp = new org.omg.CORBA.AnyHolder(myAny_comp);
        org.omg.CORBA.AnyHolder myAnyHolder_appl = new org.omg.CORBA.AnyHolder(myAny_appl);
        org.omg.CORBA.AnyHolder myAnyHolder_host = new org.omg.CORBA.AnyHolder(myAny_host);
        org.omg.CORBA.AnyHolder myAnyHolder_system = new org.omg.CORBA.AnyHolder(myAny_system);

        
        try
        {
        java.lang.System.out.println(" *** cdmw_initialise_component : storing m_restart_warmth ***" );
        
        proc.get_attribute("RequestedRestartWarmth", myAnyHolder_proc, Owner.PRE_DEFINED);
        //m_restart_warmth_h.value.proc = RestartWarmthHelper.extract(myAnyHolder_proc.value);;
        m_restart_warmth.proc = RestartWarmthHelper.extract(myAnyHolder_proc.value);
        
        comp.get_attribute("RequestedRestartWarmth", myAnyHolder_comp, Owner.PRE_DEFINED);
        //m_restart_warmth_h.value.comp = RestartWarmthHelper.extract(myAnyHolder_comp.value);
        m_restart_warmth.comp = RestartWarmthHelper.extract(myAnyHolder_comp.value);
        
        app.get_attribute("RequestedRestartWarmth", myAnyHolder_appl, Owner.PRE_DEFINED);
        //m_restart_warmth_h.value.appl = RestartWarmthHelper.extract(myAnyHolder_appl.value);
        m_restart_warmth.appl = RestartWarmthHelper.extract(myAnyHolder_appl.value);

        
        host.get_attribute("RequestedRestartWarmth", myAnyHolder_host, Owner.PRE_DEFINED);
        //m_restart_warmth_h.value.host = RestartWarmthHelper.extract(myAnyHolder_host.value);
        m_restart_warmth.host = RestartWarmthHelper.extract(myAnyHolder_host.value);
        
                
        sys.get_attribute("RequestedRestartWarmth", myAnyHolder_system, Owner.PRE_DEFINED);
        //m_restart_warmth_h.value.system =  RestartWarmthHelper.extract(myAnyHolder_system.value);
        m_restart_warmth.system =  RestartWarmthHelper.extract(myAnyHolder_system.value);
        
        java.lang.System.out.println("cdmw_initialise_component  : " + 
                                     m_restart_warmth.comp.value() +
                                     m_restart_warmth.proc.value() +
                                     m_restart_warmth.appl.value() +
                                     m_restart_warmth.host.value() +
                                     m_restart_warmth.system.value() );
        
        } 
        catch ( AttributeNotFound e) 
        {
             java.lang.System.out.println("Exception AttributeNotFound!!!");  
        } 
        catch(Exception e) 
        {
                java.lang.System.out.println("Unexpected exception!!");
                java.lang.System.out.println(e.toString());
        }
        
        
    }


    public void ccm_activate() {
        java.lang.System.out.println("***  ccm_activate()  ***");
        
        com.thalesgroup.CdmwPlatformMngt.External.System sys = m_ctx.the_system();
        com.thalesgroup.CdmwPlatformMngt.External.Process proc = m_ctx.the_process();
        com.thalesgroup.CdmwPlatformMngt.External.Host host = m_ctx.the_host();
        com.thalesgroup.CdmwPlatformMngt.External.Application app = m_ctx.the_application();
        com.thalesgroup.CdmwPlatformMngt.ManagedElement comp = m_ctx.the_managed_element();

/*        cdmw.common.Assert.check(sys.name().equals("S1"));*/


        

    }

    public void ccm_remove() {
        java.lang.System.out.println("***  ccm_remove() ***");
    }
  
   
    public void ccm_passivate() {
        java.lang.System.out.println("***  ccm_passivate()  ***");
    }



    public String get_host_name()
    {
        return OS.getHostname();
    }  


    public TestRequestedRestartWarmth test_operation(java.lang.String param)
    {
        java.lang.System.out.println("*** test_operation " + param + " ***");
        
        /*java.lang.System.out.println("requested_server is : " + 
                                     m_restart_warmth_h.value.comp +
                                     m_restart_warmth_h.value.proc +
                                     m_restart_warmth_h.value.appl +
                                     m_restart_warmth_h.value.host +
                                     m_restart_warmth_h.value.system );*/
                                     
               java.lang.System.out.println("requested_server is : " + 
                                     m_restart_warmth.comp.value() +
                                     m_restart_warmth.proc.value() +
                                     m_restart_warmth.appl.value() +
                                     m_restart_warmth.host.value() +
                                     m_restart_warmth.system.value() );
        
        TestRequestedRestartWarmthHolder m_restart_warmth_h = new TestRequestedRestartWarmthHolder(m_restart_warmth);                                     
        return m_restart_warmth_h.value;
        //return m_restart_warmth;
    }

}

