/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.platformmngt;

import com.thalesgroup.CdmwPlatformMngt.ManagedComponentContextFactory;
import com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.*;
//ComponentContext;
//import com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContext;


/**
 * The default implementation of a managed component context finder.
 *
 */
class ManagedComponentContextFactoryImpl 
    extends org.omg.CORBA.LocalObject
    implements ManagedComponentContextFactory 
{
    private java.util.Map<String, ComponentContextExt> m_ComponentContexts;

    private ProcessContext m_process_context;
    
    //
    // Constructor
    //
    public ManagedComponentContextFactoryImpl()
    {
        m_ComponentContexts = new java.util.HashMap<String, ComponentContextExt>();
    }
    
    
    //
    // IDL:thalesgroup.com/CdmwPlatformMngt/ManagedComponentContextFactory/find_managed_component_context:1.0
    //
    public synchronized ComponentContextExt 
    find_managed_component_context(String component_name)
    {
        // try to get ComponentContext from map
        ComponentContextExt ctx = m_ComponentContexts.get(component_name);
        if (ctx != null)
            return ctx;
        
        // create a new ComponentContext
        ctx = new ComponentContextExtImpl(component_name, m_process_context );
        
        // store it in ComponentContextMap
        m_ComponentContexts.put(component_name, ctx);
        
        return ctx;
    }
    
    public void set_managed_process_context (ProcessContext managed_process_context) 
    throws org.omg.CORBA.SystemException, com.thalesgroup.CdmwPlatformMngt.ContextAlreadyExists 
    {
        if ( null == m_process_context  )
        {
            m_process_context = managed_process_context ;
        }
        else 
        {
            throw  new com.thalesgroup.CdmwPlatformMngt.ContextAlreadyExists ();
        }
    }
}

