/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2009.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef PLUGINVALID_IMPL_HPP_
#define PLUGINVALID_IMPL_HPP_

#include "PluginValid.skel.hpp"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
#pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "tao/LocalObject.h"
#include "idllib/CdmwPlatformMngtSupervisionObserver.skel.hpp"
#include "Foundation/osthreads/Mutex.hpp"
#include "Foundation/osthreads/MutexGuard.hpp"
#include "Foundation/ossupport/OS.hpp"
#include <string>

class  PluginValid_impl
  : public virtual PluginValid,
    public virtual TAO_Local_RefCounted_Object
{
public:
  // Constructor 
  PluginValid_impl (void);
  
  // Destructor 
  virtual ~PluginValid_impl (void);
  
  virtual
  void set_system (
      ::CdmwPlatformMngt::System_ptr in_system
    )
    ACE_THROW_SPEC ((
      ::CORBA::SystemException
    ));
  
  virtual 
  void notify (
      ::CdmwPlatformMngt::Event * an_event
    )
    ACE_THROW_SPEC ((
      ::CORBA::SystemException
    ));
    
  virtual
  void set_id (CORBA::Long in_id)
    ACE_THROW_SPEC ((
      ::CORBA::SystemException
    ));
        
    
private:
    ::CdmwPlatformMngt::System_ptr m_system;    
    int m_id;
    std::string m_observername;
    Cdmw::OsSupport::Mutex m_mutex;
};


#endif /*PLUGINVALID_IMPL_HPP_*/
